-- fileIn("s8/library/luasocketExamples.st");
smalltalk:bind(smalltalk.LuaSocket["$klass"],"echoServer",0
,function(self)
local server=nil
local host=nil
local newLine=nil
(function()
	local _s8_value=("\r\n")
	newLine=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((smalltalk.LuaSocket):bind_port_("*", (0)))
	server=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((server):sockname())
	host=_s8_value; return _s8_value
end)()
;
(self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Please telnet to localhost("),(host):first())),") on port ")),(host):last()))
;
(self):print_("After connecting you have 10s to enter a line to be echoed")
;
(function() while(((function()
local client=nil
local line=nil
(function()
	local _s8_value=((server):accept())
	client=_s8_value; return _s8_value
end)();(client):settimeout_((10));(function()
	local _s8_value=(((client):receive()):first())
	line=_s8_value; return _s8_value
end)();(function() if ((((((line))~=nil)))==true) then return ((function()
(client):send_(smalltalk:object_comma_((line),newLine));return ((self):note_(line))
end))() else return nil end end)();(client):close();return (true)
end))()) do end;return nil end)()
;
return (self)
;
end
,"samples","echoServer\r\n\t\" Sample - Simple Echo server.\r\n\tBinds to an ephemeral port (one that is chosen by the operating system) on the local host and awaits client connections on that port. When a connection is established, reads a line from the remote end and sends it back, closing the connection immediately.\r\n\tYou can test it using telnet. \"\r\n\r\n\t| server host newLine |\r\n\tnewLine := '\r\n'.\tserver := LuaSocket bind: '*' port: 0.\r\n\thost := server sockname.\r\n\tself print: 'Please telnet to localhost(' ,host first ,') on port ' ,host last.\r\n\tself print: 'After connecting you have 10s to enter a line to be echoed'.\r\n\t[\t| client line |\r\n\t\tclient := server accept.\r\n\t\tclient settimeout: 10.\r\n\t\tline := client receive first.\r\n\t\tline notNil ifTrue: [\r\n\t\t\tclient send: line ,newLine.\r\n\t\t\tself note: line.\r\n\t\t].\r\n\t\tclient close.\r\n\ttrue] whileTrue","function(self)\r\nlocal server=nil\r\nlocal host=nil\r\nlocal newLine=nil\r\n(function()\r\n\tlocal _s8_value=(\"\\r\\n\")\r\n\tnewLine=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.LuaSocket):bind_port_(\"*\", (0)))\r\n\tserver=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((server):sockname())\r\n\thost=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Please telnet to localhost(\"),(host):first())),\") on port \")),(host):last()))\r\n;\r\n(self):print_(\"After connecting you have 10s to enter a line to be echoed\")\r\n;\r\n(function() while(((function()\r\nlocal client=nil\r\nlocal line=nil\r\n(function()\r\n\tlocal _s8_value=((server):accept())\r\n\tclient=_s8_value; return _s8_value\r\nend)();(client):settimeout_((10));(function()\r\n\tlocal _s8_value=(((client):receive()):first())\r\n\tline=_s8_value; return _s8_value\r\nend)();(function() if ((((((line))~=nil)))==true) then return ((function()\r\n(client):send_(smalltalk:object_comma_((line),newLine));return ((self):note_(line))\r\nend))() else return nil end end)();(client):close();return (true)\r\nend))()) do end;return nil end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"stServer",0
,function(self)
return ((self):stServer_((8087)))
;
end
,"samples","stServer\r\n\t\" Sample - Simple smalltalk fileIn server (at port 8088). \"\r\n\r\n\t^self stServer: 8087","function(self)\r\nreturn ((self):stServer_((8087)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"stServer:",0
,function(self,port)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local server=nil
local host=nil
local newLine=nil
local lines=nil
(function()
	local _s8_value=("\r\n")
	newLine=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((smalltalk.LuaSocket):bind_port_("*", port))
	server=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((server):sockname())
	host=_s8_value; return _s8_value
end)()
;
(self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Please telnet to localhost("),(host):first())),") on port ")),(host):last()))
;
(self):print_("After connecting you have 10s to enter a line to be captured")
;
(function()
	local _s8_value=(smalltalk:newArray({}))
	lines=_s8_value; return _s8_value
end)()
;
(function() while(((function()
local client=nil
local line=nil
(function()
	local _s8_value=((server):accept())
	client=_s8_value; return _s8_value
end)();(client):settimeout_((10));(function()
	local _s8_value=(((client):receive()):first())
	line=_s8_value; return _s8_value
end)();(function() if ((((((line))~=nil)))==true) then return ((function()
return ((function() if ((((line):startsWith_("##")))==true) then return ((function()
(function() if ((((smalltalk:newArray({"##clear", "##reset", "##cls"})):includes_(line)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:newArray({}))
	lines=_s8_value; return _s8_value
end)())
end))() else return nil end end)();(function() if ((((smalltalk:newArray({"##fileIn", "##showIt"})):includes_(line)))==true) then return ((function()
(client):send_(tostring(((lines):join_(newLine)):fileIn()));return ((function()
	local _s8_value=(smalltalk:newArray({}))
	lines=_s8_value; return _s8_value
end)())
end))() else return nil end end)();return ((function() if ((((smalltalk:isObject_equalTo_((line),"##close"))))==true) then return ((function()
(client):close();return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((server):close())
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)())
end))() else return ((function()
return ((lines):add_(line))
end))() end end)())
end))() else return nil end end)();(client):close();return (true)
end))()) do end;return nil end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"samples","stServer: port\r\n\t\" Sample - Simple smalltalk fileIn server.\r\n\tCapture all lines sent by clients until a line with a command is found.\r\n\tWhen a command is received it is executed with on all captured lines, and the capture lines are cleared.\r\n\tRead to learn about accepted commands\r\n\t\"\r\n\r\n\t| server host newLine lines |\r\n\tnewLine := '\r\n'.\tserver := LuaSocket bind: '*' port: port.\r\n\thost := server sockname.\r\n\tself print: 'Please telnet to localhost(' ,host first ,') on port ' ,host last.\r\n\tself print: 'After connecting you have 10s to enter a line to be captured'.\r\n\tlines := #().\r\n\t[\t| client line |\r\n\t\tclient := server accept.\r\n\t\tclient settimeout: 10.\r\n\t\tline := client receive first.\r\n\t\tline notNil ifTrue: [\r\n\t\t\t(line startsWith: '##') ifFalse: [ lines add: line ] ifTrue: [\r\n\t\t\t\t(#('##clear' '##reset' '##cls') includes: line) ifTrue: [ lines := #() ].\r\n\t\t\t\t(#('##fileIn' '##showIt') includes: line) ifTrue: [\r\n\t\t\t\t\tclient send: (# #tostring: (lines join: newLine) fileIn).\r\n\t\t\t\t\tlines := #()\r\n\t\t\t\t].\r\n\t\t\t\tline = '##close' ifTrue: [ client close. ^server close ].\r\n\t\t\t].\r\n\t\t].\r\n\t\tclient close.\r\n\ttrue] whileTrue","function(self,port)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal server=nil\r\nlocal host=nil\r\nlocal newLine=nil\r\nlocal lines=nil\r\n(function()\r\n\tlocal _s8_value=(\"\\r\\n\")\r\n\tnewLine=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.LuaSocket):bind_port_(\"*\", port))\r\n\tserver=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((server):sockname())\r\n\thost=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Please telnet to localhost(\"),(host):first())),\") on port \")),(host):last()))\r\n;\r\n(self):print_(\"After connecting you have 10s to enter a line to be captured\")\r\n;\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tlines=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() while(((function()\r\nlocal client=nil\r\nlocal line=nil\r\n(function()\r\n\tlocal _s8_value=((server):accept())\r\n\tclient=_s8_value; return _s8_value\r\nend)();(client):settimeout_((10));(function()\r\n\tlocal _s8_value=(((client):receive()):first())\r\n\tline=_s8_value; return _s8_value\r\nend)();(function() if ((((((line))~=nil)))==true) then return ((function()\r\nreturn ((function() if ((((line):startsWith_(\"##\")))==true) then return ((function()\r\n(function() if ((((smalltalk:newArray({\"##clear\", \"##reset\", \"##cls\"})):includes_(line)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tlines=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)();(function() if ((((smalltalk:newArray({\"##fileIn\", \"##showIt\"})):includes_(line)))==true) then return ((function()\r\n(client):send_(tostring(((lines):join_(newLine)):fileIn()));return ((function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tlines=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)();return ((function() if ((((smalltalk:isObject_equalTo_((line),\"##close\"))))==true) then return ((function()\r\n(client):close();return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((server):close())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)())\r\nend))() else return ((function()\r\nreturn ((lines):add_(line))\r\nend))() end end)())\r\nend))() else return nil end end)();(client):close();return (true)\r\nend))()) do end;return nil end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"stClient",0
,function(self)
return ((self):stClient_("localhost"))
;
end
,"samples","stClient\r\n\t\" Sample - Simple smalltalk client reading from default input and sending to localhost at port 8088. \"\r\n\r\n\t^self stClient: #localhost","function(self)\r\nreturn ((self):stClient_(\"localhost\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"stClient:",0
,function(self,host)
return ((self):stClient_file_((smalltalk.Array):with_with_(host, (8087)), (smalltalk.LuaFile):input()))
;
end
,"samples","stClient: host\r\n\t\" Sample - Simple smalltalk client reading from default input and sending to host at port 8088. \"\r\n\r\n\t^self stClient: (Array with: host with: 8087) file: LuaFile input","function(self,host)\r\nreturn ((self):stClient_file_((smalltalk.Array):with_with_(host, (8087)), (smalltalk.LuaFile):input()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"stClient:file:",0
,function(self,array,aLuaFile)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local client=nil
local line=nil
local newLine=nil
(function()
	local _s8_value=("\r\n")
	newLine=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((smalltalk.LuaSocket):tcp())
	client=_s8_value; return _s8_value
end)()
;
(client):connect_port_((array):first(), (array):last())
;
(function() while(((function()
(function()
	local _s8_value=((aLuaFile):read_("*l"))
	line=_s8_value; return _s8_value
end)();return ((((line))~=nil))
end))()) do (function()
(client):send_(smalltalk:object_comma_((line),newLine));return ((function() if (((((((client):receive()):second())=="closed")))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)())
end)() end;return nil end)()
;
(client):close()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"samples","stClient: array file: aLuaFile\r\n\t\" Sample - Simple smalltalk client.\r\n\tSend all lines in aFile to stServer at hostAndPort in array.\r\n\t\"\r\n\r\n\t| client line newLine |\r\n\tnewLine := '\r\n'.\tclient := LuaSocket tcp.\r\n\tclient connect: array first port: array last.\r\n\t[ line := aLuaFile read: '*l'.\r\n\t  line notNil ] whileTrue: [\r\n\t  client send: line ,newLine.\r\n\t  client receive second == #closed ifTrue: [ ^self ].\r\n\t].\r\n\tclient close","function(self,array,aLuaFile)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal client=nil\r\nlocal line=nil\r\nlocal newLine=nil\r\n(function()\r\n\tlocal _s8_value=(\"\\r\\n\")\r\n\tnewLine=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.LuaSocket):tcp())\r\n\tclient=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(client):connect_port_((array):first(), (array):last())\r\n;\r\n(function() while(((function()\r\n(function()\r\n\tlocal _s8_value=((aLuaFile):read_(\"*l\"))\r\n\tline=_s8_value; return _s8_value\r\nend)();return ((((line))~=nil))\r\nend))()) do (function()\r\n(client):send_(smalltalk:object_comma_((line),newLine));return ((function() if (((((((client):receive()):second())==\"closed\")))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)())\r\nend)() end;return nil end)()\r\n;\r\n(client):close()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"daytime",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local ip=nil
local port=nil
local server=nil
(function()
	local _s8_value=((13))
	port=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((smalltalk.DNS):toip_("raspberrypi"))
	ip=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((smalltalk.LuaSocket):udp())
	server=_s8_value; return _s8_value
end)()
;
(self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(("Sending UDP datagram to "),ip)),":")),port))
;
(server):sendto_ip_port_onError_("anything", ip, port, (function(err)
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(err))
end
)()
error(_s8Ret_,0)
end)())
end))
;
(self):print_("Waiting for daytime data")
;
(self):note_(((server):receive()):asLiteral())
;
(self):print_("done")
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"samples","daytime\r\n\t\" Sample - A simple daytime client.\r\n\tConnects to a remote server and tries to retrieve the daytime, printing the answer it got or an error message. \"\r\n\r\n\t| ip port server |\r\n\t port := 13.\r\n\tip := DNS toip: \"#localhost\" #raspberrypi.\r\n\tserver := LuaSocket udp.\r\n\tself print: 'Sending UDP datagram to ' ,ip ,':' ,port.\r\n\tserver sendto: #anything ip: ip port: port onError: [:err|\r\n\t\t^self error: err\r\n\t].\r\n\tself print: 'Waiting for daytime data'.\r\n\tself note: server receive asLiteral.\r\n\tself print: #done","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal ip=nil\r\nlocal port=nil\r\nlocal server=nil\r\n(function()\r\n\tlocal _s8_value=((13))\r\n\tport=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.DNS):toip_(\"raspberrypi\"))\r\n\tip=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.LuaSocket):udp())\r\n\tserver=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(self):print_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"Sending UDP datagram to \"),ip)),\":\")),port))\r\n;\r\n(server):sendto_ip_port_onError_(\"anything\", ip, port, (function(err)\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(err))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))\r\n;\r\n(self):print_(\"Waiting for daytime data\")\r\n;\r\n(self):note_(((server):receive()):asLiteral())\r\n;\r\n(self):print_(\"done\")\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.FTP["$klass"],"getSpeedtest",0
,function(self)
local url=nil
(function()
	local _s8_value=("ftp://speedtest.tele2.net")
	url=_s8_value; return _s8_value
end)()
;
(self):print_(smalltalk:object_comma_(("Reading contents at "),url))
;
(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((" "),((smalltalk.FTP):get_(url)):size()))," bytes read"))
;
(self):print_("done")
;
return (self)
;
end
,"samples","getSpeedtest\r\n\t\" Sample - Get file from public FTP server.\r\n\tThe Tele2 Speedtest Service helps you test your Internet connection speed through various methods and is available not only to customers of Tele2 but anyone with an Internet connection. Test your connection using speedtest.net's tool, downloading a file via your web browser (HTTP) or downloading and uploading via FTP.\thttp://speedtest.tele2.net/\"\r\n\r\n\t| url |\r\n\turl := 'ftp://speedtest.tele2.net'.\"/1MB.zip'. \"\r\n\tself print: 'Reading contents at ' ,url.\r\n\tself note: ' ',(FTP get: url) size ,' bytes read'.\r\n\tself print: #done","function(self)\r\nlocal url=nil\r\n(function()\r\n\tlocal _s8_value=(\"ftp://speedtest.tele2.net\")\r\n\turl=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(self):print_(smalltalk:object_comma_((\"Reading contents at \"),url))\r\n;\r\n(self):note_(smalltalk:object_comma_((smalltalk:object_comma_((\" \"),((smalltalk.FTP):get_(url)):size())),\" bytes read\"))\r\n;\r\n(self):print_(\"done\")\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP["$klass"],"headerTest",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local array=nil
local headers=nil
(function()
	local _s8_value=((smalltalk.HTTP):requestAll_(smalltalk:object_comma_((("method"):_minus_gt("Head")),("url"):_minus_gt("http://u8.smalltalking.net/index.html"))))
	array=_s8_value; return _s8_value
end)()
;
(function() if ((((smalltalk:isObject_equalTo_(((array):first()),(1)))))==true) then return nil else return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Invalid result - "),(array):asLiteral())))
end
)()
error(_s8Ret_,0)
end)())
end))() end end)()
;
(function()
	local _s8_value=((array):last())
	headers=_s8_value; return _s8_value
end)()
;
((headers):keys()):do_((function(key)
return ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((key),"=")),(headers):at_(key))))
end))
;
(self):print_("done")
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"samples","headerTest\r\n\t\" Sample - Get header of index file of U8 service. \"\r\n\r\n\t| array headers |\r\n\tarray := HTTP requestAll: \r\n\t\t#method -> #Head\r\n\t\t,(#url -> 'http://u8.smalltalking.net/index.html').\r\n\tarray first = 1 ifFalse: [ ^self error: 'Invalid result - ' ,array asLiteral ].\r\n\theaders := array last.\r\n\theaders keys do: [:key|\r\n\t\tself print: key ,'=' ,(headers at: key)\r\n\t].\r\n\tself print: #done","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal array=nil\r\nlocal headers=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.HTTP):requestAll_(smalltalk:object_comma_(((\"method\"):_minus_gt(\"Head\")),(\"url\"):_minus_gt(\"http://u8.smalltalking.net/index.html\"))))\r\n\tarray=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_(((array):first()),(1)))))==true) then return nil else return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid result - \"),(array):asLiteral())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() end end)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((array):last())\r\n\theaders=_s8_value; return _s8_value\r\nend)()\r\n;\r\n((headers):keys()):do_((function(key)\r\nreturn ((self):print_(smalltalk:object_comma_((smalltalk:object_comma_((key),\"=\")),(headers):at_(key))))\r\nend))\r\n;\r\n(self):print_(\"done\")\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.SMTP["$klass"],"example",0
,function(self)
(smalltalk.SMTP):send_(smalltalk:object_comma_((smalltalk:object_comma_((("from"):_minus_gt("<luasocket@example.com>")),("rcpt"):_minus_gt(smalltalk:newArray({"<fulano@example.com>", "<beltrano@example.com>", "<sicrano@example.com>"})))),("source"):_minus_gt(((smalltalk.Lua):smtp()):message_(smalltalk:object_comma_((("body"):_minus_gt("I hope this works. If it does, I can send you another 1000 copies.")),("headers"):_minus_gt(smalltalk:object_comma_((smalltalk:object_comma_((("to"):_minus_gt("Fulano da Silva <fulano@example.com>")),("cc"):_minus_gt("\"Beltrano F. Nunes\" <beltrano@example.com>"))),("subject"):_minus_gt("My first message"))))))))
;
(self):print_("done")
;
return (self)
;
end
,"samples","example\r\n\t\" Sample - Send an email to users. \"\r\n\r\n\tSMTP send:\r\n\t\t  #from -> '<luasocket@example.com>'\r\n\t\t,(#rcpt -> #(\r\n\t\t\t'<fulano@example.com>'\r\n\t\t\t'<beltrano@example.com>'\r\n\t\t\t'<sicrano@example.com>'\r\n\t\t\t))\r\n\t\t,(#source -> (Lua smtp message: (\r\n\t\t\t#body -> 'I hope this works. If it does, I can send you another 1000 copies.'\r\n\t\t\t,(#headers -> (\r\n\t\t\t\t  #to -> 'Fulano da Silva <fulano@example.com>'\r\n\t\t\t\t,(#cc -> '\"Beltrano F. Nunes\" <beltrano@example.com>')\r\n\t\t\t\t,(#subject -> 'My first message')\r\n\t\t\t))\r\n\t\t))).\r\n\tself print: #done","function(self)\r\n(smalltalk.SMTP):send_(smalltalk:object_comma_((smalltalk:object_comma_(((\"from\"):_minus_gt(\"<luasocket@example.com>\")),(\"rcpt\"):_minus_gt(smalltalk:newArray({\"<fulano@example.com>\", \"<beltrano@example.com>\", \"<sicrano@example.com>\"})))),(\"source\"):_minus_gt(((smalltalk.Lua):smtp()):message_(smalltalk:object_comma_(((\"body\"):_minus_gt(\"I hope this works. If it does, I can send you another 1000 copies.\")),(\"headers\"):_minus_gt(smalltalk:object_comma_((smalltalk:object_comma_(((\"to\"):_minus_gt(\"Fulano da Silva <fulano@example.com>\")),(\"cc\"):_minus_gt(\"\\\"Beltrano F. Nunes\\\" <beltrano@example.com>\"))),(\"subject\"):_minus_gt(\"My first message\"))))))))\r\n;\r\n(self):print_(\"done\")\r\n;\r\nreturn (self)\r\n;\r\nend")
