-- fileIn("s8/library/sharing/Objectifier.st");
smalltalk:addClass("Objectifier",smalltalk.Object,smalltalk:newArray({"origin","objects","names","transforms","natives","useJSON"}),"Objectifier")

smalltalk:bind(smalltalk.Objectifier["$klass"],"constructEventsTriggered",0
,function(self)
return (smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.Objectifier["$klass"],"constructEventsTriggered")(self)),smalltalk:newArray({"needsParser", "getNames:from:", "getTransforms:", "adapt:shape:"})))
;
end
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^super constructEventsTriggered\r\n\t,#(\t#needsParser\r\n\t\t#getNames:from:\r\n\t\t#getTransforms:\r\n\t\t#adapt:shape:\r\n\t)","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.Objectifier[\"$klass\"],\"constructEventsTriggered\")(self)),smalltalk:newArray({\"needsParser\", \"getNames:from:\", \"getTransforms:\", \"adapt:shape:\"})))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier["$klass"],"@","_at"
,function(self,aLiteral)
return (((self):new()):objectFrom_(aLiteral))
;
end
,"converting","@ aLiteral\r\n\t\" Returns a copy of an object sent from a remote system stringified into aLiteral. \"\r\n\r\n\t^self new objectFrom: aLiteral","function(self,aLiteral)\r\nreturn (((self):new()):objectFrom_(aLiteral))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier["$klass"],"from:",0
,function(self,source)
return ((
function(_s8_rec)
(_s8_rec):origin_(source);
return ((_s8_rec):yourself())
end
)((self):new()))
;
end
,"instantiation","from: source\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\torigin: source;\r\n\t\tyourself","function(self,source)\r\nreturn ((\r\nfunction(_s8_rec)\r\n(_s8_rec):origin_(source);\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)((self):new()))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"natives",0
,function(self)
(function() if ((((((self['@natives']))==nil)))==true) then return ((function()
return ((self):initializeNatives())
end))() else return nil end end)()
;
return (self['@natives'])
;
end
,"accessing","natives\r\n\t\" Private - Returns the natives of the receiver. \"\r\n\r\n\tnatives isNil ifTrue: [ self initializeNatives ].\r\n\t^natives","function(self)\r\n(function() if ((((((self['@natives']))==nil)))==true) then return ((function()\r\nreturn ((self):initializeNatives())\r\nend))() else return nil end end)()\r\n;\r\nreturn (self['@natives'])\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"platform",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(function() if ((((smalltalk.Smalltalk):includesKey_("OrderedCollection")))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ("VSE")
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ("S8")
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"constants","platform\r\n\t\" Private - Returns the platform selector. \"\r\n\r\n\t(Smalltalk includesKey: #OrderedCollection) ifTrue: [ ^#VSE ].\r\n\t^#S8","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(function() if ((((smalltalk.Smalltalk):includesKey_(\"OrderedCollection\")))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (\"VSE\")\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (\"S8\")\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"tagStart",0
,function(self)
return (" ")
;
end
,"constants","tagStart\r\n\t\" Private - Returns the tag start mask. \"\r\n\r\n\t^' '","function(self)\r\nreturn (\" \")\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"objectFrom:",0
,function(self,aString)
return ((self):unMap_((self):mapFrom_(aString)))
;
end
,"reading","objectFrom: aString\r\n\t\" Returns the next object read from aString literal. \"\r\n\r\n\t^self unMap: (self mapFrom: aString)","function(self,aString)\r\nreturn ((self):unMap_((self):mapFrom_(aString)))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"mapFrom:",0
,function(self,aString)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local parser=nil
(function()
	local _s8_value=(false)
	self['@useJSON']=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((self):triggerEvent_ifNotHandled_("needsParser", (function()
(self):tryJSON_onSuccess_(aString, (function(result)
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)())
end));return (self)
end)))
	parser=_s8_value; return _s8_value
end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((parser):parse_(aString))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","mapFrom: aString\r\n\t\" Private - Returns the map read from aString literal. \"\r\n\r\n\t| parser |\r\n\tuseJSON := false.\r\n\tparser := self triggerEvent: #needsParser ifNotHandled: [\r\n\t\tself tryJSON: aString onSuccess: [:result| ^result ].\r\n\t\tself\r\n\t].\r\n\t^parser parse: aString","function(self,aString)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal parser=nil\r\n(function()\r\n\tlocal _s8_value=(false)\r\n\tself['@useJSON']=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_ifNotHandled_(\"needsParser\", (function()\r\n(self):tryJSON_onSuccess_(aString, (function(result)\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));return (self)\r\nend)))\r\n\tparser=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((parser):parse_(aString))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"initializeNatives",0
,function(self)
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	self['@natives']=_s8_value; return _s8_value
end)()
;
(function() if ((((((self):platform())=="VSE")))==true) then return ((function()
return ((self):initializeVSEAccess())
end))() else return ((function()
return ((self):initializeS8Access())
end))() end end)()
;
return (self)
;
end
,"initialize","initializeNatives\r\n\t\" Private - Initialize the native accessors. \"\r\n\r\n\tnatives := PoolDictionary new.\r\n\tself platform == #VSE\r\n\t\tifTrue: [ self initializeVSEAccess ]\r\n\t\tifFalse: [ self initializeS8Access ]","function(self)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tself['@natives']=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((self):platform())==\"VSE\")))==true) then return ((function()\r\nreturn ((self):initializeVSEAccess())\r\nend))() else return ((function()\r\nreturn ((self):initializeS8Access())\r\nend))() end end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"poolIsObject",0
,function(self)
return ((function(obj)
return ((smalltalk:boolean_or_(((smalltalk:booleanNot_(((obj):isMemberOf_(smalltalk.PoolDictionary))))),(function()
return ((not (smalltalk:isObject_equalTo_(((obj):at_ifAbsent_("objectifier_isObject", (function()
return (nil)
end))),self))))
end))))
end))
;
end
,"natives","poolIsObject\r\n\t\" Private - Returns the native accessor for isObject when using PoolDictionaries. \"\r\n\r\n\t^[:obj|\r\n\t\t(obj isMemberOf: PoolDictionary) not or: [\r\n\t\t\t(obj at: #objectifier_isObject ifAbsent: []) ~= self\r\n\t\t]\r\n\t]","function(self)\r\nreturn ((function(obj)\r\nreturn ((smalltalk:boolean_or_(((smalltalk:booleanNot_(((obj):isMemberOf_(smalltalk.PoolDictionary))))),(function()\r\nreturn ((not (smalltalk:isObject_equalTo_(((obj):at_ifAbsent_(\"objectifier_isObject\", (function()\r\nreturn (nil)\r\nend))),self))))\r\nend))))\r\nend))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"s8IsObject",0
,function(self)
return ((function(obj)
return ((function() if ((((smalltalk:booleanNot_((smalltalk:superImplementor(smalltalk.Objectifier,"isObject_")(self,obj))))))==true) then return ((function()
(self['@natives']):removeKey_("isObject");return (true)
end))() else return ((function()
(self['@natives']):at_put_("isObject", (self):poolIsObject());return (((self):poolIsObject()):value_(obj))
end))() end end)())
end))
;
end
,"natives","s8IsObject\r\n\t\" Private - Returns the native accessor for isObject. \"\r\n\r\n\t^[:obj|\r\n\t\t(super isObject: obj) not ifTrue: [\r\n\t\t\tnatives removeKey: #isObject.\r\n\t\t\ttrue\r\n\t\t] ifFalse: [\r\n\t\t\tnatives at: #isObject put: self poolIsObject.\r\n\t\t\tself poolIsObject value: obj\r\n\t\t]\r\n\t]","function(self)\r\nreturn ((function(obj)\r\nreturn ((function() if ((((smalltalk:booleanNot_((smalltalk:superImplementor(smalltalk.Objectifier,\"isObject_\")(self,obj))))))==true) then return ((function()\r\n(self['@natives']):removeKey_(\"isObject\");return (true)\r\nend))() else return ((function()\r\n(self['@natives']):at_put_(\"isObject\", (self):poolIsObject());return (((self):poolIsObject()):value_(obj))\r\nend))() end end)())\r\nend))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"initializeVSEAccess",0
,function(self)
(
function(_s8_rec)
(_s8_rec):at_put_("get", (function(obj,key)
return ((function() if (((self['@useJSON']))==true) then return ((function()
return (((obj)[key]))
end))() else return ((function()
return ((obj):at_ifAbsent_(key, (function()
return (nil)
end)))
end))() end end)())
end));
(_s8_rec):at_put_("isObject", (self):poolIsObject());
(_s8_rec):at_put_("startsWith", (function(obj,key)
return ((smalltalk:boolean_and_(((((obj):size()) >= (key):size())),(function()
return ((smalltalk:isObject_equalTo_(((obj):copyFrom_to_((1), (key):size())),key)))
end))))
end));
return ((_s8_rec):yourself())
end
)(self['@natives'])
;
return (self)
;
end
,"initialize","initializeVSEAccess\r\n\t\" Private - Initialize the native accessors. \"\r\n\r\n\tnatives\r\n\t\tat: #get put: [:obj :key|\r\n\t\t\tuseJSON\r\n\t\t\tifTrue:  [ obj basicAt: key ]\r\n\t\t\tifFalse: [ obj at: key ifAbsent: [nil] ]\r\n\t\t];\r\n\t\tat: #isObject put: self poolIsObject;\r\n\t\tat: #startsWith put: [:obj :key|\r\n\t\t\tobj size >= key size and: [\r\n\t\t\t\t(obj copyFrom: 1 to: key size) = key\r\n\t\t\t]\r\n\t\t];\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):at_put_(\"get\", (function(obj,key)\r\nreturn ((function() if (((self['@useJSON']))==true) then return ((function()\r\nreturn (((obj)[key]))\r\nend))() else return ((function()\r\nreturn ((obj):at_ifAbsent_(key, (function()\r\nreturn (nil)\r\nend)))\r\nend))() end end)())\r\nend));\r\n(_s8_rec):at_put_(\"isObject\", (self):poolIsObject());\r\n(_s8_rec):at_put_(\"startsWith\", (function(obj,key)\r\nreturn ((smalltalk:boolean_and_(((((obj):size()) >= (key):size())),(function()\r\nreturn ((smalltalk:isObject_equalTo_(((obj):copyFrom_to_((1), (key):size())),key)))\r\nend))))\r\nend));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(self['@natives'])\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"initializeS8Access",0
,function(self)
(
function(_s8_rec)
(_s8_rec):at_put_("get", (function(obj,key)
return ((function() if (((self['@useJSON']))==true) then return ((function()
return (((obj)[key]))
end))() else return ((function()
return ((obj):at_ifAbsent_(key, (function()
return (nil)
end)))
end))() end end)())
end));
(_s8_rec):at_put_("isObject", (self):s8IsObject());
return ((_s8_rec):yourself())
end
)(self['@natives'])
;
return (self)
;
end
,"initialize","initializeS8Access\r\n\t\" Private - Initialize the native accessors. \"\r\n\r\n\tnatives\r\n\t\tat: #get put: [:obj :key|\r\n\t\t\tuseJSON\r\n\t\t\tifTrue:  [ obj basicAt: key ]\r\n\t\t\tifFalse: [ obj at: key ifAbsent: [nil] ]\r\n\t\t];\r\n\t\tat: #isObject put: self s8IsObject;\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):at_put_(\"get\", (function(obj,key)\r\nreturn ((function() if (((self['@useJSON']))==true) then return ((function()\r\nreturn (((obj)[key]))\r\nend))() else return ((function()\r\nreturn ((obj):at_ifAbsent_(key, (function()\r\nreturn (nil)\r\nend)))\r\nend))() end end)())\r\nend));\r\n(_s8_rec):at_put_(\"isObject\", (self):s8IsObject());\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(self['@natives'])\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"value:for:with:",0
,function(self,access,object,argument)
return ((((self):natives()):at_(access)):value_value_(object, argument))
;
end
,"natives","value: access for: object with: argument\r\n\t\" Private - Returns the value of access the (native)object with argument. \"\r\n\r\n\t^(self natives at: access) value: object value: argument","function(self,access,object,argument)\r\nreturn ((((self):natives()):at_(access)):value_value_(object, argument))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"readStream:",0
,function(self,source)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local support=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_("ReadStream", (function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((source):stream())
end
)()
error(_s8Ret_,0)
end)())
end)))
	support=_s8_value; return _s8_value
end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((support):on_(source))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"natives","readStream: source\r\n\t\" Private - Returns a read stream on source. \"\r\n\r\n\t| support |\r\n\tsupport := Smalltalk at: #ReadStream ifAbsent: [ ^source stream ].\r\n\t^support on: source","function(self,source)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal support=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(\"ReadStream\", (function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((source):stream())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tsupport=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((support):on_(source))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"writeStreamOn:",0
,function(self,container)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local support=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_("WriteStream", (function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((container):writeStream())
end
)()
error(_s8Ret_,0)
end)())
end)))
	support=_s8_value; return _s8_value
end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((support):on_(container))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"natives","writeStreamOn: container\r\n\t\" Private - Returns a write stream on container. \"\r\n\r\n\t| support |\r\n\tsupport := Smalltalk at: #WriteStream ifAbsent: [ ^container writeStream ].\r\n\t^support on: container","function(self,container)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal support=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(\"WriteStream\", (function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((container):writeStream())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tsupport=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((support):on_(container))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"isObject:",0
,function(self,object)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local block=nil
(function()
	local _s8_value=(((self):natives()):at_ifAbsent_("isObject", (function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:superImplementor(smalltalk.Objectifier,"isObject_")(self,object))
end
)()
error(_s8Ret_,0)
end)())
end)))
	block=_s8_value; return _s8_value
end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((block):value_(object))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"natives","isObject: object\r\n\t\" Private - Returns true if object is a (non-native)object. \"\r\n\r\n\t| block |\r\n\tblock := self natives at: #isObject ifAbsent: [ ^super isObject: object ].\r\n\t^block value: object","function(self,object)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal block=nil\r\n(function()\r\n\tlocal _s8_value=(((self):natives()):at_ifAbsent_(\"isObject\", (function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:superImplementor(smalltalk.Objectifier,\"isObject_\")(self,object))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tblock=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((block):value_(object))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"starts:with:",0
,function(self,string,key)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local block=nil
(function()
	local _s8_value=(((self):natives()):at_ifAbsent_("startsWith", (function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((string):startsWith_(key))
end
)()
error(_s8Ret_,0)
end)())
end)))
	block=_s8_value; return _s8_value
end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((block):value_value_(string, key))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"natives","starts: string with: key\r\n\t\" Private - Returns true if string starts with key. \"\r\n\r\n\t| block |\r\n\tblock := self natives at: #startsWith ifAbsent: [ ^string startsWith: key ].\r\n\t^block value: string value: key","function(self,string,key)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal block=nil\r\n(function()\r\n\tlocal _s8_value=(((self):natives()):at_ifAbsent_(\"startsWith\", (function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((string):startsWith_(key))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tblock=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((block):value_value_(string, key))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"basic:at:",0
,function(self,object,key)
return ((self):value_for_with_("get", object, key))
;
end
,"natives","basic: object at: key\r\n\t\" Private - Returns the result of indexing the (native)object with a key. \"\r\n\r\n\t^self value: #get for: object with: key","function(self,object,key)\r\nreturn ((self):value_for_with_(\"get\", object, key))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"tryJSON:onSuccess:",0
,function(self,aString,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local json=nil
local result=nil
(function() if (((smalltalk:responds_to_((smalltalk.Smalltalk),("jsObjectAt:ifAbsent:"))))==true) then return ((function()
return ((function()
	local _s8_value=((smalltalk.Smalltalk):jsObjectAt_ifAbsent_("JSON", (function()
return (nil)
end)))
	json=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((json))~=nil)))==true) then return ((function()
(function()
	local _s8_value=(true)
	self['@useJSON']=_s8_value; return _s8_value
end)();(function()
	local _s8_value=(((self):basic_at_(json, "parse")):value_(aString))
	result=_s8_value; return _s8_value
end)();return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value_(result))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","tryJSON: aString onSuccess: aBlock\r\n\t\" Private - Try to read a map from aString literal using JSON support.\r\n\tEvaluates aBlock on success.\r\n\t\"\r\n\r\n\t| json result |\r\n\t(Smalltalk respondsTo: #jsObjectAt:ifAbsent:) ifTrue: [\r\n\t\tjson := Smalltalk jsObjectAt: #JSON ifAbsent: []\r\n\t].\r\n\tjson notNil ifTrue: [\r\n\t\tuseJSON := true.\r\n\t\tresult := (self basic: json at: #parse) value: aString.\r\n\t\t^aBlock value: result\r\n\t].\r\n\t^nil","function(self,aString,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal json=nil\r\nlocal result=nil\r\n(function() if (((smalltalk:responds_to_((smalltalk.Smalltalk),(\"jsObjectAt:ifAbsent:\"))))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):jsObjectAt_ifAbsent_(\"JSON\", (function()\r\nreturn (nil)\r\nend)))\r\n\tjson=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((json))~=nil)))==true) then return ((function()\r\n(function()\r\n\tlocal _s8_value=(true)\r\n\tself['@useJSON']=_s8_value; return _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=(((self):basic_at_(json, \"parse\")):value_(aString))\r\n\tresult=_s8_value; return _s8_value\r\nend)();return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value_(result))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"names",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(function() if ((((((self['@names']))~=nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self['@names'])
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	self['@names']=_s8_value; return _s8_value
end)()
;
(function() if ((((((self):platform())=="VSE")))==true) then return ((function()
return ((self):setDefaultVSENames())
end))() else return ((function()
return ((self):setDefaultS8Names())
end))() end end)()
;
(self):triggerEvent_withArguments_("getNames:from:", (smalltalk.Array):with_with_(self['@names'], self['@origin']))
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self['@names'])
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"names","names\r\n\t\" Private - Returns the well known names map. \"\r\n\r\n\tnames notNil ifTrue: [ ^names ].\r\n\tnames := PoolDictionary new.\r\n\tself platform == #VSE\r\n\t\tifTrue: [ self setDefaultVSENames ]\r\n\t\tifFalse: [ self setDefaultS8Names ].\r\n\tself\ttriggerEvent: #getNames:from:\r\n\t\twithArguments: (Array with: names with: origin).\r\n\t^names","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(function() if ((((((self['@names']))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self['@names'])\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tself['@names']=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((self):platform())==\"VSE\")))==true) then return ((function()\r\nreturn ((self):setDefaultVSENames())\r\nend))() else return ((function()\r\nreturn ((self):setDefaultS8Names())\r\nend))() end end)()\r\n;\r\n(self):triggerEvent_withArguments_(\"getNames:from:\", (smalltalk.Array):with_with_(self['@names'], self['@origin']))\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self['@names'])\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"setDefaultS8Names",0
,function(self)
(
function(_s8_rec)
(_s8_rec):at_put_("OrderedCollection", "Array");
(_s8_rec):at_put_("Set", "HashedSet");
(_s8_rec):at_put_("Character", (function(json)
return ((self):instantiateCharacter_(json))
end));
(_s8_rec):at_put_("TimeStamp", "DateTime");
return ((_s8_rec):yourself())
end
)(self['@names'])
;
return (self)
;
end
,"initialize","setDefaultS8Names\r\n\t\" Private - Register well known names used for instantiation mappings. \"\r\n\r\n\tnames\tat: #OrderedCollection put: #Array;\r\n\t\tat: #Set put: #HashedSet;\r\n\t\tat: #Character put: [:json| self instantiateCharacter: json ];\r\n\t\tat: #TimeStamp put: #DateTime;\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):at_put_(\"OrderedCollection\", \"Array\");\r\n(_s8_rec):at_put_(\"Set\", \"HashedSet\");\r\n(_s8_rec):at_put_(\"Character\", (function(json)\r\nreturn ((self):instantiateCharacter_(json))\r\nend));\r\n(_s8_rec):at_put_(\"TimeStamp\", \"DateTime\");\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(self['@names'])\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"setDefaultVSENames",0
,function(self)
(
function(_s8_rec)
(_s8_rec):at_put_("DateTime", "TimeStamp");
return ((_s8_rec):yourself())
end
)(self['@names'])
;
return (self)
;
end
,"initialize","setDefaultVSENames\r\n\t\" Private - Register well known names used for instantiation mappings. \"\r\n\r\n\tnames\tat: #DateTime put: #TimeStamp;\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):at_put_(\"DateTime\", \"TimeStamp\");\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(self['@names'])\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"transforms",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(function() if ((((((self['@transforms']))~=nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self['@transforms'])
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	self['@transforms']=_s8_value; return _s8_value
end)()
;
(function() if ((((((self):platform())=="VSE")))==true) then return ((function()
return ((self):setDefaultVSETransforms())
end))() else return ((function()
return ((self):setDefaultS8Transforms())
end))() end end)()
;
(self):triggerEvent_("getTransforms")
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self['@transforms'])
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"transforms","transforms\r\n\t\" Private - Returns the transforms used to fill concrete instances from structure. \"\r\n\r\n\ttransforms notNil ifTrue: [ ^transforms ].\r\n\ttransforms := PoolDictionary new.\r\n\tself platform == #VSE\r\n\t\tifTrue: [ self setDefaultVSETransforms ]\r\n\t\tifFalse: [ self setDefaultS8Transforms ].\r\n\tself triggerEvent: #getTransforms.\r\n\t^transforms","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(function() if ((((((self['@transforms']))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self['@transforms'])\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tself['@transforms']=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((self):platform())==\"VSE\")))==true) then return ((function()\r\nreturn ((self):setDefaultVSETransforms())\r\nend))() else return ((function()\r\nreturn ((self):setDefaultS8Transforms())\r\nend))() end end)()\r\n;\r\n(self):triggerEvent_(\"getTransforms\")\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self['@transforms'])\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"setDefaultS8Transforms",0
,function(self)
local dateTimeSupport=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):at_("DateTime"))
	dateTimeSupport=_s8_value; return _s8_value
end)()
;
(
function(_s8_rec)
(_s8_rec):at_put_("Array", (function(oid,object,json,varNames)
local contents=nil
(function()
	local _s8_value=((self):basic_at_(json, "contents"))
	contents=_s8_value; return _s8_value
end)();(function() if ((((((contents))==nil)))==true) then return ((function()
return ((self):error_("Missing Array contents"))
end))() else return nil end end)();return (((1)):to_do_((contents):size(), (function(i)
return ((object):at_put_(i, (self):object_((contents):at_(i))))
end)))
end));
(_s8_rec):at_put_("String", (function(oid,object,json,varNames)
return (nil)
end));
(_s8_rec):at_put_("HashedSet", (function(oid,object,json,varNames)
return ((object):initialize_((self):object_((self):basic_at_(json, "contents"))))
end));
(_s8_rec):at_put_("DateTime", (function(oid,object,json,varNames)
return ((self):id_is_(oid, (dateTimeSupport):fromString_((self):basic_at_(json, "contents"))))
end));
return ((_s8_rec):yourself())
end
)(self['@transforms'])
;
return (self)
;
end
,"initialize","setDefaultS8Transforms\r\n\t\" Private - Register default transforms to fill instances from structures. \"\r\n\r\n\t| dateTimeSupport |\r\n\tdateTimeSupport := Smalltalk at: #DateTime.\r\n\ttransforms\r\n\t\tat: #Array put: [:oid :object :json :varNames | | contents |\r\n\t\t\tcontents := self basic: json at: #contents.\r\n\t\t\tcontents isNil ifTrue: [ self error: 'Missing Array contents' ].\r\n\t\t\t1 to: contents size do: [:i|\r\n\t\t\t\tobject at: i put: (self object: (contents at: i))\r\n\t\t\t].\r\n\t\t];\r\n\t\tat: #String put: [:oid :object :json :varNames | \"nothing to do\" ];\r\n\t\tat: #HashedSet put: [:oid :object :json :varNames |\r\n\t\t\tobject initialize: (self object: (self basic: json at: #contents))\r\n\t\t];\r\n\t\tat: #DateTime put: [:oid :object :json :varNames |\r\n\t\t\tself id: oid is: (dateTimeSupport fromString: (self basic: json at: #contents))\r\n\t\t];\r\n\t\tyourself","function(self)\r\nlocal dateTimeSupport=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_(\"DateTime\"))\r\n\tdateTimeSupport=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):at_put_(\"Array\", (function(oid,object,json,varNames)\r\nlocal contents=nil\r\n(function()\r\n\tlocal _s8_value=((self):basic_at_(json, \"contents\"))\r\n\tcontents=_s8_value; return _s8_value\r\nend)();(function() if ((((((contents))==nil)))==true) then return ((function()\r\nreturn ((self):error_(\"Missing Array contents\"))\r\nend))() else return nil end end)();return (((1)):to_do_((contents):size(), (function(i)\r\nreturn ((object):at_put_(i, (self):object_((contents):at_(i))))\r\nend)))\r\nend));\r\n(_s8_rec):at_put_(\"String\", (function(oid,object,json,varNames)\r\nreturn (nil)\r\nend));\r\n(_s8_rec):at_put_(\"HashedSet\", (function(oid,object,json,varNames)\r\nreturn ((object):initialize_((self):object_((self):basic_at_(json, \"contents\"))))\r\nend));\r\n(_s8_rec):at_put_(\"DateTime\", (function(oid,object,json,varNames)\r\nreturn ((self):id_is_(oid, (dateTimeSupport):fromString_((self):basic_at_(json, \"contents\"))))\r\nend));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(self['@transforms'])\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"setDefaultVSETransforms",0
,function(self)
(
function(_s8_rec)
(_s8_rec):at_put_("Array", (function(oid,proto,json,varNames)
local object=nil
local contents=nil
(function()
	local _s8_value=((self):basic_at_(json, "contents"))
	contents=_s8_value; return _s8_value
end)();(function() if ((((((contents))==nil)))==true) then return ((function()
return ((self):error_("Missing Array contents"))
end))() else return nil end end)();(function()
	local _s8_value=((smalltalk.Array):new_((contents):size()))
	object=_s8_value; return _s8_value
end)();(self):id_is_(oid, object);return (((1)):to_do_((contents):size(), (function(i)
return ((object):at_put_(i, (self):object_((contents):at_(i))))
end)))
end));
(_s8_rec):at_put_("Set", (function(oid,object,json,varNames)
return ((object):addAll_((self):object_((self):basic_at_(json, "contents"))))
end));
(_s8_rec):at_put_("PoolDictionary", (function(oid,object,json,varNames)
return (((self):object_((self):basic_at_(json, "associations"))):do_((function(assoc)
return ((object):at_put_((assoc):key(), (assoc):value()))
end)))
end));
(_s8_rec):at_put_("TimeStamp", (function(oid,object,json,varNames)
return ((self):timeStamp_from_(object, (self):basic_at_(json, "contents")))
end));
return ((_s8_rec):yourself())
end
)(self['@transforms'])
;
return (self)
;
end
,"initialize","setDefaultVSETransforms\r\n\t\" Private - Register default transforms to fill instances from structures. \"\r\n\r\n\ttransforms\r\n\t\tat: #Array put: [:oid :proto :json :varNames | | object contents |\r\n\t\t\tcontents := self basic: json at: #contents.\r\n\t\t\tcontents isNil ifTrue: [ self error: 'Missing Array contents' ].\r\n\t\t\tobject := Array new: contents size.\r\n\t\t\tself id: oid is: object.\r\n\t\t\t1 to: contents size do: [:i|\r\n\t\t\t\tobject at: i put: (self object: (contents at: i))\r\n\t\t\t].\r\n\t\t];\r\n\t\tat: #Set put: [:oid :object :json :varNames |\r\n\t\t\tobject addAll: (self object: (self basic: json at: #contents))\r\n\t\t];\r\n\t\tat: #PoolDictionary put: [:oid :object :json :varNames |\r\n\t\t\t(self object: (self basic: json at: #associations)) do: [:assoc|\r\n\t\t\t\tobject at: assoc key put: assoc value\r\n\t\t\t]\r\n\t\t];\r\n\t\tat: #TimeStamp put: [:oid :object :json :varNames |\r\n\t\t\tself timeStamp: object from: (self basic: json at: #contents)\r\n\t\t];\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):at_put_(\"Array\", (function(oid,proto,json,varNames)\r\nlocal object=nil\r\nlocal contents=nil\r\n(function()\r\n\tlocal _s8_value=((self):basic_at_(json, \"contents\"))\r\n\tcontents=_s8_value; return _s8_value\r\nend)();(function() if ((((((contents))==nil)))==true) then return ((function()\r\nreturn ((self):error_(\"Missing Array contents\"))\r\nend))() else return nil end end)();(function()\r\n\tlocal _s8_value=((smalltalk.Array):new_((contents):size()))\r\n\tobject=_s8_value; return _s8_value\r\nend)();(self):id_is_(oid, object);return (((1)):to_do_((contents):size(), (function(i)\r\nreturn ((object):at_put_(i, (self):object_((contents):at_(i))))\r\nend)))\r\nend));\r\n(_s8_rec):at_put_(\"Set\", (function(oid,object,json,varNames)\r\nreturn ((object):addAll_((self):object_((self):basic_at_(json, \"contents\"))))\r\nend));\r\n(_s8_rec):at_put_(\"PoolDictionary\", (function(oid,object,json,varNames)\r\nreturn (((self):object_((self):basic_at_(json, \"associations\"))):do_((function(assoc)\r\nreturn ((object):at_put_((assoc):key(), (assoc):value()))\r\nend)))\r\nend));\r\n(_s8_rec):at_put_(\"TimeStamp\", (function(oid,object,json,varNames)\r\nreturn ((self):timeStamp_from_(object, (self):basic_at_(json, \"contents\")))\r\nend));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(self['@transforms'])\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"timeStamp:from:",0
,function(self,ts,contents)
local aStream=nil
local yyyy=nil
local mm=nil
local dd=nil
local hh=nil
local ss=nil
(function()
	local _s8_value=((contents):asStream())
	aStream=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((aStream):upTo_("/"))
	yyyy=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((aStream):upTo_("/"))
	mm=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((aStream):upTo_(" "))
	dd=_s8_value; return _s8_value
end)()
;
(ts):date_((smalltalk.Date):fromString_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((dd),"-")),mm)),"-")),yyyy)))
;
(function()
	local _s8_value=(((aStream):upTo_(":")):asInteger())
	hh=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=(((aStream):upTo_(":")):asInteger())
	mm=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=(((aStream):upTo_(nil)):asInteger())
	ss=_s8_value; return _s8_value
end)()
;
(ts):time_((smalltalk.Time):hours_minutes_seconds_(hh, mm, ss))
;
return (self)
;
end
,"converting","timeStamp: ts from: contents\r\n\t\" Private - Read a TimeStamp instance from contents. \"\r\n\r\n\t| aStream yyyy mm dd hh ss |\r\n\taStream := contents asStream.\r\n\tyyyy := aStream upTo: $/.\r\n\tmm := aStream upTo: $/.\r\n\tdd := aStream upTo: $ .\r\n\tts date: (Date fromString: dd ,'-' ,mm ,'-' ,yyyy).\r\n\thh := (aStream upTo: $:) asInteger.\r\n\tmm := (aStream upTo: $:) asInteger.\r\n\tss := (aStream upTo: nil) asInteger.\r\n\tts time: (Time hours: hh minutes: mm seconds: ss)","function(self,ts,contents)\r\nlocal aStream=nil\r\nlocal yyyy=nil\r\nlocal mm=nil\r\nlocal dd=nil\r\nlocal hh=nil\r\nlocal ss=nil\r\n(function()\r\n\tlocal _s8_value=((contents):asStream())\r\n\taStream=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((aStream):upTo_(\"/\"))\r\n\tyyyy=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((aStream):upTo_(\"/\"))\r\n\tmm=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((aStream):upTo_(\" \"))\r\n\tdd=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(ts):date_((smalltalk.Date):fromString_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((dd),\"-\")),mm)),\"-\")),yyyy)))\r\n;\r\n(function()\r\n\tlocal _s8_value=(((aStream):upTo_(\":\")):asInteger())\r\n\thh=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=(((aStream):upTo_(\":\")):asInteger())\r\n\tmm=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=(((aStream):upTo_(nil)):asInteger())\r\n\tss=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(ts):time_((smalltalk.Time):hours_minutes_seconds_(hh, mm, ss))\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"shapeValidatingTransform",0
,function(self)
return ((function(oid,object,json,varNames)
local transform=nil
(self):validateClass_shape_((object)["$klass"], varNames);(function()
	local _s8_value=((self['@transforms']):at_ifAbsent_(((object)["$klass"]):name(), (function()
return ((self):error_("Invalid shape"))
end)))
	transform=_s8_value; return _s8_value
end)();return ((transform):valueWithArguments_((smalltalk.Array):with_with_with_with_(oid, object, json, varNames)))
end))
;
end
,"transforms","shapeValidatingTransform\r\n\t\" Private - Returns the transform to apply to fill instances from structures, validating class shape. \"\r\n\r\n\t^[:oid :object :json :varNames | | transform |\r\n\t\tself validateClass: object class shape: varNames.\r\n\t\ttransform := transforms at: object class name ifAbsent: [\r\n\t\t\tself error: 'Invalid shape'\r\n\t\t].\r\n\t\ttransform valueWithArguments: (Array\r\n\t\t\twith: oid with: object\r\n\t\t\twith: json with: varNames)\r\n\t]","function(self)\r\nreturn ((function(oid,object,json,varNames)\r\nlocal transform=nil\r\n(self):validateClass_shape_((object)[\"$klass\"], varNames);(function()\r\n\tlocal _s8_value=((self['@transforms']):at_ifAbsent_(((object)[\"$klass\"]):name(), (function()\r\nreturn ((self):error_(\"Invalid shape\"))\r\nend)))\r\n\ttransform=_s8_value; return _s8_value\r\nend)();return ((transform):valueWithArguments_((smalltalk.Array):with_with_with_with_(oid, object, json, varNames)))\r\nend))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"copyTransform",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(function() if ((((((self):platform())=="VSE")))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):copyTransformVSE())
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):copyTransformS8())
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"transforms","copyTransform\r\n\t\" Private - Returns the transform to apply to fill instances from structures. \"\r\n\r\n\tself platform == #VSE ifTrue: [ ^self copyTransformVSE ].\r\n\t^self copyTransformS8","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(function() if ((((((self):platform())==\"VSE\")))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):copyTransformVSE())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):copyTransformS8())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"copyTransformS8",0
,function(self)
return ((function(oid,object,json,varNames)
return (((1)):to_do_((varNames):size(), (function(i)
local key=nil
local value=nil
(function()
	local _s8_value=((varNames):at_(i))
	key=_s8_value; return _s8_value
end)();(function()
	local _s8_value=((self):object_((self):basic_at_(json, smalltalk:toString_((i)))))
	value=_s8_value; return _s8_value
end)();return ((object):instVarAt_put_(key, value))
end)))
end))
;
end
,"transforms","copyTransformS8\r\n\t\" Private - Returns the transform to apply to fill instances from structures. \"\r\n\r\n\t^[:oid :object :json :varNames |\r\n\t\t1 to: varNames size do: [:i| | key value |\r\n\t\t\tkey := varNames at: i.\r\n\t\t\tvalue := self object: (self basic: json at: i toString).\r\n\t\t\tobject instVarAt: key put: value\r\n\t\t]\r\n\t]","function(self)\r\nreturn ((function(oid,object,json,varNames)\r\nreturn (((1)):to_do_((varNames):size(), (function(i)\r\nlocal key=nil\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=((varNames):at_(i))\r\n\tkey=_s8_value; return _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):object_((self):basic_at_(json, smalltalk:toString_((i)))))\r\n\tvalue=_s8_value; return _s8_value\r\nend)();return ((object):instVarAt_put_(key, value))\r\nend)))\r\nend))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"copyTransformVSE",0
,function(self)
return ((function(oid,object,json,varNames)
local all=nil
(function()
	local _s8_value=(((object)["$klass"]):allInstVarNames())
	all=_s8_value; return _s8_value
end)();return (((1)):to_do_((all):size(), (function(i)
local key=nil
local index=nil
local value=nil
(function()
	local _s8_value=((all):at_(i))
	key=_s8_value; return _s8_value
end)();(function()
	local _s8_value=((varNames):indexOf_(key))
	index=_s8_value; return _s8_value
end)();return ((function() if (((((index) > (0))))==true) then return ((function()
(function()
	local _s8_value=((self):object_((self):basic_at_(json, index)))
	value=_s8_value; return _s8_value
end)();return ((object):instVarAt_put_(i, value))
end))() else return nil end end)())
end)))
end))
;
end
,"transforms","copyTransformVSE\r\n\t\" Private - Returns the transform to apply to fill instances from structures. \"\r\n\r\n\t^[:oid :object :json :varNames | | all |\r\n\t\tall := object class allInstVarNames.\r\n\t\t1 to: all size do: [:i| | key index value |\r\n\t\t\tkey := all at: i.\r\n\t\t\tindex := varNames indexOf: key.\r\n\t\t\tindex > 0 ifTrue: [\r\n\t\t\t\tvalue := self object: (self basic: json at: index).\r\n\t\t\t\tobject instVarAt: i put: value\r\n\t\t\t].\r\n\t\t].\r\n\t]","function(self)\r\nreturn ((function(oid,object,json,varNames)\r\nlocal all=nil\r\n(function()\r\n\tlocal _s8_value=(((object)[\"$klass\"]):allInstVarNames())\r\n\tall=_s8_value; return _s8_value\r\nend)();return (((1)):to_do_((all):size(), (function(i)\r\nlocal key=nil\r\nlocal index=nil\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=((all):at_(i))\r\n\tkey=_s8_value; return _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((varNames):indexOf_(key))\r\n\tindex=_s8_value; return _s8_value\r\nend)();return ((function() if (((((index) > (0))))==true) then return ((function()\r\n(function()\r\n\tlocal _s8_value=((self):object_((self):basic_at_(json, index)))\r\n\tvalue=_s8_value; return _s8_value\r\nend)();return ((object):instVarAt_put_(i, value))\r\nend))() else return nil end end)())\r\nend)))\r\nend))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"validateClass:shape:",0
,function(self,aClass,varNames)
local all=nil
local missing=nil
(function() if ((((((varNames))~=nil)))==true) then return ((function()
(function()
	local _s8_value=((aClass):allInstVarNames())
	all=_s8_value; return _s8_value
end)();return ((function() if ((((smalltalk:boolean_or_(((all):notEmpty()),(function()
return ((((varNames):size()) > (0)))
end)))))==true) then return ((function()
(function()
	local _s8_value=((all):reject_((function(each)
return ((varNames):includes_(each))
end)))
	missing=_s8_value; return _s8_value
end)();(function() if ((((missing):notEmpty()))==true) then return ((function()
return ((self):triggerEvent_withArguments_ifNotHandled_("adapt:shape:", (smalltalk.Array):with_with_(aClass, varNames), (function()
return ((self):error_(smalltalk:object_comma_(("Missing class variables "),smalltalk:asString_((missing)))))
end)))
end))() else return nil end end)();(function()
	local _s8_value=((varNames):reject_((function(each)
return ((all):includes_(each))
end)))
	missing=_s8_value; return _s8_value
end)();return ((function() if ((((missing):notEmpty()))==true) then return ((function()
return ((self):triggerEvent_withArguments_ifNotHandled_("adapt:shape:", (smalltalk.Array):with_with_(aClass, varNames), (function()
return ((self):error_(smalltalk:object_comma_(("Missing structure variables "),smalltalk:asString_((missing)))))
end)))
end))() else return nil end end)())
end))() else return nil end end)())
end))() else return nil end end)()
;
(self['@transforms']):at_put_((aClass):name(), (self):copyTransform())
;
return (self)
;
end
,"validation","validateClass: aClass shape: varNames\r\n\t\" Private - Validate shape of aClass to be mapped to varNames. \"\r\n\r\n\t| all missing |\r\n\tvarNames notNil ifTrue: [\r\n\t\tall := aClass allInstVarNames.\r\n\t\t(all notEmpty or: [varNames size > 0]) ifTrue: [\r\n\t\t\tmissing := all reject: [:each| varNames includes: each ].\r\n\t\t\tmissing notEmpty ifTrue: [\r\n\t\t\t\tself\ttriggerEvent: #adapt:shape:\r\n\t\t\t\t\twithArguments: (Array with: aClass with: varNames)\r\n\t\t\t\t\tifNotHandled: [ self error: 'Missing class variables ' ,missing asString ]\r\n\t\t\t].\r\n\t\t\tmissing := varNames reject: [:each| all includes: each ].\r\n\t\t\tmissing notEmpty ifTrue: [\r\n\t\t\t\tself\ttriggerEvent: #adapt:shape:\r\n\t\t\t\t\twithArguments: (Array with: aClass with: varNames)\r\n\t\t\t\t\tifNotHandled: [ self error: 'Missing structure variables ' ,missing asString ]\r\n\t\t\t].\r\n\t\t].\r\n\t].\r\n\ttransforms at: aClass name put: self copyTransform","function(self,aClass,varNames)\r\nlocal all=nil\r\nlocal missing=nil\r\n(function() if ((((((varNames))~=nil)))==true) then return ((function()\r\n(function()\r\n\tlocal _s8_value=((aClass):allInstVarNames())\r\n\tall=_s8_value; return _s8_value\r\nend)();return ((function() if ((((smalltalk:boolean_or_(((all):notEmpty()),(function()\r\nreturn ((((varNames):size()) > (0)))\r\nend)))))==true) then return ((function()\r\n(function()\r\n\tlocal _s8_value=((all):reject_((function(each)\r\nreturn ((varNames):includes_(each))\r\nend)))\r\n\tmissing=_s8_value; return _s8_value\r\nend)();(function() if ((((missing):notEmpty()))==true) then return ((function()\r\nreturn ((self):triggerEvent_withArguments_ifNotHandled_(\"adapt:shape:\", (smalltalk.Array):with_with_(aClass, varNames), (function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing class variables \"),smalltalk:asString_((missing)))))\r\nend)))\r\nend))() else return nil end end)();(function()\r\n\tlocal _s8_value=((varNames):reject_((function(each)\r\nreturn ((all):includes_(each))\r\nend)))\r\n\tmissing=_s8_value; return _s8_value\r\nend)();return ((function() if ((((missing):notEmpty()))==true) then return ((function()\r\nreturn ((self):triggerEvent_withArguments_ifNotHandled_(\"adapt:shape:\", (smalltalk.Array):with_with_(aClass, varNames), (function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing structure variables \"),smalltalk:asString_((missing)))))\r\nend)))\r\nend))() else return nil end end)())\r\nend))() else return nil end end)())\r\nend))() else return nil end end)()\r\n;\r\n(self['@transforms']):at_put_((aClass):name(), (self):copyTransform())\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"unMap:",0
,function(self,aMap)
local sender=nil
(function()
	local _s8_value=((self):basic_at_(aMap, "origin"))
	sender=_s8_value; return _s8_value
end)()
;
(function() if ((((((sender))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=((sender):asSymbol())
	sender=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((self['@origin']))~=nil)))==true) then return ((function()
return ((function() if ((((smalltalk:isObject_equalTo_((self['@origin']),sender))))==true) then return nil else return ((function()
return ((self):error_("Invalid origin"))
end))() end end)())
end))() else return ((function()
return ((function()
	local _s8_value=(sender)
	self['@origin']=_s8_value; return _s8_value
end)())
end))() end end)()
;
(function() if ((((((self['@objects']))==nil)))==true) then return ((function()
local count=nil
(function()
	local _s8_value=((self):basic_at_(aMap, "id"))
	count=_s8_value; return _s8_value
end)();(function()
	local _s8_value=((smalltalk.Array):new_(count))
	self['@objects']=_s8_value; return _s8_value
end)();return ((self['@objects']):atAllPut_("missing"))
end))() else return nil end end)()
;
return ((self):object_((self):basic_at_(aMap, "contents")))
;
end
,"converting","unMap: aMap\r\n\t\" Private - Returns the object instantiated from aMap. \"\r\n\r\n\t| sender |\r\n\tsender := self basic: aMap at: #origin.\r\n\tsender notNil ifTrue: [ sender := sender asSymbol ].\r\n\torigin notNil ifTrue: [\r\n\t\torigin = sender ifFalse: [ self error: 'Invalid origin' ]\r\n\t] ifFalse: [ origin := sender ].\r\n\tobjects isNil ifTrue: [ | count |\r\n\t\tcount := self basic: aMap at: #id.\r\n\t\tobjects := Array new: count.\r\n\t\tobjects atAllPut: #missing.\r\n\t].\r\n\t^self object: (self basic: aMap at: #contents)","function(self,aMap)\r\nlocal sender=nil\r\n(function()\r\n\tlocal _s8_value=((self):basic_at_(aMap, \"origin\"))\r\n\tsender=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((sender))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=((sender):asSymbol())\r\n\tsender=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((self['@origin']))~=nil)))==true) then return ((function()\r\nreturn ((function() if ((((smalltalk:isObject_equalTo_((self['@origin']),sender))))==true) then return nil else return ((function()\r\nreturn ((self):error_(\"Invalid origin\"))\r\nend))() end end)())\r\nend))() else return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(sender)\r\n\tself['@origin']=_s8_value; return _s8_value\r\nend)())\r\nend))() end end)()\r\n;\r\n(function() if ((((((self['@objects']))==nil)))==true) then return ((function()\r\nlocal count=nil\r\n(function()\r\n\tlocal _s8_value=((self):basic_at_(aMap, \"id\"))\r\n\tcount=_s8_value; return _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((smalltalk.Array):new_(count))\r\n\tself['@objects']=_s8_value; return _s8_value\r\nend)();return ((self['@objects']):atAllPut_(\"missing\"))\r\nend))() else return nil end end)()\r\n;\r\nreturn ((self):object_((self):basic_at_(aMap, \"contents\")))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"withRef:do:",0
,function(self,json,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(function() if ((((smalltalk:boolean_and_(((self):isObject_(json)),(function()
return ((json):isString())
end)))))==true) then return ((function()
return ((function() if ((((self):starts_with_(json, (self):tagStart())))==true) then return ((function()
local refID=nil
(function()
	local _s8_value=((json):copyFrom_to_((((self):tagStart()):size()):_plus((1)), (json):size()))
	refID=_s8_value; return _s8_value
end)();return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):value_((self):ref_(refID)))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (json)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"references","withRef: json do: aBlock\r\n\t\" Private - Returns the result of evaluating aBlock with reference to known object (or json). \"\r\n\r\n\t((self isObject: json) and: [json isString]) ifTrue: [\r\n\t\t(self starts: json with: self tagStart) ifTrue: [ | refID |\r\n\t\t\trefID := json copyFrom: self tagStart size + 1 to: json size.\r\n\t\t\t^aBlock value: (self ref: refID)\r\n\t\t].\r\n\t].\r\n\t^json","function(self,json,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(function() if ((((smalltalk:boolean_and_(((self):isObject_(json)),(function()\r\nreturn ((json):isString())\r\nend)))))==true) then return ((function()\r\nreturn ((function() if ((((self):starts_with_(json, (self):tagStart())))==true) then return ((function()\r\nlocal refID=nil\r\n(function()\r\n\tlocal _s8_value=((json):copyFrom_to_((((self):tagStart()):size()):_plus((1)), (json):size()))\r\n\trefID=_s8_value; return _s8_value\r\nend)();return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):value_((self):ref_(refID)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (json)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"object:",0
,function(self,json)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(function() if ((((((json))==nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((self):isObject_(json)))==true) then return nil else return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):newObject_(json))
end
)()
error(_s8Ret_,0)
end)())
end))() end end)()
;
(function() if ((((json):isArray()))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((json):collect_((function(each)
return ((self):object_(each))
end)))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):withRef_do_(json, (function(anObject)
return (anObject)
end)))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"converting","object: json\r\n\t\" Private - Returns the object instantiated from json. \"\r\n\r\n\tjson isNil ifTrue: [ ^nil ].\r\n\t(self isObject: json) ifFalse: [ ^self newObject: json ].\r\n\tjson isArray ifTrue: [ ^json collect: [:each| self object: each ] ].\r\n\t^self withRef: json do: [:anObject| anObject ]","function(self,json)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(function() if ((((((json))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((self):isObject_(json)))==true) then return nil else return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):newObject_(json))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() end end)()\r\n;\r\n(function() if ((((json):isArray()))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((json):collect_((function(each)\r\nreturn ((self):object_(each))\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):withRef_do_(json, (function(anObject)\r\nreturn (anObject)\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"instantiate:with:allInstVarNames:",0
,function(self,instantiator,json,varNames)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(function() if (((smalltalk:is_kindOf_((instantiator),(smalltalk.Behavior))))==true) then return nil else return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((instantiator):value_(json))
end
)()
error(_s8Ret_,0)
end)())
end))() end end)()
;
(function() if ((((instantiator):inheritsFrom_(smalltalk.Collection)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((instantiator):new())
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((instantiator):isClass()))==true) then return nil else return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_("Must be a class"))
end
)()
error(_s8Ret_,0)
end)())
end))() end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((instantiator):basicNew())
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"instantiating","instantiate: instantiator with: json allInstVarNames: varNames\r\n\t\" Private - Returns a new instance from json. \"\r\n\r\n\t(instantiator isKindOf: Behavior) ifFalse: [ ^instantiator value: json ].\r\n\t(instantiator inheritsFrom: Collection) ifTrue: [ ^instantiator new ].\r\n\tinstantiator isClass ifFalse: [ ^self error: 'Must be a class' ].\r\n\t^instantiator basicNew ","function(self,instantiator,json,varNames)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(function() if (((smalltalk:is_kindOf_((instantiator),(smalltalk.Behavior))))==true) then return nil else return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((instantiator):value_(json))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() end end)()\r\n;\r\n(function() if ((((instantiator):inheritsFrom_(smalltalk.Collection)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((instantiator):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((instantiator):isClass()))==true) then return nil else return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(\"Must be a class\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((instantiator):basicNew())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"fill:object:with:allInstVarNames:",0
,function(self,oid,anObject,contents,varNames)
(((self):transforms()):at_ifAbsent_(((anObject)["$klass"]):name(), (function()
return ((self):shapeValidatingTransform())
end))):valueWithArguments_((smalltalk.Array):with_with_with_with_(oid, anObject, contents, varNames))
;
return (self)
;
end
,"instantiating","fill: oid object: anObject with: contents allInstVarNames: varNames\r\n\t\" Private - Fill contents of anObject with contents. \"\r\n\r\n\t(self transforms\r\n\t\tat: anObject class name\r\n\t\tifAbsent: [ self shapeValidatingTransform ])\r\n\t\tvalueWithArguments: (Array\r\n\t\t\twith: oid with: anObject\r\n\t\t\twith: contents with: varNames)","function(self,oid,anObject,contents,varNames)\r\n(((self):transforms()):at_ifAbsent_(((anObject)[\"$klass\"]):name(), (function()\r\nreturn ((self):shapeValidatingTransform())\r\nend))):valueWithArguments_((smalltalk.Array):with_with_with_with_(oid, anObject, contents, varNames))\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"instantiateCharacter:",0
,function(self,json)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local ascii=nil
(function()
	local _s8_value=((self):basic_at_(json, (1)))
	ascii=_s8_value; return _s8_value
end)()
;
(function() if ((((((ascii))==nil)))==true) then return ((function()
return ((function()
	local _s8_value=((self):basic_at_(json, "1"))
	ascii=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((smalltalk:boolean_or_(((((ascii))==nil)),(function()
return ((smalltalk:booleanNot_(((ascii):isNumber()))))
end)))))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_("Invalid ascii code"))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.String):fromCharCode_(ascii))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"instantiating","instantiateCharacter: json\r\n\t\" Private - Instantiate a character(String) literal from json structure. \"\r\n\r\n\t| ascii |\r\n\tascii := self basic: json at: 1.\r\n\tascii isNil ifTrue: [ ascii := self basic: json at: '1' ].\r\n\t(ascii isNil or: [ ascii isNumber not ]) ifTrue: [\r\n\t\t^self error: 'Invalid ascii code'\r\n\t].\r\n\t^String fromCharCode: ascii","function(self,json)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal ascii=nil\r\n(function()\r\n\tlocal _s8_value=((self):basic_at_(json, (1)))\r\n\tascii=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((ascii))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=((self):basic_at_(json, \"1\"))\r\n\tascii=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((smalltalk:boolean_or_(((((ascii))==nil)),(function()\r\nreturn ((smalltalk:booleanNot_(((ascii):isNumber()))))\r\nend)))))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(\"Invalid ascii code\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.String):fromCharCode_(ascii))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"newObject:",0
,function(self,json)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local jsClass=nil
local cls=nil
local object=nil
local varNames=nil
local oid=nil
(function()
	local _s8_value=((self):basic_at_(json, "class"))
	jsClass=_s8_value; return _s8_value
end)()
;
(function() if ((((((jsClass))==nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):global_(json))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
	local _s8_value=((self):global_(jsClass))
	cls=_s8_value; return _s8_value
end)()
;
(function() if ((((((cls))==nil)))==true) then return ((function()
return ((self):error_("Missing class"))
end))() else return nil end end)()
;
(function()
	local _s8_value=((function() if ((((self):isObject_(jsClass)))==true) then return nil else return ((function()
return ((self):basic_at_(jsClass, "allInstVarNames"))
end))() end end)())
	varNames=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((self):basic_at_(json, "id"))
	oid=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((self):instantiate_with_allInstVarNames_(cls, json, varNames))
	object=_s8_value; return _s8_value
end)()
;
(self):id_is_(oid, object)
;
(self):fill_object_with_allInstVarNames_(oid, object, json, varNames)
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self['@objects']):at_(oid))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"converting","newObject: json\r\n\t\" Private - Returns a new instance from json. \"\r\n\r\n\t| jsClass cls object varNames oid |\r\n\tjsClass := self basic: json at: #class.\r\n\tjsClass isNil ifTrue: [ ^self global: json ].\r\n\r\n\tcls := self global: jsClass.\r\n\tcls isNil ifTrue: [ self error: 'Missing class' ].\r\n\tvarNames := (self isObject: jsClass) ifFalse: [ self basic: jsClass at: #allInstVarNames ].\r\n\toid := self basic: json at: #id.\r\n\r\n\tobject := self instantiate: cls with: json allInstVarNames: varNames.\r\n\tself id: oid is: object.\r\n\tself fill: oid object: object with: json allInstVarNames: varNames.\r\n\t^objects at: oid","function(self,json)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal jsClass=nil\r\nlocal cls=nil\r\nlocal object=nil\r\nlocal varNames=nil\r\nlocal oid=nil\r\n(function()\r\n\tlocal _s8_value=((self):basic_at_(json, \"class\"))\r\n\tjsClass=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((jsClass))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):global_(json))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((self):global_(jsClass))\r\n\tcls=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((cls))==nil)))==true) then return ((function()\r\nreturn ((self):error_(\"Missing class\"))\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((function() if ((((self):isObject_(jsClass)))==true) then return nil else return ((function()\r\nreturn ((self):basic_at_(jsClass, \"allInstVarNames\"))\r\nend))() end end)())\r\n\tvarNames=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((self):basic_at_(json, \"id\"))\r\n\toid=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((self):instantiate_with_allInstVarNames_(cls, json, varNames))\r\n\tobject=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(self):id_is_(oid, object)\r\n;\r\n(self):fill_object_with_allInstVarNames_(oid, object, json, varNames)\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self['@objects']):at_(oid))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"name:",0
,function(self,aName)
return (((self):names()):at_ifAbsent_(aName, (function()
return (aName)
end)))
;
end
,"lookup","name: aName\r\n\t\" Private - Returns the (global) name to use for reference to aName. \"\r\n\r\n\t^self names at: aName ifAbsent: [ aName ]","function(self,aName)\r\nreturn (((self):names()):at_ifAbsent_(aName, (function()\r\nreturn (aName)\r\nend)))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"globalAt:",0
,function(self,key)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local binding=nil
(function() if ((((((key))==nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_("Missing global name"))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((key):isString()))==true) then return nil else return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((key):inject_into_(nil, (function(result,selector)
return ((function() if ((((((result))==nil)))==true) then return ((function()
return ((self):globalAt_(selector))
end))() else return ((function()
return ((result):perform_((selector):asSymbol()))
end))() end end)())
end)))
end
)()
error(_s8Ret_,0)
end)())
end))() end end)()
;
(function()
	local _s8_value=((self):name_(key))
	binding=_s8_value; return _s8_value
end)()
;
(function() if ((((binding):isString()))==true) then return nil else return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (binding)
end
)()
error(_s8Ret_,0)
end)())
end))() end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.Smalltalk):at_ifAbsent_((binding):asSymbol(), (function()
return ((self):error_(smalltalk:object_comma_(("Missing global #"),key)))
end)))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"lookup","globalAt: key\r\n\t\" Private - Returns the global object references by key. \"\r\n\r\n\t| binding |\r\n\tkey isNil ifTrue: [ ^self error: 'Missing global name' ].\r\n\tkey isString ifFalse: [ \"path from global reference\"\r\n\t\t^key inject: nil into: [:result :selector|\r\n\t\t\tresult isNil ifTrue: [ self globalAt: selector ]\r\n\t\t\tifFalse: [ result perform: selector asSymbol ]\r\n\t\t]\r\n\t].\r\n\tbinding := self name: key.\r\n\tbinding isString ifFalse: [ ^binding ].\r\n\t^Smalltalk at: binding asSymbol ifAbsent: [\r\n\t\tself error: 'Missing global #' ,key\r\n\t]","function(self,key)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal binding=nil\r\n(function() if ((((((key))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(\"Missing global name\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((key):isString()))==true) then return nil else return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((key):inject_into_(nil, (function(result,selector)\r\nreturn ((function() if ((((((result))==nil)))==true) then return ((function()\r\nreturn ((self):globalAt_(selector))\r\nend))() else return ((function()\r\nreturn ((result):perform_((selector):asSymbol()))\r\nend))() end end)())\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() end end)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((self):name_(key))\r\n\tbinding=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((binding):isString()))==true) then return nil else return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (binding)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.Smalltalk):at_ifAbsent_((binding):asSymbol(), (function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing global #\"),key)))\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"id:is:",0
,function(self,id,anObject)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(function() if ((((((id))==nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (anObject)
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self['@objects']):at_put_(id, anObject))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"registration","id: id is: anObject\r\n\t\" Private - Register anObject as object at id. \"\r\n\r\n\tid isNil ifTrue: [ ^anObject ].\r\n\t^objects at: id put: anObject","function(self,id,anObject)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(function() if ((((((id))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (anObject)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self['@objects']):at_put_(id, anObject))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"global:",0
,function(self,json)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local result=nil
(self):withRef_do_(json, (function(anObject)
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (anObject)
end
)()
error(_s8Ret_,0)
end)())
end))
;
(function()
	local _s8_value=((self):globalAt_((self):basic_at_(json, "global")))
	result=_s8_value; return _s8_value
end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):id_is_((self):basic_at_(json, "id"), result))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"references","global: json\r\n\t\" Private - Returns a global from json. \"\r\n\r\n\t| result |\r\n\tself withRef: json do: [:anObject| ^anObject ].\r\n\tresult := self globalAt: (self basic: json at: #global).\r\n\t^self id: (self basic: json at: #id) is: result","function(self,json)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal result=nil\r\n(self):withRef_do_(json, (function(anObject)\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (anObject)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))\r\n;\r\n(function()\r\n\tlocal _s8_value=((self):globalAt_((self):basic_at_(json, \"global\")))\r\n\tresult=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):id_is_((self):basic_at_(json, \"id\"), result))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"ref:",0
,function(self,ref)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local value=nil
(function() if ((((self):starts_with_(ref, (self):tagStart())))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (ref)
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
	local _s8_value=((self['@objects']):at_((ref):asNumber()))
	value=_s8_value; return _s8_value
end)()
;
(function() if ((((smalltalk:isObject_equalTo_((value),"missing"))))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Missing value at #"),ref)))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (value)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"references","ref: ref\r\n\t\" Private - Returns the object pointed at reference. \"\r\n\r\n\t| value |\r\n\t(self starts: ref with: self tagStart) ifTrue: [ ^ref ].\r\n\tvalue := objects at: ref asNumber.\r\n\tvalue = #missing ifTrue: [ ^self error: 'Missing value at #' ,ref ].\r\n\t^value","function(self,ref)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal value=nil\r\n(function() if ((((self):starts_with_(ref, (self):tagStart())))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (ref)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((self['@objects']):at_((ref):asNumber()))\r\n\tvalue=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_((value),\"missing\"))))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing value at #\"),ref)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (value)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"parse:",0
,function(self,aString)
return ((self):jsonObject_((self):readStream_(aString)))
;
end
,"parsing","parse: aString\r\n\t\" Private - Returns the map read from aString literal.\r\n\tSee https://www.json.org/\r\n\t\"\r\n\r\n\t^self jsonObject: (self readStream: aString)","function(self,aString)\r\nreturn ((self):jsonObject_((self):readStream_(aString)))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"skipSeparators:",0
,function(self,stream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(function() while(((function()
(function() if ((((stream):atEnd()))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)();return (((stream):peek()):isSeparator())
end))()) do (function()
return ((stream):next())
end)() end;return nil end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","skipSeparators: stream\r\n\t\" Advance the stream upto a non-separator (or end).\r\n\tReturn true  if a non-separator contents is found,\r\n\treturn false if run upto end of stream.\r\n\t\"\r\n\r\n\t[ stream atEnd ifTrue: [ ^false ].\r\n\t  stream peek isSeparator\r\n\t] whileTrue: [ stream next ].\r\n\t^true","function(self,stream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(function() while(((function()\r\n(function() if ((((stream):atEnd()))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)();return (((stream):peek()):isSeparator())\r\nend))()) do (function()\r\nreturn ((stream):next())\r\nend)() end;return nil end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"mustRead:in:",0
,function(self,char,stream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(function() if ((((smalltalk:isObject_equalTo_(((stream):peek()),char))))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((stream):next())
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((self):skipSeparators_(stream)))==true) then return ((function()
return ((function() if ((((smalltalk:isObject_equalTo_(((stream):peek()),char))))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((stream):next())
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Invalid contents at "),smalltalk:asString_((((stream):position()):_plus((1)))))))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","mustRead: char in: stream\r\n\t\" Private - Ensure char is the next character to read from stream. \"\r\n\r\n\tstream peek = char ifTrue: [ ^stream next ].\r\n\t(self skipSeparators: stream) ifTrue: [\r\n\t\tstream peek = char ifTrue: [ ^stream next ].\r\n\t].\r\n\t^self error: 'Invalid contents at ' ,(stream position + 1) asString","function(self,char,stream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(function() if ((((smalltalk:isObject_equalTo_(((stream):peek()),char))))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((stream):next())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((self):skipSeparators_(stream)))==true) then return ((function()\r\nreturn ((function() if ((((smalltalk:isObject_equalTo_(((stream):peek()),char))))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((stream):next())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid contents at \"),smalltalk:asString_((((stream):position()):_plus((1)))))))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"mustReadToken:in:",0
,function(self,token,stream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local start=nil
(function()
	local _s8_value=(((stream):position()):_plus((1)))
	start=_s8_value; return _s8_value
end)()
;
(function() if ((((smalltalk:isObject_equalTo_((token),(stream):next_((token):size())))))==true) then return nil else return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((token)," expected at ")),smalltalk:asString_((start)))))
end
)()
error(_s8Ret_,0)
end)())
end))() end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","mustReadToken: token in: stream\r\n\t\" Private - Ensure token is the next contents to read from stream. \"\r\n\r\n\t| start |\r\n\tstart := stream position + 1.\r\n\ttoken = (stream next: token size) ifFalse: [\r\n\t\t^self error: token ,' expected at ' ,start asString\r\n\t]","function(self,token,stream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal start=nil\r\n(function()\r\n\tlocal _s8_value=(((stream):position()):_plus((1)))\r\n\tstart=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_((token),(stream):next_((token):size())))))==true) then return nil else return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((smalltalk:object_comma_((token),\" expected at \")),smalltalk:asString_((start)))))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"jsonObject:",0
,function(self,stream)
local result=nil
(function()
	local _s8_value=((smalltalk.PoolDictionary):new())
	result=_s8_value; return _s8_value
end)()
;
(result):at_put_("objectifier_isObject", self)
;
(self):mustRead_in_("{", stream)
;
(function() while(not ((function()
return ((smalltalk:isObject_equalTo_(((stream):peek()),"}")))
end))()) do (function()
local assoc=nil
(function()
	local _s8_value=((self):jsonBinding_(stream))
	assoc=_s8_value; return _s8_value
end)();(result):at_put_((assoc):key(), (assoc):value());return ((function() if ((((smalltalk:isObject_equalTo_(((stream):peek()),","))))==true) then return ((function()
return ((stream):next())
end))() else return nil end end)())
end)() end;return nil end)()
;
(self):mustRead_in_("}", stream)
;
return (result)
;
end
,"parsing","jsonObject: stream\r\n\t\" Private - Returns the next json object from stream. \"\r\n\r\n\t| result |\r\n\tresult := PoolDictionary new.\r\n\tresult at: #objectifier_isObject put: self.\r\n\tself mustRead: ${ in: stream.\r\n\t[stream peek = $}] whileFalse: [ | assoc |\r\n\t\tassoc := self jsonBinding: stream.\r\n\t\tresult at: assoc key put: assoc value.\r\n\t\tstream peek = $, ifTrue: [ stream next ].\r\n\t].\r\n\tself mustRead: $} in: stream.\r\n\t^result","function(self,stream)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.PoolDictionary):new())\r\n\tresult=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(result):at_put_(\"objectifier_isObject\", self)\r\n;\r\n(self):mustRead_in_(\"{\", stream)\r\n;\r\n(function() while(not ((function()\r\nreturn ((smalltalk:isObject_equalTo_(((stream):peek()),\"}\")))\r\nend))()) do (function()\r\nlocal assoc=nil\r\n(function()\r\n\tlocal _s8_value=((self):jsonBinding_(stream))\r\n\tassoc=_s8_value; return _s8_value\r\nend)();(result):at_put_((assoc):key(), (assoc):value());return ((function() if ((((smalltalk:isObject_equalTo_(((stream):peek()),\",\"))))==true) then return ((function()\r\nreturn ((stream):next())\r\nend))() else return nil end end)())\r\nend)() end;return nil end)()\r\n;\r\n(self):mustRead_in_(\"}\", stream)\r\n;\r\nreturn (result)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"jsonBinding:",0
,function(self,stream)
local key=nil
local value=nil
(function()
	local _s8_value=((self):jsonString_(stream))
	key=_s8_value; return _s8_value
end)()
;
(self):mustRead_in_(":", stream)
;
(function()
	local _s8_value=((self):jsonValue_(stream))
	value=_s8_value; return _s8_value
end)()
;
return ((smalltalk.Association):key_value_(key, value))
;
end
,"parsing","jsonBinding: stream\r\n\t\" Private - Returns the next json binding from stream. \"\r\n\r\n\t| key value |\r\n\tkey := self jsonString: stream.\r\n\tself mustRead: $: in: stream.\r\n\tvalue := self jsonValue: stream.\r\n\t^Association key: key value: value","function(self,stream)\r\nlocal key=nil\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=((self):jsonString_(stream))\r\n\tkey=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(self):mustRead_in_(\":\", stream)\r\n;\r\n(function()\r\n\tlocal _s8_value=((self):jsonValue_(stream))\r\n\tvalue=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn ((smalltalk.Association):key_value_(key, value))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"newArray",0
,function(self)
return (((smalltalk.Smalltalk):at_ifAbsent_("OrderedCollection", (function()
return (smalltalk.Array)
end))):new())
;
end
,"instantiating","newArray\r\n\t\" Private - Returns a new extensible arrayed collection. \"\r\n\r\n\t^(Smalltalk at: #OrderedCollection ifAbsent: [ Array ]) new","function(self)\r\nreturn (((smalltalk.Smalltalk):at_ifAbsent_(\"OrderedCollection\", (function()\r\nreturn (smalltalk.Array)\r\nend))):new())\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"numberFromString:",0
,function(self,string)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local support=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):at_ifAbsent_("Float", (function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((string):asNumber())
end
)()
error(_s8Ret_,0)
end)())
end)))
	support=_s8_value; return _s8_value
end)()
;
(function() if ((((string):includes_(".")))==true) then return nil else return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((string):asNumber())
end
)()
error(_s8Ret_,0)
end)())
end))() end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((support):fromString_decimalSeparator_(string, "."))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"instantiating","numberFromString: string\r\n\t\" Private - Returns the number encoded in string. \"\r\n\r\n\t| support |\r\n\tsupport := Smalltalk at: #Float ifAbsent: [ ^string asNumber ].\r\n\t(string includes: $.) ifFalse: [ ^string asNumber ].\r\n\t^support fromString: string decimalSeparator: '.'","function(self,string)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal support=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):at_ifAbsent_(\"Float\", (function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((string):asNumber())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tsupport=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((string):includes_(\".\")))==true) then return nil else return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((string):asNumber())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((support):fromString_decimalSeparator_(string, \".\"))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"jsonValue:",0
,function(self,stream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local char=nil
(function()
	local _s8_value=((stream):peek())
	char=_s8_value; return _s8_value
end)()
;
(function() if ((((((char))==nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Unexpected end at "),smalltalk:asString_((((stream):position()):_plus((1)))))))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((smalltalk:isObject_equalTo_((char),"\""))))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):jsonString_(stream))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((char):isDigit()))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):jsonNumber_(stream))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((smalltalk:isObject_equalTo_((char),"-"))))==true) then return ((function()
(stream):next();return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (((self):jsonNumber_(stream)):negated())
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((smalltalk:isObject_equalTo_((char),"{"))))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):jsonObject_(stream))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((smalltalk:isObject_equalTo_((char),"["))))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):jsonArray_(stream))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((smalltalk:isObject_equalTo_((char),"t"))))==true) then return ((function()
(self):mustReadToken_in_("true", stream);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((smalltalk:isObject_equalTo_((char),"f"))))==true) then return ((function()
(self):mustReadToken_in_("false", stream);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function() if ((((smalltalk:isObject_equalTo_((char),"n"))))==true) then return ((function()
(self):mustReadToken_in_("null", stream);return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Corrupt contents at "),smalltalk:asString_((((stream):position()):_plus((1)))))))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","jsonValue: stream\r\n\t\" Private - Returns the next json value from stream. \"\r\n\r\n\t| char |\r\n\tchar := stream peek.\r\n\tchar isNil ifTrue: [ ^self error: 'Unexpected end at ' ,(stream position + 1) asString ].\r\n\tchar = $\" ifTrue: [ ^self jsonString: stream ].\r\n\tchar isDigit ifTrue: [ ^self jsonNumber: stream ].\r\n\tchar = $- ifTrue: [ stream next. ^(self jsonNumber: stream) negated ].\r\n\tchar = ${ ifTrue: [ ^self jsonObject: stream ].\r\n\tchar = $[ ifTrue: [ ^self jsonArray: stream ].\r\n\tchar = $t ifTrue: [ self mustReadToken: 'true' in: stream. ^true ].\r\n\tchar = $f ifTrue: [ self mustReadToken: 'false' in: stream. ^false ].\r\n\tchar = $n ifTrue: [ self mustReadToken: 'null' in: stream. ^nil ].\r\n\t^self error: 'Corrupt contents at ' ,(stream position + 1) asString ","function(self,stream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal char=nil\r\n(function()\r\n\tlocal _s8_value=((stream):peek())\r\n\tchar=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((char))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Unexpected end at \"),smalltalk:asString_((((stream):position()):_plus((1)))))))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_((char),\"\\\"\"))))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):jsonString_(stream))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((char):isDigit()))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):jsonNumber_(stream))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_((char),\"-\"))))==true) then return ((function()\r\n(stream):next();return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (((self):jsonNumber_(stream)):negated())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_((char),\"{\"))))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):jsonObject_(stream))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_((char),\"[\"))))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):jsonArray_(stream))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_((char),\"t\"))))==true) then return ((function()\r\n(self):mustReadToken_in_(\"true\", stream);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_((char),\"f\"))))==true) then return ((function()\r\n(self):mustReadToken_in_(\"false\", stream);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((smalltalk:isObject_equalTo_((char),\"n\"))))==true) then return ((function()\r\n(self):mustReadToken_in_(\"null\", stream);return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Corrupt contents at \"),smalltalk:asString_((((stream):position()):_plus((1)))))))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"jsonArray:",0
,function(self,stream)
local result=nil
(function()
	local _s8_value=((self):newArray())
	result=_s8_value; return _s8_value
end)()
;
(self):mustRead_in_("[", stream)
;
(function() while(not ((function()
return ((smalltalk:isObject_equalTo_(((stream):peek()),"]")))
end))()) do (function()
(result):add_((self):jsonValue_(stream));return ((function() if ((((smalltalk:isObject_equalTo_(((stream):peek()),","))))==true) then return ((function()
return ((stream):next())
end))() else return nil end end)())
end)() end;return nil end)()
;
(self):mustRead_in_("]", stream)
;
return (result)
;
end
,"parsing","jsonArray: stream\r\n\t\" Private - Returns the json array from stream. \"\r\n\r\n\t| result |\r\n\tresult := self newArray.\r\n\tself mustRead: $[ in: stream.\r\n\t[ stream peek = $] ] whileFalse: [\r\n\t\tresult add: (self jsonValue: stream).\r\n\t\tstream peek = $, ifTrue: [ stream next ].\r\n\t].\r\n\tself mustRead: $] in: stream.\r\n\t^result","function(self,stream)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):newArray())\r\n\tresult=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(self):mustRead_in_(\"[\", stream)\r\n;\r\n(function() while(not ((function()\r\nreturn ((smalltalk:isObject_equalTo_(((stream):peek()),\"]\")))\r\nend))()) do (function()\r\n(result):add_((self):jsonValue_(stream));return ((function() if ((((smalltalk:isObject_equalTo_(((stream):peek()),\",\"))))==true) then return ((function()\r\nreturn ((stream):next())\r\nend))() else return nil end end)())\r\nend)() end;return nil end)()\r\n;\r\n(self):mustRead_in_(\"]\", stream)\r\n;\r\nreturn (result)\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"jsonString:",0
,function(self,stream)
(self):mustRead_in_("\"", stream)
;
return ((self):unEscape_((self):jsonStringChars_(stream)))
;
end
,"parsing","jsonString: stream\r\n\t\" Private - Returns the json string from stream. \"\r\n\r\n\tself mustRead: $\" in: stream.\r\n\t^self unEscape: (self jsonStringChars: stream)","function(self,stream)\r\n(self):mustRead_in_(\"\\\"\", stream)\r\n;\r\nreturn ((self):unEscape_((self):jsonStringChars_(stream)))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"jsonStringChars:",0
,function(self,stream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local start=nil
local result=nil
local bar=nil
local part=nil
(function()
	local _s8_value=("\\")
	bar=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=(((stream):position()):_plus((1)))
	start=_s8_value; return _s8_value
end)()
;
(function() while(((function()
(function()
	local _s8_value=((stream):upTo_("\""))
	part=_s8_value; return _s8_value
end)();(function() if ((((stream):atEnd()))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Missing end of string at "),smalltalk:asString_((start)))))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)();return ((smalltalk:boolean_and_(((part):notEmpty()),(function()
return ((smalltalk:isObject_equalTo_(((part):last()),bar)))
end))))
end))()) do (function()
(function()
	local _s8_value=((part):copyWith_("\""))
	part=_s8_value; return _s8_value
end)();return ((function()
	local _s8_value=((function() if ((((((result))==nil)))==true) then return ((function()
return (part)
end))() else return ((function()
return (smalltalk:object_comma_((result),part))
end))() end end)())
	result=_s8_value; return _s8_value
end)())
end)() end;return nil end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((function() if ((((((result))==nil)))==true) then return ((function()
return (part)
end))() else return ((function()
return (result)
end))() end end)())
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","jsonStringChars: stream\r\n\t\" Private - Returns the next sequence of json characters from stream. \"\r\n\r\n\t| start result bar part |\r\n\tbar := $\\.\r\n\tstart := stream position + 1.\r\n\t[\tpart := stream upTo: $\".\r\n\t\tstream atEnd ifTrue: [ ^self error: 'Missing end of string at ', start asString ].\r\n\t\tpart notEmpty and: [ part last = bar ]\r\n\t] whileTrue: [\r\n\t\tpart := part copyWith: $\".\r\n\t\tresult := result isNil ifTrue: [part] ifFalse: [result , part]\r\n\t].\r\n\t^result isNil ifTrue: [part] ifFalse: [result]","function(self,stream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal start=nil\r\nlocal result=nil\r\nlocal bar=nil\r\nlocal part=nil\r\n(function()\r\n\tlocal _s8_value=(\"\\\\\")\r\n\tbar=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=(((stream):position()):_plus((1)))\r\n\tstart=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() while(((function()\r\n(function()\r\n\tlocal _s8_value=((stream):upTo_(\"\\\"\"))\r\n\tpart=_s8_value; return _s8_value\r\nend)();(function() if ((((stream):atEnd()))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing end of string at \"),smalltalk:asString_((start)))))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)();return ((smalltalk:boolean_and_(((part):notEmpty()),(function()\r\nreturn ((smalltalk:isObject_equalTo_(((part):last()),bar)))\r\nend))))\r\nend))()) do (function()\r\n(function()\r\n\tlocal _s8_value=((part):copyWith_(\"\\\"\"))\r\n\tpart=_s8_value; return _s8_value\r\nend)();return ((function()\r\n\tlocal _s8_value=((function() if ((((((result))==nil)))==true) then return ((function()\r\nreturn (part)\r\nend))() else return ((function()\r\nreturn (smalltalk:object_comma_((result),part))\r\nend))() end end)())\r\n\tresult=_s8_value; return _s8_value\r\nend)())\r\nend)() end;return nil end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((function() if ((((((result))==nil)))==true) then return ((function()\r\nreturn (part)\r\nend))() else return ((function()\r\nreturn (result)\r\nend))() end end)())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"jsonUCharacter:",0
,function(self,fourDigits)
local ascii=nil
(function()
	local _s8_value=(((smalltalk.Smalltalk):at_ifAbsent_("Integer", (function()
return (smalltalk.Number)
end))):readFrom_radix_((self):readStream_(fourDigits), (16)))
	ascii=_s8_value; return _s8_value
end)()
;
return (smalltalk:asCharacter_((ascii)))
;
end
,"parsing","jsonUCharacter: fourDigits\r\n\t\" Private - Returns the character escaped in fourDigits. \"\r\n\r\n\t| ascii |\r\n\tascii := (Smalltalk at: #Integer ifAbsent: [Number])\r\n\t\treadFrom: (self readStream: fourDigits)\r\n\t\tradix: 16.\r\n\t^ascii asCharacter","function(self,fourDigits)\r\nlocal ascii=nil\r\n(function()\r\n\tlocal _s8_value=(((smalltalk.Smalltalk):at_ifAbsent_(\"Integer\", (function()\r\nreturn (smalltalk.Number)\r\nend))):readFrom_radix_((self):readStream_(fourDigits), (16)))\r\n\tascii=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn (smalltalk:asCharacter_((ascii)))\r\n;\r\nend")

smalltalk:bind(smalltalk.Objectifier,"unEscape:",0
,function(self,string)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local input=nil
local output=nil
local bar=nil
(function()
	local _s8_value=("\\")
	bar=_s8_value; return _s8_value
end)()
;
(function() if ((((string):includes_(bar)))==true) then return nil else return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (string)
end
)()
error(_s8Ret_,0)
end)())
end))() end end)()
;
(function()
	local _s8_value=((self):readStream_(string))
	input=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((self):writeStreamOn_(""))
	output=_s8_value; return _s8_value
end)()
;
(function() while(not ((function()
return ((input):atEnd())
end))()) do (function()
local c=nil
(output):nextPutAll_((input):upTo_(bar));return ((function() if ((((input):atEnd()))==true) then return nil else return ((function()
(function()
	local _s8_value=((input):next())
	c=_s8_value; return _s8_value
end)();(function() if ((((smalltalk:isObject_equalTo_((c),bar))))==true) then return ((function()
return ((output):nextPut_(bar))
end))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),"/"))))==true) then return ((function()
return ((output):nextPut_("/"))
end))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),"b"))))==true) then return ((function()
return ((output):nextPut_(smalltalk:asCharacter_(((8)))))
end))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),"f"))))==true) then return ((function()
return ((output):nextPut_(smalltalk:asCharacter_(((12)))))
end))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),"n"))))==true) then return ((function()
return ((output):nextPut_(smalltalk:asCharacter_(((10)))))
end))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),"r"))))==true) then return ((function()
return ((output):nextPut_(smalltalk:asCharacter_(((13)))))
end))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),"t"))))==true) then return ((function()
return ((output):nextPut_(smalltalk:asCharacter_(((9)))))
end))() else return nil end end)();return ((function() if ((((smalltalk:isObject_equalTo_((c),"u"))))==true) then return ((function()
return ((output):nextPut_((self):jsonUCharacter_((input):next_((4)))))
end))() else return nil end end)())
end))() end end)())
end)() end;return nil end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((output):contents())
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","unEscape: string\r\n\t\" Private - Returns the result of unescaping a string. \"\r\n\r\n\t| input output bar |\r\n\tbar := $\\.\r\n\t(string includes: bar) ifFalse: [ ^string ].\r\n\tinput := self readStream: string.\r\n\toutput := self writeStreamOn: ''.\r\n\t[input atEnd] whileFalse: [ | c |\r\n\t\toutput nextPutAll: (input upTo: bar).\r\n\t\tinput atEnd ifFalse: [\r\n\t\t\tc := input next.\r\n\t\t\tc = bar ifTrue: [ output nextPut: bar ].\r\n\t\t\tc = $/ ifTrue: [ output nextPut: $/ ].\r\n\t\t\tc = $b ifTrue: [ output nextPut: 8 asCharacter ].\r\n\t\t\tc = $f ifTrue: [ output nextPut: 12 asCharacter ].\r\n\t\t\tc = $n ifTrue: [ output nextPut: 10 asCharacter ].\r\n\t\t\tc = $r ifTrue: [ output nextPut: 13 asCharacter ].\r\n\t\t\tc = $t ifTrue: [ output nextPut: 9 asCharacter ].\r\n\t\t\tc = $u ifTrue: [ output nextPut: (self jsonUCharacter: (input next: 4)) ].\r\n\t\t]\r\n\t].\r\n\t^output contents","function(self,string)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal input=nil\r\nlocal output=nil\r\nlocal bar=nil\r\n(function()\r\n\tlocal _s8_value=(\"\\\\\")\r\n\tbar=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((string):includes_(bar)))==true) then return nil else return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (string)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() end end)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((self):readStream_(string))\r\n\tinput=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((self):writeStreamOn_(\"\"))\r\n\toutput=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() while(not ((function()\r\nreturn ((input):atEnd())\r\nend))()) do (function()\r\nlocal c=nil\r\n(output):nextPutAll_((input):upTo_(bar));return ((function() if ((((input):atEnd()))==true) then return nil else return ((function()\r\n(function()\r\n\tlocal _s8_value=((input):next())\r\n\tc=_s8_value; return _s8_value\r\nend)();(function() if ((((smalltalk:isObject_equalTo_((c),bar))))==true) then return ((function()\r\nreturn ((output):nextPut_(bar))\r\nend))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),\"/\"))))==true) then return ((function()\r\nreturn ((output):nextPut_(\"/\"))\r\nend))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),\"b\"))))==true) then return ((function()\r\nreturn ((output):nextPut_(smalltalk:asCharacter_(((8)))))\r\nend))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),\"f\"))))==true) then return ((function()\r\nreturn ((output):nextPut_(smalltalk:asCharacter_(((12)))))\r\nend))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),\"n\"))))==true) then return ((function()\r\nreturn ((output):nextPut_(smalltalk:asCharacter_(((10)))))\r\nend))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),\"r\"))))==true) then return ((function()\r\nreturn ((output):nextPut_(smalltalk:asCharacter_(((13)))))\r\nend))() else return nil end end)();(function() if ((((smalltalk:isObject_equalTo_((c),\"t\"))))==true) then return ((function()\r\nreturn ((output):nextPut_(smalltalk:asCharacter_(((9)))))\r\nend))() else return nil end end)();return ((function() if ((((smalltalk:isObject_equalTo_((c),\"u\"))))==true) then return ((function()\r\nreturn ((output):nextPut_((self):jsonUCharacter_((input):next_((4)))))\r\nend))() else return nil end end)())\r\nend))() end end)())\r\nend)() end;return nil end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((output):contents())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Objectifier,"jsonNumber:",0
,function(self,stream)
local output=nil
local valid=nil
(function()
	local _s8_value=((self):writeStreamOn_(""))
	output=_s8_value; return _s8_value
end)()
;
(function() while(((function()
return (("0123456789.+-eE"):includes_((stream):peek()))
end))()) do (function()
return ((output):nextPut_((stream):next()))
end)() end;return nil end)()
;
return ((self):numberFromString_((output):contents()))
;
end
,"parsing","jsonNumber: stream\r\n\t\" Private - Returns the json number from stream. \"\r\n\r\n\t| output valid |\r\n\toutput := self writeStreamOn: ''.\r\n\t['0123456789.+-eE' includes: stream peek] whileTrue: [\r\n\t\toutput nextPut: stream next\r\n\t].\r\n\t^self numberFromString: output contents","function(self,stream)\r\nlocal output=nil\r\nlocal valid=nil\r\n(function()\r\n\tlocal _s8_value=((self):writeStreamOn_(\"\"))\r\n\toutput=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() while(((function()\r\nreturn ((\"0123456789.+-eE\"):includes_((stream):peek()))\r\nend))()) do (function()\r\nreturn ((output):nextPut_((stream):next()))\r\nend)() end;return nil end)()\r\n;\r\nreturn ((self):numberFromString_((output):contents()))\r\n;\r\nend")
