local demo = require("demo")

function love.load()
	demo.load()
	--Ale-- Load S8 Smalltalk
	require("s8")
	if not smalltalk then error("--S8 Smalltalk is missing") end
end

function love.update(dt)
	demo.update(dt)
end

function love.draw()
	demo.draw()
	if smalltalk then smalltalk.SystemServer:current():step() end --Ale-- attend system service
end

function love.mousepressed(x, y, button)
	demo.mousepressed(x, y, button)
end

function love.mousereleased(x, y, button)
	demo.mousereleased(x, y, button)
end

function love.wheelmoved(x, y)
	demo.wheelmoved(x, y)
end

function love.keypressed(key, isrepeat)
	demo.keypressed(key, isrepeat)
end

function love.keyreleased(key)
	demo.keyreleased(key)
end

function love.textinput(text)
	demo.textinput(text)
end
