
! Object methodsFor: #s8-initialize-printing !
print: aString
	" Output a new line with aString onto output device. "

	| aBlock |
	aBlock := Object basicAt: #printBlock.
	aBlock isNil ifTrue: [
		{'self'}. # #print: aString
	] ifFalse: [
		aBlock evaluateWith: aString
	]! !

! Object methodsFor: #s8-initialize-fileIn !
fileIn: fileName
	" FileIn smalltalk source at fileName. "

	self note: 'fileIn("', fileName, '")'.
	{'self'}. ^# #fileIn: fileName! !

! Object methodsFor: #s8-initialize-fileIn !
fileInJS: fileName
	" Load native code from file at fileName. "

	self note: 'fileInJS("', fileName, '")'.
	{'self'}. ^# #fileInJS: fileName! !