" DEBUGGING NOTES:
	- see uses of message #--
"!

! Object methodsFor: #Mobile-debug !
-- text
	" DEBUG - Output text onto debug console.
	Note: if text is an array it will be sent to logger.
	"

	text isArray ifTrue: [ ^MobileTracer log: text ].
	self print: '//[',self class name,']--',text! !

Object
	subclass: #MobileTracer
	instanceVariableNames: ''
	classVariableNames: 'Enabled'
	category: #MobileLog !

! MobileTracer class methodsFor: #accesing !
debug: aBoolean
	" Set the state of the receiver "

	Enabled := aBoolean ! !

! MobileTracer class methodsFor: #debug !
log: value
	" Logs an activity "

	Enabled = true ifTrue: [ self print: value asLiteral ]! !

! MobileApplication methodsFor: #MobileLog-debug !
debugUI: aBoolean
	" Set the receiver to debug UI operations. "

	MobileTracer debug: aBoolean ! !

! MobileCoordinatorTemplate methodsFor: #MobileLog-private !
actionToHandle: eventName in: subject doing: aBlock with: data
	" Private - Return the block to handle the event. "

	^[	self -- (Array
			with: eventName
			with: subject
			with: data).
		aBlock value: subject ]! !