-- fileIn("s8/library/luasocket.st");
smalltalk:addClass("LuaSocketObject",smalltalk.NativeObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("DNS",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("FTP",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("HTTP",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("LTN12",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("LTN12Filter",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("LTN12Pump",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("LTN12Sink",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("LTN12Source",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("SMTP",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("URL",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("LuaSocket",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("TCP",smalltalk.LuaSocket,smalltalk:newArray({}),"luasocket")

smalltalk:addClass("UDP",smalltalk.LuaSocket,smalltalk:newArray({}),"luasocket")

smalltalk:bind(smalltalk.Lua["$klass"],"socket",0
,function(self)
return (smalltalk.LuaSocket)
;
end
,"accessing","socket\r\n\t\" Returns the LuaSocket library. \"\r\n\r\n\t^LuaSocket","function(self)\r\nreturn (smalltalk.LuaSocket)\r\n;\r\nend")

smalltalk:bind(smalltalk.Lua["$klass"],"http",0
,function(self)
return ((smalltalk.HTTP):new())
;
end
,"accessing","http\r\n\t\" Returns the http library wrapper. \"\r\n\r\n\t^HTTP new","function(self)\r\nreturn ((smalltalk.HTTP):new())\r\n;\r\nend")

smalltalk:bind(smalltalk.Lua["$klass"],"ftp",0
,function(self)
return ((smalltalk.FTP):new())
;
end
,"accessing","ftp\r\n\t\" Returns the ftp library wrapper. \"\r\n\r\n\t^FTP new","function(self)\r\nreturn ((smalltalk.FTP):new())\r\n;\r\nend")

smalltalk:bind(smalltalk.Lua["$klass"],"smtp",0
,function(self)
return ((smalltalk.SMTP):new())
;
end
,"accessing","smtp\r\n\t\" Returns the smtp library wrapper. \"\r\n\r\n\t^SMTP new","function(self)\r\nreturn ((smalltalk.SMTP):new())\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"nativeClass",0
,function(self)
return ((smalltalk.Lua):_at(require("socket")))
;
end
,"accessing","nativeClass\r\n\t\" Private - Returns the native module. \"\r\n\r\n\t^Lua @ (# #require: #socket)","function(self)\r\nreturn ((smalltalk.Lua):_at(require(\"socket\")))\r\n;\r\nend")

smalltalk:bind(smalltalk.DNS["$klass"],"nativeClass",0
,function(self)
return ((smalltalk.Lua):_at(((smalltalk.LuaSocket):nativeClass()):_at("dns")))
;
end
,"accessing","nativeClass\r\n\t\" Private - Returns the native module. \"\r\n\r\n\t^Lua @ (LuaSocket nativeClass @ #dns)","function(self)\r\nreturn ((smalltalk.Lua):_at(((smalltalk.LuaSocket):nativeClass()):_at(\"dns\")))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"initializeHandle",0
,function(self)
(self):handle_(require("socket.ftp"))
;
(function() if ((((((self['@handle']))==nil)))==true) then return ((function()
return ((self):error_("Missing FTP support"))
end))() else return nil end end)()
;
return (self)
;
end
,"initialize","initializeHandle\r\n\t\" Private - Initialize the handle of the receiver. \"\r\n\r\n\tself handle: (# #require: 'socket.ftp').\r\n\thandle isNil ifTrue: [ self error: 'Missing FTP support' ] ","function(self)\r\n(self):handle_(require(\"socket.ftp\"))\r\n;\r\n(function() if ((((((self['@handle']))==nil)))==true) then return ((function()\r\nreturn ((self):error_(\"Missing FTP support\"))\r\nend))() else return nil end end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP,"initializeHandle",0
,function(self)
(self):handle_(require("socket.http"))
;
(function() if ((((((self['@handle']))==nil)))==true) then return ((function()
return ((self):error_("Missing HTTP support"))
end))() else return nil end end)()
;
return (self)
;
end
,"initialize","initializeHandle\r\n\t\" Private - Initialize the handle of the receiver. \"\r\n\r\n\tself handle: (# #require: 'socket.http').\r\n\thandle isNil ifTrue: [ self error: 'Missing HTTP support' ] ","function(self)\r\n(self):handle_(require(\"socket.http\"))\r\n;\r\n(function() if ((((((self['@handle']))==nil)))==true) then return ((function()\r\nreturn ((self):error_(\"Missing HTTP support\"))\r\nend))() else return nil end end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.SMTP,"initializeHandle",0
,function(self)
(self):handle_(require("socket.smtp"))
;
(function() if ((((((self['@handle']))==nil)))==true) then return ((function()
return ((self):error_("Missing SMTP support"))
end))() else return nil end end)()
;
return (self)
;
end
,"initialize","initializeHandle\r\n\t\" Private - Initialize the handle of the receiver. \"\r\n\r\n\tself handle: (# #require: 'socket.smtp').\r\n\thandle isNil ifTrue: [ self error: 'Missing SMTP support' ] ","function(self)\r\n(self):handle_(require(\"socket.smtp\"))\r\n;\r\n(function() if ((((((self['@handle']))==nil)))==true) then return ((function()\r\nreturn ((self):error_(\"Missing SMTP support\"))\r\nend))() else return nil end end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"select:send:timeout:",0
,function(self,recSocks,sendSocks,timeout)
local reads=nil
local writes=nil
local err=nil
	reads, writes, err = self:nativeClass():handle():select( recSocks:handles(), sendSocks:handles(), timeout) 
;
return ((smalltalk.Array):with_with_with_(((smalltalk.Array):_at(reads)):collect_((function(each)
return ((smalltalk.LuaSocket):_at(each))
end)), ((smalltalk.Array):_at(writes)):collect_((function(each)
return ((smalltalk.LuaSocket):_at(each))
end)), err))
;
end
,"select","select: recSocks send: sendSocks timeout: timeout\r\n\t\" Waits for a number of sockets to change status. \"\r\n\r\n\t| reads writes err |\r\n{'\treads, writes, err = self:nativeClass():handle():select( recSocks:handles(), sendSocks:handles(), timeout) '}.\r\n\t^Array\r\n\t\twith: (Array@reads collect: [:each| LuaSocket @ each ])\r\n\t\twith: (Array@writes collect: [:each| LuaSocket @ each ])\r\n\t\twith: err","function(self,recSocks,sendSocks,timeout)\r\nlocal reads=nil\r\nlocal writes=nil\r\nlocal err=nil\r\n\treads, writes, err = self:nativeClass():handle():select( recSocks:handles(), sendSocks:handles(), timeout) \r\n;\r\nreturn ((smalltalk.Array):with_with_with_(((smalltalk.Array):_at(reads)):collect_((function(each)\r\nreturn ((smalltalk.LuaSocket):_at(each))\r\nend)), ((smalltalk.Array):_at(writes)):collect_((function(each)\r\nreturn ((smalltalk.LuaSocket):_at(each))\r\nend)), err))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"select:send:",0
,function(self,recSocks,sendSocks)
local reads=nil
local writes=nil
local err=nil
	reads, writes, err = self:nativeClass():handle():select( recSocks:handles(), sendSocks:handles()) 
;
return ((smalltalk.Array):with_with_with_(((smalltalk.Array):_at(reads)):collect_((function(each)
return ((smalltalk.LuaSocket):_at(each))
end)), ((smalltalk.Array):_at(writes)):collect_((function(each)
return ((smalltalk.LuaSocket):_at(each))
end)), err))
;
end
,"select","select: recSocks send: sendSocks\r\n\t\" Waits for a number of sockets to change status. \"\r\n\r\n\t| reads writes err |\r\n{'\treads, writes, err = self:nativeClass():handle():select( recSocks:handles(), sendSocks:handles()) '}.\r\n\t^Array\r\n\t\twith: (Array@reads collect: [:each| LuaSocket @ each ])\r\n\t\twith: (Array@writes collect: [:each| LuaSocket @ each ])\r\n\t\twith: err","function(self,recSocks,sendSocks)\r\nlocal reads=nil\r\nlocal writes=nil\r\nlocal err=nil\r\n\treads, writes, err = self:nativeClass():handle():select( recSocks:handles(), sendSocks:handles()) \r\n;\r\nreturn ((smalltalk.Array):with_with_with_(((smalltalk.Array):_at(reads)):collect_((function(each)\r\nreturn ((smalltalk.LuaSocket):_at(each))\r\nend)), ((smalltalk.Array):_at(writes)):collect_((function(each)\r\nreturn ((smalltalk.LuaSocket):_at(each))\r\nend)), err))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"select:timeout:",0
,function(self,recSocks,timeout)
local reads=nil
local err=nil
	reads, _, err = self:nativeClass():handle():select( recSocks:handles(), nil, timeout) 
;
return ((smalltalk.Array):with_with_(((smalltalk.Array):_at(reads)):collect_((function(each)
return ((smalltalk.LuaSocket):_at(each))
end)), err))
;
end
,"select","select: recSocks timeout: timeout\r\n\t\" Waits for a number of sockets to change status. \"\r\n\r\n\t| reads err |\r\n{'\treads, _, err = self:nativeClass():handle():select( recSocks:handles(), nil, timeout) '}.\r\n\t^Array\r\n\t\twith: (Array@reads collect: [:each| LuaSocket @ each ])\r\n\t\twith: err","function(self,recSocks,timeout)\r\nlocal reads=nil\r\nlocal err=nil\r\n\treads, _, err = self:nativeClass():handle():select( recSocks:handles(), nil, timeout) \r\n;\r\nreturn ((smalltalk.Array):with_with_(((smalltalk.Array):_at(reads)):collect_((function(each)\r\nreturn ((smalltalk.LuaSocket):_at(each))\r\nend)), err))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"select:",0
,function(self,recSocks)
local reads=nil
local err=nil
	reads, _, err = self:nativeClass():handle():select( recSocks:handles(), nil) 
;
return ((smalltalk.Array):with_with_(((smalltalk.Array):_at(reads)):collect_((function(each)
return ((smalltalk.LuaSocket):_at(each))
end)), err))
;
end
,"select","select: recSocks\r\n\t\" Waits for a number of sockets to change status. \"\r\n\r\n\t| reads err |\r\n{'\treads, _, err = self:nativeClass():handle():select( recSocks:handles(), nil) '}.\r\n\t^Array\r\n\t\twith: (Array@reads collect: [:each| LuaSocket @ each ])\r\n\t\twith: err","function(self,recSocks)\r\nlocal reads=nil\r\nlocal err=nil\r\n\treads, _, err = self:nativeClass():handle():select( recSocks:handles(), nil) \r\n;\r\nreturn ((smalltalk.Array):with_with_(((smalltalk.Array):_at(reads)):collect_((function(each)\r\nreturn ((smalltalk.LuaSocket):_at(each))\r\nend)), err))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket,"setBlocking:",0
,function(self,blocking)
return (self)
;
end
,"ignored","setBlocking: blocking\r\n\t\" Ignore blocking setup. \"","function(self,blocking)\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"tcp",0
,function(self)
return ((smalltalk.TCP):_at((((self):nativeClass()):handle()).tcp()))
;
end
,"wrappers","tcp\r\n\t\" Delegated to native class. \"\r\n\r\n\t^TCP @ (self nativeClass handle #_tcp)","function(self)\r\nreturn ((smalltalk.TCP):_at((((self):nativeClass()):handle()).tcp()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"bind:port:",0
,function(self,address,port)
return ((smalltalk.TCP):_at((((self):nativeClass()):handle()).bind(address, port)))
;
end
,"wrappers","bind: address port: port \r\n\t\" Delegated to native class. \"\r\n\r\n\t^TCP @ (self nativeClass handle #_bind: address port: port )","function(self,address,port)\r\nreturn ((smalltalk.TCP):_at((((self):nativeClass()):handle()).bind(address, port)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"bind:port:backlog:",0
,function(self,address,port,backlog)
return ((smalltalk.TCP):_at((((self):nativeClass()):handle()).bind(address, port, backlog)))
;
end
,"wrappers","bind: address port: port backlog: backlog \r\n\t\" Delegated to native class. \"\r\n\r\n\t^TCP @ (self nativeClass handle #_bind: address port: port backlog: backlog )","function(self,address,port,backlog)\r\nreturn ((smalltalk.TCP):_at((((self):nativeClass()):handle()).bind(address, port, backlog)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"connect:port:",0
,function(self,address,port)
return ((smalltalk.TCP):_at((((self):nativeClass()):handle()).connect(address, port)))
;
end
,"wrappers","connect: address port: port \r\n\t\" Delegated to native class. \"\r\n\r\n\t^TCP @ (self nativeClass handle #_connect: address port: port )","function(self,address,port)\r\nreturn ((smalltalk.TCP):_at((((self):nativeClass()):handle()).connect(address, port)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"connect:port:localaddr:locport:",0
,function(self,address,port,localaddr,locport)
return ((smalltalk.TCP):_at((((self):nativeClass()):handle()).connect(address, port, localaddr, locport)))
;
end
,"wrappers","connect: address port: port localaddr: localaddr locport: locport \r\n\t\" Delegated to native class. \"\r\n\r\n\t^TCP @ (self nativeClass handle #_connect: address port: port localaddr: localaddr locport: locport )","function(self,address,port,localaddr,locport)\r\nreturn ((smalltalk.TCP):_at((((self):nativeClass()):handle()).connect(address, port, localaddr, locport)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"select:sendt:",0
,function(self,recvt,sendt)
return ((((self):nativeClass()):handle()).select((recvt):handles(), (sendt):handles()))
;
end
,"wrappers","select: recvt sendt: sendt \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_select: recvt handles sendt: sendt handles ","function(self,recvt,sendt)\r\nreturn ((((self):nativeClass()):handle()).select((recvt):handles(), (sendt):handles()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"select:sendt:timeout:",0
,function(self,recvt,sendt,timeout)
return ((((self):nativeClass()):handle()).select((recvt):handles(), (sendt):handles(), timeout))
;
end
,"wrappers","select: recvt sendt: sendt timeout: timeout \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_select: recvt handles sendt: sendt handles timeout: timeout ","function(self,recvt,sendt,timeout)\r\nreturn ((((self):nativeClass()):handle()).select((recvt):handles(), (sendt):handles(), timeout))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"sink:socket:",0
,function(self,mode,socket)
return ((smalltalk.LTN12Sink):_at((((self):nativeClass()):handle()).sink(mode, (socket):json())))
;
end
,"wrappers","sink: mode socket: socket \r\n\t\" Delegated to native class. \"\r\n\r\n\t^LTN12Sink @ (self nativeClass handle #_sink: mode socket: socket json )","function(self,mode,socket)\r\nreturn ((smalltalk.LTN12Sink):_at((((self):nativeClass()):handle()).sink(mode, (socket):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"source:socket:",0
,function(self,mode,socket)
return ((smalltalk.LTN12Source):_at((((self):nativeClass()):handle()).source(mode, (socket):json())))
;
end
,"wrappers","source: mode socket: socket \r\n\t\" Delegated to native class. \"\r\n\r\n\t^LTN12Source @ (self nativeClass handle #_source: mode socket: socket json )","function(self,mode,socket)\r\nreturn ((smalltalk.LTN12Source):_at((((self):nativeClass()):handle()).source(mode, (socket):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"source:socket:length:",0
,function(self,mode,socket,length)
return ((smalltalk.LTN12Source):_at((((self):nativeClass()):handle()).source(mode, (socket):json(), length)))
;
end
,"wrappers","source: mode socket: socket length: length \r\n\t\" Delegated to native class. \"\r\n\r\n\t^LTN12Source @ (self nativeClass handle #_source: mode socket: socket json length: length )","function(self,mode,socket,length)\r\nreturn ((smalltalk.LTN12Source):_at((((self):nativeClass()):handle()).source(mode, (socket):json(), length)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"udp",0
,function(self)
return ((smalltalk.UDP):_at((((self):nativeClass()):handle()).udp()))
;
end
,"wrappers","udp\r\n\t\" Delegated to native class. \"\r\n\r\n\t^UDP @ (self nativeClass handle #_udp)","function(self)\r\nreturn ((smalltalk.UDP):_at((((self):nativeClass()):handle()).udp()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"newtry:",0
,function(self,finalBlock)
return ((((self):nativeClass()):handle()).newtry(finalBlock))
;
end
,"wrappers","newtry: finalBlock \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_newtry: finalBlock ","function(self,finalBlock)\r\nreturn ((((self):nativeClass()):handle()).newtry(finalBlock))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"protect:",0
,function(self,aBlock)
return ((((self):nativeClass()):handle()).protect(aBlock))
;
end
,"wrappers","protect: aBlock \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_protect: aBlock ","function(self,aBlock)\r\nreturn ((((self):nativeClass()):handle()).protect(aBlock))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"sleep:",0
,function(self,time)
return ((((self):nativeClass()):handle()).sleep(time))
;
end
,"wrappers","sleep: time \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_sleep: time ","function(self,time)\r\nreturn ((((self):nativeClass()):handle()).sleep(time))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"gettime",0
,function(self)
return ((((self):nativeClass()):handle()).gettime())
;
end
,"wrappers","gettime\r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_gettime","function(self)\r\nreturn ((((self):nativeClass()):handle()).gettime())\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket,"close",0
,function(self)
return (((self):handle()):close())
;
end
,"wrappers","close\r\n\t\" Delegate close to handle. \"\r\n\r\n\t^self handle #close","function(self)\r\nreturn (((self):handle()):close())\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket,"setoption:",0
,function(self,option)
return (((self):handle()):setoption(option))
;
end
,"wrappers","setoption: option \r\n\t\" Delegate setoption to handle. \"\r\n\r\n\t^self handle #setoption: option ","function(self,option)\r\nreturn (((self):handle()):setoption(option))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket,"setoption:value:",0
,function(self,option,value)
return (((self):handle()):setoption(option, value))
;
end
,"wrappers","setoption: option value: value \r\n\t\" Delegate setoption to handle. \"\r\n\r\n\t^self handle #setoption: option value: value ","function(self,option,value)\r\nreturn (((self):handle()):setoption(option, value))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket,"setoption:to:",0
,function(self,option,to)
return (((self):handle()):setoption(option, to))
;
end
,"wrappers","setoption: option to: to \r\n\t\" Delegate setoption to handle. \"\r\n\r\n\t^self handle #setoption: option to: to ","function(self,option,to)\r\nreturn (((self):handle()):setoption(option, to))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket,"settimeout:",0
,function(self,value)
return (((self):handle()):settimeout(value))
;
end
,"wrappers","settimeout: value \r\n\t\" Delegate settimeout to handle. \"\r\n\r\n\t^self handle #settimeout: value ","function(self,value)\r\nreturn (((self):handle()):settimeout(value))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket,"receive",0
,function(self)
local s=nil
local status=nil
local partial=nil
	s, status, partial = self:handle():receive() 
;
return ((smalltalk.Array):with_with_with_(s, status, partial))
;
end
,"receiving","receive\r\n\t| s status partial |\r\n{'\ts, status, partial = self:handle():receive() '}.\r\n\t^Array with: s with: status with: partial","function(self)\r\nlocal s=nil\r\nlocal status=nil\r\nlocal partial=nil\r\n\ts, status, partial = self:handle():receive() \r\n;\r\nreturn ((smalltalk.Array):with_with_with_(s, status, partial))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket,"sockname",0
,function(self)
local ip=nil
local port=nil
	ip, port = self:handle():getsockname()
	if ip==nil then return nil end

;
return ((smalltalk.Array):with_with_(ip, port))
;
end
,"accessing","sockname\r\n\t| ip port |\r\n{'\tip, port = self:handle():getsockname()\r\n\tif ip==nil then return nil end\r\n'}.\t^Array with: ip with: port","function(self)\r\nlocal ip=nil\r\nlocal port=nil\r\n\tip, port = self:handle():getsockname()\r\n\tif ip==nil then return nil end\r\n\r\n;\r\nreturn ((smalltalk.Array):with_with_(ip, port))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket,"peername",0
,function(self)
local ip=nil
local port=nil
	ip, port = self:handle():getpeername()
	if ip==nil then return nil end

;
return ((smalltalk.Array):with_with_(ip, port))
;
end
,"accessing","peername\r\n\t| ip port |\r\n{'\tip, port = self:handle():getpeername()\r\n\tif ip==nil then return nil end\r\n'}.\t^Array with: ip with: port","function(self)\r\nlocal ip=nil\r\nlocal port=nil\r\n\tip, port = self:handle():getpeername()\r\n\tif ip==nil then return nil end\r\n\r\n;\r\nreturn ((smalltalk.Array):with_with_(ip, port))\r\n;\r\nend")

smalltalk:bind(smalltalk.LuaSocket["$klass"],"version",0
,function(self)
return (((self):nativeClass()):_at("_VERSION"))
;
end
,"constants","version\r\n\r\n\t^self nativeClass @ #_VERSION","function(self)\r\nreturn (((self):nativeClass()):_at(\"_VERSION\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.DNS["$klass"],"gethostname",0
,function(self)
return ((((self):nativeClass()):handle()).gethostname())
;
end
,"wrappers","gethostname\r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_gethostname","function(self)\r\nreturn ((((self):nativeClass()):handle()).gethostname())\r\n;\r\nend")

smalltalk:bind(smalltalk.DNS["$klass"],"tohostname:",0
,function(self,address)
return ((((self):nativeClass()):handle()).tohostname(address))
;
end
,"wrappers","tohostname: address \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_tohostname: address ","function(self,address)\r\nreturn ((((self):nativeClass()):handle()).tohostname(address))\r\n;\r\nend")

smalltalk:bind(smalltalk.DNS["$klass"],"toip:",0
,function(self,address)
return ((((self):nativeClass()):handle()).toip(address))
;
end
,"wrappers","toip: address \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_toip: address ","function(self,address)\r\nreturn ((((self):nativeClass()):handle()).toip(address))\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP,"request:body:",0
,function(self,url,body)
return (((self):handle()).request(url, body))
;
end
,"wrappers","request: url body: body \r\n\t\" Delegate _request to handle. \"\r\n\r\n\t^self handle #_request: url body: body ","function(self,url,body)\r\nreturn (((self):handle()).request(url, body))\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP,"request:",0
,function(self,urlOrOptions)
return (((self):handle()).request((urlOrOptions):json()))
;
end
,"wrappers","request: urlOrOptions \r\n\t\" Delegate _request to handle. \"\r\n\r\n\t^self handle #_request: urlOrOptions json ","function(self,urlOrOptions)\r\nreturn (((self):handle()).request((urlOrOptions):json()))\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP["$klass"],"request:",0
,function(self,args)
return (((self):new()):request_(args))
;
end
,"access","request: args\r\n\t^self new request: args","function(self,args)\r\nreturn (((self):new()):request_(args))\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP["$klass"],"get:",0
,function(self,args)
return (((self):new()):request_(args))
;
end
,"access","get: args\r\n\t^self new request: args","function(self,args)\r\nreturn (((self):new()):request_(args))\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP,"requestAll:",0
,function(self,options)
local result=nil
local count=nil
local headers=nil
	result, count, headers = self:handle().request(options:json())
;
return ((smalltalk.Array):with_with_with_(result, count, (smalltalk.PoolDictionary):_at(headers)))
;
end
,"request","requestAll: options\r\n\t| result count headers |\r\n{'\tresult, count, headers = self:handle().request(options:json())'}.\r\n\t^Array with: result with: count with: PoolDictionary @ headers ","function(self,options)\r\nlocal result=nil\r\nlocal count=nil\r\nlocal headers=nil\r\n\tresult, count, headers = self:handle().request(options:json())\r\n;\r\nreturn ((smalltalk.Array):with_with_with_(result, count, (smalltalk.PoolDictionary):_at(headers)))\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP["$klass"],"requestAll:",0
,function(self,options)
return (((self):new()):requestAll_(options))
;
end
,"access","requestAll: options\r\n\t^self new requestAll: options","function(self,options)\r\nreturn (((self):new()):requestAll_(options))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"get:onError:",0
,function(self,urlOrOptions,aBlock)
local result=nil
local error=nil
	result, error = self:handle().get(urlOrOptions:json())
	if error then return aBlock:evaluateWith_(error) end
;
return (result)
;
end
,"get","get: urlOrOptions onError: aBlock\r\n\t| result error |\r\n{'\tresult, error = self:handle().get(urlOrOptions:json())\r\n\tif error then return aBlock:evaluateWith_(error) end'}.\r\n\t^result","function(self,urlOrOptions,aBlock)\r\nlocal result=nil\r\nlocal error=nil\r\n\tresult, error = self:handle().get(urlOrOptions:json())\r\n\tif error then return aBlock:evaluateWith_(error) end\r\n;\r\nreturn (result)\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"get:",0
,function(self,urlOrOptions)
return ((self):get_onError_(urlOrOptions, (function(err)
return ((self):error_(err))
end)))
;
end
,"get","get: urlOrOptions\r\n\t^self get: urlOrOptions onError: [:err| self error: err ]","function(self,urlOrOptions)\r\nreturn ((self):get_onError_(urlOrOptions, (function(err)\r\nreturn ((self):error_(err))\r\nend)))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"put:onError:",0
,function(self,options,aBlock)
local result=nil
local error=nil
	result, error = self:handle().put(options:json())
	if error then return aBlock:evaluateWith_(error) end
;
return (result)
;
end
,"put","put: options onError: aBlock\r\n\t| result error |\r\n{'\tresult, error = self:handle().put(options:json())\r\n\tif error then return aBlock:evaluateWith_(error) end'}.\r\n\t^result","function(self,options,aBlock)\r\nlocal result=nil\r\nlocal error=nil\r\n\tresult, error = self:handle().put(options:json())\r\n\tif error then return aBlock:evaluateWith_(error) end\r\n;\r\nreturn (result)\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"put:contents:",0
,function(self,url,contents)
return ((self):put_contents_onError_(url, contents, (function(err)
return ((self):error_(err))
end)))
;
end
,"put","put: url contents: contents\r\n\t^self put: url contents: contents onError: [:err| self error: err ]","function(self,url,contents)\r\nreturn ((self):put_contents_onError_(url, contents, (function(err)\r\nreturn ((self):error_(err))\r\nend)))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"put:",0
,function(self,options)
return ((self):put_onError_(options, (function(err)
return ((self):error_(err))
end)))
;
end
,"put","put: options\r\n\t^self put: options onError: [:err| self error: err ]","function(self,options)\r\nreturn ((self):put_onError_(options, (function(err)\r\nreturn ((self):error_(err))\r\nend)))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"put:contents:onError:",0
,function(self,url,contents,aBlock)
local result=nil
local error=nil
	result, error = self:handle().put(url,contents)
	if error then return aBlock:evaluateWith_(error) end
;
return (result)
;
end
,"put","put: url contents: contents onError: aBlock\r\n\t| result error |\r\n{'\tresult, error = self:handle().put(url,contents)\r\n\tif error then return aBlock:evaluateWith_(error) end'}.\r\n\t^result","function(self,url,contents,aBlock)\r\nlocal result=nil\r\nlocal error=nil\r\n\tresult, error = self:handle().put(url,contents)\r\n\tif error then return aBlock:evaluateWith_(error) end\r\n;\r\nreturn (result)\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP["$klass"],"get:",0
,function(self,args)
return (((self):new()):get_(args))
;
end
,"get","get: args\r\n\t^self new get: args","function(self,args)\r\nreturn (((self):new()):get_(args))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP["$klass"],"put:",0
,function(self,options)
return (((self):new()):put_(options))
;
end
,"put","put: options\r\n\t^self new put: options","function(self,options)\r\nreturn (((self):new()):put_(options))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP["$klass"],"put:contents:",0
,function(self,url,contents)
return (((self):new()):put_contents_(url, contents))
;
end
,"put","put: url contents: contents\r\n\t^self new put: url contents: contents","function(self,url,contents)\r\nreturn (((self):new()):put_contents_(url, contents))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"get:sink:with:user:password:command:port:type:step:create:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type,step,aBlock)
local options=nil
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((("host"):_minus_gt(host)),("sink"):_minus_gt(aLTN12Sink))),("path"):_minus_gt(argumentOrPathString)))
	options=_s8_value; return _s8_value
end)()
;
(function() if ((((((user))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("user"):_minus_gt(user)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((password))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("password"):_minus_gt(password)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((command))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("command"):_minus_gt(command)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((port))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("port"):_minus_gt(port)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((type))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("type"):_minus_gt(type)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((step))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("step"):_minus_gt(step)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((aBlock))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("create"):_minus_gt(aBlock)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
return ((self):get_(options))
;
end
,"get","get: host\r\n\tsink: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password\r\n\tcommand: command\r\n\tport: port type: type\r\n\tstep: step create: aBlock\r\n\r\n\t| options |\r\n\toptions := #host -> host\r\n\t\t,(#sink -> aLTN12Sink)\r\n\t\t,(#path -> argumentOrPathString).\r\n\tuser notNil ifTrue: [ options := options ,(#user -> user) ].\r\n\tpassword notNil ifTrue: [ options := options ,(#password -> password) ].\r\n\tcommand notNil ifTrue: [ options := options ,(#command -> command) ].\r\n\tport notNil ifTrue: [ options := options ,(#port -> port) ].\r\n\ttype notNil ifTrue: [ options := options ,(#type -> type) ].\r\n\tstep notNil ifTrue: [ options := options ,(#step -> step) ].\r\n\taBlock notNil ifTrue: [ options := options ,(#create -> aBlock) ].\r\n\t^self get: options","function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type,step,aBlock)\r\nlocal options=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((\"host\"):_minus_gt(host)),(\"sink\"):_minus_gt(aLTN12Sink))),(\"path\"):_minus_gt(argumentOrPathString)))\r\n\toptions=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((user))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"user\"):_minus_gt(user)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((password))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"password\"):_minus_gt(password)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((command))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"command\"):_minus_gt(command)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((port))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"port\"):_minus_gt(port)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((type))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"type\"):_minus_gt(type)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((step))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"step\"):_minus_gt(step)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((aBlock))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"create\"):_minus_gt(aBlock)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\nreturn ((self):get_(options))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"get:sink:with:user:password:command:port:type:step:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type,step)
return ((self):get_sink_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, type, step, nil))
;
end
,"get","get: host\r\n\tsink: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password\r\n\tcommand: command\r\n\tport: port type: type\r\n\tstep: step\r\n\r\n\t^self get: host\r\n\t\tsink: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: user password: password\r\n\t\tcommand: command\r\n\t\tport: port type: type\r\n\t\tstep: step create: nil","function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type,step)\r\nreturn ((self):get_sink_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, type, step, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"get:sink:with:user:password:command:port:type:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type)
return ((self):get_sink_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, type, nil, nil))
;
end
,"get","get: host\r\n\tsink: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password\r\n\tcommand: command\r\n\tport: port type: type\r\n\r\n\t^self get: host\r\n\t\tsink: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: user password: password\r\n\t\tcommand: command\r\n\t\tport: port type: type\r\n\t\tstep: nil create: nil","function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type)\r\nreturn ((self):get_sink_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, type, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"get:sink:with:user:password:command:port:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port)
return ((self):get_sink_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, nil, nil, nil))
;
end
,"get","get: host\r\n\tsink: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password\r\n\tcommand: command\r\n\tport: port\r\n\r\n\t^self get: host\r\n\t\tsink: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: user password: password\r\n\t\tcommand: command\r\n\t\tport: port type: nil step: nil create: nil","function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port)\r\nreturn ((self):get_sink_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, nil, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"get:sink:with:user:password:command:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password,command)
return ((self):get_sink_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, nil, nil, nil, nil))
;
end
,"get","get: host\r\n\tsink: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password\r\n\tcommand: command\r\n\r\n\t^self get: host\r\n\t\tsink: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: user password: password\r\n\t\tcommand: command\r\n\t\tport: nil type: nil step: nil create: nil","function(self,host,aLTN12Sink,argumentOrPathString,user,password,command)\r\nreturn ((self):get_sink_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, nil, nil, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"get:sink:with:user:password:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password)
return ((self):get_sink_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, nil, nil, nil, nil, nil))
;
end
,"get","get: host\r\n\tsink: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password \r\n\r\n\t^self get: host\r\n\t\tsink: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: user password: password\r\n\t\tcommand: nil port: nil type: nil step: nil create: nil","function(self,host,aLTN12Sink,argumentOrPathString,user,password)\r\nreturn ((self):get_sink_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, nil, nil, nil, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"get:sink:with:",0
,function(self,host,aLTN12Sink,argumentOrPathString)
return ((self):get_sink_with_user_password_(host, aLTN12Sink, argumentOrPathString, nil, nil))
;
end
,"get","get: host\r\n\tsink: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\r\n\t^self get: host\r\n\t\tsink: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: nil password: nil","function(self,host,aLTN12Sink,argumentOrPathString)\r\nreturn ((self):get_sink_with_user_password_(host, aLTN12Sink, argumentOrPathString, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"put:source:with:user:password:command:port:type:step:create:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type,step,aBlock)
local options=nil
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((("host"):_minus_gt(host)),("source"):_minus_gt(aLTN12Sink))),("path"):_minus_gt(argumentOrPathString)))
	options=_s8_value; return _s8_value
end)()
;
(function() if ((((((user))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("user"):_minus_gt(user)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((password))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("password"):_minus_gt(password)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((command))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("command"):_minus_gt(command)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((port))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("port"):_minus_gt(port)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((type))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("type"):_minus_gt(type)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((step))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("step"):_minus_gt(step)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((aBlock))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("create"):_minus_gt(aBlock)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
return ((self):put_(options))
;
end
,"put","put: host\r\n\tsource: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password\r\n\tcommand: command\r\n\tport: port type: type\r\n\tstep: step create: aBlock\r\n\r\n\t| options |\r\n\toptions := #host -> host\r\n\t\t,(#source -> aLTN12Sink)\r\n\t\t,(#path -> argumentOrPathString).\r\n\tuser notNil ifTrue: [ options := options ,(#user -> user) ].\r\n\tpassword notNil ifTrue: [ options := options ,(#password -> password) ].\r\n\tcommand notNil ifTrue: [ options := options ,(#command -> command) ].\r\n\tport notNil ifTrue: [ options := options ,(#port -> port) ].\r\n\ttype notNil ifTrue: [ options := options ,(#type -> type) ].\r\n\tstep notNil ifTrue: [ options := options ,(#step -> step) ].\r\n\taBlock notNil ifTrue: [ options := options ,(#create -> aBlock) ].\r\n\t^self put: options","function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type,step,aBlock)\r\nlocal options=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((\"host\"):_minus_gt(host)),(\"source\"):_minus_gt(aLTN12Sink))),(\"path\"):_minus_gt(argumentOrPathString)))\r\n\toptions=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((user))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"user\"):_minus_gt(user)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((password))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"password\"):_minus_gt(password)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((command))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"command\"):_minus_gt(command)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((port))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"port\"):_minus_gt(port)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((type))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"type\"):_minus_gt(type)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((step))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"step\"):_minus_gt(step)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((aBlock))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"create\"):_minus_gt(aBlock)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\nreturn ((self):put_(options))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"put:source:with:user:password:command:port:type:step:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type,step)
return ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, type, step, nil))
;
end
,"put","put: host\r\n\tsource: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password\r\n\tcommand: command\r\n\tport: port type: type\r\n\tstep: step\r\n\r\n\t^self put: host\r\n\t\tsource: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: user password: password\r\n\t\tcommand: command\r\n\t\tport: port type: type\r\n\t\tstep: step create: nil","function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type,step)\r\nreturn ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, type, step, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"put:source:with:user:password:command:port:type:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type)
return ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, type, nil, nil))
;
end
,"put","put: host\r\n\tsource: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password\r\n\tcommand: command\r\n\tport: port type: type\r\n\r\n\t^self put: host\r\n\t\tsource: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: user password: password\r\n\t\tcommand: command\r\n\t\tport: port type: type\r\n\t\tstep: nil create: nil","function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port,type)\r\nreturn ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, type, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"put:source:with:user:password:command:port:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port)
return ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, nil, nil, nil))
;
end
,"put","put: host\r\n\tsource: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password\r\n\tcommand: command\r\n\tport: port\r\n\r\n\t^self put: host\r\n\t\tsource: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: user password: password\r\n\t\tcommand: command\r\n\t\tport: port type: nil\r\n\t\tstep: nil create: nil","function(self,host,aLTN12Sink,argumentOrPathString,user,password,command,port)\r\nreturn ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, port, nil, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"put:source:with:user:password:command:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password,command)
return ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, nil, nil, nil, nil))
;
end
,"put","put: host\r\n\tsource: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password\r\n\tcommand: command\r\n\r\n\t^self put: host\r\n\t\tsource: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: user password: password\r\n\t\tcommand: command\r\n\t\tport: nil type: nil\r\n\t\tstep: nil create: nil","function(self,host,aLTN12Sink,argumentOrPathString,user,password,command)\r\nreturn ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, command, nil, nil, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"put:source:with:user:password:",0
,function(self,host,aLTN12Sink,argumentOrPathString,user,password)
return ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, nil, nil, nil, nil, nil))
;
end
,"put","put: host\r\n\tsource: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\tuser: user password: password\r\n\r\n\t^self put: host\r\n\t\tsource: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: user password: password\r\n\t\tcommand: nil\r\n\t\tport: nil type: nil step: nil create: nil","function(self,host,aLTN12Sink,argumentOrPathString,user,password)\r\nreturn ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, user, password, nil, nil, nil, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.FTP,"put:source:with:",0
,function(self,host,aLTN12Sink,argumentOrPathString)
return ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, nil, nil, nil, nil, nil, nil, nil))
;
end
,"put","put: host\r\n\tsource: aLTN12Sink\r\n\twith: argumentOrPathString\r\n\r\n\t^self put: host\r\n\t\tsource: aLTN12Sink\r\n\t\twith: argumentOrPathString\r\n\t\tuser: nil password: nil command: nil\r\n\t\tport: nil type: nil step: nil create: nil","function(self,host,aLTN12Sink,argumentOrPathString)\r\nreturn ((self):put_source_with_user_password_command_port_type_step_create_(host, aLTN12Sink, argumentOrPathString, nil, nil, nil, nil, nil, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP,"request:method:headers:sink:source:step:proxy:redirect:create:",0
,function(self,url,method,headers,aLTN12Sink,source,step,proxy,redirect,aBlock)
local options=nil
(function()
	local _s8_value=(("url"):_minus_gt(url))
	options=_s8_value; return _s8_value
end)()
;
(function() if ((((((method))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("method"):_minus_gt(method)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((headers))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("headers"):_minus_gt(headers)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((step))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("step"):_minus_gt(step)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((aLTN12Sink))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("sink"):_minus_gt(aLTN12Sink)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((source))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("source"):_minus_gt(source)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((step))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("step"):_minus_gt(step)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((proxy))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("proxy"):_minus_gt(proxy)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((redirect))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("redirect"):_minus_gt(redirect)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((aBlock))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("create"):_minus_gt(aBlock)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
return ((self):request_(options))
;
end
,"request","request: url\r\n\tmethod: method headers: headers\r\n\tsink: aLTN12Sink source: source step: step\r\n\tproxy: proxy redirect: redirect\r\n\tcreate: aBlock\r\n\r\n\t| options |\r\n\toptions := #url -> url.\r\n\tmethod notNil ifTrue: [ options := options ,(#method -> method) ].\r\n\theaders notNil ifTrue: [ options := options ,(#headers -> headers) ].\r\n\tstep notNil ifTrue: [ options := options ,(#step -> step) ].\r\n\taLTN12Sink  notNil ifTrue: [ options := options ,(#sink -> aLTN12Sink ) ].\r\n\tsource notNil ifTrue: [ options := options ,(#source ->source) ].\r\n\tstep notNil ifTrue: [ options := options ,(#step -> step) ].\r\n\tproxy notNil ifTrue: [ options := options ,(#proxy -> proxy) ].\r\n\tredirect notNil ifTrue: [ options := options ,(#redirect -> redirect) ].\r\n\taBlock notNil ifTrue: [ options := options ,(#create -> aBlock) ].\r\n\t^self request: options","function(self,url,method,headers,aLTN12Sink,source,step,proxy,redirect,aBlock)\r\nlocal options=nil\r\n(function()\r\n\tlocal _s8_value=((\"url\"):_minus_gt(url))\r\n\toptions=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((method))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"method\"):_minus_gt(method)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((headers))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"headers\"):_minus_gt(headers)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((step))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"step\"):_minus_gt(step)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((aLTN12Sink))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"sink\"):_minus_gt(aLTN12Sink)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((source))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"source\"):_minus_gt(source)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((step))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"step\"):_minus_gt(step)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((proxy))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"proxy\"):_minus_gt(proxy)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((redirect))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"redirect\"):_minus_gt(redirect)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((aBlock))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"create\"):_minus_gt(aBlock)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\nreturn ((self):request_(options))\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP,"request:method:headers:sink:source:step:proxy:redirect:",0
,function(self,url,method,headers,aLTN12Sink,source,step,proxy,redirect)
return ((self):request_method_headers_sink_source_step_proxy_redirect_create_(url, method, headers, aLTN12Sink, source, step, proxy, redirect, nil))
;
end
,"request","request: url\r\n\tmethod: method headers: headers\r\n\tsink: aLTN12Sink source: source step: step\r\n\tproxy: proxy redirect: redirect\r\n\r\n\t^self request: url\r\n\t\tmethod: method headers: headers\r\n\t\tsink: aLTN12Sink source: source step: step\r\n\t\tproxy: proxy redirect: redirect\r\n\t\tcreate: nil","function(self,url,method,headers,aLTN12Sink,source,step,proxy,redirect)\r\nreturn ((self):request_method_headers_sink_source_step_proxy_redirect_create_(url, method, headers, aLTN12Sink, source, step, proxy, redirect, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP,"request:method:headers:sink:source:step:",0
,function(self,url,method,headers,aLTN12Sink,source,step)
return ((self):request_method_headers_sink_source_step_proxy_redirect_create_(url, method, headers, aLTN12Sink, source, step, nil, nil, nil))
;
end
,"request","request: url\r\n\tmethod: method headers: headers\r\n\tsink: aLTN12Sink source: source step: step\r\n\r\n\t^self request: url\r\n\t\tmethod: method headers: headers\r\n\t\tsink: aLTN12Sink source: source step: step\r\n\t\tproxy: nil redirect: nil create: nil","function(self,url,method,headers,aLTN12Sink,source,step)\r\nreturn ((self):request_method_headers_sink_source_step_proxy_redirect_create_(url, method, headers, aLTN12Sink, source, step, nil, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP,"request:method:headers:",0
,function(self,url,method,headers)
return ((self):request_method_headers_sink_source_step_(url, method, headers, nil, nil, nil))
;
end
,"request","request: url method: method headers: headers\r\n\r\n\t^self request: url\r\n\t\tmethod: method headers: headers\r\n\t\tsink: nil source: nil step: nil","function(self,url,method,headers)\r\nreturn ((self):request_method_headers_sink_source_step_(url, method, headers, nil, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.HTTP,"request:method:",0
,function(self,url,method)
return ((self):request_method_headers_sink_source_step_(url, method, nil, nil, nil, nil))
;
end
,"request","request: url method: method\r\n\r\n\t^self request: url\r\n\t\tmethod: method headers: nil\r\n\t\tsink: nil source: nil step: nil","function(self,url,method)\r\nreturn ((self):request_method_headers_sink_source_step_(url, method, nil, nil, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.Lua["$klass"],"ltn12",0
,function(self)
return ((smalltalk.LTN12):new())
;
end
,"accessing","ltn12\r\n\t\" Returns the wrapper to ltn12. \"\r\n\r\n\t^LTN12 new","function(self)\r\nreturn ((smalltalk.LTN12):new())\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12,"initializeHandle",0
,function(self)
(self):handle_(require("ltn12"))
;
(function() if ((((((self['@handle']))==nil)))==true) then return ((function()
return ((self):error_("Missing ltn12 support"))
end))() else return nil end end)()
;
return (self)
;
end
,"initialize","initializeHandle\r\n\t\" Private - Initialize the handle of the receiver. \"\r\n\r\n\tself handle: (# #require: #ltn12).\r\n\thandle isNil ifTrue: [ self error: 'Missing ltn12 support' ] ","function(self)\r\n(self):handle_(require(\"ltn12\"))\r\n;\r\n(function() if ((((((self['@handle']))==nil)))==true) then return ((function()\r\nreturn ((self):error_(\"Missing ltn12 support\"))\r\nend))() else return nil end end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12,"blocksize",0
,function(self)
return ((((self):handle())["BLOSKSIZE"]))
;
end
,"constants","blocksize\r\n\r\n\t^self handle basicAt: #BLOSKSIZE","function(self)\r\nreturn ((((self):handle())[\"BLOSKSIZE\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12,"version",0
,function(self)
return ((((self):handle())["_VERSION"]))
;
end
,"constants","version\r\n\r\n\t^self handle basicAt: #_VERSION","function(self)\r\nreturn ((((self):handle())[\"_VERSION\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12,"filter",0
,function(self)
return ((smalltalk.LTN12Filter):_at((((self):handle())["filter"])))
;
end
,"accessing","filter\r\n\t\" Return the filter of the receiver. \"\r\n\r\n\t^LTN12Filter @ (self handle basicAt: #filter)","function(self)\r\nreturn ((smalltalk.LTN12Filter):_at((((self):handle())[\"filter\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12,"pump",0
,function(self)
return ((smalltalk.LTN12Pump):_at((((self):handle())["pump"])))
;
end
,"accessing","pump\r\n\t\" Return the pump of the receiver. \"\r\n\r\n\t^LTN12Pump @ (self handle basicAt: #pump)","function(self)\r\nreturn ((smalltalk.LTN12Pump):_at((((self):handle())[\"pump\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12,"sink",0
,function(self)
return ((smalltalk.LTN12Sink):_at((((self):handle())["sink"])))
;
end
,"accessing","sink\r\n\t\" Return the sink of the receiver. \"\r\n\r\n\t^LTN12Sink @ (self handle basicAt: #sink)","function(self)\r\nreturn ((smalltalk.LTN12Sink):_at((((self):handle())[\"sink\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12,"source",0
,function(self)
return ((smalltalk.LTN12Source):_at((((self):handle())["source"])))
;
end
,"accessing","source\r\n\t\" Return the source of the receiver. \"\r\n\r\n\t^LTN12Source @ (self handle basicAt: #source)","function(self)\r\nreturn ((smalltalk.LTN12Source):_at((((self):handle())[\"source\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Filter,"chain:",0
,function(self,filter)
return ((smalltalk.LTN12Filter):_at(((self):handle()).chain((filter):json())))
;
end
,"wrappers","chain: filter \r\n\t\" Delegate _chain to handle. \"\r\n\r\n\t^LTN12Filter @ (self handle #_chain: filter json )","function(self,filter)\r\nreturn ((smalltalk.LTN12Filter):_at(((self):handle()).chain((filter):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Filter,"chain:filter2:",0
,function(self,filter,filter2)
return ((smalltalk.LTN12Filter):_at(((self):handle()).chain((filter):json(), (filter2):json())))
;
end
,"wrappers","chain: filter filter2: filter2 \r\n\t\" Delegate _chain to handle. \"\r\n\r\n\t^LTN12Filter @ (self handle #_chain: filter json filter2: filter2 json )","function(self,filter,filter2)\r\nreturn ((smalltalk.LTN12Filter):_at(((self):handle()).chain((filter):json(), (filter2):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Filter,"chain:filter2:filter3:",0
,function(self,filter,filter2,filter3)
return ((smalltalk.LTN12Filter):_at(((self):handle()).chain((filter):json(), (filter2):json(), (filter3):json())))
;
end
,"wrappers","chain: filter filter2: filter2 filter3: filter3 \r\n\t\" Delegate _chain to handle. \"\r\n\r\n\t^LTN12Filter @ (self handle #_chain: filter json filter2: filter2 json filter3: filter3 json )","function(self,filter,filter2,filter3)\r\nreturn ((smalltalk.LTN12Filter):_at(((self):handle()).chain((filter):json(), (filter2):json(), (filter3):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Filter,"chain:filter2:filter3:filter4:",0
,function(self,filter,filter2,filter3,filter4)
return ((smalltalk.LTN12Filter):_at(((self):handle()).chain((filter):json(), (filter2):json(), (filter3):json(), (filter4):json())))
;
end
,"wrappers","chain: filter filter2: filter2 filter3: filter3 filter4: filter4 \r\n\t\" Delegate _chain to handle. \"\r\n\r\n\t^LTN12Filter @ (self handle #_chain: filter json filter2: filter2 json filter3: filter3 json filter4: filter4 json )","function(self,filter,filter2,filter3,filter4)\r\nreturn ((smalltalk.LTN12Filter):_at(((self):handle()).chain((filter):json(), (filter2):json(), (filter3):json(), (filter4):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Filter,"cycle:",0
,function(self,low)
return ((smalltalk.LTN12Filter):_at(((self):handle()).cycle((low):json())))
;
end
,"wrappers","cycle: low \r\n\t\" Delegate _cycle to handle. \"\r\n\r\n\t^LTN12Filter @ (self handle #_cycle: low json )","function(self,low)\r\nreturn ((smalltalk.LTN12Filter):_at(((self):handle()).cycle((low):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Filter,"cycle:ctx:extra:",0
,function(self,low,ctx,extra)
return ((smalltalk.LTN12Filter):_at(((self):handle()).cycle((low):json(), ctx, extra)))
;
end
,"wrappers","cycle: low ctx: ctx extra: extra \r\n\t\" Delegate _cycle to handle. \"\r\n\r\n\t^LTN12Filter @ (self handle #_cycle: low json ctx: ctx extra: extra )","function(self,low,ctx,extra)\r\nreturn ((smalltalk.LTN12Filter):_at(((self):handle()).cycle((low):json(), ctx, extra)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Filter,"chainAll:",0
,function(self,anArray)
return (((self)["$klass"]):_at(((((self):handle())["chain"])):evaluateWithArguments_((anArray):handles())))
;
end
,"chain","chainAll: anArray\r\n\r\n\t^self class @ ((self handle basicAt: #chain) evaluateWithArguments: anArray handles)","function(self,anArray)\r\nreturn (((self)[\"$klass\"]):_at(((((self):handle())[\"chain\"])):evaluateWithArguments_((anArray):handles())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Pump,"all:sink:",0
,function(self,source,sink)
return (((self):handle()).all((source):json(), sink))
;
end
,"wrappers","all: source sink: sink \r\n\t\" Delegate _all to handle. \"\r\n\r\n\t^self handle #_all: source json sink: sink ","function(self,source,sink)\r\nreturn (((self):handle()).all((source):json(), sink))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Pump,"step:sink:",0
,function(self,source,sink)
return (((self):handle()).step((source):json(), sink))
;
end
,"wrappers","step: source sink: sink \r\n\t\" Delegate _step to handle. \"\r\n\r\n\t^self handle #_step: source json sink: sink ","function(self,source,sink)\r\nreturn (((self):handle()).step((source):json(), sink))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Sink,"chain:sink:",0
,function(self,filter,sink)
return ((smalltalk.LTN12Sink):_at(((self):handle()).chain((filter):json(), sink)))
;
end
,"wrappers","chain: filter sink: sink \r\n\t\" Delegate _chain to handle. \"\r\n\r\n\t^LTN12Sink @ (self handle #_chain: filter json sink: sink )","function(self,filter,sink)\r\nreturn ((smalltalk.LTN12Sink):_at(((self):handle()).chain((filter):json(), sink)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Sink,"file:message:",0
,function(self,fileHandle,message)
return ((smalltalk.LTN12Sink):_at(((self):handle()).file(fileHandle, message)))
;
end
,"wrappers","file: fileHandle message: message \r\n\t\" Delegate _file to handle. \"\r\n\r\n\t^LTN12Sink @ (self handle #_file: fileHandle message: message )","function(self,fileHandle,message)\r\nreturn ((smalltalk.LTN12Sink):_at(((self):handle()).file(fileHandle, message)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Sink,"null",0
,function(self)
return ((smalltalk.LTN12Sink):_at(((self):handle()).null()))
;
end
,"wrappers","null\r\n\t\" Delegate _null to handle. \"\r\n\r\n\t^LTN12Sink @ (self handle #_null)","function(self)\r\nreturn ((smalltalk.LTN12Sink):_at(((self):handle()).null()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Sink,"table:",0
,function(self,table)
return ((smalltalk.LTN12Sink):_at(((self):handle()).table((table):json())))
;
end
,"wrappers","table: table \r\n\t\" Delegate _table to handle. \"\r\n\r\n\t^LTN12Sink @ (self handle #_table: table json )","function(self,table)\r\nreturn ((smalltalk.LTN12Sink):_at(((self):handle()).table((table):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Sink,"forError:",0
,function(self,message)
return (((self)["$klass"]):_at(((((self):handle())["error"])):evaluateWith_(message)))
;
end
,"accessing","forError: message\r\n\r\n\t^self class @ ((self handle basicAt: #error) evaluateWith: message)","function(self,message)\r\nreturn (((self)[\"$klass\"]):_at(((((self):handle())[\"error\"])):evaluateWith_(message)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Source,"cat:",0
,function(self,source1)
return ((smalltalk.LTN12Source):_at(((self):handle()).cat((source1):json())))
;
end
,"wrappers","cat: source1 \r\n\t\" Delegate _cat to handle. \"\r\n\r\n\t^LTN12Source @ (self handle #_cat: source1 json )","function(self,source1)\r\nreturn ((smalltalk.LTN12Source):_at(((self):handle()).cat((source1):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Source,"cat:source2:",0
,function(self,source1,source2)
return ((smalltalk.LTN12Source):_at(((self):handle()).cat((source1):json(), (source2):json())))
;
end
,"wrappers","cat: source1 source2: source2 \r\n\t\" Delegate _cat to handle. \"\r\n\r\n\t^LTN12Source @ (self handle #_cat: source1 json source2: source2 json )","function(self,source1,source2)\r\nreturn ((smalltalk.LTN12Source):_at(((self):handle()).cat((source1):json(), (source2):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Source,"cat:source2:source3:",0
,function(self,source1,source2,source3)
return ((smalltalk.LTN12Source):_at(((self):handle()).cat((source1):json(), (source2):json(), (source3):json())))
;
end
,"wrappers","cat: source1 source2: source2 source3: source3 \r\n\t\" Delegate _cat to handle. \"\r\n\r\n\t^LTN12Source @ (self handle #_cat: source1 json source2: source2 json source3: source3 json )","function(self,source1,source2,source3)\r\nreturn ((smalltalk.LTN12Source):_at(((self):handle()).cat((source1):json(), (source2):json(), (source3):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Source,"cat:source2:source3:source4:",0
,function(self,source1,source2,source3,source4)
return ((smalltalk.LTN12Source):_at(((self):handle()).cat((source1):json(), (source2):json(), (source3):json(), (source4):json())))
;
end
,"wrappers","cat: source1 source2: source2 source3: source3 source4: source4 \r\n\t\" Delegate _cat to handle. \"\r\n\r\n\t^LTN12Source @ (self handle #_cat: source1 json source2: source2 json source3: source3 json source4: source4 json )","function(self,source1,source2,source3,source4)\r\nreturn ((smalltalk.LTN12Source):_at(((self):handle()).cat((source1):json(), (source2):json(), (source3):json(), (source4):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Source,"chain:filter:",0
,function(self,source,filter)
return ((smalltalk.LTN12Source):_at(((self):handle()).chain((source):json(), (filter):json())))
;
end
,"wrappers","chain: source filter: filter \r\n\t\" Delegate _chain to handle. \"\r\n\r\n\t^LTN12Source @ (self handle #_chain: source json filter: filter json )","function(self,source,filter)\r\nreturn ((smalltalk.LTN12Source):_at(((self):handle()).chain((source):json(), (filter):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Source,"empty",0
,function(self)
return ((smalltalk.LTN12Source):_at(((self):handle()).empty()))
;
end
,"wrappers","empty\r\n\t\" Delegate _empty to handle. \"\r\n\r\n\t^LTN12Source @ (self handle #_empty)","function(self)\r\nreturn ((smalltalk.LTN12Source):_at(((self):handle()).empty()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Source,"file:message:",0
,function(self,fileHandle,message)
return ((smalltalk.LTN12Source):_at(((self):handle()).file(fileHandle, message)))
;
end
,"wrappers","file: fileHandle message: message \r\n\t\" Delegate _file to handle. \"\r\n\r\n\t^LTN12Source @ (self handle #_file: fileHandle message: message )","function(self,fileHandle,message)\r\nreturn ((smalltalk.LTN12Source):_at(((self):handle()).file(fileHandle, message)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Source,"simplify:",0
,function(self,source)
return ((smalltalk.LTN12Source):_at(((self):handle()).simplify((source):json())))
;
end
,"wrappers","simplify: source \r\n\t\" Delegate _simplify to handle. \"\r\n\r\n\t^LTN12Source @ (self handle #_simplify: source json )","function(self,source)\r\nreturn ((smalltalk.LTN12Source):_at(((self):handle()).simplify((source):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Source,"string:",0
,function(self,string)
return ((smalltalk.LTN12Source):_at(((self):handle()).string(string)))
;
end
,"wrappers","string: string \r\n\t\" Delegate _string to handle. \"\r\n\r\n\t^LTN12Source @ (self handle #_string: string )","function(self,string)\r\nreturn ((smalltalk.LTN12Source):_at(((self):handle()).string(string)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Source,"forError:",0
,function(self,message)
return (((self)["$klass"]):_at(((((self):handle())["error"])):evaluateWith_(message)))
;
end
,"accessing","forError: message\r\n\r\n\t^self class @ ((self handle basicAt: #error) evaluateWith: message)","function(self,message)\r\nreturn (((self)[\"$klass\"]):_at(((((self):handle())[\"error\"])):evaluateWith_(message)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LTN12Source,"catAll:",0
,function(self,anArray)
return (((self)["$klass"]):_at(((((self):handle())["cat"])):evaluateWithArguments_((anArray):handles())))
;
end
,"chain","catAll: anArray\r\n\r\n\t^self class @ ((self handle basicAt: #cat) evaluateWithArguments: anArray handles)","function(self,anArray)\r\nreturn (((self)[\"$klass\"]):_at(((((self):handle())[\"cat\"])):evaluateWithArguments_((anArray):handles())))\r\n;\r\nend")

smalltalk:addClass("Mime",smalltalk.LuaSocketObject,smalltalk:newArray({}),"luasocket")

smalltalk:bind(smalltalk.Lua["$klass"],"mime",0
,function(self)
return ((smalltalk.Mime):new())
;
end
,"accessing","mime\r\n\t\" Returns the wrapper to mime. \"\r\n\r\n\t^Mime new","function(self)\r\nreturn ((smalltalk.Mime):new())\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"initializeHandle",0
,function(self)
(self):handle_(require("mime"))
;
(function() if ((((((self['@handle']))==nil)))==true) then return ((function()
return ((self):error_("Missing mime support"))
end))() else return nil end end)()
;
return (self)
;
end
,"initialize","initializeHandle\r\n\t\" Private - Initialize the handle of the receiver. \"\r\n\r\n\tself handle: (# #require: #mime).\r\n\thandle isNil ifTrue: [ self error: 'Missing mime support' ] ","function(self)\r\n(self):handle_(require(\"mime\"))\r\n;\r\n(function() if ((((((self['@handle']))==nil)))==true) then return ((function()\r\nreturn ((self):error_(\"Missing mime support\"))\r\nend))() else return nil end end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"normalize",0
,function(self)
return (((self):handle()).normalize())
;
end
,"wrappers","normalize\r\n\t\" Delegate _normalize to handle. \"\r\n\r\n\t^self handle #_normalize","function(self)\r\nreturn (((self):handle()).normalize())\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"normalize:",0
,function(self,marker)
return (((self):handle()).normalize(marker))
;
end
,"wrappers","normalize: marker \r\n\t\" Delegate _normalize to handle. \"\r\n\r\n\t^self handle #_normalize: marker ","function(self,marker)\r\nreturn (((self):handle()).normalize(marker))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"decode:",0
,function(self,type)
return ((smalltalk.Mime):_at(((self):handle()).decode(type)))
;
end
,"wrappers","decode: type \r\n\t\" Delegate _decode to handle. \"\r\n\r\n\t^Mime @ (self handle #_decode: type )","function(self,type)\r\nreturn ((smalltalk.Mime):_at(((self):handle()).decode(type)))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"encode:",0
,function(self,type)
return ((smalltalk.Mime):_at(((self):handle()).encode(type)))
;
end
,"wrappers","encode: type \r\n\t\" Delegate _encode to handle. \"\r\n\r\n\t^Mime @ (self handle #_encode: type )","function(self,type)\r\nreturn ((smalltalk.Mime):_at(((self):handle()).encode(type)))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"encode:mode:",0
,function(self,type,mode)
return ((smalltalk.Mime):_at(((self):handle()).encode(type, mode)))
;
end
,"wrappers","encode: type mode: mode \r\n\t\" Delegate _encode to handle. \"\r\n\r\n\t^Mime @ (self handle #_encode: type mode: mode )","function(self,type,mode)\r\nreturn ((smalltalk.Mime):_at(((self):handle()).encode(type, mode)))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"stuff",0
,function(self)
return ((smalltalk.Mime):_at(((self):handle()).stuff()))
;
end
,"wrappers","stuff\r\n\t\" Delegate _stuff to handle. \"\r\n\r\n\t^Mime @ (self handle #_stuff)","function(self)\r\nreturn ((smalltalk.Mime):_at(((self):handle()).stuff()))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"wrap:",0
,function(self,type)
return ((smalltalk.Mime):_at(((self):handle()).wrap(type)))
;
end
,"wrappers","wrap: type \r\n\t\" Delegate _wrap to handle. \"\r\n\r\n\t^Mime @ (self handle #_wrap: type )","function(self,type)\r\nreturn ((smalltalk.Mime):_at(((self):handle()).wrap(type)))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"wrap:length:",0
,function(self,type,length)
return ((smalltalk.Mime):_at(((self):handle()).wrap(type, length)))
;
end
,"wrappers","wrap: type length: length \r\n\t\" Delegate _wrap to handle. \"\r\n\r\n\t^Mime @ (self handle #_wrap: type length: length )","function(self,type,length)\r\nreturn ((smalltalk.Mime):_at(((self):handle()).wrap(type, length)))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"b64:",0
,function(self,c)
return (((self):handle()).b64(c))
;
end
,"wrappers","b64: c \r\n\t\" Delegate _b64 to handle. \"\r\n\r\n\t^self handle #_b64: c ","function(self,c)\r\nreturn (((self):handle()).b64(c))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"b64:d:",0
,function(self,c,d)
return (((self):handle()).b64(c, d))
;
end
,"wrappers","b64: c d: d \r\n\t\" Delegate _b64 to handle. \"\r\n\r\n\t^self handle #_b64: c d: d ","function(self,c,d)\r\nreturn (((self):handle()).b64(c, d))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"dot:",0
,function(self,m)
return (((self):handle()).dot(m))
;
end
,"wrappers","dot: m \r\n\t\" Delegate _dot to handle. \"\r\n\r\n\t^self handle #_dot: m ","function(self,m)\r\nreturn (((self):handle()).dot(m))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"dot:b:",0
,function(self,m,b)
return (((self):handle()).dot(m, b))
;
end
,"wrappers","dot: m b: b \r\n\t\" Delegate _dot to handle. \"\r\n\r\n\t^self handle #_dot: m b: b ","function(self,m,b)\r\nreturn (((self):handle()).dot(m, b))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"eol:",0
,function(self,c)
return (((self):handle()).eol(c))
;
end
,"wrappers","eol: c \r\n\t\" Delegate _eol to handle. \"\r\n\r\n\t^self handle #_eol: c ","function(self,c)\r\nreturn (((self):handle()).eol(c))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"eol:d:marker:",0
,function(self,c,d,marker)
return (((self):handle()).eol(c, d, marker))
;
end
,"wrappers","eol: c d: d marker: marker \r\n\t\" Delegate _eol to handle. \"\r\n\r\n\t^self handle #_eol: c d: d marker: marker ","function(self,c,d,marker)\r\nreturn (((self):handle()).eol(c, d, marker))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"qp:",0
,function(self,c)
return (((self):handle()).qp(c))
;
end
,"wrappers","qp: c \r\n\t\" Delegate _qp to handle. \"\r\n\r\n\t^self handle #_qp: c ","function(self,c)\r\nreturn (((self):handle()).qp(c))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"qp:d:marker:",0
,function(self,c,d,marker)
return (((self):handle()).qp(c, d, marker))
;
end
,"wrappers","qp: c d: d marker: marker \r\n\t\" Delegate _qp to handle. \"\r\n\r\n\t^self handle #_qp: c d: d marker: marker ","function(self,c,d,marker)\r\nreturn (((self):handle()).qp(c, d, marker))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"qpwrp:",0
,function(self,n)
return (((self):handle()).qpwrp(n))
;
end
,"wrappers","qpwrp: n \r\n\t\" Delegate _qpwrp to handle. \"\r\n\r\n\t^self handle #_qpwrp: n ","function(self,n)\r\nreturn (((self):handle()).qpwrp(n))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"qpwrp:b:length:",0
,function(self,n,b,length)
return (((self):handle()).qpwrp(n, b, length))
;
end
,"wrappers","qpwrp: n b: b length: length \r\n\t\" Delegate _qpwrp to handle. \"\r\n\r\n\t^self handle #_qpwrp: n b: b length: length ","function(self,n,b,length)\r\nreturn (((self):handle()).qpwrp(n, b, length))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"unb64:",0
,function(self,c)
return (((self):handle()).unb64(c))
;
end
,"wrappers","unb64: c \r\n\t\" Delegate _unb64 to handle. \"\r\n\r\n\t^self handle #_unb64: c ","function(self,c)\r\nreturn (((self):handle()).unb64(c))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"unb64:d:",0
,function(self,c,d)
return (((self):handle()).unb64(c, d))
;
end
,"wrappers","unb64: c d: d \r\n\t\" Delegate _unb64 to handle. \"\r\n\r\n\t^self handle #_unb64: c d: d ","function(self,c,d)\r\nreturn (((self):handle()).unb64(c, d))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"unqp:",0
,function(self,c)
return (((self):handle()).unqp(c))
;
end
,"wrappers","unqp: c \r\n\t\" Delegate _unqp to handle. \"\r\n\r\n\t^self handle #_unqp: c ","function(self,c)\r\nreturn (((self):handle()).unqp(c))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"unqp:d:",0
,function(self,c,d)
return (((self):handle()).unqp(c, d))
;
end
,"wrappers","unqp: c d: d \r\n\t\" Delegate _unqp to handle. \"\r\n\r\n\t^self handle #_unqp: c d: d ","function(self,c,d)\r\nreturn (((self):handle()).unqp(c, d))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"wrp:",0
,function(self,n)
return (((self):handle()).wrp(n))
;
end
,"wrappers","wrp: n \r\n\t\" Delegate _wrp to handle. \"\r\n\r\n\t^self handle #_wrp: n ","function(self,n)\r\nreturn (((self):handle()).wrp(n))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"wrp:b:length:",0
,function(self,n,b,length)
return (((self):handle()).wrp(n, b, length))
;
end
,"wrappers","wrp: n b: b length: length \r\n\t\" Delegate _wrp to handle. \"\r\n\r\n\t^self handle #_wrp: n b: b length: length ","function(self,n,b,length)\r\nreturn (((self):handle()).wrp(n, b, length))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"decodeBase64",0
,function(self)
return ((self):decode_("base64"))
;
end
,"accessing","decodeBase64\r\n\r\n\t^self decode: #base64","function(self)\r\nreturn ((self):decode_(\"base64\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"encodeBase64",0
,function(self)
return ((self):encode_("base64"))
;
end
,"accessing","encodeBase64\r\n\r\n\t^self encode: #base64","function(self)\r\nreturn ((self):encode_(\"base64\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"decodeQuotedPrintable",0
,function(self)
return ((self):decode_("quoted-printable"))
;
end
,"accessing","decodeQuotedPrintable\r\n\r\n\t^self decode: 'quoted-printable'","function(self)\r\nreturn ((self):decode_(\"quoted-printable\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"encodeQuotedPrintable",0
,function(self)
return ((self):encode_("quoted-printable"))
;
end
,"accessing","encodeQuotedPrintable\r\n\r\n\t^self encode: 'quoted-printable'","function(self)\r\nreturn ((self):encode_(\"quoted-printable\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"wrapBase64",0
,function(self)
return ((self):wrap_("base64"))
;
end
,"accessing","wrapBase64\r\n\r\n\t^self wrap: #base64","function(self)\r\nreturn ((self):wrap_(\"base64\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"wrapQuotedPrintable",0
,function(self)
return ((self):wrap_("quoted-printable"))
;
end
,"accessing","wrapQuotedPrintable\r\n\r\n\t^self wrap: 'quoted-printable'","function(self)\r\nreturn ((self):wrap_(\"quoted-printable\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"wrapText",0
,function(self)
return ((self):wrap_("text"))
;
end
,"accessing","wrapText\r\n\r\n\t^self wrap: #text","function(self)\r\nreturn ((self):wrap_(\"text\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.Mime,"wrapText:",0
,function(self,length)
return ((self):wrap_length_("text", length))
;
end
,"accessing","wrapText: length\r\n\r\n\t^self wrap: #text length: length","function(self,length)\r\nreturn ((self):wrap_length_(\"text\", length))\r\n;\r\nend")

smalltalk:bind(smalltalk.SMTP,"send:",0
,function(self,options)
return (((self):handle()).send((options):json()))
;
end
,"wrappers","send: options \r\n\t\" Delegate _send to handle. \"\r\n\r\n\t^self handle #_send: options json ","function(self,options)\r\nreturn (((self):handle()).send((options):json()))\r\n;\r\nend")

smalltalk:bind(smalltalk.SMTP,"message:",0
,function(self,mesgt)
return ((smalltalk.LTN12Source):_at(((self):handle()).message((mesgt):json())))
;
end
,"wrappers","message: mesgt \r\n\t\" Delegate _message to handle. \"\r\n\r\n\t^LTN12Source @ (self handle #_message: mesgt json )","function(self,mesgt)\r\nreturn ((smalltalk.LTN12Source):_at(((self):handle()).message((mesgt):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.SMTP,"send:",0
,function(self,options)
return ((self):send_onError_(options, (function(err)
return ((self):error_(err))
end)))
;
end
,"sending","send: options\r\n\t^self\tsend: options\r\n\t\tonError: [:err| self error: err ]","function(self,options)\r\nreturn ((self):send_onError_(options, (function(err)\r\nreturn ((self):error_(err))\r\nend)))\r\n;\r\nend")

smalltalk:bind(smalltalk.SMTP,"send:onError:",0
,function(self,options,aBlock)
local result=nil
local error=nil
	result, error = self:handle().send(options:json())
	if error then return aBlock:evaluateWith_(error) end
;
return (true)
;
end
,"sending","send: options onError: aBlock\r\n\t| result error |\r\n{'\tresult, error = self:handle().send(options:json())\r\n\tif error then return aBlock:evaluateWith_(error) end'}.\r\n\t^true","function(self,options,aBlock)\r\nlocal result=nil\r\nlocal error=nil\r\n\tresult, error = self:handle().send(options:json())\r\n\tif error then return aBlock:evaluateWith_(error) end\r\n;\r\nreturn (true)\r\n;\r\nend")

smalltalk:bind(smalltalk.SMTP,"send:to:source:user:password:server:port:domain:step:create:",0
,function(self,from,rcpt,source,user,password,server,port,domain,step,aBlock)
local options=nil
(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((("from"):_minus_gt(from)),("rcpt"):_minus_gt(rcpt))),("source"):_minus_gt(source)))
	options=_s8_value; return _s8_value
end)()
;
(function() if ((((((user))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("user"):_minus_gt(user)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((password))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("password"):_minus_gt(password)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((server))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("server"):_minus_gt(server)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((port))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("port"):_minus_gt(port)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((domain))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("domain"):_minus_gt(domain)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((step))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("step"):_minus_gt(step)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
(function() if ((((((aBlock))~=nil)))==true) then return ((function()
return ((function()
	local _s8_value=(smalltalk:object_comma_((options),("create"):_minus_gt(aBlock)))
	options=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
return ((self):send_(options))
;
end
,"send","send: from to: rcpt source: source\r\n\tuser: user password: password\r\n\tserver: server port: port domain: domain\r\n\tstep: step create: aBlock\r\n\r\n\t| options |\r\n\toptions := #from -> from\r\n\t\t,(#rcpt -> rcpt)\r\n\t\t,(#source -> source).\r\n\tuser notNil ifTrue: [ options := options ,(#user -> user) ].\r\n\tpassword notNil ifTrue: [ options := options ,(#password -> password) ].\r\n\tserver notNil ifTrue: [ options := options ,(#server -> server) ].\r\n\tport notNil ifTrue: [ options := options ,(#port -> port) ].\r\n\tdomain notNil ifTrue: [ options := options ,(#domain -> domain) ].\r\n\tstep notNil ifTrue: [ options := options ,(#step -> step) ].\r\n\taBlock notNil ifTrue: [ options := options ,(#create -> aBlock) ].\r\n\t^self send: options","function(self,from,rcpt,source,user,password,server,port,domain,step,aBlock)\r\nlocal options=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((\"from\"):_minus_gt(from)),(\"rcpt\"):_minus_gt(rcpt))),(\"source\"):_minus_gt(source)))\r\n\toptions=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((user))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"user\"):_minus_gt(user)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((password))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"password\"):_minus_gt(password)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((server))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"server\"):_minus_gt(server)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((port))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"port\"):_minus_gt(port)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((domain))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"domain\"):_minus_gt(domain)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((step))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"step\"):_minus_gt(step)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function() if ((((((aBlock))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((options),(\"create\"):_minus_gt(aBlock)))\r\n\toptions=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\nreturn ((self):send_(options))\r\n;\r\nend")

smalltalk:bind(smalltalk.SMTP,"send:to:source:user:password:server:port:domain:",0
,function(self,from,rcpt,source,user,password,server,port,domain)
return ((self):send_to_source_user_password_server_port_domain_step_create_(from, rcpt, source, user, password, server, port, domain, nil, nil))
;
end
,"send","send: from to: rcpt source: source\r\n\tuser: user password: password\r\n\tserver: server port: port domain: domain\r\n\r\n\t^self\r\n\t\tsend: from to: rcpt source: source\r\n\t\tuser: user password: password\r\n\t\tserver: server port: port domain: domain\r\n\t\tstep: nil create: nil","function(self,from,rcpt,source,user,password,server,port,domain)\r\nreturn ((self):send_to_source_user_password_server_port_domain_step_create_(from, rcpt, source, user, password, server, port, domain, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.SMTP,"send:to:source:user:password:",0
,function(self,from,rcpt,source,user,password)
return ((self):send_to_source_user_password_server_port_domain_step_create_(from, rcpt, source, user, password, nil, nil, nil, nil, nil))
;
end
,"send","send: from to: rcpt source: source\r\n\tuser: user password: password\r\n\r\n\t^self\r\n\t\tsend: from to: rcpt source: source\r\n\t\tuser: user password: password\r\n\t\tserver: nil port: nil domain: nil\r\n\t\tstep: nil create: nil","function(self,from,rcpt,source,user,password)\r\nreturn ((self):send_to_source_user_password_server_port_domain_step_create_(from, rcpt, source, user, password, nil, nil, nil, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.SMTP,"send:to:source:",0
,function(self,from,rcpt,source)
return ((self):send_to_source_user_password_(from, rcpt, source, nil, nil))
;
end
,"send","send: from to: rcpt source: source\r\n\r\n\t^self\r\n\t\tsend: from to: rcpt source: source\r\n\t\tuser: nil password: nil","function(self,from,rcpt,source)\r\nreturn ((self):send_to_source_user_password_(from, rcpt, source, nil, nil))\r\n;\r\nend")

smalltalk:bind(smalltalk.SMTP,"message:body:",0
,function(self,headers,body)
return ((self):message_(smalltalk:object_comma_((("headers"):_minus_gt(headers)),("body"):_minus_gt(body))))
;
end
,"send","message: headers body: body\r\n\r\n\t^self message: #headers -> headers ,(#body -> body)","function(self,headers,body)\r\nreturn ((self):message_(smalltalk:object_comma_(((\"headers\"):_minus_gt(headers)),(\"body\"):_minus_gt(body))))\r\n;\r\nend")

smalltalk:bind(smalltalk.SMTP,"message:preamble:parts:epoligue:",0
,function(self,headers,preamble,anArray,epilogue)
local parts=nil
local i=nil
(function()
	local _s8_value=((0))
	i=_s8_value; return _s8_value
end)()
;
(function()
	local _s8_value=((anArray):inject_into_(nil, (function(total,each)
(function()
	local _s8_value=((i):_plus((1)))
	i=_s8_value; return _s8_value
end)();return ((function() if ((((((total))==nil)))==true) then return ((function()
return ((i):_minus_gt(each))
end))() else return ((function()
return (smalltalk:object_comma_((total),(i):_minus_gt(each)))
end))() end end)())
end)))
	parts=_s8_value; return _s8_value
end)()
;
return ((self):message_(smalltalk:object_comma_((("headers"):_minus_gt(headers)),("body"):_minus_gt(smalltalk:object_comma_((smalltalk:object_comma_((("preamble"):_minus_gt(preamble)),parts)),("epilogue"):_minus_gt(epilogue))))))
;
end
,"send","message: headers preamble: preamble parts: anArray epoligue: epilogue\r\n\r\n\t| parts i |\r\n\ti := 0.\r\n\tparts := anArray inject: nil into: [:total :each|\r\n\t\ti := i + 1.\r\n\t\ttotal isNil ifTrue: [ i -> each ]\r\n\t\tifFalse: [ total ,(i -> each )]\r\n\t].\r\n\t^self message: #headers -> headers\r\n\t\t,(#body -> ((#preamble -> preamble)\r\n\t\t\t,parts\r\n\t\t\t,(#epilogue -> epilogue)))","function(self,headers,preamble,anArray,epilogue)\r\nlocal parts=nil\r\nlocal i=nil\r\n(function()\r\n\tlocal _s8_value=((0))\r\n\ti=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function()\r\n\tlocal _s8_value=((anArray):inject_into_(nil, (function(total,each)\r\n(function()\r\n\tlocal _s8_value=((i):_plus((1)))\r\n\ti=_s8_value; return _s8_value\r\nend)();return ((function() if ((((((total))==nil)))==true) then return ((function()\r\nreturn ((i):_minus_gt(each))\r\nend))() else return ((function()\r\nreturn (smalltalk:object_comma_((total),(i):_minus_gt(each)))\r\nend))() end end)())\r\nend)))\r\n\tparts=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn ((self):message_(smalltalk:object_comma_(((\"headers\"):_minus_gt(headers)),(\"body\"):_minus_gt(smalltalk:object_comma_((smalltalk:object_comma_(((\"preamble\"):_minus_gt(preamble)),parts)),(\"epilogue\"):_minus_gt(epilogue))))))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"accept",0
,function(self)
return ((smalltalk.TCP):_at(((self):handle()):accept()))
;
end
,"wrappers","accept\r\n\t\" Delegate accept to handle. \"\r\n\r\n\t^TCP @ (self handle #accept)","function(self)\r\nreturn ((smalltalk.TCP):_at(((self):handle()):accept()))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"bind:port:",0
,function(self,address,port)
return ((smalltalk.Boolean):_at(((self):handle()):bind(address, port)))
;
end
,"wrappers","bind: address port: port \r\n\t\" Delegate bind to handle. \"\r\n\r\n\t^Boolean @ (self handle #bind: address port: port )","function(self,address,port)\r\nreturn ((smalltalk.Boolean):_at(((self):handle()):bind(address, port)))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"connect:port:",0
,function(self,address,port)
return ((smalltalk.Boolean):_at(((self):handle()):connect(address, port)))
;
end
,"wrappers","connect: address port: port \r\n\t\" Delegate connect to handle. \"\r\n\r\n\t^Boolean @ (self handle #connect: address port: port )","function(self,address,port)\r\nreturn ((smalltalk.Boolean):_at(((self):handle()):connect(address, port)))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"getstats",0
,function(self)
return ((smalltalk.PoolDictionary):_at(((self):handle()):getstats()))
;
end
,"wrappers","getstats\r\n\t\" Delegate getstats to handle. \"\r\n\r\n\t^PoolDictionary @ (self handle #getstats)","function(self)\r\nreturn ((smalltalk.PoolDictionary):_at(((self):handle()):getstats()))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"listen:",0
,function(self,backlog)
return ((smalltalk.Boolean):_at(((self):handle()):listen(backlog)))
;
end
,"wrappers","listen: backlog \r\n\t\" Delegate listen to handle. \"\r\n\r\n\t^Boolean @ (self handle #listen: backlog )","function(self,backlog)\r\nreturn ((smalltalk.Boolean):_at(((self):handle()):listen(backlog)))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"send:",0
,function(self,data)
return (((self):handle()):send((data):json()))
;
end
,"wrappers","send: data \r\n\t\" Delegate send to handle. \"\r\n\r\n\t^self handle #send: data json ","function(self,data)\r\nreturn (((self):handle()):send((data):json()))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"send:i:",0
,function(self,data,i)
return (((self):handle()):send((data):json(), i))
;
end
,"wrappers","send: data i: i \r\n\t\" Delegate send to handle. \"\r\n\r\n\t^self handle #send: data json i: i ","function(self,data,i)\r\nreturn (((self):handle()):send((data):json(), i))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"send:i:j:",0
,function(self,data,i,j)
return (((self):handle()):send((data):json(), i, j))
;
end
,"wrappers","send: data i: i j: j \r\n\t\" Delegate send to handle. \"\r\n\r\n\t^self handle #send: data json i: i j: j ","function(self,data,i,j)\r\nreturn (((self):handle()):send((data):json(), i, j))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"setstats:sent:age:",0
,function(self,received,sent,age)
return (((self):handle()):setstats(received, sent, age))
;
end
,"wrappers","setstats: received sent: sent age: age \r\n\t\" Delegate setstats to handle. \"\r\n\r\n\t^self handle #setstats: received sent: sent age: age ","function(self,received,sent,age)\r\nreturn (((self):handle()):setstats(received, sent, age))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"settimeout:mode:",0
,function(self,value,mode)
return (((self):handle()):settimeout(value, mode))
;
end
,"wrappers","settimeout: value mode: mode \r\n\t\" Delegate settimeout to handle. \"\r\n\r\n\t^self handle #settimeout: value mode: mode ","function(self,value,mode)\r\nreturn (((self):handle()):settimeout(value, mode))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"shutdown",0
,function(self)
return (((self):handle()):shutdown())
;
end
,"wrappers","shutdown\r\n\t\" Delegate shutdown to handle. \"\r\n\r\n\t^self handle #shutdown","function(self)\r\nreturn (((self):handle()):shutdown())\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"shutdown:",0
,function(self,mode)
return (((self):handle()):shutdown(mode))
;
end
,"wrappers","shutdown: mode \r\n\t\" Delegate shutdown to handle. \"\r\n\r\n\t^self handle #shutdown: mode ","function(self,mode)\r\nreturn (((self):handle()):shutdown(mode))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"acceptOrNil",0
,function(self)
local result=nil
local err=nil
	result, err = self:handle():accept() 
;
return ((smalltalk.TCP):_at(result))
;
end
,"accept","acceptOrNil\r\n\t| result err |\r\n{'\tresult, err = self:handle():accept() '}.\r\n\t^TCP @ result","function(self)\r\nlocal result=nil\r\nlocal err=nil\r\n\tresult, err = self:handle():accept() \r\n;\r\nreturn ((smalltalk.TCP):_at(result))\r\n;\r\nend")

smalltalk:bind(smalltalk.TCP,"receive:",0
,function(self,pattern)
local s=nil
local status=nil
local partial=nil
	s, status, partial = self:handle():receive(pattern) 
;
return ((smalltalk.Array):with_with_with_(s, status, partial))
;
end
,"receiving","receive: pattern\r\n\t| s status partial |\r\n{'\ts, status, partial = self:handle():receive(pattern) '}.\r\n\t^Array with: s with: status with: partial","function(self,pattern)\r\nlocal s=nil\r\nlocal status=nil\r\nlocal partial=nil\r\n\ts, status, partial = self:handle():receive(pattern) \r\n;\r\nreturn ((smalltalk.Array):with_with_with_(s, status, partial))\r\n;\r\nend")

smalltalk:bind(smalltalk.UDP,"receive:",0
,function(self,size)
return (((self):handle()):receive(size))
;
end
,"wrappers","receive: size \r\n\t\" Delegate receive to handle. \"\r\n\r\n\t^self handle #receive: size ","function(self,size)\r\nreturn (((self):handle()):receive(size))\r\n;\r\nend")

smalltalk:bind(smalltalk.UDP,"send:",0
,function(self,datagram)
return (((self):handle()):send((datagram):json()))
;
end
,"wrappers","send: datagram \r\n\t\" Delegate send to handle. \"\r\n\r\n\t^self handle #send: datagram json ","function(self,datagram)\r\nreturn (((self):handle()):send((datagram):json()))\r\n;\r\nend")

smalltalk:bind(smalltalk.UDP,"sendto:ip:port:",0
,function(self,datagram,ip,port)
return (((self):handle()):sendto((datagram):json(), ip, port))
;
end
,"wrappers","sendto: datagram ip: ip port: port \r\n\t\" Delegate sendto to handle. \"\r\n\r\n\t^self handle #sendto: datagram json ip: ip port: port ","function(self,datagram,ip,port)\r\nreturn (((self):handle()):sendto((datagram):json(), ip, port))\r\n;\r\nend")

smalltalk:bind(smalltalk.UDP,"setpeername:",0
,function(self,address)
return (((self):handle()):setpeername(address))
;
end
,"wrappers","setpeername: address \r\n\t\" Delegate setpeername to handle. \"\r\n\r\n\t^self handle #setpeername: address ","function(self,address)\r\nreturn (((self):handle()):setpeername(address))\r\n;\r\nend")

smalltalk:bind(smalltalk.UDP,"setpeername:port:",0
,function(self,address,port)
return (((self):handle()):setpeername(address, port))
;
end
,"wrappers","setpeername: address port: port \r\n\t\" Delegate setpeername to handle. \"\r\n\r\n\t^self handle #setpeername: address port: port ","function(self,address,port)\r\nreturn (((self):handle()):setpeername(address, port))\r\n;\r\nend")

smalltalk:bind(smalltalk.UDP,"setsockname:port:",0
,function(self,address,port)
return (((self):handle()):setsockname(address, port))
;
end
,"wrappers","setsockname: address port: port \r\n\t\" Delegate setsockname to handle. \"\r\n\r\n\t^self handle #setsockname: address port: port ","function(self,address,port)\r\nreturn (((self):handle()):setsockname(address, port))\r\n;\r\nend")

smalltalk:bind(smalltalk.UDP,"receive:",0
,function(self,size)
local s=nil
local status=nil
	s, status = self:handle():receive(size) 
;
return ((smalltalk.Array):with_with_(s, status))
;
end
,"receiving","receive: size\r\n\t| s status |\r\n{'\ts, status = self:handle():receive(size) '}.\r\n\t^Array with: s with: status","function(self,size)\r\nlocal s=nil\r\nlocal status=nil\r\n\ts, status = self:handle():receive(size) \r\n;\r\nreturn ((smalltalk.Array):with_with_(s, status))\r\n;\r\nend")

smalltalk:bind(smalltalk.UDP,"receivefrom:",0
,function(self,size)
local s=nil
local status=nil
	s, status = self:handle():receivefrom(size) 
;
return ((smalltalk.Array):with_with_(s, status))
;
end
,"receiving","receivefrom: size\r\n\t| s status |\r\n{'\ts, status = self:handle():receivefrom(size) '}.\r\n\t^Array with: s with: status","function(self,size)\r\nlocal s=nil\r\nlocal status=nil\r\n\ts, status = self:handle():receivefrom(size) \r\n;\r\nreturn ((smalltalk.Array):with_with_(s, status))\r\n;\r\nend")

smalltalk:bind(smalltalk.UDP,"receivefrom",0
,function(self)
local s=nil
local status=nil
	s, status = self:handle():receivefrom() 
;
return ((smalltalk.Array):with_with_(s, status))
;
end
,"receiving","receivefrom\r\n\t| s status |\r\n{'\ts, status = self:handle():receivefrom() '}.\r\n\t^Array with: s with: status","function(self)\r\nlocal s=nil\r\nlocal status=nil\r\n\ts, status = self:handle():receivefrom() \r\n;\r\nreturn ((smalltalk.Array):with_with_(s, status))\r\n;\r\nend")

smalltalk:bind(smalltalk.UDP,"send:onError:",0
,function(self,datagram,aBlock)
local result=nil
local error=nil
	result, error = self:send_(datagram,ip,port)
	if error then return aBlock:evaluateWith_(error) end
;
return (true)
;
end
,"sending","send: datagram onError: aBlock\r\n\t| result error |\r\n{'\tresult, error = self:send_(datagram,ip,port)\r\n\tif error then return aBlock:evaluateWith_(error) end'}.\r\n\t^true","function(self,datagram,aBlock)\r\nlocal result=nil\r\nlocal error=nil\r\n\tresult, error = self:send_(datagram,ip,port)\r\n\tif error then return aBlock:evaluateWith_(error) end\r\n;\r\nreturn (true)\r\n;\r\nend")

smalltalk:bind(smalltalk.UDP,"sendto:ip:port:onError:",0
,function(self,datagram,ip,port,aBlock)
local result=nil
local error=nil
	result, error = self:sendto_ip_port_(datagram,ip,port)
	if error then return aBlock:evaluateWith_(error) end
;
return (true)
;
end
,"sending","sendto: datagram ip: ip port: port onError: aBlock\r\n\t| result error |\r\n{'\tresult, error = self:sendto_ip_port_(datagram,ip,port)\r\n\tif error then return aBlock:evaluateWith_(error) end'}.\r\n\t^true","function(self,datagram,ip,port,aBlock)\r\nlocal result=nil\r\nlocal error=nil\r\n\tresult, error = self:sendto_ip_port_(datagram,ip,port)\r\n\tif error then return aBlock:evaluateWith_(error) end\r\n;\r\nreturn (true)\r\n;\r\nend")

smalltalk:bind(smalltalk.URL["$klass"],"nativeClass",0
,function(self)
return ((smalltalk.Lua):_at(require("socket.url")))
;
end
,"accessing","nativeClass\r\n\t\" Private - Returns the native module. \"\r\n\r\n\t^Lua @ (# #require: 'socket.url')","function(self)\r\nreturn ((smalltalk.Lua):_at(require(\"socket.url\")))\r\n;\r\nend")

smalltalk:bind(smalltalk.URL["$klass"],"absolute:relative:",0
,function(self,base,relative)
return ((((self):nativeClass()):handle()).absolute(base, relative))
;
end
,"wrappers","absolute: base relative: relative \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_absolute: base relative: relative ","function(self,base,relative)\r\nreturn ((((self):nativeClass()):handle()).absolute(base, relative))\r\n;\r\nend")

smalltalk:bind(smalltalk.URL["$klass"],"build:",0
,function(self,parsed)
return ((((self):nativeClass()):handle()).build((parsed):json()))
;
end
,"wrappers","build: parsed \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_build: parsed json ","function(self,parsed)\r\nreturn ((((self):nativeClass()):handle()).build((parsed):json()))\r\n;\r\nend")

smalltalk:bind(smalltalk.URL["$klass"],"escape:",0
,function(self,content)
return ((((self):nativeClass()):handle()).escape(content))
;
end
,"wrappers","escape: content \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_escape: content ","function(self,content)\r\nreturn ((((self):nativeClass()):handle()).escape(content))\r\n;\r\nend")

smalltalk:bind(smalltalk.URL["$klass"],"parse:",0
,function(self,url)
return ((smalltalk.Lua):_at((((self):nativeClass()):handle()).parse(url)))
;
end
,"wrappers","parse: url \r\n\t\" Delegated to native class. \"\r\n\r\n\t^Lua @ (self nativeClass handle #_parse: url )","function(self,url)\r\nreturn ((smalltalk.Lua):_at((((self):nativeClass()):handle()).parse(url)))\r\n;\r\nend")

smalltalk:bind(smalltalk.URL["$klass"],"parse:default:",0
,function(self,url,default)
return ((smalltalk.Lua):_at((((self):nativeClass()):handle()).parse(url, default)))
;
end
,"wrappers","parse: url default: default \r\n\t\" Delegated to native class. \"\r\n\r\n\t^Lua @ (self nativeClass handle #_parse: url default: default )","function(self,url,default)\r\nreturn ((smalltalk.Lua):_at((((self):nativeClass()):handle()).parse(url, default)))\r\n;\r\nend")

smalltalk:bind(smalltalk.URL["$klass"],"unescape:",0
,function(self,content)
return ((((self):nativeClass()):handle()).unescape(content))
;
end
,"wrappers","unescape: content \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self nativeClass handle #_unescape: content ","function(self,content)\r\nreturn ((((self):nativeClass()):handle()).unescape(content))\r\n;\r\nend")
