-- fileIn("s8/library/sharing/Sharing-FileIn.st");
smalltalk:addClass("StringifiedReader",smalltalk.FileInReader,smalltalk:newArray({"action","objectifier"}),"Sharing-FileIn")

smalltalk:bind(smalltalk.StringifiedReader,"action:",0
,function(self,aBlock)
(function()
	local _s8_value=(aBlock)
	self['@action']=_s8_value; return _s8_value
end)()
;
return (self)
;
end
,"accessing","action: aBlock\r\n\t\" Set the action to evaluate on each object read. \"\r\n\r\n\taction := aBlock","function(self,aBlock)\r\n(function()\r\n\tlocal _s8_value=(aBlock)\r\n\tself['@action']=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.StringifiedReader,"objectifier:",0
,function(self,anObjectifier)
(function()
	local _s8_value=(anObjectifier)
	self['@objectifier']=_s8_value; return _s8_value
end)()
;
return (self)
;
end
,"accessing","objectifier: anObjectifier\r\n\t\" Set the objectifier in use to read objects. \"\r\n\r\n\tobjectifier := anObjectifier","function(self,anObjectifier)\r\n(function()\r\n\tlocal _s8_value=(anObjectifier)\r\n\tself['@objectifier']=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.StringifiedReader,"objectifier",0
,function(self)
(function() if ((((((self['@objectifier']))==nil)))==true) then return ((function()
return ((function()
	local _s8_value=((smalltalk.Objectifier):new())
	self['@objectifier']=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
return (self['@objectifier'])
;
end
,"accessing","objectifier\r\n\t\" Returns the objectifier in use to read objects. \"\r\n\r\n\tobjectifier isNil ifTrue: [ objectifier := Objectifier new ].\r\n\t^objectifier","function(self)\r\n(function() if ((((((self['@objectifier']))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=((smalltalk.Objectifier):new())\r\n\tself['@objectifier']=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\nreturn (self['@objectifier'])\r\n;\r\nend")

smalltalk:bind(smalltalk.StringifiedReader,"scanFrom:",0
,function(self,aStream)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local chunk=nil
local object=nil
(function()
	local _s8_value=((aStream):nextChunk())
	chunk=_s8_value; return _s8_value
end)()
;
(function() if ((((chunk):isEmpty()))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (nil)
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
	local _s8_value=(((self):objectifier()):objectFrom_(chunk))
	object=_s8_value; return _s8_value
end)()
;
(function() if ((((((self['@action']))==nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (object)
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self['@action']):evaluateWith_(object))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"fileIn","scanFrom: aStream\r\n\t\" FileIn - Parse next chunk in aStream as stringified contents, evaluating action on the object read. \"\r\n\r\n\t| chunk object |\r\n\tchunk := aStream nextChunk.\r\n\tchunk isEmpty ifTrue: [ ^nil ].\r\n\tobject := self objectifier objectFrom: chunk.\r\n\taction isNil ifTrue: [ ^object ].\r\n\t^action evaluateWith: object","function(self,aStream)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal chunk=nil\r\nlocal object=nil\r\n(function()\r\n\tlocal _s8_value=((aStream):nextChunk())\r\n\tchunk=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((chunk):isEmpty()))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (nil)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n\tlocal _s8_value=(((self):objectifier()):objectFrom_(chunk))\r\n\tobject=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((self['@action']))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (object)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self['@action']):evaluateWith_(object))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"objectsDoing:",0
,function(self,aBlock)
return ((
function(_s8_rec)
(_s8_rec):action_(aBlock);
return ((_s8_rec):yourself())
end
)((smalltalk.StringifiedReader):new()))
;
end
,"Sharing-FileIn","objectsDoing: aBlock\r\n\t\" FileIn - Return a reader to fileIn stringified objects.\r\n\taBlock is evaluated with each object read.\r\n\t\"\r\n\r\n\t^StringifiedReader new\r\n\t\taction: aBlock;\r\n\t\tyourself","function(self,aBlock)\r\nreturn ((\r\nfunction(_s8_rec)\r\n(_s8_rec):action_(aBlock);\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.StringifiedReader):new()))\r\n;\r\nend")

smalltalk:bind(smalltalk.Smalltalk["$klass"],"objects",0
,function(self)
return ((smalltalk.StringifiedReader):new())
;
end
,"Sharing-FileIn","objects\r\n\t\" FileIn - Return a reader to fileIn stringified objects. \"\r\n\r\n\t^StringifiedReader new","function(self)\r\nreturn ((smalltalk.StringifiedReader):new())\r\n;\r\nend")
