-- fileIn("library/love/LoveApplication.st");
smalltalk:addClass("LoveApplication",smalltalk.Object,smalltalk:newArray({}),"LoveApplication")

smalltalk.LoveApplication["$klass"]["$iVarNames"]=smalltalk:newArray({"current"});

smalltalk:bind(smalltalk.LoveApplication["$klass"],"initializeCurrent",0
,function(self)
(function()
	local _s8_value=((self):new())
	self['@current']=_s8_value; return _s8_value
end)()
;
return (self)
;
end
,"initialize","initializeCurrent\r\n\t\" Private - Initialize the current of the receiver. \"\r\n\r\n\tcurrent := self new","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):new())\r\n\tself['@current']=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveApplication["$klass"],"current",0
,function(self)
(function() if ((((((self['@current']))==nil)))==true) then return ((function()
return ((self):initializeCurrent())
end))() else return nil end end)()
;
return (self['@current'])
;
end
,"accessing","current\r\n\t\" Return the current of the receiver. \"\r\n\r\n\tcurrent isNil ifTrue: [ self initializeCurrent ].\r\n\t^current","function(self)\r\n(function() if ((((((self['@current']))==nil)))==true) then return ((function()\r\nreturn ((self):initializeCurrent())\r\nend))() else return nil end end)()\r\n;\r\nreturn (self['@current'])\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveApplication["$klass"],"current:",0
,function(self,anObject)
(function()
	local _s8_value=(anObject)
	self['@current']=_s8_value; return _s8_value
end)()
;
return (self)
;
end
,"accessing","current: anObject\r\n\t\" Set the current of the receiver. \"\r\n\r\n\tcurrent := anObject","function(self,anObject)\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\tself['@current']=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveApplication["$klass"],"constructEventsTriggered",0
,function(self)
return (smalltalk:object_comma_((smalltalk:newArray({"aboutToInstall", "installed", "load", "draw", "update:", "focus:", "mouseFocus:", "lowMemory", "quit", "thread:error:", "directoryDropped:", "fileDropped:", "resize:", "visible:", "keyDown:scancode:isRepeat:", "keyUp:scancode:", "textEdited:start:length:", "textInput:", "mouse:moved:isTouch:", "mouse:pressed:isTouch:presses:", "mouse:released:isTouch:presses:", "wheelMoved:", "gamepad:axis:value:", "gamepadDown:button:", "gamepadUp:button:", "joystickAdded:", "joystickRemoved:", "joystick:axis:value:", "joystick:hat:direction:", "joystickDown:button:", "joystickUp:button:", "touch:moved:by:pressure:", "touch:down:by:pressure:", "touch:up:by:pressure:"})),smalltalk:superImplementor(smalltalk.LoveApplication["$klass"],"constructEventsTriggered")(self)))
;
end
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^#(\taboutToInstall installed\r\n\t\tload draw update:\r\n\t\tfocus: mouseFocus:\r\n\t\tlowMemory quit thread:error:\r\n\t\tdirectoryDropped: fileDropped:\r\n\t\tresize: visible:\r\n\t\tkeyDown:scancode:isRepeat:\r\n\t\tkeyUp:scancode:\r\n\t\ttextEdited:start:length: textInput:\r\n\t\tmouse:moved:isTouch:\r\n\t\tmouse:pressed:isTouch:presses:\r\n\t\tmouse:released:isTouch:presses:\r\n\t\twheelMoved:\r\n\t\tgamepad:axis:value: gamepadDown:button: gamepadUp:button:\r\n\t\tjoystickAdded: joystickRemoved:\r\n\t\tjoystick:axis:value: joystick:hat:direction:\r\n\t\tjoystickDown:button: joystickUp:button:\r\n\t\ttouch:moved:by:pressure:\r\n\t\ttouch:down:by:pressure:\r\n\t\ttouch:up:by:pressure:\r\n\t) ,super constructEventsTriggered","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:newArray({\"aboutToInstall\", \"installed\", \"load\", \"draw\", \"update:\", \"focus:\", \"mouseFocus:\", \"lowMemory\", \"quit\", \"thread:error:\", \"directoryDropped:\", \"fileDropped:\", \"resize:\", \"visible:\", \"keyDown:scancode:isRepeat:\", \"keyUp:scancode:\", \"textEdited:start:length:\", \"textInput:\", \"mouse:moved:isTouch:\", \"mouse:pressed:isTouch:presses:\", \"mouse:released:isTouch:presses:\", \"wheelMoved:\", \"gamepad:axis:value:\", \"gamepadDown:button:\", \"gamepadUp:button:\", \"joystickAdded:\", \"joystickRemoved:\", \"joystick:axis:value:\", \"joystick:hat:direction:\", \"joystickDown:button:\", \"joystickUp:button:\", \"touch:moved:by:pressure:\", \"touch:down:by:pressure:\", \"touch:up:by:pressure:\"})),smalltalk:superImplementor(smalltalk.LoveApplication[\"$klass\"],\"constructEventsTriggered\")(self)))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveApplication,"installGeneralCallbacks",0
,function(self)
(
function(_s8_rec)
(_s8_rec):on_do_("load", (function()
return ((self):triggerEvent_("load"))
end));
(_s8_rec):on_do_("draw", (function()
return ((self):triggerEvent_("draw"))
end));
(_s8_rec):on_do_("lowmemory", (function()
return ((self):triggerEvent_("lowMemory"))
end));
(_s8_rec):on_do_("update", (function(dt)
return ((self):triggerEvent_with_("update:", dt))
end));
(_s8_rec):on_do_("quit", (function()
return (((false)~=(self):triggerEvent_("quit")))
end));
(_s8_rec):on_do_("threaderror", (function(thread,errorString)
return ((self):triggerEvent_withArguments_("thread:error:", (smalltalk.Array):with_with_((smalltalk.Thread):_at(thread), errorString)))
end));
return ((_s8_rec):yourself())
end
)(smalltalk.Love)
;
return (self)
;
end
,"installation","installGeneralCallbacks\r\n\t\" Private - Set callbacks of this type \"\r\n\r\n\tLove\ton: #load do: [ self triggerEvent: #load ];\r\n\t\ton: #draw do: [ self triggerEvent: #draw ];\r\n\t\ton: #lowmemory do: [ self triggerEvent: #lowMemory ];\r\n\t\ton: #update do: [:dt | self triggerEvent: #update: with: dt ];\r\n\t\ton: #quit do: [ false ~~ (self triggerEvent: #quit) ];\r\n\t\ton: #threaderror do: [:thread :errorString|\r\n\t\t\tself triggerEvent: #thread:error: withArguments: (Array\r\n\t\t\t\twith: Thread @ thread\r\n\t\t\t\twith: errorString)\r\n\t\t];\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):on_do_(\"load\", (function()\r\nreturn ((self):triggerEvent_(\"load\"))\r\nend));\r\n(_s8_rec):on_do_(\"draw\", (function()\r\nreturn ((self):triggerEvent_(\"draw\"))\r\nend));\r\n(_s8_rec):on_do_(\"lowmemory\", (function()\r\nreturn ((self):triggerEvent_(\"lowMemory\"))\r\nend));\r\n(_s8_rec):on_do_(\"update\", (function(dt)\r\nreturn ((self):triggerEvent_with_(\"update:\", dt))\r\nend));\r\n(_s8_rec):on_do_(\"quit\", (function()\r\nreturn (((false)~=(self):triggerEvent_(\"quit\")))\r\nend));\r\n(_s8_rec):on_do_(\"threaderror\", (function(thread,errorString)\r\nreturn ((self):triggerEvent_withArguments_(\"thread:error:\", (smalltalk.Array):with_with_((smalltalk.Thread):_at(thread), errorString)))\r\nend));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(smalltalk.Love)\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveApplication,"installWindowCallbacks",0
,function(self)
(
function(_s8_rec)
(_s8_rec):on_do_("directorydropped", (function(path)
return ((self):triggerEvent_with_("directoryDropped:", path))
end));
(_s8_rec):on_do_("filedropped", (function(file)
return ((self):triggerEvent_with_("fileDropped:", (smalltalk.File):_at(file)))
end));
(_s8_rec):on_do_("focus", (function(focus)
return ((self):triggerEvent_with_("focus:", focus))
end));
(_s8_rec):on_do_("mousefocus", (function(focus)
return ((self):triggerEvent_with_("mouseFocus:", focus))
end));
(_s8_rec):on_do_("resize", (function(w,h)
return ((self):triggerEvent_with_("resize:", (w):_at(h)))
end));
(_s8_rec):on_do_("visible", (function(visible)
return ((self):triggerEvent_with_("visible:", visible))
end));
return ((_s8_rec):yourself())
end
)(smalltalk.Love)
;
return (self)
;
end
,"installation","installWindowCallbacks\r\n\t\" Private - Set callbacks of this type \"\r\n\r\n\tLove\ton: #directorydropped do: [:path |\r\n\t\t\tself triggerEvent: #directoryDropped: with: path\r\n\t\t];\r\n\t\ton: #filedropped do: [:file |\r\n\t\t\tself triggerEvent: #fileDropped: with: File @ file\r\n\t\t];\r\n\t\ton: #focus do: [:focus | self triggerEvent: #focus: with: focus ];\r\n\t\ton: #mousefocus do: [:focus | self triggerEvent: #mouseFocus: with: focus ];\r\n\t\ton: #resize do: [:w :h | self triggerEvent: #resize: with: w@h ];\r\n\t\ton: #visible do: [:visible | self triggerEvent: #visible: with: visible ];\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):on_do_(\"directorydropped\", (function(path)\r\nreturn ((self):triggerEvent_with_(\"directoryDropped:\", path))\r\nend));\r\n(_s8_rec):on_do_(\"filedropped\", (function(file)\r\nreturn ((self):triggerEvent_with_(\"fileDropped:\", (smalltalk.File):_at(file)))\r\nend));\r\n(_s8_rec):on_do_(\"focus\", (function(focus)\r\nreturn ((self):triggerEvent_with_(\"focus:\", focus))\r\nend));\r\n(_s8_rec):on_do_(\"mousefocus\", (function(focus)\r\nreturn ((self):triggerEvent_with_(\"mouseFocus:\", focus))\r\nend));\r\n(_s8_rec):on_do_(\"resize\", (function(w,h)\r\nreturn ((self):triggerEvent_with_(\"resize:\", (w):_at(h)))\r\nend));\r\n(_s8_rec):on_do_(\"visible\", (function(visible)\r\nreturn ((self):triggerEvent_with_(\"visible:\", visible))\r\nend));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(smalltalk.Love)\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveApplication,"installKeyboardCallbacks",0
,function(self)
(
function(_s8_rec)
(_s8_rec):on_do_("keypressed", (function(key,scancode,isrepeat)
return ((self):triggerEvent_withArguments_("keyDown:scancode:isRepeat:", (smalltalk.Array):with_with_with_(key, scancode, isrepeat)))
end));
(_s8_rec):on_do_("keyreleased", (function(key,scancode)
return ((self):triggerEvent_withArguments_("keyUp:scancode:", (smalltalk.Array):with_with_(key, scancode)))
end));
(_s8_rec):on_do_("textedited", (function(text,start,length)
return ((self):triggerEvent_withArguments_("textEdited:start:length:", (smalltalk.Array):with_with_with_(text, start, length)))
end));
(_s8_rec):on_do_("textinput", (function(text)
return ((self):triggerEvent_with_("textInput:", text))
end));
return ((_s8_rec):yourself())
end
)(smalltalk.Love)
;
return (self)
;
end
,"installation","installKeyboardCallbacks\r\n\t\" Private - Set callbacks of this type \"\r\n\r\n\tLove\ton: #keypressed do: [:key :scancode :isrepeat|\r\n\t\t\tself triggerEvent: #keyDown:scancode:isRepeat: withArguments: (Array\r\n\t\t\t\twith: key with: scancode with: isrepeat)\r\n\t\t];\r\n\t\ton: #keyreleased do: [:key :scancode|\r\n\t\t\tself triggerEvent: #keyUp:scancode: withArguments: (Array\r\n\t\t\t\twith: key with: scancode)\r\n\t\t];\r\n\t\ton: #textedited do: [:text :start :length|\r\n\t\t\tself triggerEvent: #textEdited:start:length: withArguments: (Array\r\n\t\t\t\twith: text with: start with: length)\r\n\t\t];\r\n\t\ton: #textinput do: [:text| self triggerEvent: #textInput: with: text ];\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):on_do_(\"keypressed\", (function(key,scancode,isrepeat)\r\nreturn ((self):triggerEvent_withArguments_(\"keyDown:scancode:isRepeat:\", (smalltalk.Array):with_with_with_(key, scancode, isrepeat)))\r\nend));\r\n(_s8_rec):on_do_(\"keyreleased\", (function(key,scancode)\r\nreturn ((self):triggerEvent_withArguments_(\"keyUp:scancode:\", (smalltalk.Array):with_with_(key, scancode)))\r\nend));\r\n(_s8_rec):on_do_(\"textedited\", (function(text,start,length)\r\nreturn ((self):triggerEvent_withArguments_(\"textEdited:start:length:\", (smalltalk.Array):with_with_with_(text, start, length)))\r\nend));\r\n(_s8_rec):on_do_(\"textinput\", (function(text)\r\nreturn ((self):triggerEvent_with_(\"textInput:\", text))\r\nend));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(smalltalk.Love)\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveApplication,"installMouseCallbacks",0
,function(self)
(
function(_s8_rec)
(_s8_rec):on_do_("mousemoved", (function(x,y,dx,dy,isTouch)
return ((self):triggerEvent_withArguments_("mouse:moved:isTouch:", (smalltalk.Array):with_with_with_((x):_at(y), (dx):_at(dy), isTouch)))
end));
(_s8_rec):on_do_("mousepressed", (function(x,y,button,isTouch,presses)
return ((self):triggerEvent_withArguments_("mouse:pressed:isTouch:presses:", (smalltalk.Array):with_with_with_with_((x):_at(y), button, isTouch, presses)))
end));
(_s8_rec):on_do_("mousereleased", (function(x,y,button,isTouch,presses)
return ((self):triggerEvent_withArguments_("mouse:released:isTouch:presses:", (smalltalk.Array):with_with_with_with_((x):_at(y), button, isTouch, presses)))
end));
(_s8_rec):on_do_("wheelmoved", (function(x,y)
return ((self):triggerEvent_with_("wheelMoved:", (x):_at(y)))
end));
return ((_s8_rec):yourself())
end
)(smalltalk.Love)
;
return (self)
;
end
,"installation","installMouseCallbacks\r\n\t\" Private - Set callbacks of this type \"\r\n\r\n\tLove\ton: #mousemoved do: [:x :y :dx :dy :isTouch|\r\n\t\t\tself triggerEvent: #mouse:moved:isTouch: withArguments: (Array\r\n\t\t\t\twith: x@y with: dx@dy with: isTouch)\r\n\t\t];\r\n\t\ton: #mousepressed do: [:x :y :button :isTouch :presses|\r\n\t\t\tself triggerEvent: #mouse:pressed:isTouch:presses: withArguments: (Array\r\n\t\t\t\twith: x@y with: button with: isTouch with: presses)\r\n\t\t];\r\n\t\ton: #mousereleased do: [:x :y :button :isTouch :presses|\r\n\t\t\tself triggerEvent: #mouse:released:isTouch:presses: withArguments: (Array\r\n\t\t\t\twith: x@y with: button with: isTouch with: presses)\r\n\t\t];\r\n\t\ton: #wheelmoved do: [:x :y |\r\n\t\t\tself triggerEvent: #wheelMoved: with: x@y\r\n\t\t];\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):on_do_(\"mousemoved\", (function(x,y,dx,dy,isTouch)\r\nreturn ((self):triggerEvent_withArguments_(\"mouse:moved:isTouch:\", (smalltalk.Array):with_with_with_((x):_at(y), (dx):_at(dy), isTouch)))\r\nend));\r\n(_s8_rec):on_do_(\"mousepressed\", (function(x,y,button,isTouch,presses)\r\nreturn ((self):triggerEvent_withArguments_(\"mouse:pressed:isTouch:presses:\", (smalltalk.Array):with_with_with_with_((x):_at(y), button, isTouch, presses)))\r\nend));\r\n(_s8_rec):on_do_(\"mousereleased\", (function(x,y,button,isTouch,presses)\r\nreturn ((self):triggerEvent_withArguments_(\"mouse:released:isTouch:presses:\", (smalltalk.Array):with_with_with_with_((x):_at(y), button, isTouch, presses)))\r\nend));\r\n(_s8_rec):on_do_(\"wheelmoved\", (function(x,y)\r\nreturn ((self):triggerEvent_with_(\"wheelMoved:\", (x):_at(y)))\r\nend));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(smalltalk.Love)\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveApplication,"installJoystickCallbacks",0
,function(self)
(
function(_s8_rec)
(_s8_rec):on_do_("gamepadaxis", (function(joystick,axis,value)
return ((self):triggerEvent_withArguments_("gamepad:axis:value:", (smalltalk.Array):with_with_with_((smalltalk.Joystick):_at(joystick), axis, value)))
end));
(_s8_rec):on_do_("gamepadpressed", (function(joystick,button)
return ((self):triggerEvent_withArguments_("gamepadDown:button:", (smalltalk.Array):with_with_((smalltalk.Joystick):_at(joystick), button)))
end));
(_s8_rec):on_do_("gamepadreleased", (function(joystick,button)
return ((self):triggerEvent_withArguments_("gamepadUp:button:", (smalltalk.Array):with_with_((smalltalk.Joystick):_at(joystick), button)))
end));
(_s8_rec):on_do_("joystickadded", (function(joystick)
return ((self):triggerEvent_with_("joystickAdded:", (smalltalk.Joystick):_at(joystick)))
end));
(_s8_rec):on_do_("joystickaxis", (function(joystick,axis,value)
return ((self):triggerEvent_withArguments_("joystick:axis:value:", (smalltalk.Array):with_with_with_((smalltalk.Joystick):_at(joystick), axis, value)))
end));
(_s8_rec):on_do_("joystickhat", (function(joystick,hat,direction)
return ((self):triggerEvent_withArguments_("joystick:hat:direction:", (smalltalk.Array):with_with_with_((smalltalk.Joystick):_at(joystick), hat, direction)))
end));
(_s8_rec):on_do_("joystickpressed", (function(joystick,button)
return ((self):triggerEvent_withArguments_("joystickDown:button:", (smalltalk.Array):with_with_((smalltalk.Joystick):_at(joystick), button)))
end));
(_s8_rec):on_do_("joystickreleased", (function(joystick,button)
return ((self):triggerEvent_withArguments_("joystickUp:button:", (smalltalk.Array):with_with_((smalltalk.Joystick):_at(joystick), button)))
end));
(_s8_rec):on_do_("joystickremoved", (function(joystick)
return ((self):triggerEvent_with_("joystickRemoved:", (smalltalk.Joystick):_at(joystick)))
end));
return ((_s8_rec):yourself())
end
)(smalltalk.Love)
;
return (self)
;
end
,"installation","installJoystickCallbacks\r\n\t\" Private - Set callbacks of this type \"\r\n\r\n\tLove\ton: #gamepadaxis do: [:joystick :axis :value|\r\n\t\t\tself triggerEvent: #gamepad:axis:value: withArguments: (Array\r\n\t\t\t\twith: Joystick @ joystick with: axis with: value)\r\n\t\t];\r\n\t\ton: #gamepadpressed do: [:joystick :button|\r\n\t\t\tself triggerEvent: #gamepadDown:button: withArguments: (Array\r\n\t\t\t\twith: Joystick @ joystick with: button)\r\n\t\t];\r\n\t\ton: #gamepadreleased do: [:joystick :button|\r\n\t\t\tself triggerEvent: #gamepadUp:button: withArguments: (Array\r\n\t\t\t\twith: Joystick @ joystick with: button)\r\n\t\t];\r\n\t\ton: #joystickadded do: [:joystick|\r\n\t\t\tself triggerEvent: #joystickAdded: with: Joystick @ joystick\r\n\t\t];\r\n\t\ton: #joystickaxis do: [:joystick :axis :value|\r\n\t\t\tself triggerEvent: #joystick:axis:value: withArguments: (Array\r\n\t\t\t\twith: Joystick @ joystick with: axis with: value)\r\n\t\t];\r\n\t\ton: #joystickhat do: [:joystick :hat :direction|\r\n\t\t\tself triggerEvent: #joystick:hat:direction: withArguments: (Array\r\n\t\t\t\twith: Joystick @ joystick with: hat with: direction)\r\n\t\t];\r\n\t\ton: #joystickpressed do: [:joystick :button|\r\n\t\t\tself triggerEvent: #joystickDown:button: withArguments: (Array\r\n\t\t\t\twith: Joystick @ joystick with: button)\r\n\t\t];\r\n\t\ton: #joystickreleased do: [:joystick :button|\r\n\t\t\tself triggerEvent: #joystickUp:button: withArguments: (Array\r\n\t\t\t\twith: Joystick @ joystick with: button)\r\n\t\t];\r\n\t\ton: #joystickremoved do: [:joystick|\r\n\t\t\tself triggerEvent: #joystickRemoved: with: Joystick @ joystick\r\n\t\t];\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):on_do_(\"gamepadaxis\", (function(joystick,axis,value)\r\nreturn ((self):triggerEvent_withArguments_(\"gamepad:axis:value:\", (smalltalk.Array):with_with_with_((smalltalk.Joystick):_at(joystick), axis, value)))\r\nend));\r\n(_s8_rec):on_do_(\"gamepadpressed\", (function(joystick,button)\r\nreturn ((self):triggerEvent_withArguments_(\"gamepadDown:button:\", (smalltalk.Array):with_with_((smalltalk.Joystick):_at(joystick), button)))\r\nend));\r\n(_s8_rec):on_do_(\"gamepadreleased\", (function(joystick,button)\r\nreturn ((self):triggerEvent_withArguments_(\"gamepadUp:button:\", (smalltalk.Array):with_with_((smalltalk.Joystick):_at(joystick), button)))\r\nend));\r\n(_s8_rec):on_do_(\"joystickadded\", (function(joystick)\r\nreturn ((self):triggerEvent_with_(\"joystickAdded:\", (smalltalk.Joystick):_at(joystick)))\r\nend));\r\n(_s8_rec):on_do_(\"joystickaxis\", (function(joystick,axis,value)\r\nreturn ((self):triggerEvent_withArguments_(\"joystick:axis:value:\", (smalltalk.Array):with_with_with_((smalltalk.Joystick):_at(joystick), axis, value)))\r\nend));\r\n(_s8_rec):on_do_(\"joystickhat\", (function(joystick,hat,direction)\r\nreturn ((self):triggerEvent_withArguments_(\"joystick:hat:direction:\", (smalltalk.Array):with_with_with_((smalltalk.Joystick):_at(joystick), hat, direction)))\r\nend));\r\n(_s8_rec):on_do_(\"joystickpressed\", (function(joystick,button)\r\nreturn ((self):triggerEvent_withArguments_(\"joystickDown:button:\", (smalltalk.Array):with_with_((smalltalk.Joystick):_at(joystick), button)))\r\nend));\r\n(_s8_rec):on_do_(\"joystickreleased\", (function(joystick,button)\r\nreturn ((self):triggerEvent_withArguments_(\"joystickUp:button:\", (smalltalk.Array):with_with_((smalltalk.Joystick):_at(joystick), button)))\r\nend));\r\n(_s8_rec):on_do_(\"joystickremoved\", (function(joystick)\r\nreturn ((self):triggerEvent_with_(\"joystickRemoved:\", (smalltalk.Joystick):_at(joystick)))\r\nend));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(smalltalk.Love)\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveApplication,"installTouchCallbacks",0
,function(self)
(
function(_s8_rec)
(_s8_rec):on_do_("touchmoved", (function(id,x,y,dx,dy,pressure)
return ((self):triggerEvent_withArguments_("touch:moved:by:pressure:", (smalltalk.Array):with_with_with_with_(id, (x):_at(y), (dx):_at(dy), pressure)))
end));
(_s8_rec):on_do_("touchpressed", (function(id,x,y,dx,dy,pressure)
return ((self):triggerEvent_withArguments_("touch:down:by:pressure:", (smalltalk.Array):with_with_with_with_(id, (x):_at(y), (dx):_at(dy), pressure)))
end));
(_s8_rec):on_do_("touchreleased", (function(id,x,y,dx,dy,pressure)
return ((self):triggerEvent_withArguments_("touch:up:by:pressure:", (smalltalk.Array):with_with_with_with_(id, (x):_at(y), (dx):_at(dy), pressure)))
end));
return ((_s8_rec):yourself())
end
)(smalltalk.Love)
;
return (self)
;
end
,"installation","installTouchCallbacks\r\n\t\" Private - Set callbacks of this type \"\r\n\r\n\tLove\ton: #touchmoved do: [:id :x :y :dx :dy :pressure|\r\n\t\t\tself triggerEvent: #touch:moved:by:pressure: withArguments: (Array\r\n\t\t\t\twith: id with: x@y with: dx@dy with: pressure)\r\n\t\t];\r\n\t\ton: #touchpressed do: [:id :x :y :dx :dy :pressure|\r\n\t\t\tself triggerEvent: #touch:down:by:pressure: withArguments: (Array\r\n\t\t\t\twith: id with: x@y with: dx@dy with: pressure)\r\n\t\t];\r\n\t\ton: #touchreleased do: [:id :x :y :dx :dy :pressure|\r\n\t\t\tself triggerEvent: #touch:up:by:pressure: withArguments: (Array\r\n\t\t\t\twith: id with: x@y with: dx@dy with: pressure)\r\n\t\t];\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):on_do_(\"touchmoved\", (function(id,x,y,dx,dy,pressure)\r\nreturn ((self):triggerEvent_withArguments_(\"touch:moved:by:pressure:\", (smalltalk.Array):with_with_with_with_(id, (x):_at(y), (dx):_at(dy), pressure)))\r\nend));\r\n(_s8_rec):on_do_(\"touchpressed\", (function(id,x,y,dx,dy,pressure)\r\nreturn ((self):triggerEvent_withArguments_(\"touch:down:by:pressure:\", (smalltalk.Array):with_with_with_with_(id, (x):_at(y), (dx):_at(dy), pressure)))\r\nend));\r\n(_s8_rec):on_do_(\"touchreleased\", (function(id,x,y,dx,dy,pressure)\r\nreturn ((self):triggerEvent_withArguments_(\"touch:up:by:pressure:\", (smalltalk.Array):with_with_with_with_(id, (x):_at(y), (dx):_at(dy), pressure)))\r\nend));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(smalltalk.Love)\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveApplication,"install",0
,function(self)
(
function(_s8_rec)
(_s8_rec):triggerEvent_("aboutToInstall");
(_s8_rec):installGeneralCallbacks();
(_s8_rec):installWindowCallbacks();
(_s8_rec):installKeyboardCallbacks();
(_s8_rec):installMouseCallbacks();
(_s8_rec):installJoystickCallbacks();
(_s8_rec):installTouchCallbacks();
return ((_s8_rec):triggerEvent_("installed"))
end
)(self)
;
return (self)
;
end
,"installation","install\r\n\t\" Private - Set callbacks \"\r\n\r\n\tself\ttriggerEvent: #aboutToInstall;\r\n\t\tinstallGeneralCallbacks;\r\n\t\tinstallWindowCallbacks;\r\n\t\tinstallKeyboardCallbacks;\r\n\t\tinstallMouseCallbacks;\r\n\t\tinstallJoystickCallbacks;\r\n\t\tinstallTouchCallbacks;\r\n\t\ttriggerEvent: #installed","function(self)\r\n(\r\nfunction(_s8_rec)\r\n(_s8_rec):triggerEvent_(\"aboutToInstall\");\r\n(_s8_rec):installGeneralCallbacks();\r\n(_s8_rec):installWindowCallbacks();\r\n(_s8_rec):installKeyboardCallbacks();\r\n(_s8_rec):installMouseCallbacks();\r\n(_s8_rec):installJoystickCallbacks();\r\n(_s8_rec):installTouchCallbacks();\r\nreturn ((_s8_rec):triggerEvent_(\"installed\"))\r\nend\r\n)(self)\r\n;\r\nreturn (self)\r\n;\r\nend")
