-- fileIn("library/love/loveframes.st");
smalltalk:addClass("LoveFramesObject",smalltalk.LoveObject,smalltalk:newArray({}),"loveframes")

smalltalk:addClass("LoveFrames",smalltalk.LoveFramesObject,smalltalk:newArray({}),"loveframes")

smalltalk.LoveFrames["$klass"]["$iVarNames"]=smalltalk:newArray({"current"});

smalltalk:addClass("LFObject",smalltalk.LoveFramesObject,smalltalk:newArray({}),"loveframes")

smalltalk:addClass("LFSkin",smalltalk.LoveFramesObject,smalltalk:newArray({}),"loveframes")

smalltalk:addClass("LFTemplate",smalltalk.LoveFramesObject,smalltalk:newArray({}),"loveframes")

smalltalk:addClass("LFView",smalltalk.LoveFramesObject,smalltalk:newArray({}),"loveframes")

smalltalk:bind(smalltalk.LoveFrames["$klass"],"current",0
,function(self)
(function() if ((((((self['@current']))==nil)))==true) then return ((function()
return ((function()
	local _s8_value=((self):new())
	self['@current']=_s8_value; return _s8_value
end)())
end))() else return nil end end)()
;
return (self['@current'])
;
end
,"accessing","current\r\n\t\" Private - Returns the current instance. \"\r\n\r\n\tcurrent isNil ifTrue: [ current := self new ].\r\n\t^current","function(self)\r\n(function() if ((((((self['@current']))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n\tlocal _s8_value=((self):new())\r\n\tself['@current']=_s8_value; return _s8_value\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\nreturn (self['@current'])\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames["$klass"],"object:",0
,function(self,aName)
return (((self):current()):objectNamed_(aName))
;
end
,"accessing","object: aName\r\n\t\" Returns the object with aName (or nil). \"\r\n\r\n\t^self current objectNamed: aName","function(self,aName)\r\nreturn (((self):current()):objectNamed_(aName))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames["$klass"],"skin:",0
,function(self,aName)
return (((self):current()):skinNamed_(aName))
;
end
,"accessing","skin: aName\r\n\t\" Returns the skin with aName (or nil). \"\r\n\r\n\t^self current skinNamed: aName","function(self,aName)\r\nreturn (((self):current()):skinNamed_(aName))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames["$klass"],"template:",0
,function(self,aName)
return (((self):current()):templateNamed_(aName))
;
end
,"accessing","template: aName\r\n\t\" Returns the template with aName (or nil). \"\r\n\r\n\t^self current templateNamed: aName","function(self,aName)\r\nreturn (((self):current()):templateNamed_(aName))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames["$klass"],"objects",0
,function(self)
return (((self):current()):objects())
;
end
,"accessing","objects\r\n\t\" Returns the registered objects. \"\r\n\r\n\t^self current objects","function(self)\r\nreturn (((self):current()):objects())\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames["$klass"],"skins",0
,function(self)
return (((self):current()):skins())
;
end
,"accessing","skins\r\n\t\" Returns the registered skins. \"\r\n\r\n\t^self current skins","function(self)\r\nreturn (((self):current()):skins())\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames["$klass"],"templates",0
,function(self)
return (((self):current()):templates())
;
end
,"accessing","templates\r\n\t\" Returns the registered templates. \"\r\n\r\n\t^self current templates","function(self)\r\nreturn (((self):current()):templates())\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"initializeHandle",0
,function(self)
(self):handle_(require("loveframes"))
;
(function() if ((((((self['@handle']))==nil)))==true) then return ((function()
return ((self):error_("Missing loveframes support"))
end))() else return nil end end)()
;
return (self)
;
end
,"initialize","initializeHandle\r\n\t\" Private - Initialize the handle of the receiver. \"\r\n\r\n\tself handle: (# #require: #loveframes).\r\n\thandle isNil ifTrue: [ self error: 'Missing loveframes support' ] ","function(self)\r\n(self):handle_(require(\"loveframes\"))\r\n;\r\n(function() if ((((((self['@handle']))==nil)))==true) then return ((function()\r\nreturn ((self):error_(\"Missing loveframes support\"))\r\nend))() else return nil end end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"base",0
,function(self)
return ((smalltalk.Lua):_at((((self):handle())["base"])))
;
end
,"accessing","base\r\n\t\" Return the base of the receiver. \"\r\n\r\n\t^Lua @ (self handle basicAt: #base)","function(self)\r\nreturn ((smalltalk.Lua):_at((((self):handle())[\"base\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"author",0
,function(self)
return ((((self):handle())["author"]))
;
end
,"accessing","author\r\n\t\" Return the author of the receiver. \"\r\n\r\n\t^self handle basicAt: #author","function(self)\r\nreturn ((((self):handle())[\"author\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"author:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["author"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","author: anObject\r\n\t\" Set the author of the receiver. \"\r\n\r\n\tself handle basicAt: #author put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"author\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"basicfont",0
,function(self)
return ((smalltalk.Font):_at((((self):handle())["basicfont"])))
;
end
,"accessing","basicfont\r\n\t\" Return the basicfont of the receiver. \"\r\n\r\n\t^Font @ (self handle basicAt: #basicfont)","function(self)\r\nreturn ((smalltalk.Font):_at((((self):handle())[\"basicfont\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"basicfont:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["basicfont"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","basicfont: anObject\r\n\t\" Set the basicfont of the receiver. \"\r\n\r\n\tself handle basicAt: #basicfont put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"basicfont\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"basicfontsmall",0
,function(self)
return ((smalltalk.Font):_at((((self):handle())["basicfontsmall"])))
;
end
,"accessing","basicfontsmall\r\n\t\" Return the basicfontsmall of the receiver. \"\r\n\r\n\t^Font @ (self handle basicAt: #basicfontsmall)","function(self)\r\nreturn ((smalltalk.Font):_at((((self):handle())[\"basicfontsmall\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"basicfontsmall:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["basicfontsmall"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","basicfontsmall: anObject\r\n\t\" Set the basicfontsmall of the receiver. \"\r\n\r\n\tself handle basicAt: #basicfontsmall put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"basicfontsmall\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"collisioncount",0
,function(self)
return ((((self):handle())["collisioncount"]))
;
end
,"accessing","collisioncount\r\n\t\" Return the collisioncount of the receiver. \"\r\n\r\n\t^self handle basicAt: #collisioncount","function(self)\r\nreturn ((((self):handle())[\"collisioncount\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"collisioncount:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["collisioncount"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","collisioncount: anObject\r\n\t\" Set the collisioncount of the receiver. \"\r\n\r\n\tself handle basicAt: #collisioncount put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"collisioncount\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"collisions",0
,function(self)
return ((smalltalk.Array):_at((((self):handle())["collisions"])))
;
end
,"accessing","collisions\r\n\t\" Return the collisions of the receiver. \"\r\n\r\n\t^Array @ (self handle basicAt: #collisions)","function(self)\r\nreturn ((smalltalk.Array):_at((((self):handle())[\"collisions\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"collisions:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["collisions"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","collisions: anObject\r\n\t\" Set the collisions of the receiver. \"\r\n\r\n\tself handle basicAt: #collisions put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"collisions\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"config",0
,function(self)
return ((smalltalk.PoolDictionary):_at((((self):handle())["config"])))
;
end
,"accessing","config\r\n\t\" Return the config of the receiver. \"\r\n\r\n\t^PoolDictionary @ (self handle basicAt: #config)","function(self)\r\nreturn ((smalltalk.PoolDictionary):_at((((self):handle())[\"config\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"config:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["config"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","config: anObject\r\n\t\" Set the config of the receiver. \"\r\n\r\n\tself handle basicAt: #config put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"config\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"downobject",0
,function(self)
return ((((self):handle())["downobject"]))
;
end
,"accessing","downobject\r\n\t\" Return the downobject of the receiver. \"\r\n\r\n\t^self handle basicAt: #downobject","function(self)\r\nreturn ((((self):handle())[\"downobject\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"downobject:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["downobject"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","downobject: anObject\r\n\t\" Set the downobject of the receiver. \"\r\n\r\n\tself handle basicAt: #downobject put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"downobject\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"dragobject",0
,function(self)
return ((((self):handle())["dragobject"]))
;
end
,"accessing","dragobject\r\n\t\" Return the dragobject of the receiver. \"\r\n\r\n\t^self handle basicAt: #dragobject","function(self)\r\nreturn ((((self):handle())[\"dragobject\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"dragobject:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["dragobject"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","dragobject: anObject\r\n\t\" Set the dragobject of the receiver. \"\r\n\r\n\tself handle basicAt: #dragobject put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"dragobject\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"drawcount",0
,function(self)
return ((((self):handle())["drawcount"]))
;
end
,"accessing","drawcount\r\n\t\" Return the drawcount of the receiver. \"\r\n\r\n\t^self handle basicAt: #drawcount","function(self)\r\nreturn ((((self):handle())[\"drawcount\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"drawcount:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["drawcount"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","drawcount: anObject\r\n\t\" Set the drawcount of the receiver. \"\r\n\r\n\tself handle basicAt: #drawcount put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"drawcount\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"hover",0
,function(self)
return ((((self):handle())["hover"]))
;
end
,"accessing","hover\r\n\t\" Return the hover of the receiver. \"\r\n\r\n\t^self handle basicAt: #hover","function(self)\r\nreturn ((((self):handle())[\"hover\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"hover:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["hover"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","hover: anObject\r\n\t\" Set the hover of the receiver. \"\r\n\r\n\tself handle basicAt: #hover put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"hover\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"hoverobject",0
,function(self)
return ((smalltalk.Lua):_at((((self):handle())["hoverobject"])))
;
end
,"accessing","hoverobject\r\n\t\" Return the hoverobject of the receiver. \"\r\n\r\n\t^Lua @ (self handle basicAt: #hoverobject)","function(self)\r\nreturn ((smalltalk.Lua):_at((((self):handle())[\"hoverobject\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"hoverobject:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["hoverobject"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","hoverobject: anObject\r\n\t\" Set the hoverobject of the receiver. \"\r\n\r\n\tself handle basicAt: #hoverobject put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"hoverobject\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"input_cursor_set",0
,function(self)
return ((((self):handle())["input_cursor_set"]))
;
end
,"accessing","input_cursor_set\r\n\t\" Return the input_cursor_set of the receiver. \"\r\n\r\n\t^self handle basicAt: #input_cursor_set","function(self)\r\nreturn ((((self):handle())[\"input_cursor_set\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"input_cursor_set:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["input_cursor_set"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","input_cursor_set: anObject\r\n\t\" Set the input_cursor_set of the receiver. \"\r\n\r\n\tself handle basicAt: #input_cursor_set put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"input_cursor_set\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"inputobject",0
,function(self)
return ((((self):handle())["inputobject"]))
;
end
,"accessing","inputobject\r\n\t\" Return the inputobject of the receiver. \"\r\n\r\n\t^self handle basicAt: #inputobject","function(self)\r\nreturn ((((self):handle())[\"inputobject\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"inputobject:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["inputobject"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","inputobject: anObject\r\n\t\" Set the inputobject of the receiver. \"\r\n\r\n\tself handle basicAt: #inputobject put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"inputobject\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"objectcount",0
,function(self)
return ((((self):handle())["objectcount"]))
;
end
,"accessing","objectcount\r\n\t\" Return the objectcount of the receiver. \"\r\n\r\n\t^self handle basicAt: #objectcount","function(self)\r\nreturn ((((self):handle())[\"objectcount\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"objectcount:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["objectcount"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","objectcount: anObject\r\n\t\" Set the objectcount of the receiver. \"\r\n\r\n\tself handle basicAt: #objectcount put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"objectcount\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"utf8",0
,function(self)
return ((smalltalk.Lua):_at((((self):handle())["utf8"])))
;
end
,"accessing","utf8\r\n\t\" Return the utf8 of the receiver. \"\r\n\r\n\t^Lua @ (self handle basicAt: #utf8)","function(self)\r\nreturn ((smalltalk.Lua):_at((((self):handle())[\"utf8\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"utf8:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["utf8"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","utf8: anObject\r\n\t\" Set the utf8 of the receiver. \"\r\n\r\n\tself handle basicAt: #utf8 put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"utf8\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"resizeobject",0
,function(self)
return ((((self):handle())["resizeobject"]))
;
end
,"accessing","resizeobject\r\n\t\" Return the resizeobject of the receiver. \"\r\n\r\n\t^self handle basicAt: #resizeobject","function(self)\r\nreturn ((((self):handle())[\"resizeobject\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"resizeobject:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["resizeobject"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","resizeobject: anObject\r\n\t\" Set the resizeobject of the receiver. \"\r\n\r\n\tself handle basicAt: #resizeobject put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"resizeobject\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"version",0
,function(self)
return ((((self):handle())["version"]))
;
end
,"accessing","version\r\n\t\" Return the version of the receiver. \"\r\n\r\n\t^self handle basicAt: #version","function(self)\r\nreturn ((((self):handle())[\"version\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"version:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["version"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","version: anObject\r\n\t\" Set the version of the receiver. \"\r\n\r\n\tself handle basicAt: #version put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"version\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"stage",0
,function(self)
return ((((self):handle())["stage"]))
;
end
,"accessing","stage\r\n\t\" Return the stage of the receiver. \"\r\n\r\n\t^self handle basicAt: #stage","function(self)\r\nreturn ((((self):handle())[\"stage\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"stage:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["stage"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","stage: anObject\r\n\t\" Set the stage of the receiver. \"\r\n\r\n\tself handle basicAt: #stage put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"stage\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"state",0
,function(self)
return ((((self):handle())["state"]))
;
end
,"accessing","state\r\n\t\" Return the state of the receiver. \"\r\n\r\n\t^self handle basicAt: #state","function(self)\r\nreturn ((((self):handle())[\"state\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"state:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["state"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","state: anObject\r\n\t\" Set the state of the receiver. \"\r\n\r\n\tself handle basicAt: #state put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"state\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"modalobject",0
,function(self)
return ((((self):handle())["modalobject"]))
;
end
,"accessing","modalobject\r\n\t\" Return the modalobject of the receiver. \"\r\n\r\n\t^self handle basicAt: #modalobject","function(self)\r\nreturn ((((self):handle())[\"modalobject\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"modalobject:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["modalobject"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","modalobject: anObject\r\n\t\" Set the modalobject of the receiver. \"\r\n\r\n\tself handle basicAt: #modalobject put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"modalobject\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"require:",0
,function(self,moduleName)
return (((self):handle()).require(moduleName))
;
end
,"wrappers","require: moduleName \r\n\t\" Delegate _require to handle. \"\r\n\r\n\t^self handle #_require: moduleName ","function(self,moduleName)\r\nreturn (((self):handle()).require(moduleName))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"draw",0
,function(self)
return (((self):handle()).draw())
;
end
,"wrappers","draw\r\n\t\" Delegate _draw to handle. \"\r\n\r\n\t^self handle #_draw","function(self)\r\nreturn (((self):handle()).draw())\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"keypressed:isrepeat:",0
,function(self,key,isrepeat)
return (((self):handle()).keypressed(key, isrepeat))
;
end
,"wrappers","keypressed: key isrepeat: isrepeat \r\n\t\" Delegate _keypressed to handle. \"\r\n\r\n\t^self handle #_keypressed: key isrepeat: isrepeat ","function(self,key,isrepeat)\r\nreturn (((self):handle()).keypressed(key, isrepeat))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"keyreleased:",0
,function(self,key)
return (((self):handle()).keyreleased(key))
;
end
,"wrappers","keyreleased: key \r\n\t\" Delegate _keyreleased to handle. \"\r\n\r\n\t^self handle #_keyreleased: key ","function(self,key)\r\nreturn (((self):handle()).keyreleased(key))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"mousepressed:y:button:",0
,function(self,x,y,button)
return (((self):handle()).mousepressed(x, y, button))
;
end
,"wrappers","mousepressed: x y: y button: button \r\n\t\" Delegate _mousepressed to handle. \"\r\n\r\n\t^self handle #_mousepressed: x y: y button: button ","function(self,x,y,button)\r\nreturn (((self):handle()).mousepressed(x, y, button))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"mousereleased:y:button:",0
,function(self,x,y,button)
return (((self):handle()).mousereleased(x, y, button))
;
end
,"wrappers","mousereleased: x y: y button: button \r\n\t\" Delegate _mousereleased to handle. \"\r\n\r\n\t^self handle #_mousereleased: x y: y button: button ","function(self,x,y,button)\r\nreturn (((self):handle()).mousereleased(x, y, button))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"update:",0
,function(self,dt)
return (((self):handle()).update(dt))
;
end
,"wrappers","update: dt \r\n\t\" Delegate _update to handle. \"\r\n\r\n\t^self handle #_update: dt ","function(self,dt)\r\nreturn (((self):handle()).update(dt))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"textinput:",0
,function(self,text)
return (((self):handle()).textinput(text))
;
end
,"wrappers","textinput: text \r\n\t\" Delegate _textinput to handle. \"\r\n\r\n\t^self handle #_textinput: text ","function(self,text)\r\nreturn (((self):handle()).textinput(text))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"wheelmoved:y:",0
,function(self,x,y)
return (((self):handle()).wheelmoved(x, y))
;
end
,"wrappers","wheelmoved: x y: y \r\n\t\" Delegate _wheelmoved to handle. \"\r\n\r\n\t^self handle #_wheelmoved: x y: y ","function(self,x,y)\r\nreturn (((self):handle()).wheelmoved(x, y))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"state",0
,function(self)
return (((self):handle()).GetState())
;
end
,"wrappers","state\r\n\t\" Delegate _GetState to handle. \"\r\n\r\n\t^self handle #_GetState","function(self)\r\nreturn (((self):handle()).GetState())\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"state:",0
,function(self,name)
return (((self):handle()).SetState(name))
;
end
,"wrappers","state: name \r\n\t\" Delegate _SetState to handle. \"\r\n\r\n\t^self handle #_SetState: name ","function(self,name)\r\nreturn (((self):handle()).SetState(name))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"activeSkin",0
,function(self)
return ((smalltalk.LFSkin):_at(((self):handle()).GetActiveSkin()))
;
end
,"wrappers","activeSkin\r\n\t\" Delegate _GetActiveSkin to handle. \"\r\n\r\n\t^LFSkin @ (self handle #_GetActiveSkin)","function(self)\r\nreturn ((smalltalk.LFSkin):_at(((self):handle()).GetActiveSkin()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"activeSkin:",0
,function(self,name)
return (((self):handle()).SetActiveSkin(name))
;
end
,"wrappers","activeSkin: name \r\n\t\" Delegate _SetActiveSkin to handle. \"\r\n\r\n\t^self handle #_SetActiveSkin: name ","function(self,name)\r\nreturn (((self):handle()).SetActiveSkin(name))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"boundingBox:x2:y1:y2:w1:w2:h1:h2:",0
,function(self,x1,x2,y1,y2,w1,w2,h1,h2)
return (((self):handle()).BoundingBox(x1, x2, y1, y2, w1, w2, h1, h2))
;
end
,"wrappers","boundingBox: x1 x2: x2 y1: y1 y2: y2 w1: w1 w2: w2 h1: h1 h2: h2 \r\n\t\" Delegate _BoundingBox to handle. \"\r\n\r\n\t^self handle #_BoundingBox: x1 x2: x2 y1: y1 y2: y2 w1: w1 w2: w2 h1: h1 h2: h2 ","function(self,x1,x2,y1,y2,w1,w2,h1,h2)\r\nreturn (((self):handle()).BoundingBox(x1, x2, y1, y2, w1, w2, h1, h2))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"collisions:into:",0
,function(self,object,into)
return (((self):handle()).GetCollisions((object):json(), into))
;
end
,"wrappers","collisions: object into: into \r\n\t\" Delegate _GetCollisions to handle. \"\r\n\r\n\t^self handle #_GetCollisions: object json into: into ","function(self,object,into)\r\nreturn (((self):handle()).GetCollisions((object):json(), into))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"allObjects:into:",0
,function(self,object,into)
return (((self):handle()).GetAllObjects((object):json(), into))
;
end
,"wrappers","allObjects: object into: into \r\n\t\" Delegate _GetAllObjects to handle. \"\r\n\r\n\t^self handle #_GetAllObjects: object json into: into ","function(self,object,into)\r\nreturn (((self):handle()).GetAllObjects((object):json(), into))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"directoryContents:into:",0
,function(self,dir,into)
return (((self):handle()).GetDirectoryContents(dir, into))
;
end
,"wrappers","directoryContents: dir into: into \r\n\t\" Delegate _GetDirectoryContents to handle. \"\r\n\r\n\t^self handle #_GetDirectoryContents: dir into: into ","function(self,dir,into)\r\nreturn (((self):handle()).GetDirectoryContents(dir, into))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"removeAll",0
,function(self)
return (((self):handle()).RemoveAll())
;
end
,"wrappers","removeAll\r\n\t\" Delegate _RemoveAll to handle. \"\r\n\r\n\t^self handle #_RemoveAll","function(self)\r\nreturn (((self):handle()).RemoveAll())\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"collisionCount",0
,function(self)
return (((self):handle()).GetCollisionCount())
;
end
,"wrappers","collisionCount\r\n\t\" Delegate _GetCollisionCount to handle. \"\r\n\r\n\t^self handle #_GetCollisionCount","function(self)\r\nreturn (((self):handle()).GetCollisionCount())\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"hover",0
,function(self)
return (((self):handle()).GetHover())
;
end
,"wrappers","hover\r\n\t\" Delegate _GetHover to handle. \"\r\n\r\n\t^self handle #_GetHover","function(self)\r\nreturn (((self):handle()).GetHover())\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"hoverObject",0
,function(self)
return ((smalltalk.LFObject):_at(((self):handle()).GetHoverObject()))
;
end
,"wrappers","hoverObject\r\n\t\" Delegate _GetHoverObject to handle. \"\r\n\r\n\t^LFObject @ (self handle #_GetHoverObject)","function(self)\r\nreturn ((smalltalk.LFObject):_at(((self):handle()).GetHoverObject()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"isCtrlDown",0
,function(self)
return (((self):handle()).IsCtrlDown())
;
end
,"wrappers","isCtrlDown\r\n\t\" Delegate _IsCtrlDown to handle. \"\r\n\r\n\t^self handle #_IsCtrlDown","function(self)\r\nreturn (((self):handle()).IsCtrlDown())\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"color:",0
,function(self,s)
return (((self):handle()).Color(s))
;
end
,"wrappers","color: s \r\n\t\" Delegate _Color to handle. \"\r\n\r\n\t^self handle #_Color: s ","function(self,s)\r\nreturn (((self):handle()).Color(s))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"color:a:",0
,function(self,s,a)
return (((self):handle()).Color(s, a))
;
end
,"wrappers","color: s a: a \r\n\t\" Delegate _Color to handle. \"\r\n\r\n\t^self handle #_Color: s a: a ","function(self,s,a)\r\nreturn (((self):handle()).Color(s, a))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"debugDraw",0
,function(self)
return (((self):handle()).DebugDraw())
;
end
,"wrappers","debugDraw\r\n\t\" Delegate _DebugDraw to handle. \"\r\n\r\n\t^self handle #_DebugDraw","function(self)\r\nreturn (((self):handle()).DebugDraw())\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"create:",0
,function(self,data)
return ((smalltalk.LFView):_at(((self):handle()).Create((data):json())))
;
end
,"wrappers","create: data \r\n\t\" Delegate _Create to handle. \"\r\n\r\n\t^LFView @ (self handle #_Create: data json )","function(self,data)\r\nreturn ((smalltalk.LFView):_at(((self):handle()).Create((data):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"create:parent:",0
,function(self,data,parent)
return ((smalltalk.LFView):_at(((self):handle()).Create((data):json(), (parent):json())))
;
end
,"wrappers","create: data parent: parent \r\n\t\" Delegate _Create to handle. \"\r\n\r\n\t^LFView @ (self handle #_Create: data json parent: parent json )","function(self,data,parent)\r\nreturn ((smalltalk.LFView):_at(((self):handle()).Create((data):json(), (parent):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"newObject:name:",0
,function(self,id,name)
return (((self):handle()).NewObject(id, name))
;
end
,"wrappers","newObject: id name: name \r\n\t\" Delegate _NewObject to handle. \"\r\n\r\n\t^self handle #_NewObject: id name: name ","function(self,id,name)\r\nreturn (((self):handle()).NewObject(id, name))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"newObject:name:inheritFromBase:",0
,function(self,id,name,inheritFromBase)
return (((self):handle()).NewObject(id, name, inheritFromBase))
;
end
,"wrappers","newObject: id name: name inheritFromBase: inheritFromBase \r\n\t\" Delegate _NewObject to handle. \"\r\n\r\n\t^self handle #_NewObject: id name: name inheritFromBase: inheritFromBase ","function(self,id,name,inheritFromBase)\r\nreturn (((self):handle()).NewObject(id, name, inheritFromBase))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"loadObjects:",0
,function(self,dir)
return (((self):handle()).LoadObjects(dir))
;
end
,"wrappers","loadObjects: dir \r\n\t\" Delegate _LoadObjects to handle. \"\r\n\r\n\t^self handle #_LoadObjects: dir ","function(self,dir)\r\nreturn (((self):handle()).LoadObjects(dir))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"applyTemplatesToObject:",0
,function(self,object)
return (((self):handle()).ApplyTemplatesToObject((object):json()))
;
end
,"wrappers","applyTemplatesToObject: object \r\n\t\" Delegate _ApplyTemplatesToObject to handle. \"\r\n\r\n\t^self handle #_ApplyTemplatesToObject: object json ","function(self,object)\r\nreturn (((self):handle()).ApplyTemplatesToObject((object):json()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"loadTemplates:",0
,function(self,dir)
return (((self):handle()).LoadTemplates(dir))
;
end
,"wrappers","loadTemplates: dir \r\n\t\" Delegate _LoadTemplates to handle. \"\r\n\r\n\t^self handle #_LoadTemplates: dir ","function(self,dir)\r\nreturn (((self):handle()).LoadTemplates(dir))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"registerSkin:",0
,function(self,skin)
return (((self):handle()).RegisterSkin((skin):json()))
;
end
,"wrappers","registerSkin: skin \r\n\t\" Delegate _RegisterSkin to handle. \"\r\n\r\n\t^self handle #_RegisterSkin: skin json ","function(self,skin)\r\nreturn (((self):handle()).RegisterSkin((skin):json()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"loadSkins:",0
,function(self,dir)
return (((self):handle()).LoadSkins(dir))
;
end
,"wrappers","loadSkins: dir \r\n\t\" Delegate _LoadSkins to handle. \"\r\n\r\n\t^self handle #_LoadSkins: dir ","function(self,dir)\r\nreturn (((self):handle()).LoadSkins(dir))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"collisions:",0
,function(self,object)
return ((self):collisions_into_(object, (smalltalk.Array):new()))
;
end
,"accessing","collisions: object\r\n\t\" Return the collisions to object. \"\r\n\r\n\t^self collisions: object into: Array new","function(self,object)\r\nreturn ((self):collisions_into_(object, (smalltalk.Array):new()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"allObjects:",0
,function(self,object)
return ((self):allObjects_into_(object, (smalltalk.Array):new()))
;
end
,"accessing","allObjects: object\r\n\t\" Return all active objects. \"\r\n\r\n\t^self allObjects: object into: Array new","function(self,object)\r\nreturn ((self):allObjects_into_(object, (smalltalk.Array):new()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"directoryContents:",0
,function(self,dir)
return ((self):directoryContents_into_(dir, (smalltalk.Array):new()))
;
end
,"accessing","directoryContents: dir\r\n\t\" Return directory contents. \"\r\n\r\n\t^self directoryContents: dir into: Array new","function(self,dir)\r\nreturn ((self):directoryContents_into_(dir, (smalltalk.Array):new()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"cls",0
,function(self)
return ((((self):handle())["class"]))
;
end
,"accessing","cls\r\n\t\" Return the (loveframes)class of the receiver. \"\r\n\r\n\t^self handle basicAt: #class","function(self)\r\nreturn ((((self):handle())[\"class\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"skins",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local h=nil
(function()
	local _s8_value=((smalltalk.Lua):_at((((self):handle())["skins"])))
	h=_s8_value; return _s8_value
end)()
;
(function() if ((((((h))==nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.PoolDictionary):new())
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (((h):keys()):inject_into_((smalltalk.PoolDictionary):new(), (function(total,each)
return ((
function(_s8_rec)
(_s8_rec):at_put_(each, (smalltalk.LFSkin):_at((h):_at(each)));
return ((_s8_rec):yourself())
end
)(total))
end)))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","skins\r\n\t\" Return a dictionary with the skins of the receiver. \"\r\n\r\n\t| h |\r\n\th := Lua @ (self handle basicAt: #skins).\r\n\th isNil ifTrue: [ ^PoolDictionary new ].\r\n\t^h keys\tinject: PoolDictionary new into: [:total :each|\r\n\t\ttotal at: each put: LFSkin @ (h @ each); yourself ]","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Lua):_at((((self):handle())[\"skins\"])))\r\n\th=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((h))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.PoolDictionary):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (((h):keys()):inject_into_((smalltalk.PoolDictionary):new(), (function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n(_s8_rec):at_put_(each, (smalltalk.LFSkin):_at((h):_at(each)));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"skinNamed:",0
,function(self,aName)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local h=nil
(function()
	local _s8_value=((smalltalk.Lua):_at((((self):handle())["skins"])))
	h=_s8_value; return _s8_value
end)()
;
return ((function() if ((((((h))~=nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.LFSkin):_at((h):_at(aName)))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)())
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","skinNamed: aName\r\n\t\" Return the skin of the receiver with aName (or nil). \"\r\n\r\n\t| h |\r\n\th := Lua @ (self handle basicAt: #skins).\r\n\t^h notNil ifTrue: [ ^LFSkin @ (h @ aName) ]","function(self,aName)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Lua):_at((((self):handle())[\"skins\"])))\r\n\th=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn ((function() if ((((((h))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.LFSkin):_at((h):_at(aName)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)())\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"templates",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local h=nil
(function()
	local _s8_value=((smalltalk.Lua):_at((((self):handle())["templates"])))
	h=_s8_value; return _s8_value
end)()
;
(function() if ((((((h))==nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.PoolDictionary):new())
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (((h):keys()):inject_into_((smalltalk.PoolDictionary):new(), (function(total,each)
return ((
function(_s8_rec)
(_s8_rec):at_put_(each, (smalltalk.LFTemplate):_at((h):_at(each)));
return ((_s8_rec):yourself())
end
)(total))
end)))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","templates\r\n\t\" Return a dictionary with the templates of the receiver. \"\r\n\r\n\t| h |\r\n\th := Lua @ (self handle basicAt: #templates).\r\n\th isNil ifTrue: [ ^PoolDictionary new ].\r\n\t^h keys\tinject: PoolDictionary new into: [:total :each|\r\n\t\ttotal at: each put: LFTemplate @ (h @ each); yourself ]","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Lua):_at((((self):handle())[\"templates\"])))\r\n\th=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((h))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.PoolDictionary):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (((h):keys()):inject_into_((smalltalk.PoolDictionary):new(), (function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n(_s8_rec):at_put_(each, (smalltalk.LFTemplate):_at((h):_at(each)));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"templateNamed:",0
,function(self,aName)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local h=nil
(function()
	local _s8_value=((smalltalk.Lua):_at((((self):handle())["templates"])))
	h=_s8_value; return _s8_value
end)()
;
return ((function() if ((((((h))~=nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.LFTemplate):_at((h):_at(aName)))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)())
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","templateNamed: aName\r\n\t\" Return the template of the receiver with aName (or nil). \"\r\n\r\n\t| h |\r\n\th := Lua @ (self handle basicAt: #templates).\r\n\t^h notNil ifTrue: [ ^LFTemplate @ (h @ aName) ]","function(self,aName)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Lua):_at((((self):handle())[\"templates\"])))\r\n\th=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn ((function() if ((((((h))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.LFTemplate):_at((h):_at(aName)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)())\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"objects",0
,function(self)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local h=nil
(function()
	local _s8_value=((smalltalk.Lua):_at((((self):handle())["objects"])))
	h=_s8_value; return _s8_value
end)()
;
(function() if ((((((h))==nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.PoolDictionary):new())
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)()
;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (((h):keys()):inject_into_((smalltalk.PoolDictionary):new(), (function(total,each)
return ((
function(_s8_rec)
(_s8_rec):at_put_(each, (smalltalk.LFObject):_at((h):_at(each)));
return ((_s8_rec):yourself())
end
)(total))
end)))
end
)()
error(_s8Ret_,0)
end)()
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","objects\r\n\t\" Return a dictionary with the objects of the receiver. \"\r\n\r\n\t| h |\r\n\th := Lua @ (self handle basicAt: #objects).\r\n\th isNil ifTrue: [ ^PoolDictionary new ].\r\n\t^h keys\tinject: PoolDictionary new into: [:total :each|\r\n\t\ttotal at: each put: LFObject @ (h @ each); yourself ]","function(self)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Lua):_at((((self):handle())[\"objects\"])))\r\n\th=_s8_value; return _s8_value\r\nend)()\r\n;\r\n(function() if ((((((h))==nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.PoolDictionary):new())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)()\r\n;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (((h):keys()):inject_into_((smalltalk.PoolDictionary):new(), (function(total,each)\r\nreturn ((\r\nfunction(_s8_rec)\r\n(_s8_rec):at_put_(each, (smalltalk.LFObject):_at((h):_at(each)));\r\nreturn ((_s8_rec):yourself())\r\nend\r\n)(total))\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)()\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LoveFrames,"objectNamed:",0
,function(self,aName)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local h=nil
(function()
	local _s8_value=((smalltalk.Lua):_at((((self):handle())["objects"])))
	h=_s8_value; return _s8_value
end)()
;
return ((function() if ((((((h))~=nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.LFObject):_at((h):_at(aName)))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)())
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","objectNamed: aName\r\n\t\" Return the object of the receiver with aName (or nil). \"\r\n\r\n\t| h |\r\n\th := Lua @ (self handle basicAt: #objects).\r\n\t^h notNil ifTrue: [ ^LFObject @ (h @ aName) ]","function(self,aName)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Lua):_at((((self):handle())[\"objects\"])))\r\n\th=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn ((function() if ((((((h))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.LFObject):_at((h):_at(aName)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)())\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LFTemplate,"name",0
,function(self)
return ((((self):handle())["name"]))
;
end
,"accessing","name\r\n\t\" Return the name of the receiver. \"\r\n\r\n\t^self handle basicAt: #name","function(self)\r\nreturn ((((self):handle())[\"name\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFTemplate,"name:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["name"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","name: anObject\r\n\t\" Set the name of the receiver. \"\r\n\r\n\tself handle basicAt: #name put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"name\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFTemplate,"properties",0
,function(self)
return ((smalltalk.Lua):_at((((self):handle())["properties"])))
;
end
,"accessing","properties\r\n\t\" Return the properties of the receiver. \"\r\n\r\n\t^Lua @ (self handle basicAt: #properties)","function(self)\r\nreturn ((smalltalk.Lua):_at((((self):handle())[\"properties\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFTemplate,"properties:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["properties"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","properties: anObject\r\n\t\" Set the properties of the receiver. \"\r\n\r\n\tself handle basicAt: #properties put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"properties\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFTemplate["$klass"],"base",0
,function(self)
return (((smalltalk.LoveFrames):current()):templateNamed_("Base"))
;
end
,"accessing","base\r\n\t\" Returns the base template. \"\r\n\r\n\t^LoveFrames current templateNamed: #Base","function(self)\r\nreturn (((smalltalk.LoveFrames):current()):templateNamed_(\"Base\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFTemplate,"star",0
,function(self)
return ((smalltalk.Lua):_at(((self):properties()):_at("*")))
;
end
,"accessing","star\r\n\t\" Return the default properties. \"\r\n\r\n\t^Lua @ (self properties @ #*)","function(self)\r\nreturn ((smalltalk.Lua):_at(((self):properties()):_at(\"*\")))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin["$klass"],"default",0
,function(self)
return (((smalltalk.LoveFrames):current()):skinNamed_("Default"))
;
end
,"accessing","default\r\n\t\" Returns the default skin. \"\r\n\r\n\t^LoveFrames current skinNamed: #Default","function(self)\r\nreturn (((smalltalk.LoveFrames):current()):skinNamed_(\"Default\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"author",0
,function(self)
return ((((self):handle())["author"]))
;
end
,"accessing","author\r\n\t\" Return the author of the receiver. \"\r\n\r\n\t^self handle basicAt: #author","function(self)\r\nreturn ((((self):handle())[\"author\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"author:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["author"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","author: anObject\r\n\t\" Set the author of the receiver. \"\r\n\r\n\tself handle basicAt: #author put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"author\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"name",0
,function(self)
return ((((self):handle())["name"]))
;
end
,"accessing","name\r\n\t\" Return the name of the receiver. \"\r\n\r\n\t^self handle basicAt: #name","function(self)\r\nreturn ((((self):handle())[\"name\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"name:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["name"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","name: anObject\r\n\t\" Set the name of the receiver. \"\r\n\r\n\tself handle basicAt: #name put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"name\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"version",0
,function(self)
return ((((self):handle())["version"]))
;
end
,"accessing","version\r\n\t\" Return the version of the receiver. \"\r\n\r\n\t^self handle basicAt: #version","function(self)\r\nreturn ((((self):handle())[\"version\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"version:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["version"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","version: anObject\r\n\t\" Set the version of the receiver. \"\r\n\r\n\tself handle basicAt: #version put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"version\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"dir",0
,function(self)
return ((((self):handle())["dir"]))
;
end
,"accessing","dir\r\n\t\" Return the dir of the receiver. \"\r\n\r\n\t^self handle basicAt: #dir","function(self)\r\nreturn ((((self):handle())[\"dir\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"dir:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["dir"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","dir: anObject\r\n\t\" Set the dir of the receiver. \"\r\n\r\n\tself handle basicAt: #dir put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"dir\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"directives",0
,function(self)
return ((smalltalk.Lua):_at((((self):handle())["directives"])))
;
end
,"accessing","directives\r\n\t\" Return the directives of the receiver. \"\r\n\r\n\t^Lua @ (self handle basicAt: #directives)","function(self)\r\nreturn ((smalltalk.Lua):_at((((self):handle())[\"directives\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"directives:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["directives"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","directives: anObject\r\n\t\" Set the directives of the receiver. \"\r\n\r\n\tself handle basicAt: #directives put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"directives\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"images",0
,function(self)
return ((smalltalk.Lua):_at((((self):handle())["images"])))
;
end
,"accessing","images\r\n\t\" Return the images of the receiver. \"\r\n\r\n\t^Lua @ (self handle basicAt: #images)","function(self)\r\nreturn ((smalltalk.Lua):_at((((self):handle())[\"images\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"images:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["images"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","images: anObject\r\n\t\" Set the images of the receiver. \"\r\n\r\n\tself handle basicAt: #images put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"images\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"controls",0
,function(self)
return ((smalltalk.Lua):_at((((self):handle())["controls"])))
;
end
,"accessing","controls\r\n\t\" Return the controls of the receiver. \"\r\n\r\n\t^Lua @ (self handle basicAt: #controls)","function(self)\r\nreturn ((smalltalk.Lua):_at((((self):handle())[\"controls\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"controls:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["controls"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","controls: anObject\r\n\t\" Set the controls of the receiver. \"\r\n\r\n\tself handle basicAt: #controls put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"controls\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"imageNamed:",0
,function(self,aName)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local h=nil
(function()
	local _s8_value=((smalltalk.Lua):_at((((self):handle())["images"])))
	h=_s8_value; return _s8_value
end)()
;
return ((function() if ((((((h))~=nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.Image):_at((h):_at(aName)))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)())
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","imageNamed: aName\r\n\t\" Return the image of the receiver with aName (or nil). \"\r\n\r\n\t| h |\r\n\th := Lua @ (self handle basicAt: #images).\r\n\t^h notNil ifTrue: [ ^Image @ (h @ aName) ]","function(self,aName)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Lua):_at((((self):handle())[\"images\"])))\r\n\th=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn ((function() if ((((((h))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.Image):_at((h):_at(aName)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)())\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LFSkin,"controlNamed:",0
,function(self,aName)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local h=nil
(function()
	local _s8_value=((smalltalk.Lua):_at((((self):handle())["controls"])))
	h=_s8_value; return _s8_value
end)()
;
return ((function() if ((((((h))~=nil)))==true) then return ((function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.Lua):_at((h):_at(aName)))
end
)()
error(_s8Ret_,0)
end)())
end))() else return nil end end)())
;
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"accessing","controlNamed: aName\r\n\t\" Return the control of the receiver with aName (or nil). \"\r\n\r\n\t| h |\r\n\th := Lua @ (self handle basicAt: #controls).\r\n\t^h notNil ifTrue: [ ^Lua @ (h @ aName) ]","function(self,aName)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal h=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Lua):_at((((self):handle())[\"controls\"])))\r\n\th=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn ((function() if ((((((h))~=nil)))==true) then return ((function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.Lua):_at((h):_at(aName)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend))() else return nil end end)())\r\n;\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.LFSkin,"color:",0
,function(self,selector)
local rgba=nil
(function()
	local _s8_value=((self):controlNamed_(smalltalk:object_comma_(("color_"),selector)))
	rgba=_s8_value; return _s8_value
end)()
;
return ((function() if ((((((rgba))~=nil)))==true) then return ((function()
return ((smalltalk.Array):_at(rgba))
end))() else return nil end end)())
;
end
,"accessing","color: selector\r\n\t\" Return the color of the receiver at selector (or nil). \"\r\n\r\n\t| rgba |\r\n\trgba := self controlNamed: #color_ ,selector.\r\n\t^rgba notNil ifTrue: [ Array @ rgba ]","function(self,selector)\r\nlocal rgba=nil\r\n(function()\r\n\tlocal _s8_value=((self):controlNamed_(smalltalk:object_comma_((\"color_\"),selector)))\r\n\trgba=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn ((function() if ((((((rgba))~=nil)))==true) then return ((function()\r\nreturn ((smalltalk.Array):_at(rgba))\r\nend))() else return nil end end)())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"font:",0
,function(self,selector)
local font=nil
(function()
	local _s8_value=((self):controlNamed_(smalltalk:object_comma_((selector),"font")))
	font=_s8_value; return _s8_value
end)()
;
return ((function() if ((((((font))~=nil)))==true) then return ((function()
return ((smalltalk.Font):_at(font))
end))() else return nil end end)())
;
end
,"accessing","font: selector\r\n\t\" Return the font of the receiver at selector (or nil). \"\r\n\r\n\t| font |\r\n\tfont := self controlNamed: selector ,#font.\r\n\t^font notNil ifTrue: [ Font @ font ]","function(self,selector)\r\nlocal font=nil\r\n(function()\r\n\tlocal _s8_value=((self):controlNamed_(smalltalk:object_comma_((selector),\"font\")))\r\n\tfont=_s8_value; return _s8_value\r\nend)()\r\n;\r\nreturn ((function() if ((((((font))~=nil)))==true) then return ((function()\r\nreturn ((smalltalk.Font):_at(font))\r\nend))() else return nil end end)())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFSkin,"smallFont",0
,function(self)
return ((self):font_("small"))
;
end
,"accessing","smallFont\r\n\t\" Return the small font of the receiver (or nil). \"\r\n\r\n\t^self font: #small","function(self)\r\nreturn ((self):font_(\"small\"))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"name",0
,function(self)
return ((((self):handle())["name"]))
;
end
,"accessing","name\r\n\t\" Return the name of the receiver. \"\r\n\r\n\t^self handle basicAt: #name","function(self)\r\nreturn ((((self):handle())[\"name\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"name:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["name"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","name: anObject\r\n\t\" Set the name of the receiver. \"\r\n\r\n\tself handle basicAt: #name put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"name\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"static",0
,function(self)
return ((smalltalk.Lua):_at((((self):handle())["static"])))
;
end
,"accessing","static\r\n\t\" Return the static of the receiver. \"\r\n\r\n\t^Lua @ (self handle basicAt: #static)","function(self)\r\nreturn ((smalltalk.Lua):_at((((self):handle())[\"static\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"static:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["static"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","static: anObject\r\n\t\" Set the static of the receiver. \"\r\n\r\n\tself handle basicAt: #static put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"static\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"super",0
,function(self)
return ((smalltalk.Lua):_at((((self):handle())["super"])))
;
end
,"accessing","super\r\n\t\" Return the super of the receiver. \"\r\n\r\n\t^Lua @ (self handle basicAt: #super)","function(self)\r\nreturn ((smalltalk.Lua):_at((((self):handle())[\"super\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"super:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["super"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","super: anObject\r\n\t\" Set the super of the receiver. \"\r\n\r\n\tself handle basicAt: #super put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"super\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"subclasses",0
,function(self)
return ((smalltalk.Array):of_withAll_(smalltalk.LFObject, (((self):handle())["subclasses"])))
;
end
,"accessing","subclasses\r\n\t\" Return the subclasses of the receiver. \"\r\n\r\n\t^Array of: LFObject withAll: (self handle basicAt: #subclasses)","function(self)\r\nreturn ((smalltalk.Array):of_withAll_(smalltalk.LFObject, (((self):handle())[\"subclasses\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"subclasses:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["subclasses"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","subclasses: anObject\r\n\t\" Set the subclasses of the receiver. \"\r\n\r\n\tself handle basicAt: #subclasses put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"subclasses\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"__declaredMethods",0
,function(self)
return ((smalltalk.Lua):_at((((self):handle())["__declaredMethods"])))
;
end
,"accessing","__declaredMethods\r\n\t\" Return the __declaredMethods of the receiver. \"\r\n\r\n\t^Lua @ (self handle basicAt: #__declaredMethods)","function(self)\r\nreturn ((smalltalk.Lua):_at((((self):handle())[\"__declaredMethods\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"__declaredMethods:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["__declaredMethods"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","__declaredMethods: anObject\r\n\t\" Set the __declaredMethods of the receiver. \"\r\n\r\n\tself handle basicAt: #__declaredMethods put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"__declaredMethods\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"__instanceDict",0
,function(self)
return ((smalltalk.Lua):_at((((self):handle())["__instanceDict"])))
;
end
,"accessing","__instanceDict\r\n\t\" Return the __instanceDict of the receiver. \"\r\n\r\n\t^Lua @ (self handle basicAt: #__instanceDict)","function(self)\r\nreturn ((smalltalk.Lua):_at((((self):handle())[\"__instanceDict\"])))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFObject,"__instanceDict:",0
,function(self,anObject)
(function() local _1_=((anObject):handle()); ((self):handle())["__instanceDict"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","__instanceDict: anObject\r\n\t\" Set the __instanceDict of the receiver. \"\r\n\r\n\tself handle basicAt: #__instanceDict put: anObject handle","function(self,anObject)\r\n(function() local _1_=((anObject):handle()); ((self):handle())[\"__instanceDict\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView["$klass"],"from:parent:",0
,function(self,data,aParent)
return (((smalltalk.LoveFrames):current()):create_parent_(data, aParent))
;
end
,"instantiating","from: data parent: aParent\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^LoveFrames current\r\n\t\tcreate: data\r\n\t\tparent: aParent","function(self,data,aParent)\r\nreturn (((smalltalk.LoveFrames):current()):create_parent_(data, aParent))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView["$klass"],"from:",0
,function(self,data)
return (((smalltalk.LoveFrames):current()):create_(data))
;
end
,"instantiating","from: data\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^LoveFrames current create: data","function(self,data)\r\nreturn (((smalltalk.LoveFrames):current()):create_(data))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView["$klass"],"type:in:",0
,function(self,data,aParent)
return (((smalltalk.LoveFrames):current()):create_parent_(data, aParent))
;
end
,"instantiating","type: data in: aParent\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^LoveFrames current\r\n\t\tcreate: data\r\n\t\tparent: aParent","function(self,data,aParent)\r\nreturn (((smalltalk.LoveFrames):current()):create_parent_(data, aParent))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView["$klass"],"type:",0
,function(self,data)
return (((smalltalk.LoveFrames):current()):create_(data))
;
end
,"instantiating","type: data\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^LoveFrames current create: data","function(self,data)\r\nreturn (((smalltalk.LoveFrames):current()):create_(data))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"alwaysupdate",0
,function(self)
return ((((self):handle())["alwaysupdate"]))
;
end
,"accessing","alwaysupdate\r\n\t\" Return the alwaysupdate of the receiver. \"\r\n\r\n\t^self handle basicAt: #alwaysupdate","function(self)\r\nreturn ((((self):handle())[\"alwaysupdate\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"alwaysupdate:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["alwaysupdate"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","alwaysupdate: anObject\r\n\t\" Set the alwaysupdate of the receiver. \"\r\n\r\n\tself handle basicAt: #alwaysupdate put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"alwaysupdate\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"calledmousefunc",0
,function(self)
return ((((self):handle())["calledmousefunc"]))
;
end
,"accessing","calledmousefunc\r\n\t\" Return the calledmousefunc of the receiver. \"\r\n\r\n\t^self handle basicAt: #calledmousefunc","function(self)\r\nreturn ((((self):handle())[\"calledmousefunc\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"calledmousefunc:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["calledmousefunc"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","calledmousefunc: anObject\r\n\t\" Set the calledmousefunc of the receiver. \"\r\n\r\n\tself handle basicAt: #calledmousefunc put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"calledmousefunc\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"collide",0
,function(self)
return ((((self):handle())["collide"]))
;
end
,"accessing","collide\r\n\t\" Return the collide of the receiver. \"\r\n\r\n\t^self handle basicAt: #collide","function(self)\r\nreturn ((((self):handle())[\"collide\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"collide:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["collide"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","collide: anObject\r\n\t\" Set the collide of the receiver. \"\r\n\r\n\tself handle basicAt: #collide put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"collide\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"draworder",0
,function(self)
return ((((self):handle())["draworder"]))
;
end
,"accessing","draworder\r\n\t\" Return the draworder of the receiver. \"\r\n\r\n\t^self handle basicAt: #draworder","function(self)\r\nreturn ((((self):handle())[\"draworder\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"draworder:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["draworder"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","draworder: anObject\r\n\t\" Set the draworder of the receiver. \"\r\n\r\n\tself handle basicAt: #draworder put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"draworder\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"hover",0
,function(self)
return ((((self):handle())["hover"]))
;
end
,"accessing","hover\r\n\t\" Return the hover of the receiver. \"\r\n\r\n\t^self handle basicAt: #hover","function(self)\r\nreturn ((((self):handle())[\"hover\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"hover:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["hover"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","hover: anObject\r\n\t\" Set the hover of the receiver. \"\r\n\r\n\tself handle basicAt: #hover put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"hover\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"internal",0
,function(self)
return ((((self):handle())["internal"]))
;
end
,"accessing","internal\r\n\t\" Return the internal of the receiver. \"\r\n\r\n\t^self handle basicAt: #internal","function(self)\r\nreturn ((((self):handle())[\"internal\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"internal:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["internal"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","internal: anObject\r\n\t\" Set the internal of the receiver. \"\r\n\r\n\tself handle basicAt: #internal put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"internal\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"retainsize",0
,function(self)
return ((((self):handle())["retainsize"]))
;
end
,"accessing","retainsize\r\n\t\" Return the retainsize of the receiver. \"\r\n\r\n\t^self handle basicAt: #retainsize","function(self)\r\nreturn ((((self):handle())[\"retainsize\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"retainsize:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["retainsize"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","retainsize: anObject\r\n\t\" Set the retainsize of the receiver. \"\r\n\r\n\tself handle basicAt: #retainsize put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"retainsize\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"state",0
,function(self)
return ((((self):handle())["state"]))
;
end
,"accessing","state\r\n\t\" Return the state of the receiver. \"\r\n\r\n\t^self handle basicAt: #state","function(self)\r\nreturn ((((self):handle())[\"state\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"state:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["state"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","state: anObject\r\n\t\" Set the state of the receiver. \"\r\n\r\n\tself handle basicAt: #state put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"state\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"staticx",0
,function(self)
return ((((self):handle())["staticx"]))
;
end
,"accessing","staticx\r\n\t\" Return the staticx of the receiver. \"\r\n\r\n\t^self handle basicAt: #staticx","function(self)\r\nreturn ((((self):handle())[\"staticx\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"staticx:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["staticx"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","staticx: anObject\r\n\t\" Set the staticx of the receiver. \"\r\n\r\n\tself handle basicAt: #staticx put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"staticx\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"staticy",0
,function(self)
return ((((self):handle())["staticy"]))
;
end
,"accessing","staticy\r\n\t\" Return the staticy of the receiver. \"\r\n\r\n\t^self handle basicAt: #staticy","function(self)\r\nreturn ((((self):handle())[\"staticy\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"staticy:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["staticy"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","staticy: anObject\r\n\t\" Set the staticy of the receiver. \"\r\n\r\n\tself handle basicAt: #staticy put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"staticy\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"visible",0
,function(self)
return ((((self):handle())["visible"]))
;
end
,"accessing","visible\r\n\t\" Return the visible of the receiver. \"\r\n\r\n\t^self handle basicAt: #visible","function(self)\r\nreturn ((((self):handle())[\"visible\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"visible:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["visible"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","visible: anObject\r\n\t\" Set the visible of the receiver. \"\r\n\r\n\tself handle basicAt: #visible put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"visible\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"height",0
,function(self)
return ((((self):handle())["height"]))
;
end
,"accessing","height\r\n\t\" Return the height of the receiver. \"\r\n\r\n\t^self handle basicAt: #height","function(self)\r\nreturn ((((self):handle())[\"height\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"height:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["height"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","height: anObject\r\n\t\" Set the height of the receiver. \"\r\n\r\n\tself handle basicAt: #height put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"height\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"width",0
,function(self)
return ((((self):handle())["width"]))
;
end
,"accessing","width\r\n\t\" Return the width of the receiver. \"\r\n\r\n\t^self handle basicAt: #width","function(self)\r\nreturn ((((self):handle())[\"width\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"width:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["width"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","width: anObject\r\n\t\" Set the width of the receiver. \"\r\n\r\n\tself handle basicAt: #width put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"width\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"x",0
,function(self)
return ((((self):handle())["x"]))
;
end
,"accessing","x\r\n\t\" Return the x of the receiver. \"\r\n\r\n\t^self handle basicAt: #x","function(self)\r\nreturn ((((self):handle())[\"x\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"x:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["x"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","x: anObject\r\n\t\" Set the x of the receiver. \"\r\n\r\n\tself handle basicAt: #x put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"x\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"y",0
,function(self)
return ((((self):handle())["y"]))
;
end
,"accessing","y\r\n\t\" Return the y of the receiver. \"\r\n\r\n\t^self handle basicAt: #y","function(self)\r\nreturn ((((self):handle())[\"y\"]))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"y:",0
,function(self,anObject)
(function() local _1_=(anObject); ((self):handle())["y"]=_1_; return _1_ end)()
;
return (self)
;
end
,"accessing","y: anObject\r\n\t\" Set the y of the receiver. \"\r\n\r\n\tself handle basicAt: #y put: anObject","function(self,anObject)\r\n(function() local _1_=(anObject); ((self):handle())[\"y\"]=_1_; return _1_ end)()\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"draw",0
,function(self)
return (((self):handle()).draw())
;
end
,"wrappers","draw\r\n\t\" Delegate _draw to handle. \"\r\n\r\n\t^self handle #_draw","function(self)\r\nreturn (((self):handle()).draw())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"update:",0
,function(self,dt)
return (((self):handle()).update(dt))
;
end
,"wrappers","update: dt \r\n\t\" Delegate _update to handle. \"\r\n\r\n\t^self handle #_update: dt ","function(self,dt)\r\nreturn (((self):handle()).update(dt))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"keypressed:isrepeat:",0
,function(self,key,isrepeat)
return (((self):handle()).keypressed(key, isrepeat))
;
end
,"wrappers","keypressed: key isrepeat: isrepeat \r\n\t\" Delegate _keypressed to handle. \"\r\n\r\n\t^self handle #_keypressed: key isrepeat: isrepeat ","function(self,key,isrepeat)\r\nreturn (((self):handle()).keypressed(key, isrepeat))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"keyreleased:",0
,function(self,key)
return (((self):handle()).keyreleased(key))
;
end
,"wrappers","keyreleased: key \r\n\t\" Delegate _keyreleased to handle. \"\r\n\r\n\t^self handle #_keyreleased: key ","function(self,key)\r\nreturn (((self):handle()).keyreleased(key))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"mousepressed:y:button:",0
,function(self,x,y,button)
return (((self):handle()).mousepressed(x, y, button))
;
end
,"wrappers","mousepressed: x y: y button: button \r\n\t\" Delegate _mousepressed to handle. \"\r\n\r\n\t^self handle #_mousepressed: x y: y button: button ","function(self,x,y,button)\r\nreturn (((self):handle()).mousepressed(x, y, button))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"mousereleased:y:button:",0
,function(self,x,y,button)
return (((self):handle()).mousereleased(x, y, button))
;
end
,"wrappers","mousereleased: x y: y button: button \r\n\t\" Delegate _mousereleased to handle. \"\r\n\r\n\t^self handle #_mousereleased: x y: y button: button ","function(self,x,y,button)\r\nreturn (((self):handle()).mousereleased(x, y, button))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"textinput:",0
,function(self,text)
return (((self):handle()).textinput(text))
;
end
,"wrappers","textinput: text \r\n\t\" Delegate _textinput to handle. \"\r\n\r\n\t^self handle #_textinput: text ","function(self,text)\r\nreturn (((self):handle()).textinput(text))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"wheelmoved:y:",0
,function(self,x,y)
return (((self):handle()).wheelmoved(x, y))
;
end
,"wrappers","wheelmoved: x y: y \r\n\t\" Delegate _wheelmoved to handle. \"\r\n\r\n\t^self handle #_wheelmoved: x y: y ","function(self,x,y)\r\nreturn (((self):handle()).wheelmoved(x, y))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"pos:y:",0
,function(self,x,y)
return (((self):handle()).SetPos(x, y))
;
end
,"wrappers","pos: x y: y \r\n\t\" Delegate _SetPos to handle. \"\r\n\r\n\t^self handle #_SetPos: x y: y ","function(self,x,y)\r\nreturn (((self):handle()).SetPos(x, y))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"pos:y:center:",0
,function(self,x,y,center)
return (((self):handle()).SetPos(x, y, center))
;
end
,"wrappers","pos: x y: y center: center \r\n\t\" Delegate _SetPos to handle. \"\r\n\r\n\t^self handle #_SetPos: x y: y center: center ","function(self,x,y,center)\r\nreturn (((self):handle()).SetPos(x, y, center))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"x:",0
,function(self,x)
return (((self):handle()).SetX(x))
;
end
,"wrappers","x: x \r\n\t\" Delegate _SetX to handle. \"\r\n\r\n\t^self handle #_SetX: x ","function(self,x)\r\nreturn (((self):handle()).SetX(x))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"x:center:",0
,function(self,x,center)
return (((self):handle()).SetX(x, center))
;
end
,"wrappers","x: x center: center \r\n\t\" Delegate _SetX to handle. \"\r\n\r\n\t^self handle #_SetX: x center: center ","function(self,x,center)\r\nreturn (((self):handle()).SetX(x, center))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"y:",0
,function(self,y)
return (((self):handle()).SetY(y))
;
end
,"wrappers","y: y \r\n\t\" Delegate _SetY to handle. \"\r\n\r\n\t^self handle #_SetY: y ","function(self,y)\r\nreturn (((self):handle()).SetY(y))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"y:center:",0
,function(self,y,center)
return (((self):handle()).SetY(y, center))
;
end
,"wrappers","y: y center: center \r\n\t\" Delegate _SetY to handle. \"\r\n\r\n\t^self handle #_SetY: y center: center ","function(self,y,center)\r\nreturn (((self):handle()).SetY(y, center))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"x",0
,function(self)
return (((self):handle()).GetX())
;
end
,"wrappers","x\r\n\t\" Delegate _GetX to handle. \"\r\n\r\n\t^self handle #_GetX","function(self)\r\nreturn (((self):handle()).GetX())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"y",0
,function(self)
return (((self):handle()).GetY())
;
end
,"wrappers","y\r\n\t\" Delegate _GetY to handle. \"\r\n\r\n\t^self handle #_GetY","function(self)\r\nreturn (((self):handle()).GetY())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"staticX",0
,function(self)
return (((self):handle()).GetStaticX())
;
end
,"wrappers","staticX\r\n\t\" Delegate _GetStaticX to handle. \"\r\n\r\n\t^self handle #_GetStaticX","function(self)\r\nreturn (((self):handle()).GetStaticX())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"staticY",0
,function(self)
return (((self):handle()).GetStaticY())
;
end
,"wrappers","staticY\r\n\t\" Delegate _GetStaticY to handle. \"\r\n\r\n\t^self handle #_GetStaticY","function(self)\r\nreturn (((self):handle()).GetStaticY())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"center",0
,function(self)
return (((self):handle()).Center())
;
end
,"wrappers","center\r\n\t\" Delegate _Center to handle. \"\r\n\r\n\t^self handle #_Center","function(self)\r\nreturn (((self):handle()).Center())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"centerX",0
,function(self)
return (((self):handle()).CenterX())
;
end
,"wrappers","centerX\r\n\t\" Delegate _CenterX to handle. \"\r\n\r\n\t^self handle #_CenterX","function(self)\r\nreturn (((self):handle()).CenterX())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"centerY",0
,function(self)
return (((self):handle()).CenterY())
;
end
,"wrappers","centerY\r\n\t\" Delegate _CenterY to handle. \"\r\n\r\n\t^self handle #_CenterY","function(self)\r\nreturn (((self):handle()).CenterY())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"centerWithinArea:y:width:height:",0
,function(self,x,y,width,height)
return (((self):handle()).CenterWithinArea(x, y, width, height))
;
end
,"wrappers","centerWithinArea: x y: y width: width height: height \r\n\t\" Delegate _CenterWithinArea to handle. \"\r\n\r\n\t^self handle #_CenterWithinArea: x y: y width: width height: height ","function(self,x,y,width,height)\r\nreturn (((self):handle()).CenterWithinArea(x, y, width, height))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"width:",0
,function(self,width)
return (((self):handle()).SetWidth(width))
;
end
,"wrappers","width: width \r\n\t\" Delegate _SetWidth to handle. \"\r\n\r\n\t^self handle #_SetWidth: width ","function(self,width)\r\nreturn (((self):handle()).SetWidth(width))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"width:relative:",0
,function(self,width,relative)
return (((self):handle()).SetWidth(width, relative))
;
end
,"wrappers","width: width relative: relative \r\n\t\" Delegate _SetWidth to handle. \"\r\n\r\n\t^self handle #_SetWidth: width relative: relative ","function(self,width,relative)\r\nreturn (((self):handle()).SetWidth(width, relative))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"height:",0
,function(self,height)
return (((self):handle()).SetHeight(height))
;
end
,"wrappers","height: height \r\n\t\" Delegate _SetHeight to handle. \"\r\n\r\n\t^self handle #_SetHeight: height ","function(self,height)\r\nreturn (((self):handle()).SetHeight(height))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"height:relative:",0
,function(self,height,relative)
return (((self):handle()).SetHeight(height, relative))
;
end
,"wrappers","height: height relative: relative \r\n\t\" Delegate _SetHeight to handle. \"\r\n\r\n\t^self handle #_SetHeight: height relative: relative ","function(self,height,relative)\r\nreturn (((self):handle()).SetHeight(height, relative))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"width",0
,function(self)
return (((self):handle()).GetWidth())
;
end
,"wrappers","width\r\n\t\" Delegate _GetWidth to handle. \"\r\n\r\n\t^self handle #_GetWidth","function(self)\r\nreturn (((self):handle()).GetWidth())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"height",0
,function(self)
return (((self):handle()).GetHeight())
;
end
,"wrappers","height\r\n\t\" Delegate _GetHeight to handle. \"\r\n\r\n\t^self handle #_GetHeight","function(self)\r\nreturn (((self):handle()).GetHeight())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"visible",0
,function(self)
return (((self):handle()).GetVisible())
;
end
,"wrappers","visible\r\n\t\" Delegate _GetVisible to handle. \"\r\n\r\n\t^self handle #_GetVisible","function(self)\r\nreturn (((self):handle()).GetVisible())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"visible:",0
,function(self,aBoolean)
return (((self):handle()).SetVisible(aBoolean))
;
end
,"wrappers","visible: aBoolean \r\n\t\" Delegate _SetVisible to handle. \"\r\n\r\n\t^self handle #_SetVisible: aBoolean ","function(self,aBoolean)\r\nreturn (((self):handle()).SetVisible(aBoolean))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"parent",0
,function(self)
return (((self):handle()).GetParent())
;
end
,"wrappers","parent\r\n\t\" Delegate _GetParent to handle. \"\r\n\r\n\t^self handle #_GetParent","function(self)\r\nreturn (((self):handle()).GetParent())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"parent:",0
,function(self,parent)
return (((self):handle()).SetParent((parent):json()))
;
end
,"wrappers","parent: parent \r\n\t\" Delegate _SetParent to handle. \"\r\n\r\n\t^self handle #_SetParent: parent json ","function(self,parent)\r\nreturn (((self):handle()).SetParent((parent):json()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"remove",0
,function(self)
return (((self):handle()).Remove())
;
end
,"wrappers","remove\r\n\t\" Delegate _Remove to handle. \"\r\n\r\n\t^self handle #_Remove","function(self)\r\nreturn (((self):handle()).Remove())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"removeClickBounds",0
,function(self)
return (((self):handle()).RemoveClickBounds())
;
end
,"wrappers","removeClickBounds\r\n\t\" Delegate _RemoveClickBounds to handle. \"\r\n\r\n\t^self handle #_RemoveClickBounds","function(self)\r\nreturn (((self):handle()).RemoveClickBounds())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"inClickBounds",0
,function(self)
return (((self):handle()).InClickBounds())
;
end
,"wrappers","inClickBounds\r\n\t\" Delegate _InClickBounds to handle. \"\r\n\r\n\t^self handle #_InClickBounds","function(self)\r\nreturn (((self):handle()).InClickBounds())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"clickBounds:y:width:height:",0
,function(self,x,y,width,height)
return (((self):handle()).SetClickBounds(x, y, width, height))
;
end
,"wrappers","clickBounds: x y: y width: width height: height \r\n\t\" Delegate _SetClickBounds to handle. \"\r\n\r\n\t^self handle #_SetClickBounds: x y: y width: width height: height ","function(self,x,y,width,height)\r\nreturn (((self):handle()).SetClickBounds(x, y, width, height))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"baseParent:",0
,function(self,t)
return ((smalltalk.LFObject):_at(((self):handle()).GetBaseParent((t):json())))
;
end
,"wrappers","baseParent: t \r\n\t\" Delegate _GetBaseParent to handle. \"\r\n\r\n\t^LFObject @ (self handle #_GetBaseParent: t json )","function(self,t)\r\nreturn ((smalltalk.LFObject):_at(((self):handle()).GetBaseParent((t):json())))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"checkHover",0
,function(self)
return (((self):handle()).CheckHover())
;
end
,"wrappers","checkHover\r\n\t\" Delegate _CheckHover to handle. \"\r\n\r\n\t^self handle #_CheckHover","function(self)\r\nreturn (((self):handle()).CheckHover())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"hover",0
,function(self)
return ((smalltalk.LFView):_at(((self):handle()).GetHover()))
;
end
,"wrappers","hover\r\n\t\" Delegate _GetHover to handle. \"\r\n\r\n\t^LFView @ (self handle #_GetHover)","function(self)\r\nreturn ((smalltalk.LFView):_at(((self):handle()).GetHover()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"children",0
,function(self)
return ((smalltalk.Array):of_withAll_(smalltalk.LFView, ((self):handle()).GetChildren()))
;
end
,"wrappers","children\r\n\t\" Delegate _GetChildren to handle. \"\r\n\r\n\t^Array of: LFView withAll: (self handle #_GetChildren)","function(self)\r\nreturn ((smalltalk.Array):of_withAll_(smalltalk.LFView, ((self):handle()).GetChildren()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"internals",0
,function(self)
return ((smalltalk.Array):of_withAll_(smalltalk.LFView, ((self):handle()).GetInternals()))
;
end
,"wrappers","internals\r\n\t\" Delegate _GetInternals to handle. \"\r\n\r\n\t^Array of: LFView withAll: (self handle #_GetInternals)","function(self)\r\nreturn ((smalltalk.Array):of_withAll_(smalltalk.LFView, ((self):handle()).GetInternals()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"isTopList",0
,function(self)
return (((self):handle()).IsTopList())
;
end
,"wrappers","isTopList\r\n\t\" Delegate _IsTopList to handle. \"\r\n\r\n\t^self handle #_IsTopList","function(self)\r\nreturn (((self):handle()).IsTopList())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"isTopChild",0
,function(self)
return (((self):handle()).IsTopChild())
;
end
,"wrappers","isTopChild\r\n\t\" Delegate _IsTopChild to handle. \"\r\n\r\n\t^self handle #_IsTopChild","function(self)\r\nreturn (((self):handle()).IsTopChild())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"moveToTop",0
,function(self)
return (((self):handle()).MoveToTop())
;
end
,"wrappers","moveToTop\r\n\t\" Delegate _MoveToTop to handle. \"\r\n\r\n\t^self handle #_MoveToTop","function(self)\r\nreturn (((self):handle()).MoveToTop())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"drawFunc",0
,function(self)
return (((self):handle()).SetDrawFunc())
;
end
,"wrappers","drawFunc\r\n\t\" Delegate _SetDrawFunc to handle. \"\r\n\r\n\t^self handle #_SetDrawFunc","function(self)\r\nreturn (((self):handle()).SetDrawFunc())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"skinName",0
,function(self)
return (((self):handle()).GetSkinName())
;
end
,"wrappers","skinName\r\n\t\" Delegate _GetSkinName to handle. \"\r\n\r\n\t^self handle #_GetSkinName","function(self)\r\nreturn (((self):handle()).GetSkinName())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"skin",0
,function(self)
return ((smalltalk.LFSkin):_at(((self):handle()).GetSkin()))
;
end
,"wrappers","skin\r\n\t\" Delegate _GetSkin to handle. \"\r\n\r\n\t^LFSkin @ (self handle #_GetSkin)","function(self)\r\nreturn ((smalltalk.LFSkin):_at(((self):handle()).GetSkin()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"skin:",0
,function(self,name)
return (((self):handle()).SetSkin(name))
;
end
,"wrappers","skin: name \r\n\t\" Delegate _SetSkin to handle. \"\r\n\r\n\t^self handle #_SetSkin: name ","function(self,name)\r\nreturn (((self):handle()).SetSkin(name))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"alwaysUpdate",0
,function(self)
return (((self):handle()).GetAlwaysUpdate())
;
end
,"wrappers","alwaysUpdate\r\n\t\" Delegate _GetAlwaysUpdate to handle. \"\r\n\r\n\t^self handle #_GetAlwaysUpdate","function(self)\r\nreturn (((self):handle()).GetAlwaysUpdate())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"alwaysUpdate:",0
,function(self,bool)
return (((self):handle()).SetAlwaysUpdate(bool))
;
end
,"wrappers","alwaysUpdate: bool \r\n\t\" Delegate _SetAlwaysUpdate to handle. \"\r\n\r\n\t^self handle #_SetAlwaysUpdate: bool ","function(self,bool)\r\nreturn (((self):handle()).SetAlwaysUpdate(bool))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"retainSize",0
,function(self)
return (((self):handle()).GetRetainSize())
;
end
,"wrappers","retainSize\r\n\t\" Delegate _GetRetainSize to handle. \"\r\n\r\n\t^self handle #_GetRetainSize","function(self)\r\nreturn (((self):handle()).GetRetainSize())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"retainSize:",0
,function(self,bool)
return (((self):handle()).SetRetainSize(bool))
;
end
,"wrappers","retainSize: bool \r\n\t\" Delegate _SetRetainSize to handle. \"\r\n\r\n\t^self handle #_SetRetainSize: bool ","function(self,bool)\r\nreturn (((self):handle()).SetRetainSize(bool))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"isActive",0
,function(self)
return (((self):handle()).IsActive())
;
end
,"wrappers","isActive\r\n\t\" Delegate _IsActive to handle. \"\r\n\r\n\t^self handle #_IsActive","function(self)\r\nreturn (((self):handle()).IsActive())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"parents",0
,function(self)
return ((smalltalk.Array):of_withAll_(smalltalk.LFView, ((self):handle()).GetParents()))
;
end
,"wrappers","parents\r\n\t\" Delegate _GetParents to handle. \"\r\n\r\n\t^Array of: LFView withAll: (self handle #_GetParents)","function(self)\r\nreturn ((smalltalk.Array):of_withAll_(smalltalk.LFView, ((self):handle()).GetParents()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"isInternal",0
,function(self)
return (((self):handle()).IsInternal())
;
end
,"wrappers","isInternal\r\n\t\" Delegate _IsInternal to handle. \"\r\n\r\n\t^self handle #_IsInternal","function(self)\r\nreturn (((self):handle()).IsInternal())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"isTopInternal",0
,function(self)
return (((self):handle()).IsTopInternal())
;
end
,"wrappers","isTopInternal\r\n\t\" Delegate _IsTopInternal to handle. \"\r\n\r\n\t^self handle #_IsTopInternal","function(self)\r\nreturn (((self):handle()).IsTopInternal())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"type",0
,function(self)
return (((self):handle()).GetType())
;
end
,"wrappers","type\r\n\t\" Delegate _GetType to handle. \"\r\n\r\n\t^self handle #_GetType","function(self)\r\nreturn (((self):handle()).GetType())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"drawOrder",0
,function(self)
return (((self):handle()).GetDrawOrder())
;
end
,"wrappers","drawOrder\r\n\t\" Delegate _GetDrawOrder to handle. \"\r\n\r\n\t^self handle #_GetDrawOrder","function(self)\r\nreturn (((self):handle()).GetDrawOrder())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"drawOrder:",0
,function(self,ignored)
return (((self):handle()).SetDrawOrder(ignored))
;
end
,"wrappers","drawOrder: ignored \r\n\t\" Delegate _SetDrawOrder to handle. \"\r\n\r\n\t^self handle #_SetDrawOrder: ignored ","function(self,ignored)\r\nreturn (((self):handle()).SetDrawOrder(ignored))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"property:value:",0
,function(self,name,value)
return (((self):handle()).SetProperty(name, (value):json()))
;
end
,"wrappers","property: name value: value \r\n\t\" Delegate _SetProperty to handle. \"\r\n\r\n\t^self handle #_SetProperty: name value: value json ","function(self,name,value)\r\nreturn (((self):handle()).SetProperty(name, (value):json()))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"property:",0
,function(self,name)
return (((self):handle()).GetProperty(name))
;
end
,"wrappers","property: name \r\n\t\" Delegate _GetProperty to handle. \"\r\n\r\n\t^self handle #_GetProperty: name ","function(self,name)\r\nreturn (((self):handle()).GetProperty(name))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"isInList",0
,function(self)
return (((self):handle()).IsInList())
;
end
,"wrappers","isInList\r\n\t\" Delegate _IsInList to handle. \"\r\n\r\n\t^self handle #_IsInList","function(self)\r\nreturn (((self):handle()).IsInList())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"state",0
,function(self)
return (((self):handle()).GetState())
;
end
,"wrappers","state\r\n\t\" Delegate _GetState to handle. \"\r\n\r\n\t^self handle #_GetState","function(self)\r\nreturn (((self):handle()).GetState())\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"state:",0
,function(self,name)
return (((self):handle()).SetState(name))
;
end
,"wrappers","state: name \r\n\t\" Delegate _SetState to handle. \"\r\n\r\n\t^self handle #_SetState: name ","function(self,name)\r\nreturn (((self):handle()).SetState(name))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"pos",0
,function(self)
local x=nil
local y=nil
	x, y = self:handle():GetPos()
;
return ((smalltalk.Array):with_with_(x, y))
;
end
,"accessing","pos\r\n\t| x y |\r\n{'\tx, y = self:handle():GetPos()'}.\r\n\t^Array with: x with: y","function(self)\r\nlocal x=nil\r\nlocal y=nil\r\n\tx, y = self:handle():GetPos()\r\n;\r\nreturn ((smalltalk.Array):with_with_(x, y))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"position",0
,function(self)
local x=nil
local y=nil
	x, y = self:handle():GetPos()
;
return ((x):_at(y))
;
end
,"accessing","position\r\n\t| x y |\r\n{'\tx, y = self:handle():GetPos()'}.\r\n\t^x@y","function(self)\r\nlocal x=nil\r\nlocal y=nil\r\n\tx, y = self:handle():GetPos()\r\n;\r\nreturn ((x):_at(y))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"position:",0
,function(self,aPoint)
(self):pos_y_((aPoint):x(), (aPoint):y())
;
return (self)
;
end
,"accessing","position: aPoint\r\n\tself pos: aPoint x y: aPoint y","function(self,aPoint)\r\n(self):pos_y_((aPoint):x(), (aPoint):y())\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"staticPosition",0
,function(self)
local x=nil
local y=nil
	x, y = self:handle():GetStaticPos()
;
return ((x):_at(y))
;
end
,"accessing","staticPosition\r\n\t| x y |\r\n{'\tx, y = self:handle():GetStaticPos()'}.\r\n\t^x@y","function(self)\r\nlocal x=nil\r\nlocal y=nil\r\n\tx, y = self:handle():GetStaticPos()\r\n;\r\nreturn ((x):_at(y))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"staticPos",0
,function(self)
local x=nil
local y=nil
	x, y = self:handle():GetStaticPos()
;
return ((smalltalk.Array):with_with_(x, y))
;
end
,"accessing","staticPos\r\n\t| x y |\r\n{'\tx, y = self:handle():GetStaticPos()'}.\r\n\t^Array with: x with: y","function(self)\r\nlocal x=nil\r\nlocal y=nil\r\n\tx, y = self:handle():GetStaticPos()\r\n;\r\nreturn ((smalltalk.Array):with_with_(x, y))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"centerWithinArea:",0
,function(self,aRectangle)
(self):centerWithinArea_y_width_height_((aRectangle):left(), (aRectangle):top(), (aRectangle):width(), (aRectangle):height())
;
return (self)
;
end
,"layout","centerWithinArea: aRectangle\r\n\tself centerWithinArea: aRectangle left y: aRectangle top\r\n\t\twidth: aRectangle width height: aRectangle height","function(self,aRectangle)\r\n(self):centerWithinArea_y_width_height_((aRectangle):left(), (aRectangle):top(), (aRectangle):width(), (aRectangle):height())\r\n;\r\nreturn (self)\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"extent",0
,function(self)
local x=nil
local y=nil
	x, y = self:handle():GetSize()
;
return ((x):_at(y))
;
end
,"accessing","extent\r\n\t| x y |\r\n{'\tx, y = self:handle():GetSize()'}.\r\n\t^x@y","function(self)\r\nlocal x=nil\r\nlocal y=nil\r\n\tx, y = self:handle():GetSize()\r\n;\r\nreturn ((x):_at(y))\r\n;\r\nend")

smalltalk:bind(smalltalk.LFView,"size",0
,function(self)
local x=nil
local y=nil
	x, y = self:handle():GetSize()
;
return ((smalltalk.Array):with_with_(x, y))
;
end
,"accessing","size\r\n\t| x y |\r\n{'\tx, y = self:handle():GetSize()'}.\r\n\t^Array with: x with: y","function(self)\r\nlocal x=nil\r\nlocal y=nil\r\n\tx, y = self:handle():GetSize()\r\n;\r\nreturn ((smalltalk.Array):with_with_(x, y))\r\n;\r\nend")
