
-- fileIn("s8/library/ffi-reflect.st")
smalltalk:addClass("FFIReflect",smalltalk.NativeObject,smalltalk:newArray({}),"ffi-reflect")

smalltalk.FFIReflect["$klass"]["$iVarNames"]=smalltalk:newArray({"nativeClass"})

smalltalk:bind(smalltalk.FFIReflect["$klass"],"typeof:",0
,function(self,x)
return ((self):_at((((self):nativeClass()):handle()).typeof((x):json())));
end
,"wrappers","typeof: x \r\n\t\" Delegated to native class. \"\r\n\r\n\t^self @ (self nativeClass handle #_typeof: x json )","function(self,x)\r\nreturn ((self):_at((((self):nativeClass()):handle()).typeof((x):json())));\r\nend")

smalltalk:bind(smalltalk.FFIReflect["$klass"],"getmetatable:",0
,function(self,x)
return ((smalltalk.Lua):_at((((self):nativeClass()):handle()).getmetatable((x):json())));
end
,"wrappers","getmetatable: x \r\n\t\" Delegated to native class. \"\r\n\r\n\t^Lua @ (self nativeClass handle #_getmetatable: x json )","function(self,x)\r\nreturn ((smalltalk.Lua):_at((((self):nativeClass()):handle()).getmetatable((x):json())));\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"alignment",0
,function(self)
return (((self):handle())["alignment"]);
end
,"accessing","alignment\r\n\t\" Return the alignment of the receiver. \"\r\n\r\n\t^self handle basicAt: #alignment","function(self)\r\nreturn (((self):handle())[\"alignment\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"offset",0
,function(self)
return (((self):handle())["offset"]);
end
,"accessing","offset\r\n\t\" Return the offset of the receiver. \"\r\n\r\n\t^self handle basicAt: #offset","function(self)\r\nreturn (((self):handle())[\"offset\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"size",0
,function(self)
return (((self):handle())["size"]);
end
,"accessing","size\r\n\t\" Return the size of the receiver. \"\r\n\r\n\t^self handle basicAt: #size","function(self)\r\nreturn (((self):handle())[\"size\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"typeid",0
,function(self)
return (((self):handle())["typeid"]);
end
,"accessing","typeid\r\n\t\" Return the typeid of the receiver. \"\r\n\r\n\t^self handle basicAt: #typeid","function(self)\r\nreturn (((self):handle())[\"typeid\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"what",0
,function(self)
return (((self):handle())["what"]);
end
,"accessing","what\r\n\t\" Return the what of the receiver. \"\r\n\r\n\t^self handle basicAt: #what","function(self)\r\nreturn (((self):handle())[\"what\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"name",0
,function(self)
return (((self):handle())["name"]);
end
,"accessing","name\r\n\t\" Return the name of the receiver. \"\r\n\r\n\t^self handle basicAt: #name","function(self)\r\nreturn (((self):handle())[\"name\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"const",0
,function(self)
return (((self):handle())["const"]);
end
,"accessing","const\r\n\t\" Return the const of the receiver. \"\r\n\r\n\t^self handle basicAt: #const","function(self)\r\nreturn (((self):handle())[\"const\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"volatile",0
,function(self)
return (((self):handle())["volatile"]);
end
,"accessing","volatile\r\n\t\" Return the volatile of the receiver. \"\r\n\r\n\t^self handle basicAt: #volatile","function(self)\r\nreturn (((self):handle())[\"volatile\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"nargs",0
,function(self)
return (((self):handle())["nargs"]);
end
,"accessing","nargs\r\n\t\" Return the nargs of the receiver. \"\r\n\r\n\t^self handle basicAt: #nargs","function(self)\r\nreturn (((self):handle())[\"nargs\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"convention",0
,function(self)
return (((self):handle())["convention"]);
end
,"accessing","convention\r\n\t\" Return the convention of the receiver. \"\r\n\r\n\t^self handle basicAt: #convention","function(self)\r\nreturn (((self):handle())[\"convention\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"value",0
,function(self)
return (((self):handle())["value"]);
end
,"accessing","value\r\n\t\" Return the value of the receiver. \"\r\n\r\n\t^self handle basicAt: #value","function(self)\r\nreturn (((self):handle())[\"value\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"type",0
,function(self)
return ((smalltalk.FFIReflect):_at(((self):handle())["type"]));
end
,"accessing","type\r\n\t\" Return the type of the receiver. \"\r\n\r\n\t^FFIReflect @ (self handle basicAt: #type)","function(self)\r\nreturn ((smalltalk.FFIReflect):_at(((self):handle())[\"type\"]));\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"member:",0
,function(self,nameOrIndex)
return ((smalltalk.FFIReflect):_at(((self):handle()):member(nameOrIndex)));
end
,"wrappers","member: nameOrIndex \r\n\t\" Delegate to handle. \"\r\n\r\n\t^FFIReflect @ (self handle #member: nameOrIndex )","function(self,nameOrIndex)\r\nreturn ((smalltalk.FFIReflect):_at(((self):handle()):member(nameOrIndex)));\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"argument:",0
,function(self,nameOrIndex)
return ((smalltalk.FFIReflect):_at(((self):handle()):argument(nameOrIndex)));
end
,"wrappers","argument: nameOrIndex \r\n\t\" Delegate to handle. \"\r\n\r\n\t^FFIReflect @ (self handle #argument: nameOrIndex )","function(self,nameOrIndex)\r\nreturn ((smalltalk.FFIReflect):_at(((self):handle()):argument(nameOrIndex)));\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"value:",0
,function(self,nameOrIndex)
return ((smalltalk.FFIReflect):_at(((self):handle()):value(nameOrIndex)));
end
,"wrappers","value: nameOrIndex \r\n\t\" Delegate to handle. \"\r\n\r\n\t^FFIReflect @ (self handle #value: nameOrIndex )","function(self,nameOrIndex)\r\nreturn ((smalltalk.FFIReflect):_at(((self):handle()):value(nameOrIndex)));\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"members",0
,function(self)
local next=nil
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):member_(((result):size()):_plus(1)))
	next=_s8_value
	return _s8_value
end)();return (smalltalk:notNil_((next)))
end))() do (result):add_(next); end;
return (result);
end
,"accessing","members\r\n\t| next result |\r\n\tresult := #().\r\n\t[\tnext := self member: result size + 1.\r\n\t\tnext notNil ] whileTrue: [\r\n\t\tresult add: next\r\n\t].\r\n\t^result","function(self)\r\nlocal next=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):member_(((result):size()):_plus(1)))\r\n\tnext=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:notNil_((next)))\r\nend))() do (result):add_(next); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"arguments",0
,function(self)
local next=nil
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):argument_(((result):size()):_plus(1)))
	next=_s8_value
	return _s8_value
end)();return (smalltalk:notNil_((next)))
end))() do (result):add_(next); end;
return (result);
end
,"accessing","arguments\r\n\t| next result |\r\n\tresult := #().\r\n\t[\tnext := self argument: result size + 1.\r\n\t\tnext notNil ] whileTrue: [\r\n\t\tresult add: next\r\n\t].\r\n\t^result","function(self)\r\nlocal next=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):argument_(((result):size()):_plus(1)))\r\n\tnext=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:notNil_((next)))\r\nend))() do (result):add_(next); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"values",0
,function(self)
local next=nil
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
while ((function()
(function()
	local _s8_value=((self):value_(((result):size()):_plus(1)))
	next=_s8_value
	return _s8_value
end)();return (smalltalk:notNil_((next)))
end))() do (result):add_(next); end;
return (result);
end
,"accessing","values\r\n\t| next result |\r\n\tresult := #().\r\n\t[\tnext := self value: result size + 1.\r\n\t\tnext notNil ] whileTrue: [\r\n\t\tresult add: next\r\n\t].\r\n\t^result","function(self)\r\nlocal next=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nwhile ((function()\r\n(function()\r\n\tlocal _s8_value=((self):value_(((result):size()):_plus(1)))\r\n\tnext=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:notNil_((next)))\r\nend))() do (result):add_(next); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"symName",0
,function(self)
return (((self):handle())["sym_name"]);
end
,"accessing","symName\r\n\t^self handle basicAt: #sym_name","function(self)\r\nreturn (((self):handle())[\"sym_name\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"elementType",0
,function(self)
return ((smalltalk.FFIReflect):_at(((self):handle())["element_type"]));
end
,"accessing","elementType\r\n\t^FFIReflect @ (self handle basicAt: #element_type)","function(self)\r\nreturn ((smalltalk.FFIReflect):_at(((self):handle())[\"element_type\"]));\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"returnType",0
,function(self)
return ((smalltalk.FFIReflect):_at(((self):handle())["return_type"]));
end
,"accessing","returnType\r\n\t^FFIReflect @ (self handle basicAt: #return_type)","function(self)\r\nreturn ((smalltalk.FFIReflect):_at(((self):handle())[\"return_type\"]));\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"is:",0
,function(self,tag)
if not (((smalltalk:newArray({"bool", "unsigned", "long", "vla", "transparent", "vector", "complex", "vararg", "sse_reg_params"})):includes_(tag)))==true then (self):error_(smalltalk:object_comma_(("Unknown tag "),tag)); end;
return (((((self):handle())[tag])==true));
end
,"query","is: tag\r\n\t(#(\tbool unsigned long vla\r\n\t\ttransparent vector complex\r\n\t\tvararg sse_reg_params \r\n\t) includes: tag) ifFalse: [\r\n\t\tself error: 'Unknown tag ' ,tag\r\n\t].\r\n\t^(self handle basicAt: tag) == true","function(self,tag)\r\nif not (((smalltalk:newArray({\"bool\", \"unsigned\", \"long\", \"vla\", \"transparent\", \"vector\", \"complex\", \"vararg\", \"sse_reg_params\"})):includes_(tag)))==true then (self):error_(smalltalk:object_comma_((\"Unknown tag \"),tag)); end;\r\nreturn (((((self):handle())[tag])==true));\r\nend")

smalltalk:bind(smalltalk.FFIReflect,"has:",0
,function(self,tag)
return (smalltalk:notNil_((((self):handle())[tag])));
end
,"query","has: tag\r\n\t^(self handle basicAt: tag) notNil","function(self,tag)\r\nreturn (smalltalk:notNil_((((self):handle())[tag])));\r\nend")

smalltalk:bind(smalltalk.FFIReflect["$klass"],"nativeClass",0
,function(self)
if (smalltalk:isNil_((self["@nativeClass"])))==true then (function()
	local _s8_value=((smalltalk.Lua):_at(((smalltalk.Smalltalk):current()):eval_((self):sourceCode())))
	self["@nativeClass"]=_s8_value
	return _s8_value
end)(); end;
return (self["@nativeClass"]);
end
,"private","nativeClass\r\n\t\" Private - Returns the wrapper for native binding of the receiver. \"\r\n\r\n\tnativeClass isNil ifTrue: [\r\n\t\tnativeClass := Lua @ (Smalltalk current eval: self sourceCode)\r\n\t].\r\n\t^nativeClass","function(self)\r\nif (smalltalk:isNil_((self[\"@nativeClass\"])))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Lua):_at(((smalltalk.Smalltalk):current()):eval_((self):sourceCode())))\r\n\tself[\"@nativeClass\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn (self[\"@nativeClass\"]);\r\nend")

smalltalk:bind(smalltalk.FFIReflect["$klass"],"sourceCode",0
,function(self)
return ("--[[ LuaJIT FFI reflection Library ]]--\r\n--[[ Copyright (C) 2014 Peter Cawley <lua@corsix.org>. All rights reserved.\r\n\r\nPermission is hereby granted, free of charge, to any person obtaining a copy\r\nof this software and associated documentation files (the \"Software\"), to deal\r\nin the Software without restriction, including without limitation the rights\r\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\r\ncopies of the Software, and to permit persons to whom the Software is\r\nfurnished to do so, subject to the following conditions:\r\n\r\nThe above copyright notice and this permission notice shall be included in\r\nall copies or substantial portions of the Software.\r\n\r\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\r\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\r\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE\r\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\r\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\r\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\r\nTHE SOFTWARE.\r\n--]]\r\nlocal ffi = require \"ffi\"\r\nlocal bit = require \"bit\"\r\nlocal reflect = {}\r\n\r\nlocal CTState, init_CTState\r\nlocal miscmap, init_miscmap\r\n\r\nlocal function gc_str(gcref) -- Convert a GCref (to a GCstr) into a string\r\n  if gcref ~= 0 then\r\n    local ts = ffi.cast(\"uint32_t*\", gcref)\r\n    return ffi.string(ts + 4, ts[3])\r\n  end\r\nend\r\n\r\nlocal typeinfo = ffi.typeinfo or function(id)\r\n  -- ffi.typeof is present in LuaJIT v2.1 since 8th Oct 2014 (d6ff3afc)\r\n  -- this is an emulation layer for older versions of LuaJIT\r\n  local ctype = (CTState or init_CTState()).tab[id]\r\n  return {\r\n    info = ctype.info,\r\n    size = bit.bnot(ctype.size) ~= 0 and ctype.size,\r\n    sib = ctype.sib ~= 0 and ctype.sib,\r\n    name = gc_str(ctype.name),\r\n  }\r\nend\r\n\r\nlocal function memptr(gcobj)\r\n  return tonumber(tostring(gcobj):match\"%x*$\", 16)\r\nend\r\n\r\ninit_CTState = function()\r\n  -- Relevant minimal definitions from lj_ctype.h\r\n  ffi.cdef [[\r\n    typedef struct CType {\r\n      uint32_t info;\r\n      uint32_t size;\r\n      uint16_t sib;\r\n      uint16_t next;\r\n      uint32_t name;\r\n    } CType;\r\n    \r\n    typedef struct CTState {\r\n      CType *tab;\r\n      uint32_t top;\r\n      uint32_t sizetab;\r\n      void *L;\r\n      void *g;\r\n      void *finalizer;\r\n      void *miscmap;\r\n    } CTState;\r\n  ]]\r\n\r\n  -- Acquire a pointer to this Lua universe's CTState\r\n  local co = coroutine.create(function()end) -- Any live coroutine will do.\r\n  local uint32_ptr = ffi.typeof(\"uint32_t*\")\r\n  local G = ffi.cast(uint32_ptr, ffi.cast(uint32_ptr, memptr(co))[2])\r\n  -- In global_State, `MRef ctype_state` is immediately before `GCRef gcroot[GCROOT_MAX]`.\r\n  -- We first find (an entry in) gcroot by looking for a metamethod name string.\r\n  local anchor = ffi.cast(\"uint32_t\", ffi.cast(\"const char*\", \"__index\"))\r\n  local i = 0\r\n  while math.abs(tonumber(G[i] - anchor)) > 64 do\r\n    i = i + 1\r\n  end\r\n  -- We then work backwards looking for something resembling ctype_state.\r\n  repeat\r\n    i = i - 1\r\n    CTState = ffi.cast(\"CTState*\", G[i])\r\n  until ffi.cast(uint32_ptr, CTState.g) == G\r\n  \r\n  return CTState\r\nend\r\n\r\ninit_miscmap = function()\r\n  -- Acquire the CTState's miscmap table as a Lua variable\r\n  local t = {}; t[0] = t\r\n  local tvalue = ffi.cast(\"uint32_t*\", memptr(t))[2]\r\n  ffi.cast(\"uint32_t*\", tvalue)[ffi.abi\"le\" and 0 or 1] = ffi.cast(\"uint32_t\", ffi.cast(\"uintptr_t\", (CTState or init_CTState()).miscmap))\r\n  miscmap = t[0]\r\n  return miscmap\r\nend\r\n\r\n-- Information for unpacking a `struct CType`.\r\n-- One table per CT_* constant, containing:\r\n-- * A name for that CT_\r\n-- * Roles of the cid and size fields.\r\n-- * Whether the sib field is meaningful.\r\n-- * Zero or more applicable boolean flags.\r\nlocal CTs = {[0] =\r\n  {\"int\",\r\n    \"\", \"size\", false,\r\n    {0x08000000, \"bool\"},\r\n    {0x04000000, \"float\", \"subwhat\"},\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n    {0x00800000, \"unsigned\"},\r\n    {0x00400000, \"long\"},\r\n  },\r\n  {\"struct\",\r\n    \"\", \"size\", true,\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n    {0x00800000, \"union\", \"subwhat\"},\r\n    {0x00100000, \"vla\"},\r\n  },\r\n  {\"ptr\",\r\n    \"element_type\", \"size\", false,\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n    {0x00800000, \"ref\", \"subwhat\"},\r\n  },\r\n  {\"array\",\r\n    \"element_type\", \"size\", false,\r\n    {0x08000000, \"vector\"},\r\n    {0x04000000, \"complex\"},\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n    {0x00100000, \"vla\"},\r\n  },\r\n  {\"void\",\r\n    \"\", \"size\", false,\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n  },\r\n  {\"enum\",\r\n    \"type\", \"size\", true,\r\n  },\r\n  {\"func\",\r\n    \"return_type\", \"nargs\", true,\r\n    {0x00800000, \"vararg\"},\r\n    {0x00400000, \"sse_reg_params\"},\r\n  },\r\n  {\"typedef\", -- Not seen\r\n    \"element_type\", \"\", false,\r\n  },\r\n  {\"attrib\", -- Only seen internally\r\n    \"type\", \"value\", true,\r\n  },\r\n  {\"field\",\r\n    \"type\", \"offset\", true,\r\n  },\r\n  {\"bitfield\",\r\n    \"\", \"offset\", true,\r\n    {0x08000000, \"bool\"},\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n    {0x00800000, \"unsigned\"},\r\n  },\r\n  {\"constant\",\r\n    \"type\", \"value\", true,\r\n    {0x02000000, \"const\"},\r\n  },\r\n  {\"extern\", -- Not seen\r\n    \"CID\", \"\", true,\r\n  },\r\n  {\"kw\", -- Not seen\r\n    \"TOK\", \"size\",\r\n  },\r\n}\r\n\r\n-- Set of CType::cid roles which are a CTypeID.\r\nlocal type_keys = {\r\n  element_type = true,\r\n  return_type = true,\r\n  value_type = true,\r\n  type = true,\r\n}\r\n\r\n-- Create a metatable for each CT.\r\nlocal metatables = {\r\n}\r\nfor _, CT in ipairs(CTs) do\r\n  local what = CT[1]\r\n  local mt = {__index = {}}\r\n  metatables[what] = mt\r\nend\r\n\r\n-- Logic for merging an attribute CType onto the annotated CType.\r\nlocal CTAs = {[0] =\r\n  function(a, refct) error(\"TODO: CTA_NONE\") end,\r\n  function(a, refct) error(\"TODO: CTA_QUAL\") end,\r\n  function(a, refct)\r\n    a = 2^a.value\r\n    refct.alignment = a\r\n    refct.attributes.align = a\r\n  end,\r\n  function(a, refct)\r\n    refct.transparent = true\r\n    refct.attributes.subtype = refct.typeid\r\n  end,\r\n  function(a, refct) refct.sym_name = a.name end,\r\n  function(a, refct) error(\"TODO: CTA_BAD\") end,\r\n}\r\n\r\n-- C function calling conventions (CTCC_* constants in lj_refct.h)\r\nlocal CTCCs = {[0] = \r\n  \"cdecl\",\r\n  \"thiscall\",\r\n  \"fastcall\",\r\n  \"stdcall\",\r\n}\r\n\r\nlocal function refct_from_id(id) -- refct = refct_from_id(CTypeID)\r\n  local ctype = typeinfo(id)\r\n  local CT_code = bit.rshift(ctype.info, 28)\r\n  local CT = CTs[CT_code]\r\n  local what = CT[1]\r\n  local refct = setmetatable({\r\n    what = what,\r\n    typeid = id,\r\n    name = ctype.name,\r\n  }, metatables[what])\r\n  \r\n  -- Interpret (most of) the CType::info field\r\n  for i = 5, #CT do\r\n    if bit.band(ctype.info, CT[i][1]) ~= 0 then\r\n      if CT[i][3] == \"subwhat\" then\r\n        refct.what = CT[i][2]\r\n      else\r\n        refct[CT[i][2]] = true\r\n      end\r\n    end\r\n  end\r\n  if CT_code <= 5 then\r\n    refct.alignment = bit.lshift(1, bit.band(bit.rshift(ctype.info, 16), 15))\r\n  elseif what == \"func\" then\r\n    refct.convention = CTCCs[bit.band(bit.rshift(ctype.info, 16), 3)]\r\n  end\r\n  \r\n  if CT[2] ~= \"\" then -- Interpret the CType::cid field\r\n    local k = CT[2]\r\n    local cid = bit.band(ctype.info, 0xffff)\r\n    if type_keys[k] then\r\n      if cid == 0 then\r\n        cid = nil\r\n      else\r\n        cid = refct_from_id(cid)\r\n      end\r\n    end\r\n    refct[k] = cid\r\n  end\r\n  \r\n  if CT[3] ~= \"\" then -- Interpret the CType::size field\r\n    local k = CT[3]\r\n    refct[k] = ctype.size or (k == \"size\" and \"none\")\r\n  end\r\n  \r\n  if what == \"attrib\" then\r\n    -- Merge leading attributes onto the type being decorated.\r\n    local CTA = CTAs[bit.band(bit.rshift(ctype.info, 16), 0xff)]\r\n    if refct.type then\r\n      local ct = refct.type\r\n      ct.attributes = {}\r\n      CTA(refct, ct)\r\n      ct.typeid = refct.typeid\r\n      refct = ct\r\n    else\r\n      refct.CTA = CTA\r\n    end\r\n  elseif what == \"bitfield\" then\r\n    -- Decode extra bitfield fields, and make it look like a normal field.\r\n    refct.offset = refct.offset + bit.band(ctype.info, 127) / 8\r\n    refct.size = bit.band(bit.rshift(ctype.info, 8), 127) / 8\r\n    refct.type = {\r\n      what = \"int\",\r\n      bool = refct.bool,\r\n      const = refct.const,\r\n      volatile = refct.volatile,\r\n      unsigned = refct.unsigned,\r\n      size = bit.band(bit.rshift(ctype.info, 16), 127),\r\n    }\r\n    refct.bool, refct.const, refct.volatile, refct.unsigned = nil\r\n  end\r\n  \r\n  if CT[4] then -- Merge sibling attributes onto this type.\r\n    while ctype.sib do\r\n      local entry = typeinfo(ctype.sib)\r\n      if CTs[bit.rshift(entry.info, 28)][1] ~= \"attrib\" then break end\r\n      if bit.band(entry.info, 0xffff) ~= 0 then break end\r\n      local sib = refct_from_id(ctype.sib)\r\n      sib:CTA(refct)\r\n      ctype = entry\r\n    end\r\n  end\r\n  \r\n  return refct\r\nend\r\n\r\nlocal function sib_iter(s, refct)\r\n  repeat\r\n    local ctype = typeinfo(refct.typeid)\r\n    if not ctype.sib then return end\r\n    refct = refct_from_id(ctype.sib)\r\n  until refct.what ~= \"attrib\" -- Pure attribs are skipped.\r\n  return refct\r\nend\r\n\r\nlocal function siblings(refct)\r\n  -- Follow to the end of the attrib chain, if any.\r\n  while refct.attributes do\r\n    refct = refct_from_id(refct.attributes.subtype or typeinfo(refct.typeid).sib)\r\n  end\r\n\r\n  return sib_iter, nil, refct\r\nend\r\n\r\nmetatables.struct.__index.members = siblings\r\nmetatables.func.__index.arguments = siblings\r\nmetatables.enum.__index.values = siblings\r\n\r\nlocal function find_sibling(refct, name)\r\n  local num = tonumber(name)\r\n  if num then\r\n    for sib in siblings(refct) do\r\n      if num == 1 then\r\n        return sib\r\n      end\r\n      num = num - 1\r\n    end\r\n  else\r\n    for sib in siblings(refct) do\r\n      if sib.name == name then\r\n        return sib\r\n      end\r\n    end\r\n  end\r\nend\r\n\r\nmetatables.struct.__index.member = find_sibling\r\nmetatables.func.__index.argument = find_sibling\r\nmetatables.enum.__index.value = find_sibling\r\n\r\nfunction reflect.typeof(x) -- refct = reflect.typeof(ct)\r\n  return refct_from_id(tonumber(ffi.typeof(x)))\r\nend\r\n\r\nfunction reflect.getmetatable(x) -- mt = reflect.getmetatable(ct)\r\n  return (miscmap or init_miscmap())[-tonumber(ffi.typeof(x))]\r\nend\r\n\r\nreturn reflect");
end
,"private","sourceCode\r\n\t\" Returns the source code of the receiver as found at git storage. \"\r\n\r\n\t^'--[[ LuaJIT FFI reflection Library ]]--\r\n--[[ Copyright (C) 2014 Peter Cawley <lua@corsix.org>. All rights reserved.\r\n\r\nPermission is hereby granted, free of charge, to any person obtaining a copy\r\nof this software and associated documentation files (the \"Software\"), to deal\r\nin the Software without restriction, including without limitation the rights\r\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\r\ncopies of the Software, and to permit persons to whom the Software is\r\nfurnished to do so, subject to the following conditions:\r\n\r\nThe above copyright notice and this permission notice shall be included in\r\nall copies or substantial portions of the Software.\r\n\r\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\r\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\r\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE\r\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\r\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\r\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\r\nTHE SOFTWARE.\r\n--]]\r\nlocal ffi = require \"ffi\"\r\nlocal bit = require \"bit\"\r\nlocal reflect = {}\r\n\r\nlocal CTState, init_CTState\r\nlocal miscmap, init_miscmap\r\n\r\nlocal function gc_str(gcref) -- Convert a GCref (to a GCstr) into a string\r\n  if gcref ~= 0 then\r\n    local ts = ffi.cast(\"uint32_t*\", gcref)\r\n    return ffi.string(ts + 4, ts[3])\r\n  end\r\nend\r\n\r\nlocal typeinfo = ffi.typeinfo or function(id)\r\n  -- ffi.typeof is present in LuaJIT v2.1 since 8th Oct 2014 (d6ff3afc)\r\n  -- this is an emulation layer for older versions of LuaJIT\r\n  local ctype = (CTState or init_CTState()).tab[id]\r\n  return {\r\n    info = ctype.info,\r\n    size = bit.bnot(ctype.size) ~= 0 and ctype.size,\r\n    sib = ctype.sib ~= 0 and ctype.sib,\r\n    name = gc_str(ctype.name),\r\n  }\r\nend\r\n\r\nlocal function memptr(gcobj)\r\n  return tonumber(tostring(gcobj):match\"%x*$\", 16)\r\nend\r\n\r\ninit_CTState = function()\r\n  -- Relevant minimal definitions from lj_ctype.h\r\n  ffi.cdef [[\r\n    typedef struct CType {\r\n      uint32_t info;\r\n      uint32_t size;\r\n      uint16_t sib;\r\n      uint16_t next;\r\n      uint32_t name;\r\n    } CType;\r\n    \r\n    typedef struct CTState {\r\n      CType *tab;\r\n      uint32_t top;\r\n      uint32_t sizetab;\r\n      void *L;\r\n      void *g;\r\n      void *finalizer;\r\n      void *miscmap;\r\n    } CTState;\r\n  ]]\r\n\r\n  -- Acquire a pointer to this Lua universe''s CTState\r\n  local co = coroutine.create(function()end) -- Any live coroutine will do.\r\n  local uint32_ptr = ffi.typeof(\"uint32_t*\")\r\n  local G = ffi.cast(uint32_ptr, ffi.cast(uint32_ptr, memptr(co))[2])\r\n  -- In global_State, `MRef ctype_state` is immediately before `GCRef gcroot[GCROOT_MAX]`.\r\n  -- We first find (an entry in) gcroot by looking for a metamethod name string.\r\n  local anchor = ffi.cast(\"uint32_t\", ffi.cast(\"const char*\", \"__index\"))\r\n  local i = 0\r\n  while math.abs(tonumber(G[i] - anchor)) > 64 do\r\n    i = i + 1\r\n  end\r\n  -- We then work backwards looking for something resembling ctype_state.\r\n  repeat\r\n    i = i - 1\r\n    CTState = ffi.cast(\"CTState*\", G[i])\r\n  until ffi.cast(uint32_ptr, CTState.g) == G\r\n  \r\n  return CTState\r\nend\r\n\r\ninit_miscmap = function()\r\n  -- Acquire the CTState''s miscmap table as a Lua variable\r\n  local t = {}; t[0] = t\r\n  local tvalue = ffi.cast(\"uint32_t*\", memptr(t))[2]\r\n  ffi.cast(\"uint32_t*\", tvalue)[ffi.abi\"le\" and 0 or 1] = ffi.cast(\"uint32_t\", ffi.cast(\"uintptr_t\", (CTState or init_CTState()).miscmap))\r\n  miscmap = t[0]\r\n  return miscmap\r\nend\r\n\r\n-- Information for unpacking a `struct CType`.\r\n-- One table per CT_* constant, containing:\r\n-- * A name for that CT_\r\n-- * Roles of the cid and size fields.\r\n-- * Whether the sib field is meaningful.\r\n-- * Zero or more applicable boolean flags.\r\nlocal CTs = {[0] =\r\n  {\"int\",\r\n    \"\", \"size\", false,\r\n    {0x08000000, \"bool\"},\r\n    {0x04000000, \"float\", \"subwhat\"},\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n    {0x00800000, \"unsigned\"},\r\n    {0x00400000, \"long\"},\r\n  },\r\n  {\"struct\",\r\n    \"\", \"size\", true,\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n    {0x00800000, \"union\", \"subwhat\"},\r\n    {0x00100000, \"vla\"},\r\n  },\r\n  {\"ptr\",\r\n    \"element_type\", \"size\", false,\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n    {0x00800000, \"ref\", \"subwhat\"},\r\n  },\r\n  {\"array\",\r\n    \"element_type\", \"size\", false,\r\n    {0x08000000, \"vector\"},\r\n    {0x04000000, \"complex\"},\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n    {0x00100000, \"vla\"},\r\n  },\r\n  {\"void\",\r\n    \"\", \"size\", false,\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n  },\r\n  {\"enum\",\r\n    \"type\", \"size\", true,\r\n  },\r\n  {\"func\",\r\n    \"return_type\", \"nargs\", true,\r\n    {0x00800000, \"vararg\"},\r\n    {0x00400000, \"sse_reg_params\"},\r\n  },\r\n  {\"typedef\", -- Not seen\r\n    \"element_type\", \"\", false,\r\n  },\r\n  {\"attrib\", -- Only seen internally\r\n    \"type\", \"value\", true,\r\n  },\r\n  {\"field\",\r\n    \"type\", \"offset\", true,\r\n  },\r\n  {\"bitfield\",\r\n    \"\", \"offset\", true,\r\n    {0x08000000, \"bool\"},\r\n    {0x02000000, \"const\"},\r\n    {0x01000000, \"volatile\"},\r\n    {0x00800000, \"unsigned\"},\r\n  },\r\n  {\"constant\",\r\n    \"type\", \"value\", true,\r\n    {0x02000000, \"const\"},\r\n  },\r\n  {\"extern\", -- Not seen\r\n    \"CID\", \"\", true,\r\n  },\r\n  {\"kw\", -- Not seen\r\n    \"TOK\", \"size\",\r\n  },\r\n}\r\n\r\n-- Set of CType::cid roles which are a CTypeID.\r\nlocal type_keys = {\r\n  element_type = true,\r\n  return_type = true,\r\n  value_type = true,\r\n  type = true,\r\n}\r\n\r\n-- Create a metatable for each CT.\r\nlocal metatables = {\r\n}\r\nfor _, CT in ipairs(CTs) do\r\n  local what = CT[1]\r\n  local mt = {__index = {}}\r\n  metatables[what] = mt\r\nend\r\n\r\n-- Logic for merging an attribute CType onto the annotated CType.\r\nlocal CTAs = {[0] =\r\n  function(a, refct) error(\"TODO: CTA_NONE\") end,\r\n  function(a, refct) error(\"TODO: CTA_QUAL\") end,\r\n  function(a, refct)\r\n    a = 2^a.value\r\n    refct.alignment = a\r\n    refct.attributes.align = a\r\n  end,\r\n  function(a, refct)\r\n    refct.transparent = true\r\n    refct.attributes.subtype = refct.typeid\r\n  end,\r\n  function(a, refct) refct.sym_name = a.name end,\r\n  function(a, refct) error(\"TODO: CTA_BAD\") end,\r\n}\r\n\r\n-- C function calling conventions (CTCC_* constants in lj_refct.h)\r\nlocal CTCCs = {[0] = \r\n  \"cdecl\",\r\n  \"thiscall\",\r\n  \"fastcall\",\r\n  \"stdcall\",\r\n}\r\n\r\nlocal function refct_from_id(id) -- refct = refct_from_id(CTypeID)\r\n  local ctype = typeinfo(id)\r\n  local CT_code = bit.rshift(ctype.info, 28)\r\n  local CT = CTs[CT_code]\r\n  local what = CT[1]\r\n  local refct = setmetatable({\r\n    what = what,\r\n    typeid = id,\r\n    name = ctype.name,\r\n  }, metatables[what])\r\n  \r\n  -- Interpret (most of) the CType::info field\r\n  for i = 5, #CT do\r\n    if bit.band(ctype.info, CT[i][1]) ~= 0 then\r\n      if CT[i][3] == \"subwhat\" then\r\n        refct.what = CT[i][2]\r\n      else\r\n        refct[CT[i][2]] = true\r\n      end\r\n    end\r\n  end\r\n  if CT_code <= 5 then\r\n    refct.alignment = bit.lshift(1, bit.band(bit.rshift(ctype.info, 16), 15))\r\n  elseif what == \"func\" then\r\n    refct.convention = CTCCs[bit.band(bit.rshift(ctype.info, 16), 3)]\r\n  end\r\n  \r\n  if CT[2] ~= \"\" then -- Interpret the CType::cid field\r\n    local k = CT[2]\r\n    local cid = bit.band(ctype.info, 0xffff)\r\n    if type_keys[k] then\r\n      if cid == 0 then\r\n        cid = nil\r\n      else\r\n        cid = refct_from_id(cid)\r\n      end\r\n    end\r\n    refct[k] = cid\r\n  end\r\n  \r\n  if CT[3] ~= \"\" then -- Interpret the CType::size field\r\n    local k = CT[3]\r\n    refct[k] = ctype.size or (k == \"size\" and \"none\")\r\n  end\r\n  \r\n  if what == \"attrib\" then\r\n    -- Merge leading attributes onto the type being decorated.\r\n    local CTA = CTAs[bit.band(bit.rshift(ctype.info, 16), 0xff)]\r\n    if refct.type then\r\n      local ct = refct.type\r\n      ct.attributes = {}\r\n      CTA(refct, ct)\r\n      ct.typeid = refct.typeid\r\n      refct = ct\r\n    else\r\n      refct.CTA = CTA\r\n    end\r\n  elseif what == \"bitfield\" then\r\n    -- Decode extra bitfield fields, and make it look like a normal field.\r\n    refct.offset = refct.offset + bit.band(ctype.info, 127) / 8\r\n    refct.size = bit.band(bit.rshift(ctype.info, 8), 127) / 8\r\n    refct.type = {\r\n      what = \"int\",\r\n      bool = refct.bool,\r\n      const = refct.const,\r\n      volatile = refct.volatile,\r\n      unsigned = refct.unsigned,\r\n      size = bit.band(bit.rshift(ctype.info, 16), 127),\r\n    }\r\n    refct.bool, refct.const, refct.volatile, refct.unsigned = nil\r\n  end\r\n  \r\n  if CT[4] then -- Merge sibling attributes onto this type.\r\n    while ctype.sib do\r\n      local entry = typeinfo(ctype.sib)\r\n      if CTs[bit.rshift(entry.info, 28)][1] ~= \"attrib\" then break end\r\n      if bit.band(entry.info, 0xffff) ~= 0 then break end\r\n      local sib = refct_from_id(ctype.sib)\r\n      sib:CTA(refct)\r\n      ctype = entry\r\n    end\r\n  end\r\n  \r\n  return refct\r\nend\r\n\r\nlocal function sib_iter(s, refct)\r\n  repeat\r\n    local ctype = typeinfo(refct.typeid)\r\n    if not ctype.sib then return end\r\n    refct = refct_from_id(ctype.sib)\r\n  until refct.what ~= \"attrib\" -- Pure attribs are skipped.\r\n  return refct\r\nend\r\n\r\nlocal function siblings(refct)\r\n  -- Follow to the end of the attrib chain, if any.\r\n  while refct.attributes do\r\n    refct = refct_from_id(refct.attributes.subtype or typeinfo(refct.typeid).sib)\r\n  end\r\n\r\n  return sib_iter, nil, refct\r\nend\r\n\r\nmetatables.struct.__index.members = siblings\r\nmetatables.func.__index.arguments = siblings\r\nmetatables.enum.__index.values = siblings\r\n\r\nlocal function find_sibling(refct, name)\r\n  local num = tonumber(name)\r\n  if num then\r\n    for sib in siblings(refct) do\r\n      if num == 1 then\r\n        return sib\r\n      end\r\n      num = num - 1\r\n    end\r\n  else\r\n    for sib in siblings(refct) do\r\n      if sib.name == name then\r\n        return sib\r\n      end\r\n    end\r\n  end\r\nend\r\n\r\nmetatables.struct.__index.member = find_sibling\r\nmetatables.func.__index.argument = find_sibling\r\nmetatables.enum.__index.value = find_sibling\r\n\r\nfunction reflect.typeof(x) -- refct = reflect.typeof(ct)\r\n  return refct_from_id(tonumber(ffi.typeof(x)))\r\nend\r\n\r\nfunction reflect.getmetatable(x) -- mt = reflect.getmetatable(ct)\r\n  return (miscmap or init_miscmap())[-tonumber(ffi.typeof(x))]\r\nend\r\n\r\nreturn reflect'","function(self)\r\nreturn (\"--[[ LuaJIT FFI reflection Library ]]--\\r\\n--[[ Copyright (C) 2014 Peter Cawley <lua@corsix.org>. All rights reserved.\\r\\n\\r\\nPermission is hereby granted, free of charge, to any person obtaining a copy\\r\\nof this software and associated documentation files (the \\\"Software\\\"), to deal\\r\\nin the Software without restriction, including without limitation the rights\\r\\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\\r\\ncopies of the Software, and to permit persons to whom the Software is\\r\\nfurnished to do so, subject to the following conditions:\\r\\n\\r\\nThe above copyright notice and this permission notice shall be included in\\r\\nall copies or substantial portions of the Software.\\r\\n\\r\\nTHE SOFTWARE IS PROVIDED \\\"AS IS\\\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\\r\\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\\r\\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE\\r\\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\\r\\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\\r\\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\\r\\nTHE SOFTWARE.\\r\\n--]]\\r\\nlocal ffi = require \\\"ffi\\\"\\r\\nlocal bit = require \\\"bit\\\"\\r\\nlocal reflect = {}\\r\\n\\r\\nlocal CTState, init_CTState\\r\\nlocal miscmap, init_miscmap\\r\\n\\r\\nlocal function gc_str(gcref) -- Convert a GCref (to a GCstr) into a string\\r\\n  if gcref ~= 0 then\\r\\n    local ts = ffi.cast(\\\"uint32_t*\\\", gcref)\\r\\n    return ffi.string(ts + 4, ts[3])\\r\\n  end\\r\\nend\\r\\n\\r\\nlocal typeinfo = ffi.typeinfo or function(id)\\r\\n  -- ffi.typeof is present in LuaJIT v2.1 since 8th Oct 2014 (d6ff3afc)\\r\\n  -- this is an emulation layer for older versions of LuaJIT\\r\\n  local ctype = (CTState or init_CTState()).tab[id]\\r\\n  return {\\r\\n    info = ctype.info,\\r\\n    size = bit.bnot(ctype.size) ~= 0 and ctype.size,\\r\\n    sib = ctype.sib ~= 0 and ctype.sib,\\r\\n    name = gc_str(ctype.name),\\r\\n  }\\r\\nend\\r\\n\\r\\nlocal function memptr(gcobj)\\r\\n  return tonumber(tostring(gcobj):match\\\"%x*$\\\", 16)\\r\\nend\\r\\n\\r\\ninit_CTState = function()\\r\\n  -- Relevant minimal definitions from lj_ctype.h\\r\\n  ffi.cdef [[\\r\\n    typedef struct CType {\\r\\n      uint32_t info;\\r\\n      uint32_t size;\\r\\n      uint16_t sib;\\r\\n      uint16_t next;\\r\\n      uint32_t name;\\r\\n    } CType;\\r\\n    \\r\\n    typedef struct CTState {\\r\\n      CType *tab;\\r\\n      uint32_t top;\\r\\n      uint32_t sizetab;\\r\\n      void *L;\\r\\n      void *g;\\r\\n      void *finalizer;\\r\\n      void *miscmap;\\r\\n    } CTState;\\r\\n  ]]\\r\\n\\r\\n  -- Acquire a pointer to this Lua universe's CTState\\r\\n  local co = coroutine.create(function()end) -- Any live coroutine will do.\\r\\n  local uint32_ptr = ffi.typeof(\\\"uint32_t*\\\")\\r\\n  local G = ffi.cast(uint32_ptr, ffi.cast(uint32_ptr, memptr(co))[2])\\r\\n  -- In global_State, `MRef ctype_state` is immediately before `GCRef gcroot[GCROOT_MAX]`.\\r\\n  -- We first find (an entry in) gcroot by looking for a metamethod name string.\\r\\n  local anchor = ffi.cast(\\\"uint32_t\\\", ffi.cast(\\\"const char*\\\", \\\"__index\\\"))\\r\\n  local i = 0\\r\\n  while math.abs(tonumber(G[i] - anchor)) > 64 do\\r\\n    i = i + 1\\r\\n  end\\r\\n  -- We then work backwards looking for something resembling ctype_state.\\r\\n  repeat\\r\\n    i = i - 1\\r\\n    CTState = ffi.cast(\\\"CTState*\\\", G[i])\\r\\n  until ffi.cast(uint32_ptr, CTState.g) == G\\r\\n  \\r\\n  return CTState\\r\\nend\\r\\n\\r\\ninit_miscmap = function()\\r\\n  -- Acquire the CTState's miscmap table as a Lua variable\\r\\n  local t = {}; t[0] = t\\r\\n  local tvalue = ffi.cast(\\\"uint32_t*\\\", memptr(t))[2]\\r\\n  ffi.cast(\\\"uint32_t*\\\", tvalue)[ffi.abi\\\"le\\\" and 0 or 1] = ffi.cast(\\\"uint32_t\\\", ffi.cast(\\\"uintptr_t\\\", (CTState or init_CTState()).miscmap))\\r\\n  miscmap = t[0]\\r\\n  return miscmap\\r\\nend\\r\\n\\r\\n-- Information for unpacking a `struct CType`.\\r\\n-- One table per CT_* constant, containing:\\r\\n-- * A name for that CT_\\r\\n-- * Roles of the cid and size fields.\\r\\n-- * Whether the sib field is meaningful.\\r\\n-- * Zero or more applicable boolean flags.\\r\\nlocal CTs = {[0] =\\r\\n  {\\\"int\\\",\\r\\n    \\\"\\\", \\\"size\\\", false,\\r\\n    {0x08000000, \\\"bool\\\"},\\r\\n    {0x04000000, \\\"float\\\", \\\"subwhat\\\"},\\r\\n    {0x02000000, \\\"const\\\"},\\r\\n    {0x01000000, \\\"volatile\\\"},\\r\\n    {0x00800000, \\\"unsigned\\\"},\\r\\n    {0x00400000, \\\"long\\\"},\\r\\n  },\\r\\n  {\\\"struct\\\",\\r\\n    \\\"\\\", \\\"size\\\", true,\\r\\n    {0x02000000, \\\"const\\\"},\\r\\n    {0x01000000, \\\"volatile\\\"},\\r\\n    {0x00800000, \\\"union\\\", \\\"subwhat\\\"},\\r\\n    {0x00100000, \\\"vla\\\"},\\r\\n  },\\r\\n  {\\\"ptr\\\",\\r\\n    \\\"element_type\\\", \\\"size\\\", false,\\r\\n    {0x02000000, \\\"const\\\"},\\r\\n    {0x01000000, \\\"volatile\\\"},\\r\\n    {0x00800000, \\\"ref\\\", \\\"subwhat\\\"},\\r\\n  },\\r\\n  {\\\"array\\\",\\r\\n    \\\"element_type\\\", \\\"size\\\", false,\\r\\n    {0x08000000, \\\"vector\\\"},\\r\\n    {0x04000000, \\\"complex\\\"},\\r\\n    {0x02000000, \\\"const\\\"},\\r\\n    {0x01000000, \\\"volatile\\\"},\\r\\n    {0x00100000, \\\"vla\\\"},\\r\\n  },\\r\\n  {\\\"void\\\",\\r\\n    \\\"\\\", \\\"size\\\", false,\\r\\n    {0x02000000, \\\"const\\\"},\\r\\n    {0x01000000, \\\"volatile\\\"},\\r\\n  },\\r\\n  {\\\"enum\\\",\\r\\n    \\\"type\\\", \\\"size\\\", true,\\r\\n  },\\r\\n  {\\\"func\\\",\\r\\n    \\\"return_type\\\", \\\"nargs\\\", true,\\r\\n    {0x00800000, \\\"vararg\\\"},\\r\\n    {0x00400000, \\\"sse_reg_params\\\"},\\r\\n  },\\r\\n  {\\\"typedef\\\", -- Not seen\\r\\n    \\\"element_type\\\", \\\"\\\", false,\\r\\n  },\\r\\n  {\\\"attrib\\\", -- Only seen internally\\r\\n    \\\"type\\\", \\\"value\\\", true,\\r\\n  },\\r\\n  {\\\"field\\\",\\r\\n    \\\"type\\\", \\\"offset\\\", true,\\r\\n  },\\r\\n  {\\\"bitfield\\\",\\r\\n    \\\"\\\", \\\"offset\\\", true,\\r\\n    {0x08000000, \\\"bool\\\"},\\r\\n    {0x02000000, \\\"const\\\"},\\r\\n    {0x01000000, \\\"volatile\\\"},\\r\\n    {0x00800000, \\\"unsigned\\\"},\\r\\n  },\\r\\n  {\\\"constant\\\",\\r\\n    \\\"type\\\", \\\"value\\\", true,\\r\\n    {0x02000000, \\\"const\\\"},\\r\\n  },\\r\\n  {\\\"extern\\\", -- Not seen\\r\\n    \\\"CID\\\", \\\"\\\", true,\\r\\n  },\\r\\n  {\\\"kw\\\", -- Not seen\\r\\n    \\\"TOK\\\", \\\"size\\\",\\r\\n  },\\r\\n}\\r\\n\\r\\n-- Set of CType::cid roles which are a CTypeID.\\r\\nlocal type_keys = {\\r\\n  element_type = true,\\r\\n  return_type = true,\\r\\n  value_type = true,\\r\\n  type = true,\\r\\n}\\r\\n\\r\\n-- Create a metatable for each CT.\\r\\nlocal metatables = {\\r\\n}\\r\\nfor _, CT in ipairs(CTs) do\\r\\n  local what = CT[1]\\r\\n  local mt = {__index = {}}\\r\\n  metatables[what] = mt\\r\\nend\\r\\n\\r\\n-- Logic for merging an attribute CType onto the annotated CType.\\r\\nlocal CTAs = {[0] =\\r\\n  function(a, refct) error(\\\"TODO: CTA_NONE\\\") end,\\r\\n  function(a, refct) error(\\\"TODO: CTA_QUAL\\\") end,\\r\\n  function(a, refct)\\r\\n    a = 2^a.value\\r\\n    refct.alignment = a\\r\\n    refct.attributes.align = a\\r\\n  end,\\r\\n  function(a, refct)\\r\\n    refct.transparent = true\\r\\n    refct.attributes.subtype = refct.typeid\\r\\n  end,\\r\\n  function(a, refct) refct.sym_name = a.name end,\\r\\n  function(a, refct) error(\\\"TODO: CTA_BAD\\\") end,\\r\\n}\\r\\n\\r\\n-- C function calling conventions (CTCC_* constants in lj_refct.h)\\r\\nlocal CTCCs = {[0] = \\r\\n  \\\"cdecl\\\",\\r\\n  \\\"thiscall\\\",\\r\\n  \\\"fastcall\\\",\\r\\n  \\\"stdcall\\\",\\r\\n}\\r\\n\\r\\nlocal function refct_from_id(id) -- refct = refct_from_id(CTypeID)\\r\\n  local ctype = typeinfo(id)\\r\\n  local CT_code = bit.rshift(ctype.info, 28)\\r\\n  local CT = CTs[CT_code]\\r\\n  local what = CT[1]\\r\\n  local refct = setmetatable({\\r\\n    what = what,\\r\\n    typeid = id,\\r\\n    name = ctype.name,\\r\\n  }, metatables[what])\\r\\n  \\r\\n  -- Interpret (most of) the CType::info field\\r\\n  for i = 5, #CT do\\r\\n    if bit.band(ctype.info, CT[i][1]) ~= 0 then\\r\\n      if CT[i][3] == \\\"subwhat\\\" then\\r\\n        refct.what = CT[i][2]\\r\\n      else\\r\\n        refct[CT[i][2]] = true\\r\\n      end\\r\\n    end\\r\\n  end\\r\\n  if CT_code <= 5 then\\r\\n    refct.alignment = bit.lshift(1, bit.band(bit.rshift(ctype.info, 16), 15))\\r\\n  elseif what == \\\"func\\\" then\\r\\n    refct.convention = CTCCs[bit.band(bit.rshift(ctype.info, 16), 3)]\\r\\n  end\\r\\n  \\r\\n  if CT[2] ~= \\\"\\\" then -- Interpret the CType::cid field\\r\\n    local k = CT[2]\\r\\n    local cid = bit.band(ctype.info, 0xffff)\\r\\n    if type_keys[k] then\\r\\n      if cid == 0 then\\r\\n        cid = nil\\r\\n      else\\r\\n        cid = refct_from_id(cid)\\r\\n      end\\r\\n    end\\r\\n    refct[k] = cid\\r\\n  end\\r\\n  \\r\\n  if CT[3] ~= \\\"\\\" then -- Interpret the CType::size field\\r\\n    local k = CT[3]\\r\\n    refct[k] = ctype.size or (k == \\\"size\\\" and \\\"none\\\")\\r\\n  end\\r\\n  \\r\\n  if what == \\\"attrib\\\" then\\r\\n    -- Merge leading attributes onto the type being decorated.\\r\\n    local CTA = CTAs[bit.band(bit.rshift(ctype.info, 16), 0xff)]\\r\\n    if refct.type then\\r\\n      local ct = refct.type\\r\\n      ct.attributes = {}\\r\\n      CTA(refct, ct)\\r\\n      ct.typeid = refct.typeid\\r\\n      refct = ct\\r\\n    else\\r\\n      refct.CTA = CTA\\r\\n    end\\r\\n  elseif what == \\\"bitfield\\\" then\\r\\n    -- Decode extra bitfield fields, and make it look like a normal field.\\r\\n    refct.offset = refct.offset + bit.band(ctype.info, 127) / 8\\r\\n    refct.size = bit.band(bit.rshift(ctype.info, 8), 127) / 8\\r\\n    refct.type = {\\r\\n      what = \\\"int\\\",\\r\\n      bool = refct.bool,\\r\\n      const = refct.const,\\r\\n      volatile = refct.volatile,\\r\\n      unsigned = refct.unsigned,\\r\\n      size = bit.band(bit.rshift(ctype.info, 16), 127),\\r\\n    }\\r\\n    refct.bool, refct.const, refct.volatile, refct.unsigned = nil\\r\\n  end\\r\\n  \\r\\n  if CT[4] then -- Merge sibling attributes onto this type.\\r\\n    while ctype.sib do\\r\\n      local entry = typeinfo(ctype.sib)\\r\\n      if CTs[bit.rshift(entry.info, 28)][1] ~= \\\"attrib\\\" then break end\\r\\n      if bit.band(entry.info, 0xffff) ~= 0 then break end\\r\\n      local sib = refct_from_id(ctype.sib)\\r\\n      sib:CTA(refct)\\r\\n      ctype = entry\\r\\n    end\\r\\n  end\\r\\n  \\r\\n  return refct\\r\\nend\\r\\n\\r\\nlocal function sib_iter(s, refct)\\r\\n  repeat\\r\\n    local ctype = typeinfo(refct.typeid)\\r\\n    if not ctype.sib then return end\\r\\n    refct = refct_from_id(ctype.sib)\\r\\n  until refct.what ~= \\\"attrib\\\" -- Pure attribs are skipped.\\r\\n  return refct\\r\\nend\\r\\n\\r\\nlocal function siblings(refct)\\r\\n  -- Follow to the end of the attrib chain, if any.\\r\\n  while refct.attributes do\\r\\n    refct = refct_from_id(refct.attributes.subtype or typeinfo(refct.typeid).sib)\\r\\n  end\\r\\n\\r\\n  return sib_iter, nil, refct\\r\\nend\\r\\n\\r\\nmetatables.struct.__index.members = siblings\\r\\nmetatables.func.__index.arguments = siblings\\r\\nmetatables.enum.__index.values = siblings\\r\\n\\r\\nlocal function find_sibling(refct, name)\\r\\n  local num = tonumber(name)\\r\\n  if num then\\r\\n    for sib in siblings(refct) do\\r\\n      if num == 1 then\\r\\n        return sib\\r\\n      end\\r\\n      num = num - 1\\r\\n    end\\r\\n  else\\r\\n    for sib in siblings(refct) do\\r\\n      if sib.name == name then\\r\\n        return sib\\r\\n      end\\r\\n    end\\r\\n  end\\r\\nend\\r\\n\\r\\nmetatables.struct.__index.member = find_sibling\\r\\nmetatables.func.__index.argument = find_sibling\\r\\nmetatables.enum.__index.value = find_sibling\\r\\n\\r\\nfunction reflect.typeof(x) -- refct = reflect.typeof(ct)\\r\\n  return refct_from_id(tonumber(ffi.typeof(x)))\\r\\nend\\r\\n\\r\\nfunction reflect.getmetatable(x) -- mt = reflect.getmetatable(ct)\\r\\n  return (miscmap or init_miscmap())[-tonumber(ffi.typeof(x))]\\r\\nend\\r\\n\\r\\nreturn reflect\");\r\nend")
