
-- fileIn("s8/library/scripting/S8Scripting.st")
smalltalk:bind(smalltalk.Compiler,"parse:",0
,function(self,smalltalkExpression)
return ((self):parseMethod_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((smalltalk.String):doItSelector())," ^[")),smalltalkExpression)),"] value")));
end
,"parsing","parse: smalltalkExpression\r\n\t\" Return the result of parsing a method to evaluate smalltalkExpression. \"\r\n\r\n\t^self parseMethod: String doItSelector\r\n\t\t,' ^[', smalltalkExpression\r\n\t\t,'] value' ","function(self,smalltalkExpression)\r\nreturn ((self):parseMethod_(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_(((smalltalk.String):doItSelector()),\" ^[\")),smalltalkExpression)),\"] value\")));\r\nend")

smalltalk:bind(smalltalk.Compiler,"parse:onError:",0
,function(self,smalltalkExpression,aBlock)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local syntax=nil
((function()
(function()
	local _s8_value=((self):parse_(smalltalkExpression))
	syntax=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_(((syntax):isParseFailure()),(function()
return ((self):error_(smalltalk:toString_((syntax))))
end),nil))
end)):on_do_(smalltalk.Error,(function(ex)
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((aBlock):evaluateWith_(ex))
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (syntax)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"parsing","parse: smalltalkExpression onError: aBlock\r\n\t\" Return the result of parsing a method to evaluate smalltalkExpression. \"\r\n\r\n\t| syntax |\r\n\t[ syntax := self parse: smalltalkExpression.\r\n\t  syntax isParseFailure ifTrue: [ self error: syntax toString ].\r\n\t] on: Error do: [:ex| ^aBlock evaluateWith: ex ].\r\n\t^syntax ","function(self,smalltalkExpression,aBlock)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal syntax=nil\r\n((function()\r\n(function()\r\n\tlocal _s8_value=((self):parse_(smalltalkExpression))\r\n\tsyntax=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_(((syntax):isParseFailure()),(function()\r\nreturn ((self):error_(smalltalk:toString_((syntax))))\r\nend),nil))\r\nend)):on_do_(smalltalk.Error,(function(ex)\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((aBlock):evaluateWith_(ex))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (syntax)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.CompilerNode,"evaluate",0
,function(self)
return ((self):evaluate_(nil));
end
,"evaluating","evaluate\r\n\t\" Evaluate the receiver in an empty context. \"\r\n\r\n\t^self evaluate: nil ","function(self)\r\nreturn ((self):evaluate_(nil));\r\nend")

smalltalk:bind(smalltalk.CompilerNode,"evaluate:",0
,function(self,aReceiver)
return ((self):evaluateIn_((smalltalk.S8Context):for_(aReceiver)));
end
,"evaluating","evaluate: aReceiver\r\n\t\" Returns the result of evaluating the receiver in a context bound to aReceiver. \"\r\n\r\n\t^self evaluateIn: (S8Context for: aReceiver) ","function(self,aReceiver)\r\nreturn ((self):evaluateIn_((smalltalk.S8Context):for_(aReceiver)));\r\nend")

smalltalk:bind(smalltalk.CompilerNode,"evaluateContentsIn:",0
,function(self,aContext)
local result=nil
((self):nodes()):do_((function(each)
return ((function()
	local _s8_value=((each):evaluateIn_(aContext))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"evaluating","evaluateContentsIn: aContext\r\n\t\" Private - Returns the result of evaluating the nodes of receiver in aContext. \"\r\n\r\n\t| result |\r\n\tself nodes do: [:each| result := each evaluateIn: aContext ].\r\n\t^result ","function(self,aContext)\r\nlocal result=nil\r\n((self):nodes()):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=((each):evaluateIn_(aContext))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.CompilerNode,"evaluateIn:",0
,function(self,aContext)
return ((self):subclassResponsibility_("evaluateIn:"));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext.\r\n\tThis message must be implemented by the subclasses. \"\r\n\r\n\t^self subclassResponsibility: #evaluateIn: ","function(self,aContext)\r\nreturn ((self):subclassResponsibility_(\"evaluateIn:\"));\r\nend")

smalltalk:bind(smalltalk.CompilerNode,"exitBlock:",0
,function(self,aBlock)
if (smalltalk:notNil_((self["@nodes"])))==true then (self["@nodes"]):do_((function(each)
return ((each):exitBlock_(aBlock))
end)); end;
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver.\r\n\tThis block will be used to abort execution of the receiver.\r\n\tPropagate to nodes by default.\r\n\tThis method can be refined by subclasses. \"\r\n\r\n\tnodes notNil ifTrue: [\r\n\t\tnodes do: [:each| each exitBlock: aBlock ]\r\n\t] ","function(self,aBlock)\r\nif (smalltalk:notNil_((self[\"@nodes\"])))==true then (self[\"@nodes\"]):do_((function(each)\r\nreturn ((each):exitBlock_(aBlock))\r\nend)); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.CompilerNode,"isOO",0
,function(self)
return (true);
end
,"query","isOO\r\n\t\" Returns true if the receiver refers to an object. \"\r\n\r\n\t^true ","function(self)\r\nreturn (true);\r\nend")

smalltalk:bind(smalltalk.AssignmentNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.AssignmentNode,"exitBlock_")(self,aBlock);
((self):left()):exitBlock_(aBlock);
((self):right()):exitBlock_(aBlock);
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\tself left exitBlock: aBlock.\r\n\tself right exitBlock: aBlock ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.AssignmentNode,\"exitBlock_\")(self,aBlock);\r\n((self):left()):exitBlock_(aBlock);\r\n((self):right()):exitBlock_(aBlock);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.AssignmentNode,"evaluateIn:",0
,function(self,aContext)
return (((self):left()):bind_in_(((self):right()):evaluateIn_(aContext),aContext));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^self left bind: (self right evaluateIn: aContext) in: aContext ","function(self,aContext)\r\nreturn (((self):left()):bind_in_(((self):right()):evaluateIn_(aContext),aContext));\r\nend")

smalltalk:bind(smalltalk.BlockNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.BlockNode,"exitBlock_")(self,aBlock);
((self):parameters()):do_((function(each)
return ((each):exitBlock_(aBlock))
end));
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\tself parameters do: [:each| each exitBlock: aBlock ] ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.BlockNode,\"exitBlock_\")(self,aBlock);\r\n((self):parameters()):do_((function(each)\r\nreturn ((each):exitBlock_(aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.BlockNode,"evaluateIn:",0
,function(self,aContext)
return ((smalltalk.S8Block):for_in_(self,aContext));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^S8Block for: self in: aContext ","function(self,aContext)\r\nreturn ((smalltalk.S8Block):for_in_(self,aContext));\r\nend")

smalltalk:bind(smalltalk.BlockNode,"arguments",0
,function(self)
return ((self):parameters());
end
,"accessing","arguments\r\n\t\" Return the arguments of the receiver. \"\r\n\r\n\t^self parameters ","function(self)\r\nreturn ((self):parameters());\r\nend")

smalltalk:bind(smalltalk.BlockNode,"temporaries",0
,function(self)
return (smalltalk:newArray({}));
end
,"accessing","temporaries\r\n\t\" Return the temporaries of the receiver. \"\r\n\r\n\t^#() ","function(self)\r\nreturn (smalltalk:newArray({}));\r\nend")

smalltalk:bind(smalltalk.BlockNode,"statements",0
,function(self)
return ((self):nodes());
end
,"accessing","statements\r\n\t\" Return the statements of the receiver. \"\r\n\r\n\t^self nodes ","function(self)\r\nreturn ((self):nodes());\r\nend")

smalltalk:bind(smalltalk.CascadeNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.CascadeNode,"exitBlock_")(self,aBlock);
if (smalltalk:notNil_((self["@receiver"])))==true then (self["@receiver"]):exitBlock_(aBlock); end;
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\treceiver notNil ifTrue: [ receiver exitBlock: aBlock ]. ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.CascadeNode,\"exitBlock_\")(self,aBlock);\r\nif (smalltalk:notNil_((self[\"@receiver\"])))==true then (self[\"@receiver\"]):exitBlock_(aBlock); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MethodNode,"clearExitBlock",0
,function(self)
(self):exitBlock_(nil);
return (self);
end
,"evaluating","clearExitBlock\r\n\t\" Clear the exit block. \"\r\n\r\n\tself exitBlock: nil ","function(self)\r\n(self):exitBlock_(nil);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.MethodNode,"evaluateIn:",0
,function(self,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(self):exitBlock_((function(result)
(self):clearExitBlock();return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (result)
end
)()
error(_s8Ret_,0)
end)())
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (smalltalk:if_true_false_(((((self["@nodes"]):size()) > 0)),(function()
return ((self):evaluateContentsIn_(aContext))
end),(function()
return ((aContext):self())
end)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\tself exitBlock: [:result| self clearExitBlock. ^result ].\r\n\t^nodes size > 0\r\n\t\tifTrue: [ self evaluateContentsIn: aContext ]\r\n\t\tifFalse: [ aContext self ] ","function(self,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(self):exitBlock_((function(result)\r\n(self):clearExitBlock();return ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (result)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (smalltalk:if_true_false_(((((self[\"@nodes\"]):size()) > 0)),(function()\r\nreturn ((self):evaluateContentsIn_(aContext))\r\nend),(function()\r\nreturn ((aContext):self())\r\nend)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.ReturnNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.ReturnNode,"exitBlock_")(self,aBlock);
(function()
	local _s8_value=(aBlock)
	self["@exitBlock"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","exitBlock: aBlock\r\n\t\" Set the receiver's exitBlock. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\texitBlock := aBlock. ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.ReturnNode,\"exitBlock_\")(self,aBlock);\r\n(function()\r\n\tlocal _s8_value=(aBlock)\r\n\tself[\"@exitBlock\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ReturnNode,"exitWith:",0
,function(self,anObject)
if (smalltalk:isNil_((self["@exitBlock"])))==true then return ((self):error_("Invalid context.")); end;
return ((self["@exitBlock"]):value_(anObject));
end
,"evaluating","exitWith: anObject\r\n\t\" Exit the receiver with anObject as returned value. \"\r\n\r\n\texitBlock isNil ifTrue: [ ^self error: 'Invalid context.' ].\r\n\t^exitBlock value: anObject ","function(self,anObject)\r\nif (smalltalk:isNil_((self[\"@exitBlock\"])))==true then return ((self):error_(\"Invalid context.\")); end;\r\nreturn ((self[\"@exitBlock\"]):value_(anObject));\r\nend")

smalltalk:bind(smalltalk.ReturnNode,"evaluateIn:",0
,function(self,aContext)
return ((self):exitWith_((self):evaluateContentsIn_(aContext)));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^self exitWith: (self evaluateContentsIn: aContext) ","function(self,aContext)\r\nreturn ((self):exitWith_((self):evaluateContentsIn_(aContext)));\r\nend")

smalltalk:bind(smalltalk.SendNode["$klass"],"actionToSend:ifAbsent:",0
,function(self,selector,aBlock)
return (((smalltalk.S8Block):optimizations()):at_ifAbsent_(selector,aBlock));
end
,"actions","actionToSend: selector ifAbsent: aBlock\r\n\t\" Private - Returns the block to evaluate for sending message selector. \"\r\n\r\n\t^S8Block optimizations at: selector ifAbsent: aBlock ","function(self,selector,aBlock)\r\nreturn (((smalltalk.S8Block):optimizations()):at_ifAbsent_(selector,aBlock));\r\nend")

smalltalk:bind(smalltalk.SendNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.SendNode,"exitBlock_")(self,aBlock);
if (smalltalk:notNil_((self["@receiver"])))==true then (self["@receiver"]):exitBlock_(aBlock); end;
((self):arguments()):do_((function(each)
return ((each):exitBlock_(aBlock))
end));
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\treceiver notNil ifTrue: [ receiver exitBlock: aBlock ].\r\n\tself arguments do: [:each| each exitBlock: aBlock ]. ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.SendNode,\"exitBlock_\")(self,aBlock);\r\nif (smalltalk:notNil_((self[\"@receiver\"])))==true then (self[\"@receiver\"]):exitBlock_(aBlock); end;\r\n((self):arguments()):do_((function(each)\r\nreturn ((each):exitBlock_(aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SendNode,"evaluateIn:",0
,function(self,aContext)
local value=nil
(function()
	local _s8_value=(((self):receiver()):evaluateIn_(aContext))
	value=_s8_value
	return _s8_value
end)();
return ((self):evaluate_value_in_((self):receiver(),value,aContext));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t| value |\r\n\tvalue := self receiver evaluateIn: aContext.\r\n\t^self evaluate: self receiver value: value in: aContext ","function(self,aContext)\r\nlocal value=nil\r\n(function()\r\n\tlocal _s8_value=(((self):receiver()):evaluateIn_(aContext))\r\n\tvalue=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((self):evaluate_value_in_((self):receiver(),value,aContext));\r\nend")

smalltalk:bind(smalltalk.SendNode,"evaluate:value:in:",0
,function(self,aReceiver,anObject,aContext)
local values=nil
(function()
	local _s8_value=(((self):arguments()):collect_((function(each)
return ((each):evaluateIn_(aContext))
end)))
	values=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_(((aReceiver):isSuper()),(function()
return (smalltalk:booleanNot_(((aReceiver):isOO())))
end)))==true then return ((aReceiver):send_to_withArguments_in_((self):selector(),anObject,values,aContext)); end;
return ((self):send_to_withArguments_in_((self):selector(),anObject,values,aContext));
end
,"evaluating","evaluate: aReceiver value: anObject in: aContext\r\n\t\" Private - Returns the result of sending message to anObject in aContext. \"\r\n\r\n\t| values |\r\n\tvalues := self arguments collect: [:each| each evaluateIn: aContext ].\r\n\t(aReceiver isSuper or: [ aReceiver isOO not ]) ifTrue: [\r\n\t\t^aReceiver send: self selector to: anObject withArguments: values in: aContext\r\n\t].\r\n\t^self send: self selector to: anObject withArguments: values in: aContext ","function(self,aReceiver,anObject,aContext)\r\nlocal values=nil\r\n(function()\r\n\tlocal _s8_value=(((self):arguments()):collect_((function(each)\r\nreturn ((each):evaluateIn_(aContext))\r\nend)))\r\n\tvalues=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_(((aReceiver):isSuper()),(function()\r\nreturn (smalltalk:booleanNot_(((aReceiver):isOO())))\r\nend)))==true then return ((aReceiver):send_to_withArguments_in_((self):selector(),anObject,values,aContext)); end;\r\nreturn ((self):send_to_withArguments_in_((self):selector(),anObject,values,aContext));\r\nend")

smalltalk:bind(smalltalk.SendNode["$klass"],"selectorToSend:",0
,function(self,msg)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((msg):first()),"#")),(function()
return (((msg):copyFrom_to_(2,(msg):size())):upTo_(":"))
end),(function()
return (msg)
end)));
end
,"private","selectorToSend: msg\r\n\t\" Private - Returns the selector to use to lookup method for sending message msg. \"\r\n\r\n\t^msg first = $# ifTrue: [\r\n\t\t(msg copyFrom: 2 to: msg size) upTo: $:\r\n\t] ifFalse: [ msg ]","function(self,msg)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((msg):first()),\"#\")),(function()\r\nreturn (((msg):copyFrom_to_(2,(msg):size())):upTo_(\":\"))\r\nend),(function()\r\nreturn (msg)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SendNode,"send:to:withArguments:in:",0
,function(self,msg,anObject,values,aContext)
local sel=nil
(function()
	local _s8_value=(((self)["$klass"]):selectorToSend_(msg))
	sel=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((self["@action"])))==true then (function()
	local _s8_value=((self):actionToSend_(sel))
	self["@action"]=_s8_value
	return _s8_value
end)(); end;
return ((self["@action"]):value_value_value_value_(anObject,sel,values,aContext));
end
,"evaluating","send: msg to: anObject withArguments: values in: aContext\r\n\t\" Private - Returns the result of sending message to anObject in aContext. \"\r\n\r\n\t| sel |\r\n\tsel := self class selectorToSend: msg.\r\n\taction isNil ifTrue: [ action := self actionToSend: sel ].\r\n\t^action\tvalue: anObject value: sel\r\n\t\tvalue: values value: aContext ","function(self,msg,anObject,values,aContext)\r\nlocal sel=nil\r\n(function()\r\n\tlocal _s8_value=(((self)[\"$klass\"]):selectorToSend_(msg))\r\n\tsel=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((self[\"@action\"])))==true then (function()\r\n\tlocal _s8_value=((self):actionToSend_(sel))\r\n\tself[\"@action\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self[\"@action\"]):value_value_value_value_(anObject,sel,values,aContext));\r\nend")

smalltalk:bind(smalltalk.SendNode,"actionToSend:",0
,function(self,aSymbol)
return (((self)["$klass"]):actionToSend_ifAbsent_(aSymbol,(function()
return ((function(receiver,msg,values,context)
return ((receiver):perform_withArguments_(msg,values))
end))
end)));
end
,"actions","actionToSend: aSymbol\r\n\t\" Private - Returns the block to evaluate for sending message aSymbol. \"\r\n\r\n\t^self class actionToSend: aSymbol ifAbsent: [\r\n\t\t[:receiver :msg :values :context|\r\n\t\t\treceiver perform: msg withArguments: values\r\n\t\t]\r\n\t] ","function(self,aSymbol)\r\nreturn (((self)[\"$klass\"]):actionToSend_ifAbsent_(aSymbol,(function()\r\nreturn ((function(receiver,msg,values,context)\r\nreturn ((receiver):perform_withArguments_(msg,values))\r\nend))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.CascadeNode,"evaluateIn:",0
,function(self,aContext)
local rec=nil
local result=nil
(function()
	local _s8_value=(((self):receiver()):evaluateIn_(aContext))
	rec=_s8_value
	return _s8_value
end)();
(self["@nodes"]):do_((function(each)
return ((function()
	local _s8_value=((each):evaluate_value_in_((self):receiver(),rec,aContext))
	result=_s8_value
	return _s8_value
end)())
end));
return (result);
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t| rec result |\r\n\trec := self receiver evaluateIn: aContext.\r\n\tnodes do: [:each| result := each evaluate: self receiver value: rec in: aContext ].\r\n\t^result ","function(self,aContext)\r\nlocal rec=nil\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(((self):receiver()):evaluateIn_(aContext))\r\n\trec=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self[\"@nodes\"]):do_((function(each)\r\nreturn ((function()\r\n\tlocal _s8_value=((each):evaluate_value_in_((self):receiver(),rec,aContext))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.InlineNode,"evaluateIn:",0
,function(self,aContext)
local src=nil
local lang=nil
(function()
	local _s8_value=((aContext):nativeLanguage())
	lang=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((lang)))==true then (function()
	local _s8_value=((smalltalk.Smalltalk):nativeLanguage())
	lang=_s8_value
	return _s8_value
end)(); end;
(function()
	local _s8_value=((self):sourceFor_(lang))
	src=_s8_value
	return _s8_value
end)();
return ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(src,(function()
return ((self):error_(smalltalk:object_comma_(("Invalid/missing native code - "),src)))
end)));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t| src lang |\r\n\tlang := aContext nativeLanguage.\r\n\tlang isNil ifTrue:  [ lang := Smalltalk nativeLanguage ].\r\n\tsrc := self sourceFor: lang.\r\n\t^Smalltalk\r\n\t\tnativeObjectAt: src\r\n\t\tifAbsent: [ self error: 'Invalid/missing native code - ' ,src ] ","function(self,aContext)\r\nlocal src=nil\r\nlocal lang=nil\r\n(function()\r\n\tlocal _s8_value=((aContext):nativeLanguage())\r\n\tlang=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((lang)))==true then (function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):nativeLanguage())\r\n\tlang=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(function()\r\n\tlocal _s8_value=((self):sourceFor_(lang))\r\n\tsrc=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(src,(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Invalid/missing native code - \"),src)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.SequenceNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.SequenceNode,"exitBlock_")(self,aBlock);
((self):temps()):do_((function(each)
return ((each):exitBlock_(aBlock))
end));
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\tself temps do: [:each| each exitBlock: aBlock ]. ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.SequenceNode,\"exitBlock_\")(self,aBlock);\r\n((self):temps()):do_((function(each)\r\nreturn ((each):exitBlock_(aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.SequenceNode,"evaluateIn:",0
,function(self,aContext)
return ((smalltalk.S8Context):in_clear_do_(aContext,(self):temps(),(function(ctx)
return ((self):evaluateContentsIn_(ctx))
end)));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^S8Context\r\n\t\tin: aContext clear: self temps\r\n\t\tdo: [:ctx| self evaluateContentsIn: ctx ] ","function(self,aContext)\r\nreturn ((smalltalk.S8Context):in_clear_do_(aContext,(self):temps(),(function(ctx)\r\nreturn ((self):evaluateContentsIn_(ctx))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.ExtendedSequenceNode,"exitBlock:",0
,function(self,aBlock)
smalltalk:superImplementor(smalltalk.ExtendedSequenceNode,"exitBlock_")(self,aBlock);
((self):directives()):do_((function(each)
return ((each):exitBlock_(aBlock))
end));
return (self);
end
,"evaluating","exitBlock: aBlock\r\n\t\" Set the exit block of the receiver. \"\r\n\r\n\tsuper exitBlock: aBlock.\r\n\tself directives do: [:each| each exitBlock: aBlock ] ","function(self,aBlock)\r\nsmalltalk:superImplementor(smalltalk.ExtendedSequenceNode,\"exitBlock_\")(self,aBlock);\r\n((self):directives()):do_((function(each)\r\nreturn ((each):exitBlock_(aBlock))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ExtendedSequenceNode,"evaluateIn:",0
,function(self,aContext)
((self):directives()):do_((function(each)
return ((each):evaluateIn_(aContext))
end));
return (smalltalk:superImplementor(smalltalk.ExtendedSequenceNode,"evaluateIn_")(self,aContext));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\tself directives do: [:each| each evaluateIn: aContext ].\r\n\t^super evaluateIn: aContext ","function(self,aContext)\r\n((self):directives()):do_((function(each)\r\nreturn ((each):evaluateIn_(aContext))\r\nend));\r\nreturn (smalltalk:superImplementor(smalltalk.ExtendedSequenceNode,\"evaluateIn_\")(self,aContext));\r\nend")

smalltalk:bind(smalltalk.ValueNode["$klass"],"literal:value:",0
,function(self,aName,aValue)
return (((self):new()):literal_value_(aName,aValue));
end
,"instantiation","literal: aName value: aValue\r\n\t\" Return an instance of the receiver. \"\r\n\r\n\t^self new literal: aName value: aValue","function(self,aName,aValue)\r\nreturn (((self):new()):literal_value_(aName,aValue));\r\nend")

smalltalk:bind(smalltalk.ValueNode,"literal:value:",0
,function(self,aName,aValue)
(function()
	local _s8_value=(aName)
	self["@value"]=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((smalltalk.S8LiteralBinding):value_(aValue))
	self["@binding"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","literal: aName value: aValue\r\n\t\" Private - Initialize the receiver as a literal constant with aValue. \"\r\n\r\n\tvalue := aName.\r\n\tbinding := S8LiteralBinding value: aValue ","function(self,aName,aValue)\r\n(function()\r\n\tlocal _s8_value=(aName)\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((smalltalk.S8LiteralBinding):value_(aValue))\r\n\tself[\"@binding\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ValueNode,"evaluateIn:",0
,function(self,aContext)
return ((self):index_in_((self):valueIn_(aContext),aContext));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^self index: (self valueIn: aContext) in: aContext ","function(self,aContext)\r\nreturn ((self):index_in_((self):valueIn_(aContext),aContext));\r\nend")

smalltalk:bind(smalltalk.ValueNode,"index:in:",0
,function(self,anObject,aContext)
return (anObject);
end
,"indexing","index: anObject in: aContext\r\n\t\" Private - Returns the result of indexing anObject. \"\r\n\r\n\t^anObject ","function(self,anObject,aContext)\r\nreturn (anObject);\r\nend")

smalltalk:bind(smalltalk.ValueNode,"initializeBinding:",0
,function(self,aContext)
(function()
	local _s8_value=("constant")
	self["@binding"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeBinding: aContext\r\n\t\" Private - Initialize the binding of the receiver. \"\r\n\r\n\tbinding := #constant ","function(self,aContext)\r\n(function()\r\n\tlocal _s8_value=(\"constant\")\r\n\tself[\"@binding\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.ValueNode,"enter:",0
,function(self,aContext)
if (smalltalk:isNil_((self["@binding"])))==true then (self):initializeBinding_(aContext); end;
if (smalltalk:isObject_equalTo_((self["@binding"]),"constant"))==true then return (false); end;
return (smalltalk:notNil_((self["@binding"])));
end
,"bindings","enter: aContext\r\n\t\" Private - Returns true if the receiver is bound to aContext. \"\r\n\r\n\tbinding isNil ifTrue: [ self initializeBinding: aContext ].\r\n\tbinding = #constant ifTrue: [ ^false ].\r\n\t^binding notNil ","function(self,aContext)\r\nif (smalltalk:isNil_((self[\"@binding\"])))==true then (self):initializeBinding_(aContext); end;\r\nif (smalltalk:isObject_equalTo_((self[\"@binding\"]),\"constant\"))==true then return (false); end;\r\nreturn (smalltalk:notNil_((self[\"@binding\"])));\r\nend")

smalltalk:bind(smalltalk.ValueNode,"valueIn:",0
,function(self,aContext)
if not (((self):enter_(aContext)))==true then return ((self["@value"]):shallowCopy()); end;
return ((self["@binding"]):evaluateIn_(aContext));
end
,"value","valueIn: aContext\r\n\t\" Private - Returns the value of the receiver in aContext. \"\r\n\r\n\t(self enter: aContext) ifFalse: [ ^value shallowCopy ].\r\n\t^binding evaluateIn: aContext ","function(self,aContext)\r\nif not (((self):enter_(aContext)))==true then return ((self[\"@value\"]):shallowCopy()); end;\r\nreturn ((self[\"@binding\"]):evaluateIn_(aContext));\r\nend")

smalltalk:bind(smalltalk.ValueNode,"clear:",0
,function(self,aContext)
if not (((self):enter_(aContext)))==true then return ((aContext):clear_((self["@value"]):_minus_gt(nil))); end;
return ((aContext):clear_(self["@binding"]));
end
,"evaluating","clear: aContext\r\n\t\" Clear the receiver's contents. \"\r\n\r\n\t(self enter: aContext) ifFalse: [\r\n\t\t^aContext clear: value -> nil\r\n\t].\r\n\t^aContext clear: binding ","function(self,aContext)\r\nif not (((self):enter_(aContext)))==true then return ((aContext):clear_((self[\"@value\"]):_minus_gt(nil))); end;\r\nreturn ((aContext):clear_(self[\"@binding\"]));\r\nend")

smalltalk:bind(smalltalk.ValueNode,"bind:in:",0
,function(self,aValue,aContext)
return ((self):assignValue_in_(aValue,aContext));
end
,"binding","bind: aValue in: aContext\r\n\t\" Set the receiver's value to aValue in aContext.\r\n\tWARNING: The receiver MUST return the value set. \"\r\n\r\n\t^self assignValue: aValue in: aContext ","function(self,aValue,aContext)\r\nreturn ((self):assignValue_in_(aValue,aContext));\r\nend")

smalltalk:bind(smalltalk.ValueNode,"followBlockIn:",0
,function(self,aContext)
return (nil);
end
,"evaluating","followBlockIn: aContext\r\n\t\" Private - Returns the block to follow indices. \"\r\n\r\n\t^nil ","function(self,aContext)\r\nreturn (nil);\r\nend")

smalltalk:bind(smalltalk.ValueNode,"assignValue:in:",0
,function(self,aValue,aContext)
if not (((self):enter_(aContext)))==true then return ((aContext):at_put_(self["@value"],aValue)); end;
return ((self["@binding"]):assign_to_in_((self):followBlockIn_(aContext),aValue,aContext));
end
,"evaluating","assignValue: aValue in: aContext\r\n\t\" Private - Set the receiver's value to aValue.\r\n\tWARNING: The receiver MUST return the value set. \"\r\n\r\n\t(self enter: aContext) ifFalse: [\r\n\t\t^aContext at: value put: aValue\r\n\t].\r\n\t^binding\r\n\t\tassign: (self followBlockIn: aContext)\r\n\t\tto: aValue in: aContext ","function(self,aValue,aContext)\r\nif not (((self):enter_(aContext)))==true then return ((aContext):at_put_(self[\"@value\"],aValue)); end;\r\nreturn ((self[\"@binding\"]):assign_to_in_((self):followBlockIn_(aContext),aValue,aContext));\r\nend")

smalltalk:bind(smalltalk.VariableNode,"index:in:",0
,function(self,anObject,aContext)
if (smalltalk:isNil_((self["@indices"])))==true then return (anObject); end;
return ((self["@indices"]):inject_into_(anObject,(function(result,index)
return (smalltalk:basic_at_ifAbsent_((result),(self):key_in_(index,aContext),(function()
return (nil)
end)))
end)));
end
,"indexing","index: anObject in: aContext\r\n\t\" Private - Returns the result of indexing anObject. \"\r\n\r\n\tindices isNil ifTrue: [ ^anObject ].\r\n\t^indices inject: anObject into: [:result :index|\r\n\t\tresult\tbasicAt: (self key: index in: aContext)\r\n\t\t\tifAbsent: [ ]\r\n\t]","function(self,anObject,aContext)\r\nif (smalltalk:isNil_((self[\"@indices\"])))==true then return (anObject); end;\r\nreturn ((self[\"@indices\"]):inject_into_(anObject,(function(result,index)\r\nreturn (smalltalk:basic_at_ifAbsent_((result),(self):key_in_(index,aContext),(function()\r\nreturn (nil)\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.VariableNode,"key:in:",0
,function(self,index,aContext)
return (smalltalk:if_true_false_((smalltalk:is_kindOf_((index),(smalltalk.CompilerNode))),(function()
return ((index):evaluateIn_(aContext))
end),(function()
return (index)
end)));
end
,"indexing","key: index in: aContext\r\n\t\" Private - Returns the key to index an object in aContext. \"\r\n\r\n\t^(index isKindOf: CompilerNode)\r\n\t\tifTrue: [ index evaluateIn: aContext ]\r\n\t\tifFalse: [ index ]","function(self,index,aContext)\r\nreturn (smalltalk:if_true_false_((smalltalk:is_kindOf_((index),(smalltalk.CompilerNode))),(function()\r\nreturn ((index):evaluateIn_(aContext))\r\nend),(function()\r\nreturn (index)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.VariableNode,"initializeBinding:",0
,function(self,aContext)
if ((smalltalk:newArray({"self", "super"})):includes_(self["@value"]))==true then return ((function()
	local _s8_value=((smalltalk.S8Binding):key_("self"))
	self["@binding"]=_s8_value
	return _s8_value
end)()); end;
if (smalltalk:isObject_equalTo_((self["@value"]),"nil"))==true then (function()
	local _s8_value=(nil)
	self["@value"]=_s8_value
	return _s8_value
end)();
return ((function()
	local _s8_value=("constant")
	self["@binding"]=_s8_value
	return _s8_value
end)()); end;
if ((smalltalk:newArray({"true", "false"})):includes_(self["@value"]))==true then (function()
	local _s8_value=(smalltalk:isObject_equalTo_((self["@value"]),"true"))
	self["@value"]=_s8_value
	return _s8_value
end)();
return ((function()
	local _s8_value=("constant")
	self["@binding"]=_s8_value
	return _s8_value
end)()); end;
if (((((aContext):self())["$klass"]):allInstVarNames()):includes_((self):value()))==true then return ((function()
	local _s8_value=((smalltalk.S8Binding):toInstanceVariable_((self):value()))
	self["@binding"]=_s8_value
	return _s8_value
end)()); end;
(function()
	local _s8_value=((smalltalk.S8Binding):key_(self["@value"]))
	self["@binding"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeBinding: aContext\r\n\t\" Private - Initialize the binding of the receiver. \"\r\n\r\n\t(#( #self #super ) includes: value) ifTrue: [\r\n\t\t^binding := S8Binding key: #self\r\n\t].\r\n\tvalue = #nil ifTrue: [\r\n\t\tvalue := nil.\r\n\t\t^binding := #constant\r\n\t].\r\n\t(#( #true #false ) includes: value) ifTrue: [\r\n\t\tvalue := value = #true.\r\n\t\t^binding := #constant\r\n\t].\r\n\t(aContext self class allInstVarNames includes: self value) ifTrue: [\r\n\t\t^binding := S8Binding toInstanceVariable: self value\r\n\t].\r\n\r\n\tbinding := S8Binding key: value ","function(self,aContext)\r\nif ((smalltalk:newArray({\"self\", \"super\"})):includes_(self[\"@value\"]))==true then return ((function()\r\n\tlocal _s8_value=((smalltalk.S8Binding):key_(\"self\"))\r\n\tself[\"@binding\"]=_s8_value\r\n\treturn _s8_value\r\nend)()); end;\r\nif (smalltalk:isObject_equalTo_((self[\"@value\"]),\"nil\"))==true then (function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((function()\r\n\tlocal _s8_value=(\"constant\")\r\n\tself[\"@binding\"]=_s8_value\r\n\treturn _s8_value\r\nend)()); end;\r\nif ((smalltalk:newArray({\"true\", \"false\"})):includes_(self[\"@value\"]))==true then (function()\r\n\tlocal _s8_value=(smalltalk:isObject_equalTo_((self[\"@value\"]),\"true\"))\r\n\tself[\"@value\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((function()\r\n\tlocal _s8_value=(\"constant\")\r\n\tself[\"@binding\"]=_s8_value\r\n\treturn _s8_value\r\nend)()); end;\r\nif (((((aContext):self())[\"$klass\"]):allInstVarNames()):includes_((self):value()))==true then return ((function()\r\n\tlocal _s8_value=((smalltalk.S8Binding):toInstanceVariable_((self):value()))\r\n\tself[\"@binding\"]=_s8_value\r\n\treturn _s8_value\r\nend)()); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.S8Binding):key_(self[\"@value\"]))\r\n\tself[\"@binding\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.VariableNode,"clear:",0
,function(self,aContext)
(self):enter_(aContext);
if (smalltalk:isObject_equalTo_((self["@binding"]),"constant"))==true then return ((self):error_("Should not be constant")); end;
return (smalltalk:superImplementor(smalltalk.VariableNode,"clear_")(self,aContext));
end
,"evaluating","clear: aContext\r\n\t\" Clear the receiver's contents. \"\r\n\r\n\tself enter: aContext.\r\n\tbinding = #constant ifTrue: [\r\n\t\t^self error: 'Should not be constant'\r\n\t].\r\n\t^super clear: aContext ","function(self,aContext)\r\n(self):enter_(aContext);\r\nif (smalltalk:isObject_equalTo_((self[\"@binding\"]),\"constant\"))==true then return ((self):error_(\"Should not be constant\")); end;\r\nreturn (smalltalk:superImplementor(smalltalk.VariableNode,\"clear_\")(self,aContext));\r\nend")

smalltalk:bind(smalltalk.VariableNode,"followBlockIn:",0
,function(self,aContext)
return (smalltalk:if_true_false_((smalltalk:notNil_((self["@indices"]))),(function()
return ((function(root)
return ((self):follow_in_(root,aContext))
end))
end),nil));
end
,"evaluating","followBlockIn: aContext\r\n\t\" Private - Returns the block to follow indices. \"\r\n\r\n\t^indices notNil ifTrue: [ [:root| self follow: root in: aContext ] ] ","function(self,aContext)\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((self[\"@indices\"]))),(function()\r\nreturn ((function(root)\r\nreturn ((self):follow_in_(root,aContext))\r\nend))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.VariableNode,"follow:in:",0
,function(self,anObject,aContext)
local target=nil
local index=nil
if (smalltalk:isNil_((self["@indices"])))==true then return (nil); end;
(function()
	local _s8_value=(anObject)
	target=_s8_value
	return _s8_value
end)();
(1):to_do_(((self["@indices"]):size()):_minus(1),(function(i)
(function()
	local _s8_value=((self):key_in_((self["@indices"]):at_(i),aContext))
	index=_s8_value
	return _s8_value
end)();return ((function()
	local _s8_value=(smalltalk:basic_at_ifAbsent_((target),index,(function()
return (nil)
end)))
	target=_s8_value
	return _s8_value
end)())
end));
(function()
	local _s8_value=((self):key_in_((self["@indices"]):last(),aContext))
	index=_s8_value
	return _s8_value
end)();
return ((smalltalk.Array):with_with_(target,index));
end
,"indexing","follow: anObject in: aContext\r\n\t\" Private - Returns the result of following the indices from anObject and last index to evaluate (or nil). \"\r\n\r\n\t| target index |\r\n\tindices isNil ifTrue: [ ^nil ].\r\n\ttarget := anObject.\r\n\t1 to: indices size - 1 do: [:i|\r\n\t\tindex := self key: (indices at: i) in: aContext.\r\n\t\ttarget := target basicAt: index ifAbsent: []\r\n\t].\r\n\tindex := self key: indices last in: aContext.\r\n\t^Array with: target with: index ","function(self,anObject,aContext)\r\nlocal target=nil\r\nlocal index=nil\r\nif (smalltalk:isNil_((self[\"@indices\"])))==true then return (nil); end;\r\n(function()\r\n\tlocal _s8_value=(anObject)\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(1):to_do_(((self[\"@indices\"]):size()):_minus(1),(function(i)\r\n(function()\r\n\tlocal _s8_value=((self):key_in_((self[\"@indices\"]):at_(i),aContext))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();return ((function()\r\n\tlocal _s8_value=(smalltalk:basic_at_ifAbsent_((target),index,(function()\r\nreturn (nil)\r\nend)))\r\n\ttarget=_s8_value\r\n\treturn _s8_value\r\nend)())\r\nend));\r\n(function()\r\n\tlocal _s8_value=((self):key_in_((self[\"@indices\"]):last(),aContext))\r\n\tindex=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((smalltalk.Array):with_with_(target,index));\r\nend")

smalltalk:bind(smalltalk.VariableNode,"send:to:withArguments:in:",0
,function(self,selector,anObject,anArray,aContext)
local anImplementor=nil
(function()
	local _s8_value=(((aContext):self())["$klass"])
	anImplementor=_s8_value
	return _s8_value
end)();
if (smalltalk:isNil_((anImplementor)))==true then (function()
	local _s8_value=((anObject)["$klass"])
	anImplementor=_s8_value
	return _s8_value
end)(); end;
return ((self):apply_to_withArguments_in_((self):functionToCall_in_(selector,anImplementor),anObject,anArray,aContext));
end
,"evaluating","send: selector to: anObject withArguments: anArray in: aContext\r\n\t\" Private - Returns the result of sending message to anObject in aContext. \"\r\n\r\n\t| anImplementor |\r\n\tanImplementor := aContext self class.\r\n\tanImplementor isNil ifTrue: [ anImplementor := anObject class ].\r\n\t^self\tapply: (self functionToCall: selector in: anImplementor)\r\n\t\tto: anObject withArguments: anArray\r\n\t\tin: aContext ","function(self,selector,anObject,anArray,aContext)\r\nlocal anImplementor=nil\r\n(function()\r\n\tlocal _s8_value=(((aContext):self())[\"$klass\"])\r\n\tanImplementor=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isNil_((anImplementor)))==true then (function()\r\n\tlocal _s8_value=((anObject)[\"$klass\"])\r\n\tanImplementor=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nreturn ((self):apply_to_withArguments_in_((self):functionToCall_in_(selector,anImplementor),anObject,anArray,aContext));\r\nend")

smalltalk:bind(smalltalk.VariableNode,"functionToCall:in:",0
,function(self,selector,anImplementor)
return (((smalltalk.Smalltalk):current()):superImplementor(anImplementor,selector));
end
,"evaluating","functionToCall: selector in: anImplementor\r\n\t\" Private - Returns the native function to call for selector. \"\r\n\r\n\t^Smalltalk current\r\n\t\t#superImplementor: anImplementor\r\n\t\tof: selector ","function(self,selector,anImplementor)\r\nreturn (((smalltalk.Smalltalk):current()):superImplementor(anImplementor,selector));\r\nend")

smalltalk:bind(smalltalk.VariableNode,"apply:to:withArguments:in:",0
,function(self,fn,anObject,anArray,aContext)
return (fn(anObject,(table.unpack or unpack)(anArray)));
end
,"evaluating","apply: fn to: anObject withArguments: anArray in: aContext\r\n\t\" Private - Returns the result of evaluating the native function in anObject @ aContext. \"\r\n\r\n\t^{''\r\n\tjs'fn.apply(anObject,anArray)'\r\n\tlua'fn(anObject,(table.unpack or unpack)(anArray))'\r\n\tpy'fn(anObject,*smalltalk.objects_toCall_(anArray,fn))'}. ","function(self,fn,anObject,anArray,aContext)\r\nreturn (fn(anObject,(table.unpack or unpack)(anArray)));\r\nend")

smalltalk:bind(smalltalk.AlienNode,"initializeBinding:",0
,function(self,aContext)
(function()
	local _s8_value=((smalltalk.S8Binding):key_((function()
return ((smalltalk.Smalltalk):nativeObjectAt_(self["@value"]))
end)))
	self["@binding"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeBinding: aContext\r\n\t\" Private - Initialize the binding of the receiver. \"\r\n\r\n\tbinding := S8Binding key: [ Smalltalk nativeObjectAt: value ] ","function(self,aContext)\r\n(function()\r\n\tlocal _s8_value=((smalltalk.S8Binding):key_((function()\r\nreturn ((smalltalk.Smalltalk):nativeObjectAt_(self[\"@value\"]))\r\nend)))\r\n\tself[\"@binding\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.GlobalReferenceNode,"bindingIn:",0
,function(self,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local st=nil
local cls=nil
local aName=nil
(function()
	local _s8_value=((self):value())
	aName=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((aContext):self())["$klass"])
	cls=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((cls))),(function()
return ((cls):instanceClass())
end),(function()
return ((nil)["$klass"])
end)))
	cls=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=(((aContext):self()):smalltalk())
	st=_s8_value
	return _s8_value
end)();
(cls):withAllSuperclassesDo_((function(each)
local vars=nil
(function()
	local _s8_value=((each):classVariables())
	vars=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((vars))),(function()
return ((vars):includesKey_(aName))
end))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.S8Binding):key_in_(aName,vars))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(cls):sharedPoolsAndNamesDo_((function(poolName,pool)
return (smalltalk:if_true_false_(((pool):includesKey_(aName)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.S8Binding):key_in_(aName,(st):at_(poolName)))
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.S8Binding):key_in_(aName,st))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"visiting","bindingIn: aContext\r\n\t\" Private - Returns the binding of the receiver. \"\r\n\r\n\t| st cls aName |\r\n\taName := self value.\r\n\tcls := aContext self class.\r\n\tcls := cls notNil\r\n\t\tifTrue: [ cls instanceClass ]\r\n\t\tifFalse: [ nil class ].\r\n\tst := aContext self smalltalk.\r\n\tcls withAllSuperclassesDo: [:each| | vars |\r\n\t\tvars := each classVariables.\r\n\t\t(vars notNil and: [ vars includesKey: aName ]) ifTrue: [\r\n\t\t\t^S8Binding key: aName in: vars\r\n\t\t]\r\n\t].\r\n\tcls sharedPoolsAndNamesDo: [:poolName :pool|\r\n\t\t(pool includesKey: aName) ifTrue: [\r\n\t\t\t^S8Binding\r\n\t\t\t\tkey: aName\r\n\t\t\t\tin: (st at: poolName)\r\n\t\t]\r\n\t].\r\n\t^S8Binding key: aName in: st ","function(self,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal st=nil\r\nlocal cls=nil\r\nlocal aName=nil\r\n(function()\r\n\tlocal _s8_value=((self):value())\r\n\taName=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((aContext):self())[\"$klass\"])\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_((smalltalk:notNil_((cls))),(function()\r\nreturn ((cls):instanceClass())\r\nend),(function()\r\nreturn ((nil)[\"$klass\"])\r\nend)))\r\n\tcls=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=(((aContext):self()):smalltalk())\r\n\tst=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(cls):withAllSuperclassesDo_((function(each)\r\nlocal vars=nil\r\n(function()\r\n\tlocal _s8_value=((each):classVariables())\r\n\tvars=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:notNil_((vars))),(function()\r\nreturn ((vars):includesKey_(aName))\r\nend))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.S8Binding):key_in_(aName,vars))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(cls):sharedPoolsAndNamesDo_((function(poolName,pool)\r\nreturn (smalltalk:if_true_false_(((pool):includesKey_(aName)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.S8Binding):key_in_(aName,(st):at_(poolName)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.S8Binding):key_in_(aName,st))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.GlobalReferenceNode,"initializeBinding:",0
,function(self,aContext)
(function()
	local _s8_value=((self):bindingIn_(aContext))
	self["@binding"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"visiting","initializeBinding: aContext\r\n\t\" Private - Initialize the binding of the receiver. \"\r\n\r\n\tbinding := self bindingIn: aContext ","function(self,aContext)\r\n(function()\r\n\tlocal _s8_value=((self):bindingIn_(aContext))\r\n\tself[\"@binding\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.NoReceiverNode,"isOO",0
,function(self)
return (false);
end
,"query","isOO\r\n\t\" Returns true if the receiver refers to an object. \"\r\n\r\n\t^false ","function(self)\r\nreturn (false);\r\nend")

smalltalk:bind(smalltalk.NoReceiverNode,"send:to:withArguments:in:",0
,function(self,msg,anObject,anArray,aContext)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local fn=nil
local selector=nil
(function()
	local _s8_value=((smalltalk.SendNode):selectorToSend_(msg))
	selector=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((selector),"self"))==true then (self):note_(smalltalk:object_comma_((((self)["$klass"]):name()),">>#send:to:... need testing"));
return (((aContext):self()):evaluateWithArguments_(anArray)); end;
(function()
	local _s8_value=((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(selector,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):error_(smalltalk:object_comma_(("Missing native function "),(selector):asLiteral())))
end
)()
error(_s8Ret_,0)
end)())
end)))
	fn=_s8_value
	return _s8_value
end)();
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (fn(anObject,(table.unpack or unpack)(anArray)))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"evaluating","send: msg to: anObject withArguments: anArray in: aContext\r\n\t\" Private - Returns the result of sending message to anObject in aContext. \"\r\n\r\n\t| fn selector |\r\n\tselector := SendNode selectorToSend: msg.\r\n\tselector = #self ifTrue: [\r\n\t\tself note: self class name,'>>#send:to:... need testing'.\r\n\t\t^aContext self evaluateWithArguments: anArray\r\n\t].\r\n\tfn := Smalltalk nativeObjectAt: selector ifAbsent: [\r\n\t\t^self error: 'Missing native function ' ,selector asLiteral\r\n\t].\r\n\t^{''\r\n\tjs'fn.apply(anObject,anArray)'\r\n\tlua'fn(anObject,(table.unpack or unpack)(anArray))'\r\n\tpy'fn(anObject,*smalltalk.objects_toCall_(anArray,fn))'}. ","function(self,msg,anObject,anArray,aContext)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal fn=nil\r\nlocal selector=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.SendNode):selectorToSend_(msg))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((selector),\"self\"))==true then (self):note_(smalltalk:object_comma_((((self)[\"$klass\"]):name()),\">>#send:to:... need testing\"));\r\nreturn (((aContext):self()):evaluateWithArguments_(anArray)); end;\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(selector,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):error_(smalltalk:object_comma_((\"Missing native function \"),(selector):asLiteral())))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\n\tfn=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (fn(anObject,(table.unpack or unpack)(anArray)))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.JSDirectiveNode,"evaluateIn:",0
,function(self,aContext)
return ((self):error_("Directive support missing"));
end
,"evaluating","evaluateIn: aContext\r\n\t\" Returns the result of evaluating the receiver in aContext. \"\r\n\r\n\t^self error: 'Directive support missing' ","function(self,aContext)\r\nreturn ((self):error_(\"Directive support missing\"));\r\nend")
