
-- fileIn("s8/library/sharing/Stringifier.st")
smalltalk:addClass("Stringifier",smalltalk.Object,smalltalk:newArray({"origin","rememberedSet","id","markedObjects","objectHandlers"}),"Stringifier")

smalltalk:bind(smalltalk.Stringifier["$klass"],"constructEventsTriggered",0
,function(self)
return (smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.Stringifier["$klass"],"constructEventsTriggered")(self)),smalltalk:newArray({"needsOrigin", "prepare:", "needsStringifier", "aboutToReset", "reset", "aboutToClose", "needsObjectHandlers", "objectHandlersContents", "needsHandlerFor:"})));
end
,"events","constructEventsTriggered\r\n\t\" Private - Return the events managed by instances of the receiver. \"\r\n\r\n\t^super constructEventsTriggered\r\n\t,#(\t#needsOrigin\r\n\t\t#prepare: #needsStringifier\r\n\t\t#aboutToReset #reset #aboutToClose\r\n\t\t#needsObjectHandlers #objectHandlersContents\r\n\t\t#needsHandlerFor:\r\n\t)","function(self)\r\nreturn (smalltalk:object_comma_((smalltalk:superImplementor(smalltalk.Stringifier[\"$klass\"],\"constructEventsTriggered\")(self)),smalltalk:newArray({\"needsOrigin\", \"prepare:\", \"needsStringifier\", \"aboutToReset\", \"reset\", \"aboutToClose\", \"needsObjectHandlers\", \"objectHandlersContents\", \"needsHandlerFor:\"})));\r\nend")

smalltalk:bind(smalltalk.Stringifier["$klass"],"@","_at"
,function(self,anObject)
return (((self):new()):literalForOne_(anObject));
end
,"converting","@ anObject\r\n\t\" Returns the literal to send to a remote system to obtain a copy of anObject. \"\r\n\r\n\t^self new literalForOne: anObject","function(self,anObject)\r\nreturn (((self):new()):literalForOne_(anObject));\r\nend")

smalltalk:bind(smalltalk.Stringifier["$klass"],"to:",0
,function(self,target)
return (((self):new()):yourself());
end
,"instantiation","to: target\r\n\t\" Returns an instance of the receiver. \"\r\n\r\n\t^self new\r\n\t\t\"target: target; - ignored\"\r\n\t\tyourself","function(self,target)\r\nreturn (((self):new()):yourself());\r\nend")

smalltalk:bind(smalltalk.Stringifier,"origin",0
,function(self)
if (smalltalk:isNil_((self["@origin"])))==true then (self):initializeOrigin(); end;
return (self["@origin"]);
end
,"accessing","origin\r\n\t\" Returns the origin of the receiver. \"\r\n\r\n\torigin isNil ifTrue: [ self initializeOrigin ].\r\n\t^origin","function(self)\r\nif (smalltalk:isNil_((self[\"@origin\"])))==true then (self):initializeOrigin(); end;\r\nreturn (self[\"@origin\"]);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"id",0
,function(self)
return (self["@id"]);
end
,"accessing","id\r\n\t\" Returns the id of the receiver (can be nil). \"\r\n\r\n\t^id","function(self)\r\nreturn (self[\"@id\"]);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"origin:",0
,function(self,aSymbol)
(function()
	local _s8_value=(aSymbol)
	self["@origin"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"accessing","origin: aSymbol\r\n\t\" Set the origin of the receiver. \"\r\n\r\n\torigin := aSymbol","function(self,aSymbol)\r\n(function()\r\n\tlocal _s8_value=(aSymbol)\r\n\tself[\"@origin\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"tagStart",0
,function(self)
return (" ");
end
,"constants","tagStart\r\n\t\" Private - Returns the tag start mask. \"\r\n\r\n\t^' '","function(self)\r\nreturn (\" \");\r\nend")

smalltalk:bind(smalltalk.Stringifier,"markID",0
,function(self)
return (smalltalk:object_comma_(((self):tagStart()),"id"));
end
,"constants","markID\r\n\t\" Private - Returns the id mark token. \"\r\n\r\n\t^self tagStart ,#id","function(self)\r\nreturn (smalltalk:object_comma_(((self):tagStart()),\"id\"));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"defaultOrigin",0
,function(self)
if ((smalltalk.Smalltalk):includesKey_("OrderedCollection"))==true then return ("VSE"); end;
return ("S8");
end
,"initialize","defaultOrigin\r\n\t\" Private - Initialize the default origin. \"\r\n\r\n\t(Smalltalk includesKey: #OrderedCollection) ifTrue: [ ^#VSE ].\r\n\t^#S8","function(self)\r\nif ((smalltalk.Smalltalk):includesKey_(\"OrderedCollection\"))==true then return (\"VSE\"); end;\r\nreturn (\"S8\");\r\nend")

smalltalk:bind(smalltalk.Stringifier,"initializeOrigin",0
,function(self)
(function()
	local _s8_value=((self):triggerEvent_ifNotHandled_("needsOrigin",(function()
return ((self):defaultOrigin())
end)))
	self["@origin"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeOrigin\r\n\t\" Private - Initialize the origin (hosting platform). \"\r\n\r\n\torigin := self\r\n\t\ttriggerEvent: #needsOrigin\r\n\t\tifNotHandled: [ self defaultOrigin ]","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_ifNotHandled_(\"needsOrigin\",(function()\r\nreturn ((self):defaultOrigin())\r\nend)))\r\n\tself[\"@origin\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"initializeRememberedSet",0
,function(self)
(function()
	local _s8_value=(smalltalk:if_true_false_(((smalltalk.Smalltalk):includesKey_("IdentityDictionary")),(function()
return ((smalltalk.IdentityDictionary):new())
end),(function()
return (self)
end)))
	self["@rememberedSet"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"initialize","initializeRememberedSet\r\n\t\" Private - Initialize the walked objects cache. \"\r\n\r\n\trememberedSet := (Smalltalk includesKey: #IdentityDictionary)\r\n\t\tifTrue: [ IdentityDictionary new ]\r\n\t\tifFalse: [ self ]","function(self)\r\n(function()\r\n\tlocal _s8_value=(smalltalk:if_true_false_(((smalltalk.Smalltalk):includesKey_(\"IdentityDictionary\")),(function()\r\nreturn ((smalltalk.IdentityDictionary):new())\r\nend),(function()\r\nreturn (self)\r\nend)))\r\n\tself[\"@rememberedSet\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"reset",0
,function(self)
(self):triggerEvent_("aboutToReset");
(self):forgetObjects();
(function()
	local _s8_value=((function()
	local _s8_value=(nil)
	self["@id"]=_s8_value
	return _s8_value
end)())
	self["@rememberedSet"]=_s8_value
	return _s8_value
end)();
(self):triggerEvent_("reset");
return (self);
end
,"configuration","reset\r\n\t\" Private - Reset the receiver to initial state. \"\r\n\r\n\tself triggerEvent: #aboutToReset.\r\n\tself forgetObjects.\r\n\trememberedSet := id := nil.\r\n\tself triggerEvent: #reset","function(self)\r\n(self):triggerEvent_(\"aboutToReset\");\r\n(self):forgetObjects();\r\n(function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@id\"]=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\tself[\"@rememberedSet\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_(\"reset\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"close",0
,function(self)
(self):triggerEvent_("aboutToClose");
(self):reset();
return (self);
end
,"configuration","close\r\n\t\" Private - Close the receiver.\r\n\tREQUIRED in platforms where there is no support for IdentityDictionary (e.g. S8 systems). \"\r\n\r\n\tself triggerEvent: #aboutToClose.\r\n\tself reset.","function(self)\r\n(self):triggerEvent_(\"aboutToClose\");\r\n(self):reset();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"initializeObjectHandlers",0
,function(self)
(function()
	local _s8_value=((self):triggerEvent_ifNotHandled_("needsObjectHandlers",(function()
return ((smalltalk.PoolDictionary):new())
end)))
	self["@objectHandlers"]=_s8_value
	return _s8_value
end)();
(self):triggerEvent_ifNotHandled_("objectHandlersContents",(function()
if (smalltalk:isObject_equalTo_(((self):origin()),"VSE"))==true then (self):initializeVSEObjectHandlers(); end;return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((self["@origin"]),"S8")),(function()
return ((self):initializeS8ObjectHandlers())
end),nil))
end));
return (self);
end
,"configuration","initializeObjectHandlers\r\n\t\" Private - Initialize the handlers to map objects. \"\r\n\r\n\tobjectHandlers := self\r\n\t\ttriggerEvent: #needsObjectHandlers\r\n\t\tifNotHandled: [ PoolDictionary new ].\r\n\tself triggerEvent: #objectHandlersContents ifNotHandled: [\r\n\t\tself origin = #VSE ifTrue: [ self initializeVSEObjectHandlers ].\r\n\t\torigin = #S8 ifTrue: [ self initializeS8ObjectHandlers ].\r\n\t]","function(self)\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_ifNotHandled_(\"needsObjectHandlers\",(function()\r\nreturn ((smalltalk.PoolDictionary):new())\r\nend)))\r\n\tself[\"@objectHandlers\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):triggerEvent_ifNotHandled_(\"objectHandlersContents\",(function()\r\nif (smalltalk:isObject_equalTo_(((self):origin()),\"VSE\"))==true then (self):initializeVSEObjectHandlers(); end;return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((self[\"@origin\"]),\"S8\")),(function()\r\nreturn ((self):initializeS8ObjectHandlers())\r\nend),nil))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"cantHandleBlock",0
,function(self)
return ((function(object,my)
return ((my):error_(smalltalk:object_comma_(("Can't handle instances of "),((object)["$klass"]):name())))
end));
end
,"handlers","cantHandleBlock\r\n\t\" Private - Returns the block to use when the receiver do NOT handle an object. \"\r\n\r\n\t^[:object :my| my error: 'Can''t handle instances of ' ,object class name ]","function(self)\r\nreturn ((function(object,my)\r\nreturn ((my):error_(smalltalk:object_comma_((\"Can't handle instances of \"),((object)[\"$klass\"]):name())))\r\nend));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"defaultHandleBlock",0
,function(self)
return ((function(anObject,my)
return ((my):basicMapForObject_(anObject))
end));
end
,"handlers","defaultHandleBlock\r\n\t\" Private - Returns the block to handle objects. \"\r\n\r\n\t^[:anObject :my| my basicMapForObject: anObject ]","function(self)\r\nreturn ((function(anObject,my)\r\nreturn ((my):basicMapForObject_(anObject))\r\nend));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"dictionaryHandleBlock",0
,function(self)
return ((function(anObject,my)
local result=nil
local ref=nil
(function()
	local _s8_value=((my):newMapForObject_(anObject))
	result=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self):mapForArray_((self):associationsIn_(anObject)))
	ref=_s8_value
	return _s8_value
end)();(result):at_put_("associations",ref);return (result)
end));
end
,"handlers","dictionaryHandleBlock\r\n\t\" Private - Returns the block to handle dictionaries. \"\r\n\r\n\t^[:anObject :my| | result ref |\r\n\t\tresult := my newMapForObject: anObject.\r\n\t\tref := self mapForArray: (self associationsIn: anObject).\r\n\t\tresult at: #associations put: ref.\r\n\t\tresult\r\n\t]","function(self)\r\nreturn ((function(anObject,my)\r\nlocal result=nil\r\nlocal ref=nil\r\n(function()\r\n\tlocal _s8_value=((my):newMapForObject_(anObject))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):mapForArray_((self):associationsIn_(anObject)))\r\n\tref=_s8_value\r\n\treturn _s8_value\r\nend)();(result):at_put_(\"associations\",ref);return (result)\r\nend));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"asArrayHandleBlock",0
,function(self)
return ((function(anObject,my)
local result=nil
local ref=nil
(function()
	local _s8_value=((my):newMapForObject_(anObject))
	result=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self):mapForArray_((anObject):asArray()))
	ref=_s8_value
	return _s8_value
end)();(result):at_put_("contents",ref);return (result)
end));
end
,"handlers","asArrayHandleBlock\r\n\t\" Private - Returns the block to handle arrayable collections. \"\r\n\r\n\t^[:anObject :my| | result ref |\r\n\t\tresult := my newMapForObject: anObject.\r\n\t\tref := self mapForArray: anObject asArray.\r\n\t\tresult at: #contents put: ref.\r\n\t\tresult\r\n\t]","function(self)\r\nreturn ((function(anObject,my)\r\nlocal result=nil\r\nlocal ref=nil\r\n(function()\r\n\tlocal _s8_value=((my):newMapForObject_(anObject))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):mapForArray_((anObject):asArray()))\r\n\tref=_s8_value\r\n\treturn _s8_value\r\nend)();(result):at_put_(\"contents\",ref);return (result)\r\nend));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"bytesHandleBlock",0
,function(self)
return ((function(anObject,my)
local result=nil
local ref=nil
(function()
	local _s8_value=((my):newMapForObject_(anObject))
	result=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self):mapForArray_((anObject):notImplementedYet_("bytesHandleBlock")))
	ref=_s8_value
	return _s8_value
end)();(result):at_put_("contents",ref);return (result)
end));
end
,"handlers","bytesHandleBlock\r\n\t\" Private - Returns the block to handle objects. \"\r\n\r\n\t^[:anObject :my| | result ref |\r\n\t\tresult := my newMapForObject: anObject.\r\n\t\tref := self mapForArray: (anObject notImplementedYet: #bytesHandleBlock).\r\n\t\tresult at: #contents put: ref.\r\n\t\tresult\r\n\t]","function(self)\r\nreturn ((function(anObject,my)\r\nlocal result=nil\r\nlocal ref=nil\r\n(function()\r\n\tlocal _s8_value=((my):newMapForObject_(anObject))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self):mapForArray_((anObject):notImplementedYet_(\"bytesHandleBlock\")))\r\n\tref=_s8_value\r\n\treturn _s8_value\r\nend)();(result):at_put_(\"contents\",ref);return (result)\r\nend));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"timeStampHandleBlock",0
,function(self)
return ((function(timeStamp,my)
local result=nil
local ref=nil
local time=nil
(function()
	local _s8_value=((my):newMapForObject_(timeStamp))
	result=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((timeStamp):time())
	time=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((((timeStamp):date()):printInFormat_twoDigitYear_("YYYY/mm/dd",false))," ")),smalltalk:asString_(((time):hours())))),":")),smalltalk:asString_(((time):minutes())))),":")),smalltalk:asString_(((time):seconds()))))
	ref=_s8_value
	return _s8_value
end)();(result):at_put_("contents",ref);return (result)
end));
end
,"handlers","timeStampHandleBlock\r\n\t\" Private - Returns the block to handle instances of TimeStamp. \"\r\n\r\n\t^[:timeStamp :my| | result ref time | \"we save literal representation\"\r\n\t\tresult := my newMapForObject: timeStamp.\r\n\t\ttime := timeStamp time.\r\n\t\tref := (timeStamp date printInFormat: 'YYYY/mm/dd' twoDigitYear: false)\r\n\t\t\t,' ' ,time hours asString\r\n\t\t\t,':' ,time minutes asString\r\n\t\t\t,':' ,time seconds asString.\r\n\t\tresult at: #contents put: ref.\r\n\t\tresult\r\n\t]","function(self)\r\nreturn ((function(timeStamp,my)\r\nlocal result=nil\r\nlocal ref=nil\r\nlocal time=nil\r\n(function()\r\n\tlocal _s8_value=((my):newMapForObject_(timeStamp))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((timeStamp):time())\r\n\ttime=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((((timeStamp):date()):printInFormat_twoDigitYear_(\"YYYY/mm/dd\",false)),\" \")),smalltalk:asString_(((time):hours())))),\":\")),smalltalk:asString_(((time):minutes())))),\":\")),smalltalk:asString_(((time):seconds()))))\r\n\tref=_s8_value\r\n\treturn _s8_value\r\nend)();(result):at_put_(\"contents\",ref);return (result)\r\nend));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"dateTimeHandleBlock",0
,function(self)
return ((function(dateTime,my)
local result=nil
local ref=nil
local date=nil
(function()
	local _s8_value=((my):newMapForObject_(dateTime))
	result=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((""),(dateTime):year())),"/")),(dateTime):month())),"/")),(dateTime):dayOfMonth()))
	date=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((date)," ")),((dateTime):asTimeString()):upTo_(" ")))
	ref=_s8_value
	return _s8_value
end)();(result):at_put_("contents",ref);return (result)
end));
end
,"handlers","dateTimeHandleBlock\r\n\t\" Private - Returns the block to handle instances of DateTime. \"\r\n\r\n\t^[:dateTime :my| | result ref date | \"we save literal representation\"\r\n\t\tresult := my newMapForObject: dateTime.\r\n\t\tdate := '' ,dateTime year ,$/ ,dateTime month ,$/ ,dateTime dayOfMonth.\r\n\t\tref := date ,' ' ,(dateTime asTimeString upTo: $ ).\r\n\t\tresult at: #contents put: ref.\r\n\t\tresult\r\n\t]","function(self)\r\nreturn ((function(dateTime,my)\r\nlocal result=nil\r\nlocal ref=nil\r\nlocal date=nil\r\n(function()\r\n\tlocal _s8_value=((my):newMapForObject_(dateTime))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((smalltalk:object_comma_((\"\"),(dateTime):year())),\"/\")),(dateTime):month())),\"/\")),(dateTime):dayOfMonth()))\r\n\tdate=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_((date),\" \")),((dateTime):asTimeString()):upTo_(\" \")))\r\n\tref=_s8_value\r\n\treturn _s8_value\r\nend)();(result):at_put_(\"contents\",ref);return (result)\r\nend));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"classNamed:",0
,function(self,aName)
return ((smalltalk.Smalltalk):at_ifAbsent_(aName,(function()
return (nil)
end)));
end
,"private","classNamed: aName\r\n\t\" Private - Returns the class named aName (or nil). \"\r\n\r\n\t^Smalltalk at: aName ifAbsent: [ ]","function(self,aName)\r\nreturn ((smalltalk.Smalltalk):at_ifAbsent_(aName,(function()\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"handleMembersOf:with:",0
,function(self,aClass,aBlock)
if ((aClass):isString())==true then return ((self):handleMembersOf_with_((self):classNamed_(aClass),aBlock)); end;
return (smalltalk:if_true_false_((smalltalk:notNil_((aClass))),(function()
return ((self["@objectHandlers"]):at_put_((aClass):name(),aBlock))
end),nil));
end
,"configuration","handleMembersOf: aClass with: aBlock\r\n\t\" Private - Set the receiver to handle instances of aClass. \"\r\n\r\n\taClass isString ifTrue: [ ^self handleMembersOf: (self classNamed: aClass) with: aBlock ].\r\n\t^aClass notNil ifTrue: [ objectHandlers at: aClass name put: aBlock ]","function(self,aClass,aBlock)\r\nif ((aClass):isString())==true then return ((self):handleMembersOf_with_((self):classNamed_(aClass),aBlock)); end;\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((aClass))),(function()\r\nreturn ((self[\"@objectHandlers\"]):at_put_((aClass):name(),aBlock))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"handleInstancesOf:with:",0
,function(self,aClass,aBlock)
if ((aClass):isString())==true then return ((self):handleInstancesOf_with_((self):classNamed_(aClass),aBlock)); end;
return (smalltalk:if_true_false_((smalltalk:notNil_((aClass))),(function()
return (((aClass):withAllSubclasses()):do_((function(cls)
return ((self["@objectHandlers"]):at_put_((cls):name(),aBlock))
end)))
end),nil));
end
,"configuration","handleInstancesOf: aClass with: aBlock\r\n\t\" Private - Set the receiver to handle instances of aClass and subclasses. \"\r\n\r\n\taClass isString ifTrue: [ ^self handleInstancesOf: (self classNamed: aClass) with: aBlock ].\r\n\t^aClass notNil ifTrue: [\r\n\t\taClass withAllSubclasses do: [:cls| objectHandlers at: cls name put: aBlock ]\r\n\t]","function(self,aClass,aBlock)\r\nif ((aClass):isString())==true then return ((self):handleInstancesOf_with_((self):classNamed_(aClass),aBlock)); end;\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((aClass))),(function()\r\nreturn (((aClass):withAllSubclasses()):do_((function(cls)\r\nreturn ((self[\"@objectHandlers\"]):at_put_((cls):name(),aBlock))\r\nend)))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"cantHandleInstancesOf:",0
,function(self,aClass)
if ((aClass):isArray())==true then return ((aClass):do_((function(each)
return ((self):cantHandleInstancesOf_(each))
end))); end;
if ((aClass):isString())==true then return ((self):cantHandleInstancesOf_((self):classNamed_(aClass))); end;
return (smalltalk:if_true_false_((smalltalk:notNil_((aClass))),(function()
return ((self):handleInstancesOf_with_(aClass,(self):cantHandleBlock()))
end),nil));
end
,"configuration","cantHandleInstancesOf: aClass\r\n\t\" Private - Set the receiver to do NOT handle instances of aClass and subclasses.\r\n\tNote that aClass can be a class, a name of a class or an array of classes/classNames \"\r\n\r\n\taClass isArray ifTrue: [ ^aClass do: [:each| self cantHandleInstancesOf: each ] ].\r\n\taClass isString ifTrue: [ ^self cantHandleInstancesOf: (self classNamed: aClass) ].\r\n\t^aClass notNil ifTrue: [ self handleInstancesOf: aClass with: self cantHandleBlock ]","function(self,aClass)\r\nif ((aClass):isArray())==true then return ((aClass):do_((function(each)\r\nreturn ((self):cantHandleInstancesOf_(each))\r\nend))); end;\r\nif ((aClass):isString())==true then return ((self):cantHandleInstancesOf_((self):classNamed_(aClass))); end;\r\nreturn (smalltalk:if_true_false_((smalltalk:notNil_((aClass))),(function()\r\nreturn ((self):handleInstancesOf_with_(aClass,(self):cantHandleBlock()))\r\nend),nil));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"initializeVSEObjectHandlers",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):cantHandleInstancesOf_(smalltalk:newArray({"BlockClosure", "CallBack", "NotificationManager", "Context", "ExternalBuffer", "ExternalHandle", "FileSystemEntity", "Font", "Menu", "FileStream", "ViewManager", "Window", "WinLogicalObject"}));
	(_s8_rec):cantHandleInstancesOf_("Collection");
	(_s8_rec):handleMembersOf_with_("Dictionary",(self):dictionaryHandleBlock());
	(_s8_rec):handleMembersOf_with_("PoolDictionary",(self):dictionaryHandleBlock());
	(_s8_rec):handleInstancesOf_with_("Set",(self):asArrayHandleBlock());
	(_s8_rec):handleInstancesOf_with_("ActionSequence",(self):defaultHandleBlock());
	(_s8_rec):cantHandleInstancesOf_("ByteArray");
	(_s8_rec):handleInstancesOf_with_("Interval",(self):defaultHandleBlock());
	(_s8_rec):handleInstancesOf_with_("OrderedCollection",(self):asArrayHandleBlock());
	(_s8_rec):handleInstancesOf_with_("Array",(self):asArrayHandleBlock());
	(_s8_rec):handleInstancesOf_with_("TimeStamp",(self):timeStampHandleBlock());
	return ((_s8_rec):yourself())
end
)(self);
return (self);
end
,"configuration","initializeVSEObjectHandlers\r\n\t\" Private - Initialize the handlers to map VSE objects. \"\r\n\r\n\tself\tcantHandleInstancesOf: #(\r\n\t\t\t#BlockClosure #CallBack\r\n\t\t\t#NotificationManager\r\n\t\t\t#Context #ExternalBuffer\r\n\t\t\t#ExternalHandle #FileSystemEntity\r\n\t\t\t#Font #Menu #FileStream\r\n\t\t\t#ViewManager #Window\r\n\t\t\t#WinLogicalObject\r\n\t\t);\r\n\t\tcantHandleInstancesOf: #Collection; \"abstract\"\r\n\t\thandleMembersOf: #Dictionary with: self dictionaryHandleBlock;\r\n\t\thandleMembersOf: #PoolDictionary with: self dictionaryHandleBlock;\r\n\t\thandleInstancesOf: #Set with: self asArrayHandleBlock;\r\n\t\thandleInstancesOf: #ActionSequence with: self defaultHandleBlock;\r\n\t\tcantHandleInstancesOf: #ByteArray; \"handleInstancesOf: #ByteArray with: self bytesHandleBlock;\"\r\n\t\thandleInstancesOf: #Interval with: self defaultHandleBlock;\r\n\t\thandleInstancesOf: #OrderedCollection with: self asArrayHandleBlock;\r\n\t\thandleInstancesOf: #Array with: self asArrayHandleBlock;\r\n\t\thandleInstancesOf: #TimeStamp with: self timeStampHandleBlock;\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cantHandleInstancesOf_(smalltalk:newArray({\"BlockClosure\", \"CallBack\", \"NotificationManager\", \"Context\", \"ExternalBuffer\", \"ExternalHandle\", \"FileSystemEntity\", \"Font\", \"Menu\", \"FileStream\", \"ViewManager\", \"Window\", \"WinLogicalObject\"}));\r\n\t(_s8_rec):cantHandleInstancesOf_(\"Collection\");\r\n\t(_s8_rec):handleMembersOf_with_(\"Dictionary\",(self):dictionaryHandleBlock());\r\n\t(_s8_rec):handleMembersOf_with_(\"PoolDictionary\",(self):dictionaryHandleBlock());\r\n\t(_s8_rec):handleInstancesOf_with_(\"Set\",(self):asArrayHandleBlock());\r\n\t(_s8_rec):handleInstancesOf_with_(\"ActionSequence\",(self):defaultHandleBlock());\r\n\t(_s8_rec):cantHandleInstancesOf_(\"ByteArray\");\r\n\t(_s8_rec):handleInstancesOf_with_(\"Interval\",(self):defaultHandleBlock());\r\n\t(_s8_rec):handleInstancesOf_with_(\"OrderedCollection\",(self):asArrayHandleBlock());\r\n\t(_s8_rec):handleInstancesOf_with_(\"Array\",(self):asArrayHandleBlock());\r\n\t(_s8_rec):handleInstancesOf_with_(\"TimeStamp\",(self):timeStampHandleBlock());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"initializeS8ObjectHandlers",0
,function(self)
(
function(_s8_rec)
	(_s8_rec):cantHandleInstancesOf_(smalltalk:newArray({"BlockClosure", "Context", "CompiledMethod", "CompilerNode", "NativeObject", "PPParser"}));
	(_s8_rec):cantHandleInstancesOf_("Collection");
	(_s8_rec):handleMembersOf_with_("Dictionary",(self):dictionaryHandleBlock());
	(_s8_rec):handleMembersOf_with_("PoolDictionary",(self):dictionaryHandleBlock());
	(_s8_rec):handleInstancesOf_with_("Set",(self):asArrayHandleBlock());
	(_s8_rec):handleInstancesOf_with_("ActionSequence",(self):defaultHandleBlock());
	(_s8_rec):handleInstancesOf_with_("Array",(self):asArrayHandleBlock());
	(_s8_rec):handleInstancesOf_with_("DateTime",(self):dateTimeHandleBlock());
	return ((_s8_rec):yourself())
end
)(self);
return (self);
end
,"configuration","initializeS8ObjectHandlers\r\n\t\" Private - Initialize the handlers to map S8 objects. \"\r\n\r\n\tself\tcantHandleInstancesOf: #(\r\n\t\t\t#BlockClosure #Context\r\n\t\t\t#CompiledMethod #CompilerNode\r\n\t\t\t#NativeObject #PPParser\r\n\t\t);\r\n\t\tcantHandleInstancesOf: #Collection; \"abstract\"\r\n\t\thandleMembersOf: #Dictionary with: self dictionaryHandleBlock;\r\n\t\thandleMembersOf: #PoolDictionary with: self dictionaryHandleBlock;\r\n\t\thandleInstancesOf: #Set with: self asArrayHandleBlock;\r\n\t\thandleInstancesOf: #ActionSequence with: self defaultHandleBlock;\r\n\t\thandleInstancesOf: #Array with: self asArrayHandleBlock;\r\n\t\thandleInstancesOf: #DateTime with: self dateTimeHandleBlock;\r\n\t\tyourself","function(self)\r\n(\r\nfunction(_s8_rec)\r\n\t(_s8_rec):cantHandleInstancesOf_(smalltalk:newArray({\"BlockClosure\", \"Context\", \"CompiledMethod\", \"CompilerNode\", \"NativeObject\", \"PPParser\"}));\r\n\t(_s8_rec):cantHandleInstancesOf_(\"Collection\");\r\n\t(_s8_rec):handleMembersOf_with_(\"Dictionary\",(self):dictionaryHandleBlock());\r\n\t(_s8_rec):handleMembersOf_with_(\"PoolDictionary\",(self):dictionaryHandleBlock());\r\n\t(_s8_rec):handleInstancesOf_with_(\"Set\",(self):asArrayHandleBlock());\r\n\t(_s8_rec):handleInstancesOf_with_(\"ActionSequence\",(self):defaultHandleBlock());\r\n\t(_s8_rec):handleInstancesOf_with_(\"Array\",(self):asArrayHandleBlock());\r\n\t(_s8_rec):handleInstancesOf_with_(\"DateTime\",(self):dateTimeHandleBlock());\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)(self);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"prepareFor:",0
,function(self,anObject)
if (smalltalk:isNil_((self["@rememberedSet"])))==true then (self):initializeRememberedSet(); end;
if (smalltalk:isNil_((self["@id"])))==true then (function()
	local _s8_value=(((self["@rememberedSet"]):size()):_plus(1))
	self["@id"]=_s8_value
	return _s8_value
end)(); end;
if (smalltalk:isNil_((self["@objectHandlers"])))==true then (self):initializeObjectHandlers(); end;
(self):triggerEvent_with_("prepare:",anObject);
return (self);
end
,"configuration","prepareFor: anObject\r\n\t\" Private - Prepare the receiver to work on anObject. \"\r\n\r\n\trememberedSet isNil ifTrue: [ self initializeRememberedSet ].\r\n\tid isNil ifTrue: [ id := rememberedSet size + 1 ].\r\n\tobjectHandlers isNil ifTrue: [ self initializeObjectHandlers ].\r\n\tself triggerEvent: #prepare: with: anObject","function(self,anObject)\r\nif (smalltalk:isNil_((self[\"@rememberedSet\"])))==true then (self):initializeRememberedSet(); end;\r\nif (smalltalk:isNil_((self[\"@id\"])))==true then (function()\r\n\tlocal _s8_value=(((self[\"@rememberedSet\"]):size()):_plus(1))\r\n\tself[\"@id\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\nif (smalltalk:isNil_((self[\"@objectHandlers\"])))==true then (self):initializeObjectHandlers(); end;\r\n(self):triggerEvent_with_(\"prepare:\",anObject);\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"@","_at"
,function(self,anObject)
return ((self):literalForOne_(anObject));
end
,"accessing","@ anObject\r\n\t\" Returns the literal to send to target to obtain a copy of anObject.\r\n\tClose the receiver after encoding anObject. \"\r\n\r\n\t^self literalForOne: anObject","function(self,anObject)\r\nreturn ((self):literalForOne_(anObject));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"literalForOne:",0
,function(self,anObject)
local result=nil
(function()
	local _s8_value=((self):literalFor_(anObject))
	result=_s8_value
	return _s8_value
end)();
(self):close();
return (result);
end
,"accessing","literalForOne: anObject\r\n\t\" Returns the literal to send to target to obtain a copy of anObject.\r\n\tClose the receiver after encoding anObject. \"\r\n\r\n\t| result |\r\n\tresult := self literalFor: anObject.\r\n\tself close.\r\n\t^result","function(self,anObject)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((self):literalFor_(anObject))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):close();\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"literalFor:",0
,function(self,anObject)
(self):prepareFor_(anObject);
return ((self):stringify_object_((self):mapFor_(anObject),anObject));
end
,"accessing","literalFor: anObject\r\n\t\" Returns the literal to send to target to obtain a copy of anObject. \"\r\n\r\n\tself prepareFor: anObject.\r\n\t^self stringify: (self mapFor: anObject) object: anObject","function(self,anObject)\r\n(self):prepareFor_(anObject);\r\nreturn ((self):stringify_object_((self):mapFor_(anObject),anObject));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"stringifierFor:",0
,function(self,structure)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
if (smalltalk:responds_to_((structure),("asJSON")))==true then local j=nil
(function()
	local _s8_value=((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_("JSON",(function()
return (nil)
end)))
	j=_s8_value
	return _s8_value
end)();
smalltalk:if_true_false_((smalltalk:notNil_((j))),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ("asJSON")
end
)()
error(_s8Ret_,0)
end)())
end),nil); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (self)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"constants","stringifierFor: structure\r\n\t\" Returns the default stringifier to emmit structure.\r\n\tNote that on S8 we will use native JSON if present.\r\n\tIf structure do not respondsTo #asJSON the receiver will format the output\r\n\t\"\r\n\r\n\t(structure respondsTo: #asJSON) ifTrue: [ | j |\r\n\t\tj := Smalltalk nativeObjectAt: #JSON ifAbsent: [].\r\n\t\tj notNil ifTrue: [ ^#asJSON ]\r\n\t].\r\n\t^self","function(self,structure)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nif (smalltalk:responds_to_((structure),(\"asJSON\")))==true then local j=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Smalltalk):nativeObjectAt_ifAbsent_(\"JSON\",(function()\r\nreturn (nil)\r\nend)))\r\n\tj=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nsmalltalk:if_true_false_((smalltalk:notNil_((j))),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (\"asJSON\")\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (self)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Stringifier,"stringify:object:",0
,function(self,aMap,anObject)
local package=nil
local stringifier=nil
(function()
	local _s8_value=((self):packageWith_(aMap))
	package=_s8_value
	return _s8_value
end)();
(function()
	local _s8_value=((self):triggerEvent_ifNotHandled_("needsStringifier",(function()
return ((self):stringifierFor_(package))
end)))
	stringifier=_s8_value
	return _s8_value
end)();
if ((stringifier):isString())==true then return ((package):perform_(stringifier)); end;
return ((stringifier):stringify_(package));
end
,"stringify","stringify: aMap object: anObject\r\n\t\" Private - Returns a string literal from aMap. \"\r\n\r\n\t| package stringifier |\r\n\tpackage := self packageWith: aMap.\r\n\tstringifier := self\r\n\t\ttriggerEvent: #needsStringifier\r\n\t\tifNotHandled: [ self stringifierFor: package ].\r\n\tstringifier isString ifTrue: [ ^package perform: stringifier ].\r\n\t^stringifier stringify: package","function(self,aMap,anObject)\r\nlocal package=nil\r\nlocal stringifier=nil\r\n(function()\r\n\tlocal _s8_value=((self):packageWith_(aMap))\r\n\tpackage=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(function()\r\n\tlocal _s8_value=((self):triggerEvent_ifNotHandled_(\"needsStringifier\",(function()\r\nreturn ((self):stringifierFor_(package))\r\nend)))\r\n\tstringifier=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((stringifier):isString())==true then return ((package):perform_(stringifier)); end;\r\nreturn ((stringifier):stringify_(package));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"mapFor:",0
,function(self,anObject)
local selector=nil
(function()
	local _s8_value=((self):selectorFor_(anObject))
	selector=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_((selector),"literal"))==true then return ((self):mapForLiteral_(anObject)); end;
if (smalltalk:isObject_equalTo_((selector),"array"))==true then return ((self):mapForArray_(anObject)); end;
if (smalltalk:isObject_equalTo_((selector),"class"))==true then return ((self):referenceToClass_(anObject)); end;
if (smalltalk:isObject_equalTo_((selector),"object"))==true then return ((self):mapForObject_(anObject)); end;
return ((self):error_("Invalid selector"));
end
,"mapping","mapFor: anObject\r\n\t\" Private - Returns the map to export anObject. \"\r\n\r\n\t| selector |\r\n\tselector := self selectorFor: anObject.\r\n\tselector = #literal ifTrue: [ ^self mapForLiteral: anObject ].\r\n\tselector = #array ifTrue: [ ^self mapForArray: anObject ].\r\n\tselector = #class ifTrue: [ ^self referenceToClass: anObject ].\r\n\tselector = #object ifTrue: [ ^self mapForObject: anObject ].\r\n\t^self error: 'Invalid selector'","function(self,anObject)\r\nlocal selector=nil\r\n(function()\r\n\tlocal _s8_value=((self):selectorFor_(anObject))\r\n\tselector=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_((selector),\"literal\"))==true then return ((self):mapForLiteral_(anObject)); end;\r\nif (smalltalk:isObject_equalTo_((selector),\"array\"))==true then return ((self):mapForArray_(anObject)); end;\r\nif (smalltalk:isObject_equalTo_((selector),\"class\"))==true then return ((self):referenceToClass_(anObject)); end;\r\nif (smalltalk:isObject_equalTo_((selector),\"object\"))==true then return ((self):mapForObject_(anObject)); end;\r\nreturn ((self):error_(\"Invalid selector\"));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"selectorFor:",0
,function(self,anObject)
if (smalltalk:isNil_((anObject)))==true then return ("literal"); end;
if (smalltalk:boolean_or_(((anObject):isString()),(function()
return (smalltalk:boolean_or_(((anObject):isNumber()),(function()
return (smalltalk:boolean_or_((((anObject)==true)),(function()
return (((anObject)==false))
end)))
end)))
end)))==true then return ("literal"); end;
if (smalltalk:is_kindOf_((anObject),(smalltalk.Behavior)))==true then return ("class"); end;
return ("object");
end
,"mapping","selectorFor: anObject\r\n\t\" Private - Returns the keyword to represent anObject as a literal or well known object. \"\r\n\r\n\tanObject isNil ifTrue: [ ^#literal ].\r\n\t(anObject isString\r\n\t\tor: [ anObject isNumber\r\n\t\tor: [ anObject == true\r\n\t\tor: [anObject == false]]]) ifTrue: [ ^#literal ].\r\n\t(anObject isKindOf: Behavior) ifTrue: [ ^#class ].\r\n\t^#object","function(self,anObject)\r\nif (smalltalk:isNil_((anObject)))==true then return (\"literal\"); end;\r\nif (smalltalk:boolean_or_(((anObject):isString()),(function()\r\nreturn (smalltalk:boolean_or_(((anObject):isNumber()),(function()\r\nreturn (smalltalk:boolean_or_((((anObject)==true)),(function()\r\nreturn (((anObject)==false))\r\nend)))\r\nend)))\r\nend)))==true then return (\"literal\"); end;\r\nif (smalltalk:is_kindOf_((anObject),(smalltalk.Behavior)))==true then return (\"class\"); end;\r\nreturn (\"object\");\r\nend")

smalltalk:bind(smalltalk.Stringifier,"associationsIn:",0
,function(self,aDictionary)
local keys=nil
(function()
	local _s8_value=(((aDictionary):keys()):asArray())
	keys=_s8_value
	return _s8_value
end)();
return ((keys):collect_((function(each)
return ((aDictionary):associationAt_(each))
end)));
end
,"mapping","associationsIn: aDictionary\r\n\t\" Private - Returns the associations contained in aDictionary. \"\r\n\r\n\t| keys |\r\n\tkeys :=  aDictionary keys asArray.\r\n\t^keys collect: [:each| aDictionary associationAt: each ]","function(self,aDictionary)\r\nlocal keys=nil\r\n(function()\r\n\tlocal _s8_value=(((aDictionary):keys()):asArray())\r\n\tkeys=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn ((keys):collect_((function(each)\r\nreturn ((aDictionary):associationAt_(each))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"newMap",0
,function(self)
return ((
function(_s8_rec)
	(_s8_rec):at_put_("id",self["@id"]);
	return ((_s8_rec):yourself())
end
)((smalltalk.PoolDictionary):new()));
end
,"mapping","newMap\r\n\t\" Private - Returns a new map to host current object id. \"\r\n\r\n\t^PoolDictionary new\r\n\t\tat: #id put: id;\r\n\t\tyourself","function(self)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(\"id\",self[\"@id\"]);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.PoolDictionary):new()));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"mapForLiteral:",0
,function(self,literal)
if ((literal):isNumber())==true then if ((((literal)["$klass"])==smalltalk.Number))==true then return (literal); end;
if ((literal):isInteger())==true then return (literal); end;
if ((literal):isFloat())==true then return ((self):mapForFloat_(literal)); end;
return ((self):mapForObject_(literal)); end;
if ((literal):isString())==true then return ((self):mapForString_(literal)); end;
return (literal);
end
,"mapping","mapForLiteral: literal\r\n\t\" Private - Returns the map to export a literal. \"\r\n\r\n\tliteral isNumber ifTrue: [\r\n\t\tliteral class == Number ifTrue: [ ^literal ].\r\n\t\tliteral isInteger ifTrue: [ ^literal ].\r\n\t\tliteral isFloat ifTrue: [ ^self mapForFloat: literal ].\r\n\t\t^self mapForObject: literal\r\n\t].\r\n\tliteral isString ifTrue: [\r\n\t\t^self mapForString: literal\r\n\t].\r\n\t^literal","function(self,literal)\r\nif ((literal):isNumber())==true then if ((((literal)[\"$klass\"])==smalltalk.Number))==true then return (literal); end;\r\nif ((literal):isInteger())==true then return (literal); end;\r\nif ((literal):isFloat())==true then return ((self):mapForFloat_(literal)); end;\r\nreturn ((self):mapForObject_(literal)); end;\r\nif ((literal):isString())==true then return ((self):mapForString_(literal)); end;\r\nreturn (literal);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"mapForString:",0
,function(self,literal)
return (smalltalk:if_true_false_(((self):hasTag_(literal)),(function()
return (smalltalk:object_comma_(((self):tagStart()),literal))
end),(function()
return (literal)
end)));
end
,"mapping","mapForString: literal\r\n\t\" Private - Returns the map to export string literal. \"\r\n\r\n\t^(self hasTag: literal) ifTrue: [self tagStart ,literal] ifFalse: [literal]","function(self,literal)\r\nreturn (smalltalk:if_true_false_(((self):hasTag_(literal)),(function()\r\nreturn (smalltalk:object_comma_(((self):tagStart()),literal))\r\nend),(function()\r\nreturn (literal)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"mapForFloat:",0
,function(self,aFloat)
return (aFloat);
end
,"mapping","mapForFloat: aFloat\r\n\t\" Private - Returns the map to export aFloat. \"\r\n\r\n\t^aFloat","function(self,aFloat)\r\nreturn (aFloat);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"mapForArray:",0
,function(self,anArray)
return ((anArray):collect_((function(each)
return ((self):mapFor_(each))
end)));
end
,"mapping","mapForArray: anArray\r\n\t\" Private - Returns the map to export anArray. \"\r\n\r\n\t^anArray collect: [:each| self mapFor: each ]","function(self,anArray)\r\nreturn ((anArray):collect_((function(each)\r\nreturn ((self):mapFor_(each))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"referenceToClass:",0
,function(self,aClass)
return ((self):referenceTo_ifAbsent_(aClass,(function()
local ref=nil
local ivn=nil
(function()
	local _s8_value=((self):newMap())
	ref=_s8_value
	return _s8_value
end)();(ref):at_put_("global",(self):nameOfClass_(aClass));(function()
	local _s8_value=((aClass):allInstVarNames())
	ivn=_s8_value
	return _s8_value
end)();if ((ivn):notEmpty())==true then (ref):at_put_("allInstVarNames",ivn); end;return (ref)
end)));
end
,"mapping","referenceToClass: aClass\r\n\t\" Private - Returns the map to reference aClass in target system. \"\r\n\r\n\t^self referenceTo: aClass ifAbsent: [ | ref ivn |\r\n\t\tref := self newMap.\r\n\t\tref at: #global put: (self nameOfClass: aClass).\r\n\t\tivn := aClass allInstVarNames.\r\n\t\tivn notEmpty ifTrue: [ ref at: #allInstVarNames put: ivn ].\r\n\t\tref\r\n\t]","function(self,aClass)\r\nreturn ((self):referenceTo_ifAbsent_(aClass,(function()\r\nlocal ref=nil\r\nlocal ivn=nil\r\n(function()\r\n\tlocal _s8_value=((self):newMap())\r\n\tref=_s8_value\r\n\treturn _s8_value\r\nend)();(ref):at_put_(\"global\",(self):nameOfClass_(aClass));(function()\r\n\tlocal _s8_value=((aClass):allInstVarNames())\r\n\tivn=_s8_value\r\n\treturn _s8_value\r\nend)();if ((ivn):notEmpty())==true then (ref):at_put_(\"allInstVarNames\",ivn); end;return (ref)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"nameOfClass:",0
,function(self,aClass)
if ((aClass):isClass())==true then return ((aClass):name()); end;
return ((smalltalk.Array):with_with_(((aClass):instanceClass()):name(),"class"));
end
,"mapping","nameOfClass: aClass\r\n\t\" Private - Returns a literal to reference aClass by name. \"\r\n\r\n\taClass isClass ifTrue: [ ^aClass name ].\r\n\t^Array with: aClass instanceClass name with: #class","function(self,aClass)\r\nif ((aClass):isClass())==true then return ((aClass):name()); end;\r\nreturn ((smalltalk.Array):with_with_(((aClass):instanceClass()):name(),\"class\"));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"newMapForObject:",0
,function(self,anObject)
return ((
function(_s8_rec)
	(_s8_rec):at_put_("class",(self):referenceToClass_((anObject)["$klass"]));
	return ((_s8_rec):yourself())
end
)((self):newMap()));
end
,"mapping","newMapForObject: anObject\r\n\t\" Private - Returns a new/clean map literal to anObject structure. \"\r\n\r\n\t^self newMap\r\n\t\tat: #class put: (self referenceToClass: anObject class);\r\n\t\tyourself","function(self,anObject)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(\"class\",(self):referenceToClass_((anObject)[\"$klass\"]));\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((self):newMap()));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"basicMapForObject:",0
,function(self,anObject)
local map=nil
(function()
	local _s8_value=((self):newMapForObject_(anObject))
	map=_s8_value
	return _s8_value
end)();
(self):storeFieldsOf_into_(anObject,map);
return (map);
end
,"mapping","basicMapForObject: anObject\r\n\t\" Private - Returns a new map literal to anObject structure. \"\r\n\r\n\t| map |\r\n\tmap := self newMapForObject: anObject.\r\n\tself storeFieldsOf: anObject into: map.\r\n\t^map","function(self,anObject)\r\nlocal map=nil\r\n(function()\r\n\tlocal _s8_value=((self):newMapForObject_(anObject))\r\n\tmap=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):storeFieldsOf_into_(anObject,map);\r\nreturn (map);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"mapForObject:",0
,function(self,anObject)
return ((self):referenceTo_ifAbsent_(anObject,(function()
local none=nil
local mapper=nil
(function()
	local _s8_value=("none")
	none=_s8_value
	return _s8_value
end)();(function()
	local _s8_value=((self["@objectHandlers"]):at_ifAbsentPut_(((anObject)["$klass"]):name(),(function()
return ((self):triggerEvent_withArguments_ifNotHandled_("needsHandlerFor:",(smalltalk.Array):with_((anObject)["$klass"]),(function()
return (none)
end)))
end)))
	mapper=_s8_value
	return _s8_value
end)();return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((mapper),none)),(function()
return ((self):basicMapForObject_(anObject))
end),(function()
return ((mapper):value_value_(anObject,self))
end)))
end)));
end
,"mapping","mapForObject: anObject\r\n\t\" Private - Returns the map to export anObject. \"\r\n\r\n\t^self referenceTo: anObject ifAbsent: [ | none mapper |\r\n\t\tnone := #none.\r\n\t\tmapper := objectHandlers at: anObject class name ifAbsentPut: [\r\n\t\t\tself\ttriggerEvent: #needsHandlerFor:\r\n\t\t\t\twithArguments: (Array with: anObject class)\r\n\t\t\t\tifNotHandled: [none]\r\n\t\t].\r\n\t\tmapper = none\r\n\t\t\tifTrue: [ self basicMapForObject: anObject ]\r\n\t\t\tifFalse: [ mapper value: anObject value: self ]\r\n\t]","function(self,anObject)\r\nreturn ((self):referenceTo_ifAbsent_(anObject,(function()\r\nlocal none=nil\r\nlocal mapper=nil\r\n(function()\r\n\tlocal _s8_value=(\"none\")\r\n\tnone=_s8_value\r\n\treturn _s8_value\r\nend)();(function()\r\n\tlocal _s8_value=((self[\"@objectHandlers\"]):at_ifAbsentPut_(((anObject)[\"$klass\"]):name(),(function()\r\nreturn ((self):triggerEvent_withArguments_ifNotHandled_(\"needsHandlerFor:\",(smalltalk.Array):with_((anObject)[\"$klass\"]),(function()\r\nreturn (none)\r\nend)))\r\nend)))\r\n\tmapper=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_((mapper),none)),(function()\r\nreturn ((self):basicMapForObject_(anObject))\r\nend),(function()\r\nreturn ((mapper):value_value_(anObject,self))\r\nend)))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"storeFieldsOf:into:",0
,function(self,anObject,map)
if (smalltalk:isObject_equalTo_(((self):origin()),"VSE"))==true then return ((self):storeVSEFieldsOf_into_(anObject,map)); end;
if (smalltalk:isObject_equalTo_((self["@origin"]),"S8"))==true then return ((self):storeS8FieldsOf_into_(anObject,map)); end;
return ((self):error_("Unsupported origin"));
end
,"mapping","storeFieldsOf: anObject into: map\r\n\t\" Private - Store the contents of anObject into map. \"\r\n\r\n\tself origin = #VSE ifTrue: [ ^self storeVSEFieldsOf: anObject into: map ].\r\n\torigin = #S8 ifTrue: [ ^self storeS8FieldsOf: anObject into: map ].\r\n\t^self error: 'Unsupported origin' ","function(self,anObject,map)\r\nif (smalltalk:isObject_equalTo_(((self):origin()),\"VSE\"))==true then return ((self):storeVSEFieldsOf_into_(anObject,map)); end;\r\nif (smalltalk:isObject_equalTo_((self[\"@origin\"]),\"S8\"))==true then return ((self):storeS8FieldsOf_into_(anObject,map)); end;\r\nreturn ((self):error_(\"Unsupported origin\"));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"storeVSEFieldsOf:into:",0
,function(self,anObject,map)
(1):to_do_(((anObject)["$klass"]):instSize(),(function(i)
return ((map):at_put_(i,(self):mapFor_((anObject):instVarAt_(i))))
end));
return (self);
end
,"mapping","storeVSEFieldsOf: anObject into: map\r\n\t\" Private - Store the contents of anObject into map. \"\r\n\r\n\t1 to: anObject class instSize do: [:i|\r\n\t\tmap at: i put: (self mapFor: (anObject instVarAt: i))\r\n\t]","function(self,anObject,map)\r\n(1):to_do_(((anObject)[\"$klass\"]):instSize(),(function(i)\r\nreturn ((map):at_put_(i,(self):mapFor_((anObject):instVarAt_(i))))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"storeS8FieldsOf:into:",0
,function(self,anObject,map)
(((anObject)["$klass"]):allInstVarNames()):withIndexDo_((function(each,i)
return ((map):at_put_(i,(self):mapFor_((anObject):instVarAt_(each))))
end));
return (self);
end
,"mapping","storeS8FieldsOf: anObject into: map\r\n\t\" Private - Store the contents of anObject into map. \"\r\n\r\n\tanObject class allInstVarNames withIndexDo: [:each :i|\r\n\t\tmap at: i put: (self mapFor: (anObject instVarAt: each))\r\n\t]","function(self,anObject,map)\r\n(((anObject)[\"$klass\"]):allInstVarNames()):withIndexDo_((function(each,i)\r\nreturn ((map):at_put_(i,(self):mapFor_((anObject):instVarAt_(each))))\r\nend));\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"forgetObjects",0
,function(self)
if (smalltalk:notNil_((self["@markedObjects"])))==true then local markID=nil
(function()
	local _s8_value=((self):markID())
	markID=_s8_value
	return _s8_value
end)();
(self["@markedObjects"]):do_((function(each)
return ((each):basicDelete_(markID))
end)); end;
(function()
	local _s8_value=(nil)
	self["@markedObjects"]=_s8_value
	return _s8_value
end)();
return (self);
end
,"cache","forgetObjects\r\n\t\" Private - Forget/unmark the rememebered objects. \"\r\n\r\n\tmarkedObjects notNil ifTrue: [ | markID |\r\n\t\tmarkID := self markID.\r\n\t\tmarkedObjects do: [:each| each basicDelete: markID ]\r\n\t].\r\n\tmarkedObjects := nil","function(self)\r\nif (smalltalk:notNil_((self[\"@markedObjects\"])))==true then local markID=nil\r\n(function()\r\n\tlocal _s8_value=((self):markID())\r\n\tmarkID=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self[\"@markedObjects\"]):do_((function(each)\r\nreturn ((each):basicDelete_(markID))\r\nend)); end;\r\n(function()\r\n\tlocal _s8_value=(nil)\r\n\tself[\"@markedObjects\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"referenceTo:ifAbsent:",0
,function(self,anObject,aBlock)
return ((self["@rememberedSet"]):at_ifAbsent_(anObject,(function()
(self["@rememberedSet"]):at_put_(anObject,(self):newReference());return ((aBlock):value())
end)));
end
,"cache","referenceTo: anObject ifAbsent: aBlock\r\n\t\" Private - Save a new reference ID for anObject. \"\r\n\r\n\t^rememberedSet at: anObject ifAbsent: [\r\n\t\trememberedSet at: anObject put: self newReference.\r\n\t\taBlock value\r\n\t]","function(self,anObject,aBlock)\r\nreturn ((self[\"@rememberedSet\"]):at_ifAbsent_(anObject,(function()\r\n(self[\"@rememberedSet\"]):at_put_(anObject,(self):newReference());return ((aBlock):value())\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"newReference",0
,function(self)
(function()
	local _s8_value=((self["@id"]):_plus(1))
	self["@id"]=_s8_value
	return _s8_value
end)();
return (smalltalk:object_comma_(((self):tagStart()),smalltalk:asString_((self["@id"]))));
end
,"cache","newReference\r\n\t\" Private - Returns a new reference literal. \"\r\n\r\n\tid := id + 1.\r\n\t^self tagStart ,id asString","function(self)\r\n(function()\r\n\tlocal _s8_value=((self[\"@id\"]):_plus(1))\r\n\tself[\"@id\"]=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nreturn (smalltalk:object_comma_(((self):tagStart()),smalltalk:asString_((self[\"@id\"]))));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"at:ifAbsent:",0
,function(self,anObject,aBlock)
return (smalltalk:basic_at_ifAbsent_((anObject),(self):markID(),aBlock));
end
,"cache","at: anObject ifAbsent: aBlock\r\n\t\" Private - Returns the value catched for anObject or the result of evaluating aBlock.\r\n\tThis implementation is a default implementation for marking objects while walking when there is no support for IdentityDictionary.\r\n\t\"\r\n\r\n\t^anObject basicAt: self markID ifAbsent: aBlock","function(self,anObject,aBlock)\r\nreturn (smalltalk:basic_at_ifAbsent_((anObject),(self):markID(),aBlock));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"at:put:",0
,function(self,anObject,aValue)
if (smalltalk:isNil_((self["@markedObjects"])))==true then (function()
	local _s8_value=(smalltalk:newArray({}))
	self["@markedObjects"]=_s8_value
	return _s8_value
end)(); end;
(self["@markedObjects"]):add_(anObject);
smalltalk:basic_at_put_((anObject),(self):markID(),aValue);
return (aValue);
end
,"cache","at: anObject put: aValue\r\n\t\" Private - Set the value catched for anObject.\r\n\tThis implementation is a default implementation for marking objects while walking when there is no support for IdentityDictionary.\r\n\t\"\r\n\r\n\tmarkedObjects isNil ifTrue: [ markedObjects := #() ].\r\n\tmarkedObjects add: anObject.\r\n\tanObject basicAt: self markID put: aValue.\r\n\t^aValue","function(self,anObject,aValue)\r\nif (smalltalk:isNil_((self[\"@markedObjects\"])))==true then (function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tself[\"@markedObjects\"]=_s8_value\r\n\treturn _s8_value\r\nend)(); end;\r\n(self[\"@markedObjects\"]):add_(anObject);\r\nsmalltalk:basic_at_put_((anObject),(self):markID(),aValue);\r\nreturn (aValue);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"writeStream",0
,function(self)
if (smalltalk:isObject_equalTo_((self["@origin"]),"VSE"))==true then return ((""):asStream()); end;
return ((""):stream());
end
,"private","writeStream\r\n\t\" Private - Returns new write stream. \"\r\n\r\n\torigin = #VSE ifTrue: [ ^'' asStream ].\r\n\t^'' stream","function(self)\r\nif (smalltalk:isObject_equalTo_((self[\"@origin\"]),\"VSE\"))==true then return ((\"\"):asStream()); end;\r\nreturn ((\"\"):stream());\r\nend")

smalltalk:bind(smalltalk.Stringifier,"stringify:",0
,function(self,aMap)
local stream=nil
(function()
	local _s8_value=((self):writeStream())
	stream=_s8_value
	return _s8_value
end)();
(self):stringify_into_(aMap,stream);
return ((stream):contents());
end
,"stringify","stringify: aMap\r\n\t\" Private - Returns a string literal from map. \"\r\n\r\n\t| stream |\r\n\tstream := self writeStream.\r\n\tself stringify: aMap into: stream.\r\n\t^stream contents","function(self,aMap)\r\nlocal stream=nil\r\n(function()\r\n\tlocal _s8_value=((self):writeStream())\r\n\tstream=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n(self):stringify_into_(aMap,stream);\r\nreturn ((stream):contents());\r\nend")

smalltalk:bind(smalltalk.Stringifier,"packageWith:",0
,function(self,aMap)
return ((
function(_s8_rec)
	(_s8_rec):at_put_("origin",(self):origin());
	(_s8_rec):at_put_("id",self["@id"]);
	(_s8_rec):at_put_("contents",aMap);
	return ((_s8_rec):yourself())
end
)((smalltalk.PoolDictionary):new()));
end
,"stringify","packageWith: aMap\r\n\t\" Private - Returns aMap wrapped with information of the receiver. \"\r\n\r\n\t^PoolDictionary new\r\n\t\tat: #origin put: self origin;\r\n\t\tat: #id put: id;\r\n\t\tat: #contents put: aMap;\r\n\t\tyourself","function(self,aMap)\r\nreturn ((\r\nfunction(_s8_rec)\r\n\t(_s8_rec):at_put_(\"origin\",(self):origin());\r\n\t(_s8_rec):at_put_(\"id\",self[\"@id\"]);\r\n\t(_s8_rec):at_put_(\"contents\",aMap);\r\n\treturn ((_s8_rec):yourself())\r\nend\r\n)((smalltalk.PoolDictionary):new()));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"printFloat:into:",0
,function(self,literal,stream)
(literal):printOn_decimalSeparator_(stream,".");
return (self);
end
,"formating","printFloat: literal into: stream\r\n\t\" Private - Dump literal formated as JSON. \"\r\n\r\n\tliteral printOn: stream decimalSeparator: '.'","function(self,literal,stream)\r\n(literal):printOn_decimalSeparator_(stream,\".\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"hasTag:",0
,function(self,literal)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
local tag=nil
(function()
	local _s8_value=((self):tagStart())
	tag=_s8_value
	return _s8_value
end)();
if (smalltalk:isObject_equalTo_(((self):origin()),"S8"))==true then return ((literal):startsWith_(tag)); end;
if ((((tag):size()) > (literal):size()))==true then return (false); end;
(1):to_do_((tag):size(),(function(i)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tag):at_(i)),(literal):at_(i))),nil,(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (false)
end
)()
error(_s8Ret_,0)
end)())
end)))
end));
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return (true)
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"formating","hasTag: literal\r\n\t\" Private - Returns true if the literal starts with tagStart. \"\r\n\r\n\t| tag |\r\n\ttag := self tagStart.\r\n\tself origin = #S8 ifTrue: [ ^literal startsWith: tag ].\r\n\ttag size > literal size ifTrue: [ ^false ].\r\n\t1 to: tag size do: [:i|\r\n\t\t(tag at: i) = (literal at: i) ifFalse: [ ^false ]\r\n\t].\r\n\t^true","function(self,literal)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\nlocal tag=nil\r\n(function()\r\n\tlocal _s8_value=((self):tagStart())\r\n\ttag=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:isObject_equalTo_(((self):origin()),\"S8\"))==true then return ((literal):startsWith_(tag)); end;\r\nif ((((tag):size()) > (literal):size()))==true then return (false); end;\r\n(1):to_do_((tag):size(),(function(i)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tag):at_(i)),(literal):at_(i))),nil,(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (false)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend)))\r\nend));\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn (true)\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Stringifier,"jsonEscapeUnicode:",0
,function(self,ascii)
return (smalltalk:object_comma_(("u"),(ascii):printPaddedWith_to_base_("0",4,16)));
end
,"formating","jsonEscapeUnicode: ascii\r\n\t\" Private - Returns the escape sequence for unicode value. \"\r\n\r\n\t^'u' ,(ascii printPaddedWith: $0 to: 4 base: 16)","function(self,ascii)\r\nreturn (smalltalk:object_comma_((\"u\"),(ascii):printPaddedWith_to_base_(\"0\",4,16)));\r\nend")

smalltalk:bind(smalltalk.Stringifier,"jsonEscape:char:",0
,function(self,ascii,c)

local _s8Ret_={["name"]="stReturn"}
local _s8_f = function()
(smalltalk:newArray({smalltalk:newArray({10, "n"}), smalltalk:newArray({13, "r"}), smalltalk:newArray({9, "t"}), smalltalk:newArray({12, "f"}), smalltalk:newArray({8, "b"})})):do_((function(tuple)
return (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tuple):first()),ascii)),(function()
return ((function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((tuple):last())
end
)()
error(_s8Ret_,0)
end)())
end),nil))
end));
if not (((ascii):between_and_(32,126)))==true then (function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((self):jsonEscapeUnicode_(ascii))
end
)()
error(_s8Ret_,0)
end)(); end;
(function()
_s8Ret_.hasResult=true
_s8Ret_.result=(function()
return ((smalltalk.String):with_(c))
end
)()
error(_s8Ret_,0)
end)();
end
local _s8_status, _s8_result = pcall(_s8_f)
if _s8_status then return _s8_result
else
    if (_s8Ret_.hasResult) then
      return (_s8Ret_.result)
    end
end
error(_s8_result,0)

end
,"formating","jsonEscape: ascii char: c\r\n\t\" Private - Returns the escape sequence for ascii code. \"\r\n\r\n\t#( #(10 n) #(13 r) #(9 t) #(12 f) #(8 b) ) do: [:tuple|\r\n\t\ttuple first = ascii ifTrue: [ ^tuple last ]\r\n\t].\r\n\t(ascii between: 32 and: 126) ifFalse: [\r\n\t\t^self jsonEscapeUnicode: ascii\r\n\t].\r\n\t^String with: c","function(self,ascii,c)\r\n\r\nlocal _s8Ret_={[\"name\"]=\"stReturn\"}\r\nlocal _s8_f = function()\r\n(smalltalk:newArray({smalltalk:newArray({10, \"n\"}), smalltalk:newArray({13, \"r\"}), smalltalk:newArray({9, \"t\"}), smalltalk:newArray({12, \"f\"}), smalltalk:newArray({8, \"b\"})})):do_((function(tuple)\r\nreturn (smalltalk:if_true_false_((smalltalk:isObject_equalTo_(((tuple):first()),ascii)),(function()\r\nreturn ((function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((tuple):last())\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)())\r\nend),nil))\r\nend));\r\nif not (((ascii):between_and_(32,126)))==true then (function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((self):jsonEscapeUnicode_(ascii))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)(); end;\r\n(function()\r\n_s8Ret_.hasResult=true\r\n_s8Ret_.result=(function()\r\nreturn ((smalltalk.String):with_(c))\r\nend\r\n)()\r\nerror(_s8Ret_,0)\r\nend)();\r\nend\r\nlocal _s8_status, _s8_result = pcall(_s8_f)\r\nif _s8_status then return _s8_result\r\nelse\r\n    if (_s8Ret_.hasResult) then\r\n      return (_s8Ret_.result)\r\n    end\r\nend\r\nerror(_s8_result,0)\r\n\r\nend")

smalltalk:bind(smalltalk.Stringifier,"jsonEncodeChar:into:",0
,function(self,c,stream)
local ascii=nil
(function()
	local _s8_value=((c):asciiValue())
	ascii=_s8_value
	return _s8_value
end)();
if (smalltalk:boolean_or_((((ascii) < 32)),(function()
return (smalltalk:boolean_or_((((ascii) > 126)),(function()
return ((smalltalk:newArray({34, 92, 47})):includes_(ascii))
end)))
end)))==true then (
function(_s8_rec)
	(_s8_rec):nextPut_("\\");
	return ((_s8_rec):nextPutAll_((self):jsonEscape_char_(ascii,c)))
end
)(stream); else (stream):nextPut_(c); end;
return (self);
end
,"formating","jsonEncodeChar: c into: stream\r\n\t\" Private - Encode character c into stream.\r\n\tSee https://www.json.org/\r\n\t\"\r\n\r\n\t| ascii |\r\n\tascii := c asciiValue.\r\n\t(ascii < 32 or: [ascii > 126 or: [ #(34 92 47) includes: ascii ]])\r\n\tifTrue: [ stream nextPut: $\\; nextPutAll: (self jsonEscape: ascii char: c) ]\r\n\tifFalse: [ stream nextPut: c ]","function(self,c,stream)\r\nlocal ascii=nil\r\n(function()\r\n\tlocal _s8_value=((c):asciiValue())\r\n\tascii=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif (smalltalk:boolean_or_((((ascii) < 32)),(function()\r\nreturn (smalltalk:boolean_or_((((ascii) > 126)),(function()\r\nreturn ((smalltalk:newArray({34, 92, 47})):includes_(ascii))\r\nend)))\r\nend)))==true then (\r\nfunction(_s8_rec)\r\n\t(_s8_rec):nextPut_(\"\\\\\");\r\n\treturn ((_s8_rec):nextPutAll_((self):jsonEscape_char_(ascii,c)))\r\nend\r\n)(stream); else (stream):nextPut_(c); end;\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"printString:into:",0
,function(self,literal,stream)
(stream):nextPut_("\"");
(smalltalk:asString_((literal))):do_((function(c)
return ((self):jsonEncodeChar_into_(c,stream))
end));
(stream):nextPut_("\"");
return (self);
end
,"formating","printString: literal into: stream\r\n\t\" Private - Dump literal formated as JSON. \"\r\n\r\n\tstream nextPut: $\".\r\n\tliteral asString do: [:c| self jsonEncodeChar: c into: stream ].\r\n\tstream nextPut: $\"","function(self,literal,stream)\r\n(stream):nextPut_(\"\\\"\");\r\n(smalltalk:asString_((literal))):do_((function(c)\r\nreturn ((self):jsonEncodeChar_into_(c,stream))\r\nend));\r\n(stream):nextPut_(\"\\\"\");\r\nreturn (self);\r\nend")

smalltalk:bind(smalltalk.Stringifier,"stringify:into:",0
,function(self,literal,stream)
if (smalltalk:isNil_((literal)))==true then return ((stream):nextPutAll_("null")); end;
if ((literal):isArray())==true then (stream):nextPut_("[");
(literal):do_andBetweenDo_((function(each)
return ((self):stringify_into_(each,stream))
end),(function()
return ((stream):nextPut_(","))
end));
(stream):nextPut_("]");
return (self); end;
if ((literal):isMemberOf_(smalltalk.PoolDictionary))==true then (stream):nextPut_("{");
((literal):keys()):do_andBetweenDo_((function(key)
(self):printString_into_(key,stream);(stream):nextPut_(":");return ((self):stringify_into_((literal):at_(key),stream))
end),(function()
return ((stream):nextPut_(","))
end));
(stream):nextPut_("}");
return (self); end;
if ((literal):isString())==true then return ((self):printString_into_(literal,stream)); end;
if (smalltalk:boolean_and_(((literal):isNumber()),(function()
return (smalltalk:isObject_equalTo_((((literal)["$klass"]):name()),"Float"))
end)))==true then return ((self):printFloat_into_(literal,stream)); end;
(stream):nextPutAll_(smalltalk:printString_((literal)));
return (self);
end
,"stringify","stringify: literal into: stream\r\n\t\" Private - Dump literal onto stream. \"\r\n\r\n\tliteral isNil ifTrue: [ ^stream nextPutAll: #null ].\r\n\tliteral isArray ifTrue: [\r\n\t\tstream nextPut: $[.\r\n\t\tliteral\tdo: [:each| self stringify: each into: stream ]\r\n\t\t\tandBetweenDo: [ stream nextPut: $, ].\r\n\t\tstream nextPut: $].\r\n\t\t^self\r\n\t].\r\n\t(literal isMemberOf: PoolDictionary) ifTrue: [\r\n\t\tstream nextPut: ${.\r\n\t\tliteral keys do: [:key|\r\n\t\t\tself printString: key into: stream.\r\n\t\t\tstream nextPut: $:.\r\n\t\t\tself stringify: (literal at: key) into: stream ]\r\n\t\t\tandBetweenDo: [ stream nextPut: $, ].\r\n\t\tstream nextPut: $}.\r\n\t\t^self\r\n\t].\r\n\tliteral isString ifTrue: [\r\n\t\t^self printString: literal into: stream\r\n\t].\r\n\t(literal isNumber and: [literal class name = 'Float']) ifTrue: [\r\n\t\t^self printFloat: literal into: stream\r\n\t].\r\n\tstream nextPutAll: literal printString","function(self,literal,stream)\r\nif (smalltalk:isNil_((literal)))==true then return ((stream):nextPutAll_(\"null\")); end;\r\nif ((literal):isArray())==true then (stream):nextPut_(\"[\");\r\n(literal):do_andBetweenDo_((function(each)\r\nreturn ((self):stringify_into_(each,stream))\r\nend),(function()\r\nreturn ((stream):nextPut_(\",\"))\r\nend));\r\n(stream):nextPut_(\"]\");\r\nreturn (self); end;\r\nif ((literal):isMemberOf_(smalltalk.PoolDictionary))==true then (stream):nextPut_(\"{\");\r\n((literal):keys()):do_andBetweenDo_((function(key)\r\n(self):printString_into_(key,stream);(stream):nextPut_(\":\");return ((self):stringify_into_((literal):at_(key),stream))\r\nend),(function()\r\nreturn ((stream):nextPut_(\",\"))\r\nend));\r\n(stream):nextPut_(\"}\");\r\nreturn (self); end;\r\nif ((literal):isString())==true then return ((self):printString_into_(literal,stream)); end;\r\nif (smalltalk:boolean_and_(((literal):isNumber()),(function()\r\nreturn (smalltalk:isObject_equalTo_((((literal)[\"$klass\"]):name()),\"Float\"))\r\nend)))==true then return ((self):printFloat_into_(literal,stream)); end;\r\n(stream):nextPutAll_(smalltalk:printString_((literal)));\r\nreturn (self);\r\nend")
