"Patches to set SwikiCodeRobot for NLua8"!

! SwikiCodeRobot methodsFor: #defaults !
defaultDeferred
	" Private - Return true if the receiver run in deferred mode. "

	^false! !

! SwikiCodeRobot class methodsFor: #constants !
defaultFetch
	" Private - Returns the default fetch block. "

	^[:url :action| | html |
		html := NLua8 httpGet: url.
		#(	#('&amp;' $&) #('&nbsp;' $ )
			#('&lt;' $<) #('&gt;' $>)
			#('&quot;' $")
		) do: [:tuple| html := html replace: tuple first with: tuple last ].
		action value: html
	]! !

! SwikiCodeRobot class methodsFor: #constants !
fetch
	" Returns the fetch block (or nil). "

	Fetch isNil ifTrue: [ self fetch: self defaultFetch ].
	^Fetch! !