--[[
Make file used to build image from S8 kernel source files.
Copyright (C) 2018 Alejandro F. Reimondo <aleReimondo@smalltalking.net>
MIT License - See license.txt file
--]]
dofile("m8n.lua")
--print("--executing _make.lua")
local chunks = [[

#(	's8/start/Kernel.st'
	's8/start/Compiler.st'
	's8/start/Tools.st'
	's8/start/Builders.st'
	's8/start/Transcript.st'
	's8/start/Snapshot.st'
	's8/start/Natives.st'
	's8/start/Lua.st'
	's8/start/platform.st'
) emmit!

self fileIn: 's8/library/build.st'!
self fileIn: 'library/build.st'!

]]
chunks:fileIn()
quit()