
-- fileIn("s8/start/platform.st")
smalltalk:bind(smalltalk.Smalltalk,"defaultWorkspaceList",0
,function(self)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
if ((smalltalk.Smalltalk):includesKey_("WorkspaceList"))==true then (result):addAll_((smalltalk.Smalltalk):at_("WorkspaceList")); end;
if ((smalltalk.Smalltalk):includesKey_("U8"))==true then (result):addAll_((smalltalk.U8):commonExpressions()); end;
return (result);
end
,"platform-tools","defaultWorkspaceList\r\n\t\" Private - Return the (captured) workspace list of the receiver.\r\n\tReturn an array of tuples; each tuple is anArray of the form\r\n\t\t#( title code )\r\n\twhere:\r\n\t\ttitle is aString to be shown as a title of the workspace page.\r\n\t\tcode is the text to be shown as contents of workspace page.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\t(Smalltalk includesKey: #WorkspaceList) ifTrue: [\r\n\t\tresult addAll: (Smalltalk at: #WorkspaceList)\r\n\t].\r\n\t(Smalltalk includesKey: #U8) ifTrue: [\r\n\t\tresult addAll: U8 commonExpressions\r\n\t].\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((smalltalk.Smalltalk):includesKey_(\"WorkspaceList\"))==true then (result):addAll_((smalltalk.Smalltalk):at_(\"WorkspaceList\")); end;\r\nif ((smalltalk.Smalltalk):includesKey_(\"U8\"))==true then (result):addAll_((smalltalk.U8):commonExpressions()); end;\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"workspaceList",0
,function(self)
return ((self):defaultWorkspaceList());
end
,"platform-tools","workspaceList\r\n\t\" Return the (captured) workspace list of the receiver. \"\r\n\r\n\t^self defaultWorkspaceList","function(self)\r\nreturn ((self):defaultWorkspaceList());\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"defaultAppList",0
,function(self)
local result=nil
(function()
	local _s8_value=(smalltalk:newArray({}))
	result=_s8_value
	return _s8_value
end)();
if ((smalltalk.Smalltalk):includesKey_("AppList"))==true then (result):addAll_((smalltalk.Smalltalk):at_("AppList")); end;
if ((smalltalk.Smalltalk):includesKey_("U8Configuration"))==true then (result):addAll_((smalltalk.U8Configuration):appList()); end;
(result):addAll_((self):allClassMethodsList_(smalltalk:newArray({"sample", "samples"})));
return (result);
end
,"platform-tools","defaultAppList\r\n\t\" Private - Return the (captured) apps of the receiver.\r\n\tReturn an array of tuples; each tuple is anArray of the form\r\n\t\t#( title comment code )\r\n\twhere:\r\n\t\ttitle is aString that can include an icon name inside brackets.\r\n\t\tcomment is aString with short description of the app.\r\n\t\tcode is the code to evaluate to open the app.\r\n\t\"\r\n\r\n\t| result |\r\n\tresult := #().\r\n\t(Smalltalk includesKey: #AppList) ifTrue: [\r\n\t\tresult addAll: (Smalltalk at: #AppList)\r\n\t].\r\n\t(Smalltalk includesKey: #U8Configuration) ifTrue: [\r\n\t\tresult addAll: U8Configuration appList\r\n\t].\r\n\tresult addAll: (self allClassMethodsList: #(sample samples)).\r\n\t^result","function(self)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=(smalltalk:newArray({}))\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\nif ((smalltalk.Smalltalk):includesKey_(\"AppList\"))==true then (result):addAll_((smalltalk.Smalltalk):at_(\"AppList\")); end;\r\nif ((smalltalk.Smalltalk):includesKey_(\"U8Configuration\"))==true then (result):addAll_((smalltalk.U8Configuration):appList()); end;\r\n(result):addAll_((self):allClassMethodsList_(smalltalk:newArray({\"sample\", \"samples\"})));\r\nreturn (result);\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"appList",0
,function(self)
return ((self):defaultAppList());
end
,"platform-tools","appList\r\n\t\" Return the (captured) apps of the receiver. \"\r\n\r\n\t^self defaultAppList","function(self)\r\nreturn ((self):defaultAppList());\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"allClassMethodsList:",0
,function(self,choices)
local result=nil
(function()
	local _s8_value=((smalltalk.Array):new())
	result=_s8_value
	return _s8_value
end)();
((self):classes()):do_((function(cls)
return (((cls)["$klass"]):methodsDo_((function(mth)
local comment=nil
return (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_((((mth):selector()):argumentCount()),0)),(function()
return (smalltalk:boolean_and_((smalltalk:boolean_or_(((choices):includes_((mth):category())),(function()
return ((choices):includes_((mth):selector()))
end))),(function()
(function()
	local _s8_value=((mth):comment())
	comment=_s8_value
	return _s8_value
end)();return (smalltalk:booleanNot_(((((smalltalk:asString_((comment))):upTo_("-")):asLowercase()):includes_("private"))))
end)))
end))),(function()
local title=nil
local code=nil
(function()
	local _s8_value=((function()
	local _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((cls):name())," ")),(mth):selector()))
	code=_s8_value
	return _s8_value
end)())
	title=_s8_value
	return _s8_value
end)();return ((result):add_((smalltalk.Array):with_with_with_(title,(comment):upTo_("."),code)))
end),nil))
end)))
end));
return ((result):sorted_((function(a,b)
return ((((a):first()) < (b):first()))
end)));
end
,"platform-tools","allClassMethodsList: choices\r\n\t\" Private - Return the list of all (class) methods in the receiver matching choices. \"\r\n\r\n\t| result |\r\n\tresult := Array new.\r\n\tself classes do: [:cls|\r\n\t\tcls class methodsDo: [:mth| | comment |\r\n\t\t\t(mth selector argumentCount = 0 and: [\r\n\t\t\t((choices includes: mth category) or: [\r\n\t\t\t  choices includes: mth selector\r\n\t\t\t]) and: [ comment := mth comment.\r\n\t\t\t ((comment asString upTo: $-) asLowercase includes: #private) not\r\n\t\t\t]]) ifTrue: [ | title code |\r\n\t\t\t\ttitle := code := cls name ,$  ,mth selector.\r\n\t\t\t\tresult add: (Array\r\n\t\t\t\t\twith: title with: (comment upTo: $.)\r\n\t\t\t\t\twith: code)\r\n\t\t\t].\r\n\t\t].\r\n\t].\r\n\t^result sorted: [:a :b| a first < b first ]","function(self,choices)\r\nlocal result=nil\r\n(function()\r\n\tlocal _s8_value=((smalltalk.Array):new())\r\n\tresult=_s8_value\r\n\treturn _s8_value\r\nend)();\r\n((self):classes()):do_((function(cls)\r\nreturn (((cls)[\"$klass\"]):methodsDo_((function(mth)\r\nlocal comment=nil\r\nreturn (smalltalk:if_true_false_((smalltalk:boolean_and_((smalltalk:isObject_equalTo_((((mth):selector()):argumentCount()),0)),(function()\r\nreturn (smalltalk:boolean_and_((smalltalk:boolean_or_(((choices):includes_((mth):category())),(function()\r\nreturn ((choices):includes_((mth):selector()))\r\nend))),(function()\r\n(function()\r\n\tlocal _s8_value=((mth):comment())\r\n\tcomment=_s8_value\r\n\treturn _s8_value\r\nend)();return (smalltalk:booleanNot_(((((smalltalk:asString_((comment))):upTo_(\"-\")):asLowercase()):includes_(\"private\"))))\r\nend)))\r\nend))),(function()\r\nlocal title=nil\r\nlocal code=nil\r\n(function()\r\n\tlocal _s8_value=((function()\r\n\tlocal _s8_value=(smalltalk:object_comma_((smalltalk:object_comma_(((cls):name()),\" \")),(mth):selector()))\r\n\tcode=_s8_value\r\n\treturn _s8_value\r\nend)())\r\n\ttitle=_s8_value\r\n\treturn _s8_value\r\nend)();return ((result):add_((smalltalk.Array):with_with_with_(title,(comment):upTo_(\".\"),code)))\r\nend),nil))\r\nend)))\r\nend));\r\nreturn ((result):sorted_((function(a,b)\r\nreturn ((((a):first()) < (b):first()))\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"exampleList",0
,function(self)
return ((self):allClassMethodsList_(smalltalk:newArray({"example"})));
end
,"platform-tools","exampleList\r\n\t\" Return the (captured) examples of the receiver. \"\r\n\r\n\t^self allClassMethodsList: #(example)","function(self)\r\nreturn ((self):allClassMethodsList_(smalltalk:newArray({\"example\"})));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"screen:",0
,function(self,aBlock)
return ("S8 system running as console application");
end
,"platform-tools","screen: aBlock\r\n\t\" Return the (captured) screen of the receiver. \"\r\n\r\n\t^'S8 system running as console application'","function(self,aBlock)\r\nreturn (\"S8 system running as console application\");\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"fileContentsAt:",0
,function(self,pathName)
return (((function()
return ((pathName):fileContents())
end)):on_do_(smalltalk.Exception,(function(ex)
return (nil)
end)));
end
,"platform-tools","fileContentsAt: pathName\r\n\t\" Return the contents of file at pathName (or nil). \"\r\n\r\n\t^[ pathName fileContents ] on: Exception do: [:ex| nil ]","function(self,pathName)\r\nreturn (((function()\r\nreturn ((pathName):fileContents())\r\nend)):on_do_(smalltalk.Exception,(function(ex)\r\nreturn (nil)\r\nend)));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"output:toFile:",0
,function(self,aString,pathName)
return ((aString):outputToFile_(pathName));
end
,"platform-tools","output: aString toFile: pathName\r\n\t\" Save aString onto a file at pathName. \"\r\n\r\n\t^aString outputToFile: pathName","function(self,aString,pathName)\r\nreturn ((aString):outputToFile_(pathName));\r\nend")

smalltalk:bind(smalltalk.Smalltalk,"append:toFile:",0
,function(self,aString,pathName)
return ((aString):appendToFile_(pathName));
end
,"platform-tools","append: aString toFile: pathName\r\n\t\" Append aString onto a file contents at pathName. \"\r\n\r\n\t^aString appendToFile: pathName","function(self,aString,pathName)\r\nreturn ((aString):appendToFile_(pathName));\r\nend")
